<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
 
 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

class Admin extends MY_Controller {

//	private $logged_in;
//	private $member_id;
//	private $is_admin;
	 
	function __construct()
{
		parent::__construct();
	 
		/* Standard Libraries of codeigniter are required */
// 		$this->load->database();
// 		$this->load->helper('url');
// 		$this->load->model('model_parando');

		$params = ['tag' => 'login_session_data'];
		$this->load->library('randosession',$params);

		$this->load->library('grocery_CRUD');
	 
	}
 
//	private function die_error($heading,$message){
//		$this->load->view('errors/html/error_general',array('title'=>$heading, 'heading'=>$heading,'message'=> $message));
//		$this->output->_display();
//		exit();
//	}
	
	private function send_output($output = null) 
	{
		$style_url=base_url("assets/parando/css/admin.css");
		$output->css_files=array_merge($output->css_files,[$style_url]);
		$this->load->view('view_admin.php',$output);    
	}

	private function is_admin(){
		return $this->randosession->get_data('login_is_admin');
	}

	private function admin_check(){
		if($this->is_admin()){
			return true;
		}else{
			$this->die_error('Access Denied',"This function is available only to administrators.");
		}

	}

	private function login_check(){
		if($this->randosession->get_data('login_logged_in')){
			return $this->randosession->get_data('login_member_id');
		}else{
			$this->die_error('Access Denied',"This function is available only when logged in.");
		}

	}

// EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT

 	public function event($timerange=null){

		$member_id=$this->login_check();
		
		$title="Organizer Events";
		$subject='Event';
		$crud = new grocery_CRUD();

//$crud->set_theme('datatables');

		$dt = new DateTime();
		$now = $dt->format('Y-m-d');
		switch($timerange){
//			case 'future':
			default:
				$crud->where('date >=',$now);
				$crud->order_by('date','asc');
				$title="Future Events";
				break;
			case 'past':
				$crud->where('date <',$now);
		    $crud->order_by('date','desc');
				$title="Past Events";
				break;
			case 'all':
				$title="All Events";
				break;
		}
		

		$crud->set_subject($subject);
		$crud->set_table('event');
		$crud->set_relation('start_id','start','start_name');
		$crud->set_relation('club_id','club','{nickname}');
		$crud->set_relation('organizer','member','{first_name} {last_name}');
		$crud->columns('distance','type','date','start_time','name','start_id','club_id','organizer','status','roster','admin');
		$crud->display_as('start_id','Start Location');
		$crud->display_as('name','Ride Title');
		$crud->display_as('club_id','Club');
		
		
		if(!$this->is_admin()){
			$crud->where('event.organizer =', $member_id);
			$crud->unset_add();
			$crud->unset_delete();
//			$crud->unset_edit();
//			$crud->edit_fields('name','distance','date','start_id','start_time','cuesheet','map','description','volunteers_needed');
			$crud->field_type('sanction','readonly');
			$crud->field_type('distance','readonly');
			$crud->field_type('type','readonly');
			$crud->field_type('date','readonly');
			$crud->field_type('organizer','readonly');
//			$crud->field_type('start_id','readonly');
		}
		
		$crud->set_relation_n_n('volunteers_needed','volunteer_need','paragraph','event_id','job_id','description',null,['location'=>'volunteer']);
		
		$crud->field_type('prepay_only', 'true_false', array('No', 'Yes'));
		$crud->field_type('status', 'set', array('locked', 'hidden', 'suspended', 'canceled'));
		$crud->field_type('waive_guest_fee', 'true_false', array('No', 'Yes'));
//		$crud->field_type('hidden', 'true_false', array('No', 'Yes'));
//		$crud->field_type('suspended', 'true_false', array('No', 'Yes'));
//		$crud->field_type('canceled', 'true_false', array('No', 'Yes'));
		$crud->field_type('payment_methods','set',array('pay_online','pay_mail','pay_event'));
		
//		$crud->required_fields('sanction','distance','type','date');
//		$crud->required_fields('sanction','type');
		$crud->unset_fields('info'); // Legacy info page URL
		$crud->callback_column('admin', array($this,'_paperwork'));
		$crud->callback_column('status', array($this,'_status_icons'));
		$crud->set_lang_string('update_error','An error has occurred on saving. Event locked? Missing rusa_route?');
		$crud->set_lang_string('delete_error_message','An error has occurred on deleting. Event locked?');
		$crud->callback_before_update(array($this,'_update_lock_check'));
		$crud->callback_before_delete(array($this,'_delete_lock_check'));

		$crud->callback_column('roster', array($this,'_roster_url'));
		
		$crud->add_action('Check RUSA Membership', 'https://parando.org/images/rusacheck.png', 'roster/rusa_member_check');
		$crud->add_action('Cue Wizard', 'https://parando.org/images/ScrollCW-24.png', 'route/wizard');


		$output = $crud->render();
		$output->title=$title;
		
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}
	
	public function _roster_url($value,$row){
		$span_center = '<span style="width:100%;text-align:center;display:block;">';
		$event_id=$row->id;
		$n_riders=$this->model_parando->roster_count($event_id); // =$value; //$this->truncate($value,30);
		$rosterurl=site_url("admin/roster/$event_id");
		return "$span_center<A HREF='{$rosterurl}' TITLE='Roster'><i class='fas fa-users'  style='color: blue;'></i></A> ($n_riders)</span>";
	}

	private $status_icon=[
		'hidden'=>"<i class='fas fa-mask'  style='color: blue;'></i>",
		'canceled'=>"<i class='fas fa-thumbs-down'  style='color: blue;'></i>",
		'locked'=>"<i class='fas fa-lock'  style='color: blue;'></i>",
		'suspended'=>"<i class='fas fa-question-circle'  style='color: blue;'></i>"];


	public function _status_icons($value,$row){
		$attribs=explode(',',$value);

		$d="";

		foreach ($attribs as $a){
			$icon = ((!empty($this->status_icon[$a]))?$this->status_icon[$a]:"$a ");
			$d .= "<div class='tooltip'>$icon<span class='tooltiptext'>$a</span></div>";
		}

		return $d;
	}


	public function _update_lock_check($post_array, $key){
		$sql="SELECT * FROM event where id='{$key}'";
		$q=$this->db->query($sql);
		$row=$q->row_array();
		$locked=$this->model_parando->event_status_q($row,'locked');
		$pa_locked=$this->model_parando->event_status_q($post_array,'locked');

		// if($pa_locked){
		//		if(empty($row['rusa_route']) && $row['type']!='fleche') return false; $this->die_error(__METHOD__, "Can't lock event: RUSA Route missing.");
		// }

		if($locked && $pa_locked){
			return false;
		}else{
			return $post_array;
		}
        }

	public function _delete_lock_check($key){
		$sql="SELECT status FROM event where id='{$key}'";
		$q=$this->db->query($sql);
		$row=$q->row_array();
		$locked=$this->model_parando->event_status_q($row,'locked');
		if($locked){
			return false;
		}else{
			return true;
		}
        }

	public function _paperwork($value,$row){
		$su=site_url();
		$id=$row->id;
		return <<<EOT
<div class="dropdown">
  <button class="dropbtn">Paperwork</button>
  <div class="dropdown-content">
    <A HREF="{$su}roster/start/$id">Start Sign In</A>
    <A HREF="{$su}roster/waiver/$id">Event Waiver (1 Signature)</A>
    <A HREF="{$su}roster/controle/$id">Finish/Intermediate Sign-In</A>
    <A HREF="{$su}roster/postcard_backs/$id">Postcard backs for Roster</A>
    <A HREF="{$su}roster/postcard_fronts/$id">Postcard Fronts for Event (1 Page)</A>
    <A HREF="{$su}route/event/$id/card_outside_roster">Card Outsides for Roster</A>
    <A HREF="{$su}route/event/$id/card_inside">Card Inside (start stamped)</A>
    <A HREF="{$su}route/event/$id/card_inside_novalidatefirst">Card Inside</A>
    <A HREF="{$su}route/event/$id/card_outside_blank">Blank Card Outside</A>
    <A HREF="{$su}admin/purchase/event_id/$id">Purchase Orders</A>
    <A HREF="{$su}admin/mint_event_coupon/$id">Mint Coupon (text)</A>
    <A HREF="{$su}roster/email/$id">Roster Email Addresses</A>
    <A HREF="{$su}roster/comcsv/$id">Roster CSV Download for COM</A>
    <A HREF="{$su}roster/rusacsv/$id">Results CSV Download for RUSA</A>
    <A HREF="{$su}roster/fullcsv/$id">Full Results CSV Download with all info</A>
    <A HREF="{$su}roster/setnullfinished/$id">Set empty results to FINISHED</A>
  </div>
</div> 
EOT;
	}
	
	

// START START START START START START START START START START START START START

	public function start(){
		$this->login_check(); $this->admin_check();
		$subject='Start Location';
		$crud = new grocery_CRUD();
		$crud->set_subject($subject);
		$crud->set_table('start');
		$crud->columns('id','start_name','start_city','start_state');
		$crud->required_fields('start_name','start_city','start_state','start_street','start_zip','parking','lodging','start_description','directions_url');
		$output = $crud->render();
		$output->title=$subject;
		
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}

// SPOT SPOT SPOT SPOT SPOT SPOT SPOT SPOT SPOT SPOT SPOT SPOT SPOT SPOT SPOT 

	public function spot(){
		$this->login_check(); $this->admin_check();
		$subject='Club SPOT Tracker';
		$crud = new grocery_CRUD();
		$crud->set_subject($subject);
		$crud->set_table('tracker');
		$crud->required_fields('first_name','last_name','url');
		$output = $crud->render();
		$output->title=$subject;
		
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}

	public function encrypt_password_callback($post_array, $primary_key=null) {
	  if(!empty($post_array['password'])){
	    $post_array['password'] = password_hash($post_array['password'],PASSWORD_DEFAULT);
	  }else{
	    unset($post_array['password']);
	  }
	  
//	  $this->die_error(__METHOD__,print_r($post_array,true));
	  
	  
	  return $post_array;
	}

	public function set_password_input_to_empty() {
	return "<input type='password' name='password' value='' />";
	}
	
// MEMBER MEMBER MEMBER MEMBER MEMBER MEMBER MEMBER MEMBER MEMBER MEMBER MEMBER

	public function member(){
		$this->login_check(); $this->admin_check();
		$subject='Member';
		$crud = new grocery_CRUD();
		$crud->set_subject($subject);
		$crud->set_table('member');
		$crud->columns('first_name','last_name','rusa_id','expires','notes');
		$crud->display_as('m_street','Street');
		$crud->display_as('m_city','City');
		$crud->display_as('m_state','State');
		$crud->display_as('m_country','Country');
		$crud->order_by('last_name,first_name','asc');
        $country_codes=array_keys($this->model_parando->get_countries());
		$crud->field_type('m_country','enum',$country_codes);
		$crud->display_as('m_zip','Zip');
		$crud->display_as('m_phone','Cell Phone');
		$crud->display_as('m_phone_alt','Phone (alt)');
		$crud->display_as('emergency_phone_alt','Emergency Phone (alt)');
		$crud->display_as('tracker','Tracker URL');
		$crud->display_as('m_email','Email');
		$crud->field_type('password','password');
		$crud->field_type('administrator', 'true_false', array('No', 'Yes'));
		$crud->field_type('waive_fees', 'true_false', array('No', 'Yes'));
		$crud->callback_edit_field('password',array($this,'set_password_input_to_empty'));
		$crud->callback_add_field('password',array($this,'set_password_input_to_empty'));
		$crud->callback_before_insert(array($this,'encrypt_password_callback'));
		$crud->callback_before_update(array($this,'encrypt_password_callback'));
		$crud->set_rules('password', 'Password','min_length[6]|max_length[50]');
		$crud->required_fields('first_name','last_name','m_email');

		$crud->add_action('Rider Results', '', 'results/member','fa fa-book');

		$output = $crud->render();
		$output->title=$subject;
		
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}

// PROFILE PROFILE PROFILE PROFILE PROFILE PROFILE PROFILE PROFILE PROFILE PROFILE

	private function old_profile(){
		$this->login_check(); 

		$subject='Profile';
		$crud = new grocery_CRUD();

		$state = $crud->getState();
		$state_info = $crud->getStateInfo();
		switch($state){
			case 'edit':
			case 'update_validation':
			case 'success':
				$primary_key = $state_info->primary_key;
				$member_id = $this->randosession->get_data('login_member_id');
				if($primary_key != $member_id){
					$this->load->view('errors/html/error_general',array('title'=>'ID Mismatch', 'heading'=>'Access Denied','message'=> "Member ID mismatch."));
					$this->output->_display();
					exit();
				}
				break;
			default:
				$this->load->view('errors/html/error_general',array('title'=>'Edit Only', 'heading'=>'State Denied','message'=> "This function can only be called to edit. State=$state"));
		$this->output->_display();
				exit();
				break;
		}

		$crud->set_subject($subject);
		$crud->set_table('member');
//		$crud->columns('first_name','last_name','rusa_id');
		$crud->where('id',$member_id);
		$crud->unset_add();
		$crud->unset_list();
		$crud->unset_fields('administrator','waive_fees','expires');
		$crud->field_type('password','password');
		$crud->callback_edit_field('password',array($this,'set_password_input_to_empty'));
//		$crud->callback_add_field('password',array($this,'set_password_input_to_empty'));
//		$crud->callback_before_insert(array($this,'encrypt_password_callback'));
		$crud->callback_before_update(array($this,'encrypt_password_callback'));
//		$crud->set_rules('password', 'Password','min_length[6]|max_length[50]');
//		$crud->unset_back_to_list();
		$crud->display_as('m_street','Street');
		$crud->display_as('m_city','City');
		$crud->display_as('m_state','State');
		$crud->display_as('m_country','Country');

                $country_codes=array_keys($this->model_parando->get_countries());
		$crud->field_type('m_country','enum',$country_codes);

		$crud->display_as('m_zip','Zip');
		$crud->field_type('m_zip','string');
		$crud->display_as('m_phone','Cell Phone');
		$crud->display_as('m_phone_alt','Phone (alt)');
		$crud->display_as('emergency_phone_alt','Emergency Phone (alt)');
		$crud->display_as('m_email','Email');

		$output = $crud->render();
		$output->title=$subject;
		
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);    
	}

// 	private function make_profile_edit_code($m){
// 		$em_id="$e-$m";
// 		$secret=$this->model_parando->secret;
// 		$hash=hash('crc32',$em_id.$secret);
// 		return "$em_id-$hash";
// 	}
	
	public function profile(){
		$this->login_check(); 

		$subject='Profile';
		$crud = new grocery_CRUD();
		$state = $crud->getState();
		$state_info = $crud->getStateInfo();
		switch($state){
			case 'edit':
			case 'update_validation':
			case 'update':
			case 'success':
				$primary_key = $state_info->primary_key;
				$member_id = $this->randosession->get_data('login_member_id');
 				if($primary_key != $member_id){
 					trigger_error("ID Mismatch: pk=$primary_key; mi=$member_id",E_USER_ERROR);
 				}
				break;
			default:
 				trigger_error("This function can only be called in states edit/update_validation/success. State=$state",E_USER_ERROR);
				break;
		}
		$crud->set_subject($subject);
		$crud->set_table('member');
		$crud->unset_add();
		$crud->unset_list();
		$crud->unset_fields('administrator','waive_fees','expires');
		$crud->field_type('password','password');
		$crud->callback_edit_field('password',array($this,'set_password_input_to_empty'));
		$crud->callback_before_update(array($this,'encrypt_password_callback'));
		$crud->unset_back_to_list();
		$crud->display_as('m_street','Street');
		$crud->display_as('m_city','City');
		$crud->display_as('m_state','State');
		$crud->display_as('m_country','Country');
        $country_codes=array_keys($this->model_parando->get_countries());
		$crud->field_type('m_country','enum',$country_codes);
		$crud->display_as('m_zip','Zip');
		$crud->field_type('m_zip','string');
		$crud->display_as('m_phone','Cell Phone');
		$crud->display_as('m_phone_alt','Phone (alt)');
		$crud->display_as('emergency_phone_alt','Emergency Phone (alt)');
		$crud->display_as('m_email','Email');
		$output = $crud->render();
		$output->title=$subject;
		$this->send_output($output);    
	}



// WEBSITE WEBSITE WEBSITE WEBSITE WEBSITE WEBSITE WEBSITE WEBSITE WEBSITE WEBSITE

	public function paragraph($location=null){
		$this->login_check(); $this->admin_check();
		$subject='Text Paragraph';
		$crud = new grocery_CRUD();
		$crud->set_subject($subject);
		$crud->set_table('paragraph');
		if(!empty($location)){ 
		  if(preg_match('/not_(\w+)/', $location, $m)){
		    $not_loc = $m[1];
		  	$crud->where("NOT (location = '$not_loc')"); 
		  }else{
		  	$crud->where("location = '$location'"); 
		  	}
		  }
		$crud->columns('location','description','sort_priority', 'hidden','last_change','text');
		$crud->order_by('location,hidden,description','asc');

		$crud->field_type('created', 'readonly');
		$crud->field_type('last_change', 'readonly');

		$stmt = "SELECT DISTINCT location FROM paragraph order by location"; 
		$query = $this->db->query($stmt);
		$result = $query->result_array();
		$loc=[];
		foreach ($result as $r){
			$loc[]=$r['location'];
		}

		$crud->field_type('location','enum',$loc);
		$crud->field_type('hidden', 'true_false', array('No', 'Yes'));

		$output = $crud->render();
		$output->title=$subject;
		
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}
	

	public function settings(){
		$this->login_check(); $this->admin_check();
		$subject='Web Site Setting';
		$crud = new grocery_CRUD();
		$crud->set_subject($subject);
		$crud->set_table('settings');
		$output = $crud->render();
		$output->title=$subject;
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}
	
	public function club(){
		$this->login_check(); $this->admin_check();
		$subject='Club';
		$crud = new grocery_CRUD();
		$crud->set_subject($subject);
		$crud->set_table('club');
		$crud->set_relation('rba_id','member','{first_name} {last_name}');
		$crud->set_relation('state_id','state','{code}');
		$crud->set_relation('country_id','country','{code}');
		$crud->columns('name','region','rba_id','logo_url');
        $crud->callback_column('logo_url',[$this,'_callback_logo_url']);
       $crud->callback_column('name',[$this,'_callback_name']);
        $crud->field_type('secret','password');
        $crud->unset_read_fields(['secret']);
        $crud->display_as('rba_id','RBA');
        $crud->display_as('logo_url','Logo');
		$output = $crud->render();
		$output->title=$subject;
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}
	
	public function _callback_logo_url($value, $row){
        return "<IMG WIDTH='32' SRC='$value'/>";
    }
    public function _callback_name($value, $row){
    return "<a href='$row->website_url'>$value</a>";
    }



	public function coupons(){
		$this->login_check(); $this->admin_check();
		$subject='Coupon';
		$crud = new grocery_CRUD();
		$crud->set_subject($subject);
		$crud->set_table('coupon');
		$crud->unset_add();
		$crud->set_relation('minter_id','member','{first_name} {last_name}');
		$crud->set_relation('spender_id','member','{first_name} {last_name}');
		//$crud->set_relation('invoice_number','purchase','{invoice_number}');
		$crud->field_type('void', 'true_false', array('No', 'Yes'));
		$crud->display_as('mint_timestamp','Minted On');
		$crud->display_as('spend_timestamp','Spent On');
		$crud->display_as('minter_id','Minted By');
		$crud->display_as('spender_id','Spent By');
		$crud->order_by('mint_timestamp','desc');
		$crud->callback_column('mint_timestamp', array($this,'_timestamp_to_localtime'));
		$crud->callback_column('spend_timestamp', array($this,'_timestamp_to_localtime'));
//		$crud->callback_column('attributes', array($this,'_coupon_show_attributes'));
		$crud->edit_fields('void');
		$output = $crud->render();
		$output->title=$subject;
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}
	
	public function mint_event_coupon($event_id,$format="text"){
		$member_id=$this->login_check(); 
		
				$this->load->library('controletimes');

		$e=$this->model_parando->get_event($event_id);
		$organizer=$e['organizer'];		
		if($organizer!=$member_id){
			$this->admin_check();
		}
		$event=$this->model_parando->get_event($event_id);
		if(null===$event)$this->die_error(__METHOD__,"No event $event_id");
			$schedule=$this->model_parando->event_schedule($event);
			$event=array_merge($event,$schedule);

		$this->load->model('coupon');
		$c=$this->coupon->mint_free_event($member_id,$event_id);
		$coupon_data=$this->coupon->get($c);
		if($coupon_data===false)$this->die_error(__METHOD__,"Failed to mint coupon $c");
		$coupon_id=$coupon_data['id'];
		$coupon_code=$coupon_data['code'];
		$coupon_prefix=$this->coupon->prefix;
		$coupon_url=site_url("register/event/$event_id/$coupon_code");
		
		$tagname=$this->model_parando->make_event_tagname($event);
		$event_region=$this->model_parando->region;
		$event_distance=$this->model_parando->make_distance($event);
		$event_name=$this->model_parando->he_decode($event['name']);
		$event_date=$event['start_daymonthyear_str'];
		$this_organization=$this->model_parando->organization;
		$event_title="$event_date $event_region $event_name $event_distance";

		switch($format){
			case 'text':
				$body=<<<EOT
<div id=container>
<pre>
$this_organization Event Coupon
==============================================================
Event Name: $event_name $event_distance
Event Date: $event_date
==============================================================

Register for FREE at this event by using this link

  $coupon_url

This coupon is valid for one use only and may be redeemed
only for registration at the $this_organization event listed above.
</pre> 
<div id=fineprint>
One per rider. One-time use. Must present coupon at online registration. Cannot be combined with any other discounts. 
Member dues, RUSA dues, jerseys, pins, and other incidental purchases excluded from minimum spend and discount. 
We reserve the right to cancel the offer. No monetary value. Void if altered, reproduced or sold. Not available to 
$this_organization officers and official organizers.
</div>

</div>
EOT;
				$this->die_info("Event Coupon", $body);
				break;
			case 'pdf':
				$params = compact('event','event_title','tagname','this_organization');
				$this->load->library('coupon_print',$params);
				$this->coupon_print->AddPage();
				$this->coupon_print->render($coupon_data);
				$this->coupon_print->Output("I", $tagname . "-Coupon-$coupon_prefix$coupon_id.pdf");
				break;
			default:
				$this->die_error(__METHOD__,"Unknown format: $format");
				break;
		}
	}


	public function _timestamp_to_localtime($value,$row){
		$timestamp=$value;
		if($value<=0)return"";
		$id=$row->id;
		$mdt=new DateTime('@'.$value);
		$localtz = new DateTimeZone($this->model_parando->tzname);
		$mdt->setTimezone($localtz);
		return $mdt->format('Y-m-d H:i:s T');
	}


  // FLECHE FLECHE FLECHE FLECHE FLECHE FLECHE FLECHE FLECHE FLECHE FLECHE

	public function fleche_team($event_id=0){

		$this->load->model('fleche_parando');
		$this->load->model('accounting_parando');

		$this->login_check(); $this->admin_check();
		$subject='Fl&egrave;che Teams';
		$title=$subject;
		$crud = new grocery_CRUD();
		$crud->set_subject($subject);
		$crud->set_table('fleche_team');
		$crud->columns('event_id','name','captain_id','start_date','start_time','map','riders','approved','penult_km_dist','final_km_dist','status');
		
		if(!empty($event_id)){
			$crud->where('event_id',$event_id);
			$event=$this->model_parando->get_event($event_id);
			$event_name=$event['date'];
			$title="$subject $event_name";
		}
		
		$crud->set_relation_n_n('riders','fleche_team_member','member','fleche_team_id','member_id','{first_name} {last_name}');
		$crud->set_relation('captain_id','member','{first_name} {last_name}');
		$crud->set_relation('event_id','event','{date}');

		$crud->field_type('approved', 'true_false', array('No', 'Yes'));
		$crud->display_as('captain_id','Captain');
		$crud->display_as('penult_km_dist','Dist @22-hr (km)');
		$crud->display_as('final_km_dist','Dist @finish (km)');

		$crud->order_by('start_date','desc');

		$crud->callback_column('map', array($this,'_map_url'));
		$crud->callback_column('riders', array($this,'_fleche_roster_url'));
		$crud->callback_column('status', array($this,'_team_status'));

		// $crud->unset_add();
		$crud->unset_clone();
		
		$crud->add_action('Set All Finished', '', 'admin/team_result/finish', 'fa fa-flag-checkered');
		// $crud->add_action('Erase Results', '', 'admin/team_result/erase', 'fa fa-flag');


		$output = $crud->render();
		$output->title=$title;
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}


	public function _map_url($value,$row){
		$span_center = '<span style="width:100%;text-align:center;display:block;">';
		$color=(empty($value))?"#C0C0C0":"blue";
		return "$span_center<A HREF='{$value}'><i class='fas fa-map-marker-alt' style='color: {$color};'></i></A></span>";
	}

	public function _fleche_roster_url($value,$row){
		$span_center = '<span style="width:100%;text-align:center;display:block;">';
		$event_id=$row->event_id;
		$fleche_team_id=$row->id;
		$n_riders=$this->fleche_parando->num_members_on_team($fleche_team_id); // =$value; //$this->truncate($value,30);
		$rosterurl=site_url("admin/fleche_team_member/$fleche_team_id");
		return "$span_center<A HREF='{$rosterurl}' TITLE='Roster'><i class='fas fa-users'  style='color: blue;'></i></A> ($n_riders)</span>";
	}

	public function _team_status($value,$row){
		$span_center = '<span style="width:100%;text-align:center;display:block;color:blue;">';	
		$event_id=$row->event_id;
		$fleche_team_id=$row->id;

		$ts=$this->fleche_parando->fleche_team_status($fleche_team_id);
		// $route_status=($route_approved)?"":"Under RBA Review";
		// $membership_status=($too_few)?"Too Few ($num_members < 3 minimum)":(($too_many)?"Too Many ($num_members > 5 maximum)":"");
		// $payment_status=(!$all_paid)?"Only $num_paid of $num_riders riders have paid":"";
		$team_status = ($ts['good_to_go'])?($span_center.'<i class="fas fa-thumbs-up"></i></span>'):""; // $route_status . $membership_status . $payment_status;

		return $team_status;
	}
	
	
	public function team_result($result,$fleche_team_id){
		$this->login_check(); $this->admin_check();
		if(empty($fleche_team_id)){$this->die_error(__METHOD__,"No team specified");}
		$result = strtoupper($result);


		$this->db->where('fleche_team_id', $fleche_team_id);
		switch($result){
			case 'ERASE':
				$rc=$this->db->update('fleche_roster_member',['result'=>'NULL','elapsed_time'=>NULL]);  	
				break;
			case 'DNS':
			case 'DNF':
			case 'DNQ':
				$rc=$this->db->update('fleche_roster_member',['result'=>$result,'elapsed_time'=>NULL]);  	
				break;
			case 'FINISH':
				// $this->die_error(__METHOD__,"FTID=$fleche_team_id; RESULT=$result");
				$rc=$this->db->update('fleche_roster_member',['result'=>$result,'elapsed_time'=>'24:00:00']);  	
				break;
		}
		
		$this->load->model('fleche_parando');
		$team=$this->fleche_parando->get_fleche_team_by_id($fleche_team_id);
		$event_id=$team['event_id'];
		$event_id=(!empty($event_id))?$event_id:0;
		redirect(site_url("admin/fleche_team/$event_id"));
	}

// REFACTOR: This fleche roster method is so similar to 
// the brevet roster() method they really should be unified


	public function fleche_team_member($fleche_team_id){
		$this->login_check(); $this->admin_check();
		$this->load->model('accounting_parando');
		$subject='Fleche Team Roster';
		$crud = new grocery_CRUD();
		$crud->set_subject($subject);
		$crud->set_table('fleche_roster_member');
		$crud->set_primary_key('fleche_team_member_id');

//  The fleche_roster_member table is a view something like this:
//	$sql="SELECT * FROM member,roster,fleche_team,fleche_team_member WHERE
//			fleche_team.id='{$fleche_team_id}' AND 
//			fleche_team_member.fleche_team_id='{$fleche_team_id}' AND
//			fleche_team_member.member_id=roster.member_id AND
//			roster.event_id=fleche_team.event_id AND
//			roster.member_id=member.id order by last_name, first_name";

		$crud->columns('first_last_name','membership','total_fee','paid','tracker_id','tandem','result','elapsed_time','comment');		
		$crud->edit_fields('tracker_id','total_fee','tandem','result','elapsed_time','comment');
		$crud->display_as('first_last_name','Rider');
		$crud->callback_column('paid',array($this,'_callback_total_paid'));
		$crud->callback_column('total_fee',array($this,'_prepend_dollar_sign'));
		$crud->display_as('total_fee','Fee');
		$crud->callback_column('tracker_id',array($this,'_callback_tracker_id'));

		$crud->unset_add();
//		$crud->unset_edit();
		$crud->unset_delete();
		$crud->unset_clone();

		$crud->add_action('Pay for Order', '', 'admin/pay_for_order/fleche_team_member_id', 'fas fa-donate');
		$crud->add_action('Delete Team Member', '', 'admin/delete_fleche_team_member', 'delete-icon');
//		$crud->add_action('Edit Team Member', '', 'admin/edit_fleche_team_member', 'edit-icon');

		$sql="SELECT * FROM tracker";
		$q=$this->db->query($sql);
		$tracker_select=array();
		foreach ($q->result_array() as $row){
			$tracker_select[$row['id']]=$row['tag'];      
		}
		$crud->field_type('tracker_id','dropdown',$tracker_select);

		$crud->order_by('last_name, first_name','asc');

		$crud->where('fleche_team_id',$fleche_team_id);

		$sql="SELECT fleche_team.name as team_name,event.* FROM fleche_team,event WHERE 
			fleche_team.id='{$fleche_team_id}' AND
			event.id=fleche_team.event_id";
		$q=$this->db->query($sql);
		$t=$q->row_array();
		$name=$t['team_name'];
		$event_name=$t['date'] . ' ' . $this->model_parando->make_distance($t);
		// $event_id=$t['event_id'];
		$title="Roster for $name ($event_name)";
		
		$output = $crud->render();
		$output->title=$title;
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}

	public function delete_fleche_team_member($fleche_team_member_id){
		$this->login_check(); $this->admin_check();
		$fleche_team_member_id = (int) $fleche_team_member_id;
		if(empty($fleche_team_member_id)){$this->die_error(__METHOD__,"No team member specified");}

//		$sql="SELECT member_id,event_id,fleche_team_id FROM fleche_team_member,fleche_team WHERE 
//				fleche_team_member.id='{$fleche_team_member_id}' AND
//				fleche_team_member.fleche_team_id=fleche_team.id";
		$sql="SELECT member_id,event_id,fleche_team_id,roster_id FROM fleche_roster_member WHERE 
				fleche_team_member_id='{$fleche_team_member_id}'";
		$q=$this->db->query($sql);
		$t=$q->row_array();
		$fleche_team_id=$t['fleche_team_id'];
		$member_id=$t['member_id'];
		$event_id=$t['event_id'];
		$roster_id=$t['roster_id'];
		if(empty($member_id)){$this->die_error(__METHOD__,"Member not found.");}
		if(empty($event_id)){$this->die_error(__METHOD__,"Event not found.");}
		if(empty($roster_id)){$this->die_error(__METHOD__,"Not in roster.");}
		$this->db->where('id', $roster_id);
		$rc=$this->db->delete('roster');  	
		redirect(site_url("admin/fleche_team_member/$fleche_team_id"));
	}		

	public function edit_fleche_team_member($fleche_team_member_id){
		$this->login_check(); $this->admin_check();
		$fleche_team_member_id = (int) $fleche_team_member_id;
		if(empty($fleche_team_member_id)){$this->die_error(__METHOD__,"No team member specified");}

		$sql="SELECT member_id,event_id,fleche_team_id,roster_id FROM fleche_roster_member WHERE 
				fleche_team_member_id='{$fleche_team_member_id}'";
		$q=$this->db->query($sql);
		$t=$q->row_array();
		$fleche_team_id=$t['fleche_team_id'];
		$member_id=$t['member_id'];
		$event_id=$t['event_id'];
		$roster_id=$t['roster_id'];
		if(empty($member_id)){$this->die_error(__METHOD__,"Member not found.");}
		if(empty($event_id)){$this->die_error(__METHOD__,"Event not found.");}
		if(empty($roster_id)){$this->die_error(__METHOD__,"Not in roster.");}
		redirect(site_url("admin/roster/$event_id/edit/$roster_id"));
	}		
	
	
// ACCOUNTING ACCOUNTING ACCOUNTING ACCOUNTING ACCOUNTING ACCOUNTING ACCOUNTING ACCOUNTING


// Replace transaction_id column with Info callback that decodes transaction info to display description, etc... 

	public function payment($purchase_id=null){
		$this->login_check(); $this->admin_check();
		$this->load->model('accounting_parando');
		$subject='Payment Received';
		$crud = new grocery_CRUD();

		$crud->set_subject($subject);
		$crud->set_table('payment');
		$crud->order_by('entered_on','desc');
		$crud->display_as('member_id','Member Name');
		$crud->display_as('purchase_id','Invoice Number');
		$crud->set_relation('member_id','member','{first_name} {last_name}');
		$crud->set_relation('purchase_id','purchase','{invoice_number}');
		$crud->columns('member_id','purchase_id','purchase_order','amount','point_of_sale','transaction_fee','payer','info','entered_on');
		$crud->callback_column('info',[$this,'_payment_info']);
		$crud->callback_column('purchase_order',[$this,'_payment_purchase_order']);
		$crud->callback_column('point_of_sale',[$this,'_payment_point_of_sale']);
		$crud->unset_add();
		$crud->unset_edit();
		//$crud->unset_delete();

		if(isset($purchase_id) && $purchase_id>0){
			$crud->where('purchase_id=',$purchase_id);
		}


		$output = $crud->render();
		$output->title=$subject;
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}
	
	public function _payment_info($value,$row){
		$transaction_info=$row->transaction_info;
		$decoded_info=json_decode($transaction_info,true);
		if(empty($transaction_info) || json_last_error() !== JSON_ERROR_NONE || empty($decoded_info['payment_description'])){
			return $row->transaction_id;
		}else{
			return $decoded_info['payment_description'];
		}
	}

	public function _payment_purchase_order($value,$row){
		$su=site_url();
		$id=$row->purchase_id;
		return "<A HREF='{$su}admin/purchase/read/$id'>PO</A>";
  }

	public function catalog(){
		$this->login_check(); $this->admin_check();
		$subject='Catalog Item';
		$crud = new grocery_CRUD();
		$crud->set_subject($subject);
		$crud->set_table('catalog');
		$crud->unset_columns('long_description','unit','image_url');
		$crud->field_type('for_sale', 'true_false', array('No', 'Yes'));
		$crud->field_type('shipping_methods', 'set', array('pickup', 'deliver'));
		$output = $crud->render();
		$output->title=$subject;
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}

	public function shipping_queue($category=null){
		$this->login_check(); $this->admin_check();
        $this->load->model('accounting_parando');

//		$catalog_id=($catalog_id+0);
		$crud = new grocery_CRUD();
		if($category!==null) {
//			$this->load->model('accounting_parando');
//			$item=$this->accounting_parando->get_catalog_id($catalog_id);
			$subject="Orders for " . ucfirst($category);
		}else{
			$subject='Item to Ship';
		}
		$crud->set_subject($subject);
		$crud->set_table('shipping_queue');
		$crud->field_type('shipped', 'true_false', array('No', 'Yes'));
		$crud->display_as('value','Option');
		$crud->display_as('purchase_id','Invoice Number');
		$crud->display_as('catalog_id','Description');
		$crud->field_type('created', 'readonly');
		$crud->field_type('last_change', 'readonly');
		$crud->set_relation('member_id','member','"{last_name}, {first_name}"');
		
		if($category!==null) {
			$crud->where('category',$category);
			$crud->set_relation('catalog_id','catalog','{description}',['category'=>$category]);
			$crud->set_relation('purchase_id','purchase','{invoice_number}, ${amount_due}');
			$crud->columns('member_id','email','street','city','state','zip','invoice_number','amount_due','quantity','catalog_id','value','shipping_method','shipped');
			$crud->callback_column('invoice_number', array($this,'_invoice_number'));
			$crud->callback_column('amount_due', array($this,'_amount_due'));
			$crud->callback_column('email', array($this,'_email'));
			$crud->callback_column('street', array($this,'_street'));
			$crud->callback_column('city', array($this,'_city'));
			$crud->callback_column('state', array($this,'_state'));
			$crud->callback_column('zip', array($this,'_zip'));
		}else{
			$crud->set_relation('catalog_id','catalog','{description}');
			$crud->set_relation('purchase_id','purchase','{invoice_number}');
		}
		
		$crud->order_by('created','desc');
		$output = $crud->render();
		$output->title=$subject;
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}

	public function _invoice_number($value,$row){
		$member=$this->accounting_parando->get_purchase_by_id($row->purchase_id);
		return $member['invoice_number'];
	}
	public function _amount_due($value,$row){
		$member=$this->accounting_parando->get_purchase_by_id($row->purchase_id);
		return '$'.$member['amount_due'];
	}
	public function _email($value,$row){
		$member=$this->model_parando->get_member($row->member_id);
		return $member['m_email'];
	}
	public function _street($value,$row){
		$member=$this->model_parando->get_member($row->member_id);
		return '"'.$member['m_street'].'"';
	}
	public function _city($value,$row){
		$member=$this->model_parando->get_member($row->member_id);
		return $member['m_city'];
	}
	public function _state($value,$row){
		$member=$this->model_parando->get_member($row->member_id);
		return $member['m_state'];
	}
	public function _zip($value,$row){
		$member=$this->model_parando->get_member($row->member_id);
		return $member['m_zip'];
	}

	public function pay_for_order($id_type,$id,$create_po=true){

		$payer_member_id=$this->login_check(); 
		$payer_member=$this->model_parando->get_member($payer_member_id);
		$payer_name=$payer_member['first_name'] . ' ' . $payer_member['last_name'];

		$this->load->helper('form');
		$this->load->model('accounting_parando');

		switch($id_type){
			case 'purchase_id':
				$purchase=$this->accounting_parando->get_purchase_by_id($id);
				break;
			case 'roster_id':
				$purchase=$this->accounting_parando->get_purchase_by_roster($id);
				if(empty($purchase) && false!==$create_po){ 
					$roster=$this->model_parando->get_roster_member($id);
					$event_id=$roster->event_id;
					$event=$this->model_parando->get_event($event_id);
					$point_of_sale=__METHOD__;
					$event_value=$event['name'] . ' ' . $event['distance'] . " (Event: $event_id)";

					$items=[];
					$generic_item=$this->accounting_parando->get_product_item('generic');
					$generic_item['unit_price']=$roster->total_fee;
					$generic_item['value']=$event_value;

					$items[]=$generic_item; 
					$purchase=$this->accounting_parando->create_purchase_order(
						$roster->member_id,
						$items,
						$point_of_sale,
						$roster->event_id,
						$description="Event Fee"
						);
					if(is_string($purchase)) $this->die_error(__METHOD__,$purchase);
				}
				break;
			case 'fleche_team_member_id':
				$purchase=$this->accounting_parando->get_purchase_by_fleche_team_member($id);
				$sql="SELECT fleche_team_id FROM fleche_team_member WHERE id={$id}";
				$q=$this->db->query($sql);
				$r=$q->row();
				$fleche_team_id=$r->fleche_team_id;
				break;
			default:
				$this->die_error(__METHOD__,"Unknown or missing id type");
				break;
		}

		if(empty($purchase)){
			$this->die_error(__METHOD__,  "No such purchase for TYPE=$id_type; ID=$id");
		}
		$purchase_id=$purchase['id'];
		$invoice_number=$purchase['invoice_number'];
		$event_id=$purchase['event_id'];
		
		if(!empty($event_id)){
			$e=$this->model_parando->get_event($event_id);
			$organizer=$e['organizer'];
			$event_description=$e['date'] . ' ' . $this->model_parando->make_distance($e);
		}else{
			$event_description="";
			$organizer="";
		}
		
		if(!isset($organizer) || $organizer!=$payer_member_id){
			$this->admin_check();
		}

		// Finally Secure

		$member_id=$purchase['member_id'];
		$member=$this->model_parando->get_member($member_id);

		$member_name=$member['first_name'] . ' ' . $member['last_name'];
		$purchase_description=$purchase['description'];

		$this->form_validation->set_rules('amount_to_pay','Amount to pay in USD','trim|numeric|required');
		$this->form_validation->set_rules('payment_description','Payment Description','trim|required');
		if('POST' == $this->input->method(TRUE) && $this->input->post('submit') == 'pay' && $this->form_validation->run()){  // PAID
			$point_of_sale=__METHOD__;
			$amount_paid=$this->input->post('amount_to_pay');
			$payment_description=$this->input->post('payment_description');
			$payment_data=compact('payment_description','payer_name','member_name','invoice_number','purchase_description',
				'event_description','point_of_sale');
			$this->do_pay_for_order($purchase,$amount_paid,$payment_data);
			switch($id_type){
				case 'purchase_id':
					redirect(site_url("admin/purchase"));
					break;
				case 'roster_id':
					$event_id=(!empty($event_id))?$event_id:-1;
					redirect(site_url("admin/roster/$event_id"));
					break;
				case 'fleche_team_member_id':
					if(!empty($fleche_team_id)){
						redirect(site_url("admin/fleche_team_member/$fleche_team_id"));
					}else{
						$event_id=(!empty($event_id))?$event_id:-1;
						redirect(site_url("admin/roster/$event_id"));
					}
					break;
			}
		}elseif('POST' == $this->input->method(TRUE) && $this->input->post('submit') != 'pay'){  // CANCEL
			switch($id_type){
				case 'purchase_id':
					redirect(site_url("admin/purchase"));
					break;
				case 'roster_id':
					$event_id=(!empty($event_id))?$event_id:-1;
					redirect(site_url("admin/roster/$event_id"));
					break;
				case 'fleche_team_member_id':
					if(!empty($fleche_team_id)){
						redirect(site_url("admin/fleche_team_member/$fleche_team_id"));
					}else{
						$event_id=(!empty($event_id))?$event_id:-1;
						redirect(site_url("admin/roster/$event_id"));
					}
					break;
			}
		}else{

			$opd=$this->accounting_parando->total_order_paid($purchase_id);
			extract($opd); // total_order, total_paid, total_due
		
			$form_title="Pay for Order";
			$form_subject=$form_title;
			$form_comment = <<<EOT
<H2>Payment Details:</H2>
<div class=rider>
<TABLE>
<TR><TD>Member Name:</TD><TD>$member_name</TD></TR>
<TR><TD>Payer Name:</TD><TD>$payer_name</TD></TR>
<TR><TD>Invoice Number:</TD><TD>$invoice_number</TD></TR>
<TR><TD>Description:</TD><TD>$purchase_description $event_description</TD></TR>
<TR><TD>Total Order:</TD><TD>\$$total_order</TD></TR>
<TR><TD>Past Payments:</TD><TD>\$$total_paid</TD></TR>
</TABLE>
</div>
EOT;

			$amount_to_pay_value=set_value('amount_to_pay',$total_due);
			$payment_description_value=set_value('payment_description');
			$form_body="";
			if(!empty(form_error('amount_to_pay'))){
				$form_body .= "<div class=verror>" . form_error('amount_to_pay') . "</div>";
			}
			$form_body .=<<<EOT
<div class="form-group">
	<label for='amount_to_pay'>Amount To Pay</label>    
	<input placeholder="Enter amount in USD" name="amount_to_pay" value="$amount_to_pay_value" required type="text">
</div>
EOT;


			if(!empty(form_error('payment_description'))){
				$form_body .= "<div class=verror>" . form_error('payment_description') . "</div>";
			}
			$form_body .=<<<EOT
<div class="form-group">
	<label for='payment_description'>Payment Description</label>    
	<input placeholder="Enter payment description" name="payment_description" value="$payment_description_value" required type="text">
</div>
EOT;

			$form_submit=<<<EOT
<button type="submit" name="submit" value="pay">$form_subject</button>
<button type="submit" name="submit" value="cancel">Cancel</button>
EOT;

			$form_action=site_url("admin/pay_for_order/$id_type/$id");

			$data=compact('form_title','form_subject','form_comment','form_action','form_body','form_comment','form_submit','form_action');
		
			$this->load->view('form_header',$data);
			$this->load->view('form_simple',$data);
			$this->load->view('form_footer',$data);
		
		}
	}

	private function do_pay_for_order($purchase,$amount_paid,$payment_data=""){

		$purchase_id=$purchase['id'];
		$invoice_number=$purchase['invoice_number'];
		$event_id=$purchase['event_id'];
		
		if(!empty($event_id)){
			$e=$this->model_parando->get_event($event_id);
			$organizer=$e['organizer'];
		}
		
		if($amount_paid!=0){
		
			$point_of_sale=$payment_data['point_of_sale'];
			$transaction_info=json_encode($payment_data);
			$paypal_transaction_id="";
			$payer_name=$payment_data['payer_name'];

			$this->accounting_parando->post_payment($purchase, $point_of_sale, $amount_paid, $transaction_info, $payer_name, $paypal_transaction_id);
			$payment=$this->accounting_parando->get_payment($purchase['id']);
			if(empty($payment)){$this->die_error(__METHOD__,  "Failed transaction readback");}

		}else{
			$this->die_error(__METHOD__,"Nothing to pay");
		}

	}

	public function purchase($key=null,$val=null){
		$this->login_check(); $this->admin_check();
		$this->load->model('accounting_parando');
		$subject='Purchase Order';
		$crud = new grocery_CRUD();
		$crud->set_subject($subject);
		$crud->set_table('purchase');
		$crud->order_by('entered_on','desc');
		$crud->columns('member_id','invoice_number','description','event_id','point_of_sale','order_detail','amount_due','payment','entered_on');
		$crud->callback_column('order_detail',[$this,'_order_detail']);
		$crud->callback_column('point_of_sale',[$this,'_purchase_point_of_sale']);
		$crud->callback_column('amount_due',[$this,'_prepend_dollar_sign']);
		$crud->display_as('member_id','Member Name');
		$crud->display_as('amount_due','Total');
		$crud->set_relation('member_id','member','{first_name} {last_name}');
		$crud->display_as('event_id','Event');
		$crud->set_relation('event_id','event','{date} {type} {distance}');
		$crud->callback_column('payment',[$this,'_order_paid']);

		if(!empty($key) && !empty($val)){
			$crud->where($key,$val);
		}

		$crud->add_action('Pay for Order', '', 'admin/pay_for_order/purchase_id', 'fas fa-donate');

		$crud->unset_add();
		$crud->unset_edit();
		//$crud->unset_delete();

		$output = $crud->render();
		$output->title=$subject;
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}

	public function _order_paid($value,$row){
		$su=site_url();
		$purchase_id=$row->id;

		$sql="SELECT SUM(amount) as total, SUM(transaction_fee) as fee FROM payment where purchase_id='{$purchase_id}'";
		$q=$this->db->query($sql);
		$r=$q->row();
		$total=$r->total;
		$fee=round($r->fee,2);

		if(empty($total)){
			return "";
		}else{
			if(empty($fee)){
				return "<A HREF='{$su}admin/payment/$purchase_id'>\${$total}</A>";
			}else{
				return "<A HREF='{$su}admin/payment/$purchase_id'>\${$total} (\${$fee} fee)</A>";
			}
		}

  }

	public function _order_detail($value,$row){
		$su=site_url();
		$id=$row->id;
		return "<A HREF='{$su}admin/order_detail/$id'>Items</A>";
  }

	public function _purchase_point_of_sale($value,$row){
		return $this->accounting_parando->map_purchase_pos($value);
  }
	public function _payment_point_of_sale($value,$row){
		return $this->accounting_parando->map_payment_pos($value);
  }

	public function order_detail($purchase_id=null){
		$this->login_check(); $this->admin_check();
		$subject='Order Detail';
		$crud = new grocery_CRUD();
		$crud->set_subject($subject);
		$crud->set_table('purchase_item');
		$crud->columns('quantity','purchase_id','sequence','catalog_id','value','unit_price');
		$crud->display_as('purchase_id','Invoice Number');
		$crud->set_relation('purchase_id','purchase','{invoice_number}');
		$crud->set_relation('catalog_id','catalog','{description}');
		if(!empty($purchase_id)){
			$crud->where('purchase_id =',$purchase_id);
		}
		//$crud->unset_add();
		//$crud->unset_delete();
		//$crud->unset_edit();

		$output = $crud->render();
		$output->title=$subject;
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}


// ROSTER ROSTER ROSTER ROSTER ROSTER ROSTER ROSTER ROSTER ROSTER ROSTER ROSTER ROSTER ROSTER

	public function roster($event_id=null){

		$this->load->model('accounting_parando');

		if(empty($event_id)){
			$event_id=$this->model_parando->next_event_id();
		}

		$member_id=$this->login_check(); 
		$e=$this->model_parando->get_event($event_id);

//$this->die_error(__METHOD__, print_r($e,true));
		$organizer=$e['organizer'];
		
		if($organizer!=$member_id){
			$this->admin_check();
		}
		
		$subject='Rider';
		$crud = new grocery_CRUD();
		$crud->set_subject($subject);
		$crud->set_table('roster');
		$crud->where('event_id',$event_id);
		$crud->order_by('first_name','asc');
		$crud->order_by('last_name','asc');
		$crud->columns('member_id','membership','total_fee','paid','waiver_url','tracker_id','result','cert','elapsed_time','comment');
		$crud->add_fields('event_id','member_id','tracker_id','tandem','invoice_number','total_fee','result','elapsed_time','comment');
		// $crud->field_type('event_id', 'hidden', $event_id);
		$crud->edit_fields('event_id','member_id','tracker_id','total_fee','tandem','result','elapsed_time','comment');
		$crud->required_fields('event_id','member_id');
		$crud->set_relation('member_id','member','{first_name} {last_name}',null,'last_name');
		$crud->set_relation('event_id','event','{date} {distance}',null,'date');
		$crud->display_as('member_id','Name');
		$crud->display_as('waiver_url','Waiver');
		// $crud->field_type('tandem', 'true_false', array('No', 'Yes'));
		$crud->display_as('tandem','Tandem Partner');
		$crud->display_as('event_id','Event');
		$crud->callback_column('paid',array($this,'_callback_total_paid'));
		$crud->callback_column('total_fee',array($this,'_prepend_dollar_sign'));
        $crud->callback_column('waiver_url',[$this,'_callback_waiver_url']);
		$crud->display_as('total_fee','Fee');

		$crud->callback_column('tracker_id',array($this,'_callback_tracker_id'));
		$crud->callback_column('membership',array($this,'_callback_membership'));

		// $crud->field_type('member_id', 'readonly');
		$crud->field_type('created', 'readonly');
		$crud->field_type('last_change', 'readonly');

	$sql="SELECT * FROM tracker";
	$q=$this->db->query($sql);
	$tracker_select=array();
	foreach ($q->result_array() as $row){
		$tracker_select[$row['id']]=$row['tag'];      
	}

		$crud->add_action('Pay for Order', '', 'admin/pay_for_order/roster_id', 'fas fa-donate');

	$crud->field_type('tracker_id','dropdown',$tracker_select);

	$sql="SELECT * FROM event where id='{$event_id}'";
	$q=$this->db->query($sql);
	$event=$q->row_array();
	$title='Roster for: ' . $event['name'] . ' ' . $event['distance'] . 'K ' . $event['type'];

	$sql="SELECT member_id, result,
				CASE 
					WHEN member.expires='0000-00-00' THEN 'guest' 
					WHEN member.administrator=1 THEN 'administrator' 
					WHEN member.waive_fees=1 THEN 'volunteer' 
					WHEN member.expires<NOW() THEN 'terminated' 
					ELSE 'member' END as membership
				FROM roster,member where roster.event_id='{$event_id}' and member.id=roster.member_id";
	$q=$this->db->query($sql);
	$rider_list=$q->result_array();
	
	$total=0;
	$total_dues=0;
	$total_xfee=0;
	$sales=[];
	foreach($rider_list as &$rider){
		$member_id=$rider['member_id'];
		$membership=$rider['membership'];
		$rider['etop']=$etop=$this->accounting_parando->event_total_order_paid($event_id,$member_id);
		$pos=$etop['point_of_sale'];
		$xfee=$etop['total_xaction_fee'];
		$paid=$etop['total_paid'];
		$dues=$etop['dues_paid'];
		$total+=$paid-$dues;
		$total_xfee+=$xfee;
		$total_dues+=$dues;

		if(isset($sales[$pos]['total_paid'])){
			$sales[$pos]['total_paid']+=$paid-$dues;
			$sales[$pos]['total_xfee']+=$xfee;
			$sales[$pos]['dues_paid']+=$dues;
			$sales[$pos]['count']++;
		}else{
			$sales[$pos]['total_paid']=$paid-$dues;
			$sales[$pos]['total_xfee']=$xfee;
			$sales[$pos]['dues_paid']=$dues;
			$sales[$pos]['count']=1;
		}

		if(isset($sales[$pos]['by_membership'][$membership])){
			$sales[$pos]['by_membership'][$membership]['paid']+=$paid-$dues;
			$sales[$pos]['by_membership'][$membership]['xfee']+=$xfee;
			$sales[$pos]['by_membership'][$membership]['dues_paid']+=$dues;
			$sales[$pos]['by_membership'][$membership]['count']++;
		}else{
			$sales[$pos]['by_membership'][$membership]['paid']=$paid-$dues;
			$sales[$pos]['by_membership'][$membership]['xfee']=$xfee;
			$sales[$pos]['by_membership'][$membership]['dues_paid']=$dues;
			$sales[$pos]['by_membership'][$membership]['count']=1;
		}

		if(!isset($sales[$pos]['unpaid'])) $sales[$pos]['unpaid']=0;
		if($paid==0) $sales[$pos]['unpaid']++;

	}
	
	
	$accounting="<table><TR><TH></TH><TH>Receipts</TH><TH>Dues</TH><TH>Fees</TH></TR>";
	foreach($sales as $pos=>$detail){
		if(empty($pos)) $pos="Unknown";
		$accounting.="<TR><TD COLSPAN=3><B>$pos</B></TD></TR>";
		foreach($detail['by_membership'] as $membership=>$row){			
			$accounting.=
			  '<TR><TD>'. $membership . ' (' . $row['count'] . ')</TD><TD style="text-align: right;">$' . $row['paid'] . '</TD><TD style="text-align: right;">$' . $row['dues_paid'] . '</TD><TD style="text-align: right;">$' . $row['xfee'] . '</TD></TR>';
		}
		$accounting.='<TR><TD style="text-align: right;"><i>' . $detail['unpaid'] . ' Unpaid</i></TD><TD</TD><TD></TD></TR>';
		$accounting.='<TR><TD style="text-align: right;">Total:</TD><TD style="text-align: right;border-top: 2px solid black">$' . $detail['total_paid'] . '</TD><TD style="text-align: right;border-top: 2px solid black">$' . $detail['dues_paid'] . '</TD><TD style="text-align: right;border-top: 2px solid black">$' . $detail['total_xfee'] . '</TD></TR>';
	}
	$accounting.='<TR><TD style="text-align: right; background-color:#F0F0F0;">Grand Total:</TD><TD style="text-align: right;border-top: 2px solid black;  background-color:#F0F0F0;">$' . $total . '</TD><TD style="text-align: right;border-top: 2px solid black;  background-color:#F0F0F0;">$' . $total_dues . '</TD><TD style="text-align: right;border-top: 2px solid black;  background-color:#F0F0F0;">$' . $total_xfee . '</TD></TR>';
	$accounting.='</TABLE>';
	
	$lodging=$this->model_parando->get_lodging_for_event($event_id);
	if(count($lodging)>0){
	$accounting.="<br><br><table><TR><TH>Lodger</TH><TH>Paid</TH><TH>Accomodation</TH><TH>Date</TH></TR>";
	$total_lodging=0;
	$lodging_types=[];
	foreach($lodging as $lodger){
		extract($lodger);
		$first_last="$first_name $last_name";
		$total_lodging+=$total_price;
		if(empty($lodging_types{$value}{'count'})) $lodging_types{$value}{'count'}=1; else $lodging_types{$value}{'count'}++;
		if(empty($lodging_types{$value}{'paid'})) $lodging_types{$value}{'paid'}=$total_price; else $lodging_types{$value}{'paid'}+=$total_price;
		$row_array=[$first_last, $total_price, $value, $entered_on];
		$row_text=implode('</TD><TD>',$row_array);
		$accounting.="<TR><TD>$row_text</TD></TR>";
	}
	$accounting.='</TABLE>';
	$accounting.="<br><br><table><TR><TH>Accomodation</TH><TH>Count</TH><TH>Total Paid</TH></TR>";
	$total_count=0; $total_paid=0;
	foreach ($lodging_types as $t=>$d){
        $total_count+=$d{'count'}; $total_paid+=$d{'paid'};
		$row_array=[$t, $d{'count'}, $d{'paid'}];
		$row_text=implode('</TD><TD>',$row_array);
		$accounting.="<TR><TD>$row_text</TD></TR>";
	}
	$accounting.="<TR><TD style='text-align: right;border-top: 2px solid black'>TOTAL:</TD><TD style='text-align: right;border-top: 2px solid black'>$total_count</TD><TD 
	style='text-align: right;border-top: 2px solid black'>$total_paid</TD></TR>";
	$accounting.='</TABLE>';

	}



		$output = $crud->render();
		$output->title=$title;
		$output->total=$total;
		$output->accounting=$accounting;
		
		$output->next_event=$this->model_parando->next_event_id();
		$this->send_output($output);        
	}

private function _dup_tracker_check($value, $row){
	$sql="SELECT * FROM roster where tracker_id>0";
	$q=$this->db->query($sql);
	$tracker_assigned=array();
	foreach ($q->result_array() as $row){
		$tracker_assigned[$row['tracker_id']]=true;      
	}
}

public function _callback_tracker_id($value, $row){
	$member_id=$row->member_id;
	$sql="SELECT * FROM member where id='{$member_id}'";
	$q=$this->db->query($sql);
	$member=$q->row();
	$per=(!empty($member->tracker))?"Personal":"";
	return (!empty($value) && !empty($per))?"$value, $per":($value.$per);
}

public function _callback_membership($value, $row){
	$member_id=$row->member_id;
	$sql="SELECT CASE WHEN member.expires='0000-00-00' THEN 'guest' 
				WHEN member.administrator=1 THEN 'administrator' WHEN member.waive_fees=1 THEN 'volunteer' WHEN member.expires<NOW() THEN 'terminated'  ELSE 'member' END as membership
				 FROM member where id='{$member_id}'";
	$q=$this->db->query($sql);
	$m=$q->row();
	return $m->membership;
}


public function _callback_total_paid($value, $row){
	$event_id=$row->event_id;
	$member_id=$row->member_id;
	$opd=$this->accounting_parando->event_total_order_paid($event_id,$member_id);
	$pos=$opd['point_of_sale'];
	$mpos=$this->accounting_parando->map_purchase_pos($pos);
	return '$' . $opd['total_paid'] . ': ' . $mpos;
}

public function _prepend_dollar_sign($value, $row){
	return '$' . $value;
}

public function _callback_waiver_url($value, $row){
    if(empty($value)) return '';
	return "<A TITLE='Waiver PDF' HREF='$value'><i class='fas fa-file-pdf' style='color: blue;'></i></A>";
}

public function _callback_tracker_id_edit($tracker_id, $roster_id){

	$sql="SELECT * FROM roster where id='{$roster_id}'";
	$q=$this->db->query($sql);
	$roster=$q->row();
	$member_id=$roster->member_id;

	$sql="SELECT * FROM member where id='{$member_id}'";
	$q=$this->db->query($sql);
	$member=$q->row();
	$url=$member->tracker;

	if(!empty($member->tracker)){
		return <<<EOT
<A HREF="$url" TITLE="Personal Satellite Tracker">Personal</a>
EOT;
	}else{
		return <<<EOT
<input id="field-tracker_id" name="tracker_id" value="$value" class="numeric form-control" maxlength="11" type="text">
EOT;
	}
}



}
 
