<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.


class Control extends MY_Controller {


	const ARRIVAL_TABLE='arrival';
	
	private $controller_name;

	function __construct(){
		parent::__construct();

		$this->load->library('rwgps');
		$this->controller_name=strtolower(get_class($this));
	}
	
	public function checkin($event_id,$control_id,$rider_id){
		$arrival=$this->get_rider_arrival($event_id,$control_id,$rider_id);
		if($arrival===false){
			$time=gmdate('Y-m-d H:i:s');
			$arrival=compact('event_id','control_id','rider_id','time'); 
			$this->db->insert(self::ARRIVAL_TABLE,$arrival);
			$checkin_status="Rider ID $rider_id now checked in to control $control_id at $time UTC";
		}else{
			$then=$arrival['time'];
			$checkin_status="Rider ID $rider_id WAS ALREADY checked in to control $control_id at $then UTC";
		}
		
		$left_column="<DIV CLASS='narrower bordered text-center italic large-print'>$checkin_status</DIV>";
		
		
		$log=$this->get_all_arrivals($event_id,$control_id);
		$headers=['Rider','Time'];
		$left_column.="<DIV CLASS=roster><TABLE WIDTH=100%>";
		$left_column.='<TR><TH>' . implode('</TH><TH>', $headers) . '</TH></TR>';
		if(empty($log)){
			$left_column.="<TR><TD COLSPAN=" . count($headers) . ">NO ENTRIES</TD></TR>";
		}else{
			foreach ($log as $a) {
				$left_column.='<TR><TD>' . implode('</TD><TD>', $a) . '</TD></TR>';
			}
		}
		$left_column.="</TABLE></DIV>";
		
		$data=['title'=>'Checkins at Control $control_id', 'left_column'=>$left_column, 'right_column'=>''];
		$this->simple_view('info_one_column',['roster','schedule'],$data);
	
	}
		
	private function get_rider_arrival($event_id,$control_id,$rider_id){
		$q=$this->db->get_where(self::ARRIVAL_TABLE,compact('event_id','control_id','rider_id'));
		$n=$q->num_rows();
		if($n>1){
			$this->die_error(__METHOD__,"Rider $rider_id arrived at control $control_id multiple times (n=$n) "; 
		}elseif($n==1){
			return $q->row_array();
		}else{
			return false;
		}
	}

	private function get_all_arrivals($event_id,$control_id){
		$q=$this->db->get_where(self::ARRIVAL_TABLE,compact('event_id','control_id'));
		return $q->result_array();
	}
	
	
// PUT THIS IN A LIBRARY
	
	public function compute_info_code(&$controles,$event_id,$secret='xyzzy'){



		for($i=0; $i<count($controles); $i++){ 
			$p="$event_id $i";		
			$controles[$i]['info_code']=$this->make_info_hash($p,$secret);
		}

	}
	
	private $info_code_digits=4;
	
	private function make_info_hash($plaintext,$secret){
		if(empty($secret)) trigger_error("No secret.", E_USER_ERROR);
		$hash=strtoupper(substr(hash('sha256',"$plaintext-$secret"),0,$this->info_code_digits));
		return $hash;
	}




}

