<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

class Ebrevet extends my_Controller {

	public $minimum_app_version = '1.2.4';  // Published in future_event data, and used to 
											// reject checkins

	function __construct(){
		parent::__construct();

		$this->load->library('route_event');
		$this->load->library('rwgps');
		$this->load->library('controletimes');
		

		// $this->controller_name=strtolower(get_class($this));
	}
	
	public function checkin_status($event_id=null){
		$this->event_status($event_id);
	}
	

	////////////////////////////////////////////
	// Event Status
	//
	
	public function event_status($event_id=null){
	
			$params = ['tag' => 'login_session_data'];
			$this->load->library('randosession',$params);

	
        if($event_id===null) 
            $this->die_error(__METHOD__, "Missing parameter.");
            
        // Establish 'event','route','controles','warnings','cues','route_event'
        extract($this->route_event->compute_all_event_data($event_id));
        $event_name_dist=$route_event['event_name_dist'];
        $gravel_distance = $route_event['event_gravel_distance'];
        $is_gravel=$gravel_distance > 0 ? true : false;
        $ig=$is_gravel?'yes':'no';
        $roster=$this->model_parando->get_roster($event_id);
        $club_id=$route_event['club_acp_code'];
		$club = $this->model_parando->get_club_by_code($club_id);
		if(empty($club)){
			throw new Exception("ACP CODE $club_id NOT FOUND");
		}
		$epp_secret = $club['epp_secret'];
		
		$global_event_id = "$club_id-$event_id";


        $title="Control Check-Ins for $event_name_dist";
        $subject=$title;
        $form_body=<<<EOT
<div class='narrower'>
<H3>$event_name_dist</H3>
<h4>Control Check-In Status</h4>
<div class=vspace></div>
EOT;

        $headlist=[];
        $controle_num=0;
        foreach($controles as $c){
            $controle_num++;
            $cd_mi=round($c['d']/(route_event::m_per_km*route_event::km_per_mi),1) . ' mi';
            $cd_km=round($c['d']/(route_event::m_per_km),1) . ' km';
            $is_start=isset($c['start']);
            $is_finish=isset($c['finish']);
            $is_intermediate = !$is_start && !$is_finish;
            $number=($is_start)?"START":(($is_finish)?"FINISH":"Control $controle_num");
            $open=$c['open']->format('D-H:i');
            $name=$c['attributes']['name'];
            $style=$c['attributes']['style'];
            $is_untimed = $is_intermediate && ($is_gravel || ($style=='info' || $style=='photo'));
            
            
            $close= $is_untimed ? 'Untimed' : $c['close']->format('D-H:i');
            // $close= $c['close']->format('D-H:i');

            $headlist[]=compact('number','cd_mi','cd_km','is_start','is_finish','open','close','name','style');
        }
        
        $headlist=$this->flipDiagonally($headlist);
        foreach($headlist as $key=>$row){
        	$head_row[$key]= '<TH></TH><TH>' . implode('</TH><TH>',$row) . '</TH>';
        }
        $form_body.=<<<EOT
<div class='cktable'>
<TABLE WIDTH=100%>
EOT;
			$form_body.="<TR>" . $head_row['number'] . "<TH ROWSPAN=4>Finish</TH></TR>";
		
		
		$form_body.="<TR>" . $head_row['name']  . "</TR>";
		$form_body.="<TR>" . $head_row['cd_mi']. "</TR>";
		$form_body.="<TR>" . $head_row['close'] . "</TR>";

			
		$ncontroles=count($controles);
        foreach($roster as $r){    
        	if(strtolower($r->result) == 'dns') continue; 
            $first_name=$r->first_name;
            $last_name=$r->last_name;
            $member_id=$r->member_id;
            $rusa_id=$r->rusa_id;
            $rider="<A HREF='https://parando.org/results/member/$member_id'>$first_name $last_name</a>";
            
            $rider_id = $rusa_id; // assumption
            
            $checklist=[];
            for($i=0; $i<$ncontroles; $i++){
            	$open=$controles[$i]['open'];
            	$close=$controles[$i]['close'];
                $c=$this->model_parando->get_checkin($event_id,$member_id,$i); 

						$control_index = $i;
						$d = compact('control_index', 'global_event_id', 'rider_id');
						$checkin_code=$this->make_checkin_code($d,$epp_secret);


                if(null===$c){
                    if($this->isAdmin()){
                    	$checklist[]="<span title='$checkin_code'>-</span>";
                    	}else{
                    	$checklist[]="-";
                    	}
                }else{
                	extract($c);
                    $checkin_time->setTimezone($this->model_parando->get_local_time_zone());
//                    if(true || $i>0){
						$el="";
						if($preride){
							$el="<br><span class='green italic sans smaller'>Preride</span>";
						}elseif($checkin_time<$open) {
							$el="<br><span class='red italic sans smaller'>EARLY!</span>";
						}elseif($checkin_time>$close) {
							$el="<br><span class='red italic sans smaller'>LATE!</span>";
						}
						
				//		$control_index = $i;
				//		$d = compact('control_index', 'global_event_id', 'rider_id');
				//		$checkin_code=$this->make_checkin_code($d,$epp_secret);
						
//						if($this->isAdmin()){
//							$el .= "&nbsp; <i title='$checkin_code' class='fa fa-check-circle' style='color: #355681;'></i>";
//						}
						
						// && false===strpos(strtolower($comment), 'automatic check in')
						if(!empty($comment) ){
//							$el .= "&nbsp; <i title='$comment' class='fa fa-comment' //style='color: #355681;'></i>";
						if($comment!="Mass Start Brevet. Automatic Check In")
							$el .= "<br><div style='width: 70%; margin: auto; font-size: .62em; font-weight: bold; font-style: italic; background-color: #E0E0FF; border-radius: .66em; font-family: Arial, Helvetica, sans-serif;'>". wordwrap($comment, 20, '<br>', true) . "</div>";
						}
						
						$check_time_str = $checkin_time->format('H:i');
						
						if($this->isAdmin()) 
							$check_time_str = "<span title='$checkin_code'>$check_time_str</span>";
						
						$checklist[]=$check_time_str . $el;
//                     }else{
// 						if($checkin_time<$close)
// 							$checklist[]=$open->format('H:i');
//                     	else
// 							$checklist[]=$checkin_time->format('H:i') . "<br><span class='red italic sans smaller'>LATE!</span>";
//                     }
                }
            }
            $checkins=implode('</TD><TD>',$checklist);
            
            $finish_text="";
            if( $r->result == "FINISH" ){	
            	$elapsed_array=explode(':', $r->elapsed_time,3);
            	if(count($elapsed_array) == 3){
				    list($hh, $mm, $ss) = $elapsed_array;
            		$elapsed_hhmm =  "$hh$mm";
            		$d = compact('elapsed_hhmm', 'global_event_id', 'rider_id');
            		$finish_code=$this->make_finish_code($d,$epp_secret);

            		$finish_text = "${hh}h&nbsp;${mm}m";

            		if($this->isAdmin()){
            			$finish_text .= "<br>($finish_code)";
            		}
            	}
            }

            $form_body.="<TR><TD>$rider</TD><TD>$checkins</TD><TD>$finish_text</TD></TR>";
            

        }

        $form_body.=<<<EOT
</TABLE></DIV></DIV>
EOT;


        $body=$form_body;

		$view_data=compact(
			'title',
			'subject',
			'body'
		);
            
		$this->load->view('simple_header',array_merge($view_data,['page_styles'=>['table']]));
		$this->load->view('simple_body',$view_data);
		$this->load->view('simple_footer',$view_data);

    }
    
    private function isAdmin(){
      return $this->randosession->get_data('login_is_admin');
    }
    
	private function flipDiagonally($arr) {
		$out = array();
		foreach ($arr as $key => $subarr) {
			foreach ($subarr as $subkey => $subvalue) {
				$out[$subkey][$key] = $subvalue;
			}
		}
		return $out;
	}


	////////////////////////////////////////////////////////////
	// 
	// POST CHECKIN
	//
	
	
	public function post_checkin($param_acp_code=null){  // TODO use this parameter and don't assume the event ID is structured to include it? 
	
		try {
		
		
			if(empty($param_acp_code) || !is_numeric($param_acp_code)){
				$param_acp_code = $this->model_parando->club['acp_code'];
			}
		
			$club = $this->model_parando->get_club_by_code($param_acp_code);
		
			if(empty($club)){
				throw new Exception("ACP CODE $param_acp_code NOT FOUND");
			}
	
			$d = json_decode($this->security->xss_clean($this->input->raw_input_stream), true);
		
			// $notes=[];
			
			if(empty($d)) throw new Exception('NO DATA');
		
			if( empty($d['event_id']) || empty($d['app_version']) ||
				sizeof(explode('-', $d['event_id']))!=2 ||
				empty($d['rider_id']) ||
				empty($d['start_style']) ||
				empty($d['timestamp']) ||
				empty($d['signature']) ){
				 $event_id='';
				 $rider_id='';
				 throw new Exception('MISSING PARAMETER');
				 }
			
			
			// extract($d);
			
			$app_version=$d['app_version'];
			$event_id=$d['event_id'];
			$rider_id=$d['rider_id'];
			$timestamp=$d['timestamp'];
			$signature=$d['signature'];
			$start_style=$d['start_style'];
			
			if(false == $this->app_version_ok($app_version))
			  throw new Exception("UPDATE APP. SERVER NEEDS v{$this->minimum_app_version}");

			
			list($club_code,$club_event_id) = explode('-',$event_id);
			
			if($param_acp_code != $club_code) throw new Exception('INCONSISTENT PARAMETERS');
			
			// $club=$this->model_parando->get_club_by_code($club_code);
			// if(empty($club)) throw new Exception("BAD PARAMETER");
		
			$correct_signature=$this->make_signature($d,$club['epp_secret']);
			if($signature != $correct_signature) throw new Exception('INVALID');
								
			if(key_exists('control_index', $d)) $control_index=$d['control_index'];
// 			if(isset($control_index)){
// 				$notes[]="Check In at control $control_index";
// 			}
			
			// Verify rider is in roster 
			
			$rusa_id = $rider_id;  // KEY ASSUMPTION
		
			$magic_id = $this->model_parando->magic_rusa_id;
			if($rusa_id != $magic_id){
	
				$m=$this->model_parando->get_member_by_rusa_id($rusa_id);
				if(empty($m)) throw new Exception( "MEMBER NOT FOUND");
				$member_id=$m['id'];	  	
							$this->db->where([ 
					'member_id'=>$member_id, 
					'event_id'=>$club_event_id]);
	
				$q=$this->db->get('roster');  // Make sure this entry exists
				if($q->num_rows()==0){ 
					throw new Exception( 'NOT IN ROSTER');
				}
			}
			
			$preride = ($start_style == "preRide");
			
			if(key_exists('comment', $d) && !empty($d['comment'])) 
				$comment=$d['comment'];
			else
				$comment="";
			// if(!empty($comment)){ $notes[]="Comment: $comment"; }else{$comment='';}
			
			if(key_exists('outcome', $d)) $outcome=$d['outcome'];

			if(
				isset($outcome) && is_array($outcome) &&
				array_key_exists('overall_outcome', $outcome) &&
				array_key_exists('check_in_times', $outcome) &&
				is_array($outcome['check_in_times'])
			){
				$overall_outcome=$outcome['overall_outcome'];
				$check_in_times=$outcome['check_in_times'];
				// $notes[]="Outcome: $overall_outcome";
				// $notes[]="Check Ins: " . sizeof($check_in_times);
				$status = $this->update_checkin_database(
					$club_event_id, 
					$rider_id, 
					$overall_outcome, 
					$check_in_times,
					($preride)?1:0,
					$comment,
					$d);
				if ($status == 'OK' && 
					$overall_outcome=='finish' && 
					array_key_exists('finish_elapsed_time', $d)){
						$status = $this->record_finish($club_event_id, $rider_id, $d['finish_elapsed_time']);
					// if($status=='OK') $notes[]="Recorded FINISH in " . $d['finish_elapsed_time'];
				}
			}else{
				throw new Exception('NO OUTCOMES');
			}
		} catch (Exception $e){
			$status=$e->GetMessage();
		}
		$response=compact('status', 'event_id', 'rider_id');
		$this->emit_json($response);
	
	}
	
	private function record_finish($club_event_id, $rider_id, $elapsed_time){
		$rusa_id = $rider_id;  // KEY ASSUMPTION
		$magic_id = $this->model_parando->magic_rusa_id;
		if($rusa_id == $magic_id){
			return "OK";
		}else{
			$m=$this->model_parando->get_member_by_rusa_id($rusa_id);
			if(empty($m)) return "MEMBER NOT FOUND";
			$member_id=$m['id'];	  	
		
			$this->db->where([ 
				'member_id'=>$member_id, 
				'event_id'=>$club_event_id]);
		
			$q=$this->db->get('roster');  // Make sure this entry exists
			if($q->num_rows()==0){ 
				return 'NOT IN ROSTER';
			}else{
				$this->db->where([ 
				'member_id'=>$member_id, 
				'event_id'=>$club_event_id]);
				$this->db->set(['elapsed_time'=>$elapsed_time, 'result'=>'FINISH']);
				$rc=$this->db->update('roster');
				return $rc?"OK":"FINISH NOT SAVED";
			}
		}
	}
	
	private function app_version_ok($app_version){
	
			list ($a, $b, $c) = explode('.',$app_version);
			list ($ar, $br, $cr) = explode('.',$this->minimum_app_version);
			
			if((int)$a > (int)$ar) return true;
			if((int)$a < (int)$ar) return false;

			if((int)$b > (int)$br) return true;
			if((int)$b < (int)$br) return false;

			if((int)$c > (int)$cr) return true;
			if((int)$c < (int)$cr) return false;
			
			return true;
			
	}
	
	private function update_checkin_database($club_event_id, 
	$rider_id, $overall_outcome, $check_in_times,$preride,$comment='',$notes=[]){
	  if(!is_array($check_in_times)) return "CHECK_IN_TIMES NOT ARRAY";
	  foreach($check_in_times as $control_index=>$checkin_time){
	    // if(!is_array($ckin) || sizeof($ckin)!=2) return "MISFORMATTED CHECKIN: " . print_r($check_in_times,true);
	  	// list($control_index, $checkin_time) = $ckin;
	  	$rusa_id = $rider_id;  // KEY ASSUMPTION
	  	$m=$this->model_parando->get_member_by_rusa_id($rusa_id);
	  	if(empty($m)) return "MEMBER NOT FOUND";
	  	$member_id=$m['id'];	  	

	  	$this->db->where([ 
	  		'member_id'=>$member_id, 
	  		'event_id'=>$club_event_id,
	  		'control_number'=>$control_index
	  		]);
	  		
	  	$q=$this->db->get('checkin');  // See if there was a previous checkin
	  	if($q->num_rows()==0){  // if NOT, then insert this one
			$data=['member_id'=>$member_id, 
				'event_id'=>$club_event_id,
				'control_number'=>$control_index, 
				'time'=>$checkin_time, 
				'preride'=>$preride, 
				'comment'=>$comment,
				'notes'=>json_encode($notes)];

			$result=$this->db->set($data)->insert('checkin');
			

 		}  	

	  }
	  return "OK";
	}

	
	private function make_signature($d,$epp_secret){
		extract($d);
		$plaintext="$timestamp-$event_id-$rider_id-$epp_secret";
		$ciphertext=hash('sha256',$plaintext);
		return strtoupper(substr($ciphertext,0,8));
	}

	private function make_checkin_code($d,$epp_secret){
		return $this->word_text($d,$epp_secret);
		}

	private function old_make_checkin_code($d,$epp_secret){
		extract($d);
		$plaintext="$control_index-$global_event_id-$rider_id-$epp_secret";
		$ciphertext=$this->make_ciphertext($plaintext);
		$plain_code = strtoupper(substr($ciphertext,0,4));
		$xycode = str_replace(['0','1'],['X','Y'],$plain_code);
		return $xycode;

	}

private function make_finish_code($d,$epp_secret){
		extract($d);
		$plaintext="Finished:$elapsed_hhmm-$global_event_id-$rider_id-$epp_secret";
		$ciphertext=$this->make_ciphertext($plaintext);
		$plain_code = strtoupper(substr($ciphertext,0,4));
		$xycode = str_replace(['0','1'],['X','Y'],$plain_code);
		return $xycode;
	}
	
private function make_ciphertext($plaintext){
		$ciphertext=hash('sha256',$plaintext);
		return $ciphertext;
}
	
private function word_text($d,$epp_secret) {
		extract($d);
		$plaintext="$control_index-$global_event_id-$rider_id-$epp_secret";
    $ciphertext=$this->make_ciphertext($plaintext);
    $firstEight = substr($ciphertext,0,8);
    $cipherInt = hexdec($firstEight);
    $nounIndex = $cipherInt % count($this->nouns);
    $adjIndex = $this->my_intdiv($cipherInt, count($this->nouns)) % count($this->adjectives);
    return $this->adjectives[$adjIndex] . ' ' . $this->nouns[$nounIndex];
  }
  
  private function my_intdiv($a, $b){
    return ($a - $a % $b) / $b;
}
	

  public $adjectives = [
    'able',
    'absurd',
    'active',
    'afraid',
    'agreeable',
    'alert',
    'alive',
    'amused',
    'angry',
    'annoyed',
    'anxious',
    'arrogant',
    'ashamed',
    'attractive',
    'average',
    'awful',
    'bad',
    'beautiful',
    'better',
    'bewildered',
    'black',
    'bloody',
    'blue',
    'blue-eyed',
    'blushing',
    'bored',
    'brainy',
    'brave',
    'breakable',
    'bright',
    'busy',
    'calm',
    'careful',
    'cautious',
    'charming',
    'cheerful',
    'clean',
    'clear',
    'clever',
    'cloudy',
    'clumsy',
    'colorful',
    'combative',
    'comfortable',
    'concerned',
    'condemned',
    'confused',
    'cooperative',
    'courageous',
    'crazy',
    'creepy',
    'crowded',
    'cruel',
    'curious',
    'cute',
    'dangerous',
    'dark',
    'dead',
    'defeated',
    'defiant',
    'delightful',
    'depressed',
    'determined',
    'different',
    'difficult',
    'disgusted',
    'distinct',
    'disturbed',
    'dizzy',
    'doubtful',
    'drab',
    'dull',
    'eager',
    'easy',
    'elated',
    'elegant',
    'embarrassed',
    'enchanting',
    'encouraging',
    'energetic',
    'enthusiastic',
    'envious',
    'evil',
    'excited',
    'expensive',
    'exuberant',
    'fair',
    'faithful',
    'famous',
    'fancy',
    'fantastic',
    'fierce',
    'filthy',
    'fine',
    'foolish',
    'fragile',
    'frail',
    'frantic',
    'friendly',
    'frightened',
    'funny',
    'gentle',
    'gifted',
    'glamorous',
    'gleaming',
    'glorious',
    'good',
    'gorgeous',
    'graceful',
    'grieving',
    'grotesque',
    'grumpy',
    'handsome',
    'happy',
    'healthy',
    'helpful',
    'helpless',
    'hilarious',
    'homeless',
    'homely',
    'horrible',
    'hungry',
    'hurt',
    'ill',
    'important',
    'impossible',
    'inexpensive',
    'innocent',
    'inquisitive',
    'itchy',
    'jealous',
    'jittery',
    'jolly',
    'joyous',
    'juicy',
    'kind',
    'lackadaisical',
    'large',
    'lazy',
    'light',
    'lively',
    'lonely',
    'long',
    'lovely',
    'lucky',
    'magnificent',
    'misty',
    'modern',
    'motionless',
    'muddy',
    'mushy',
    'mysterious',
    'nasty',
    'naughty',
    'nervous',
    'nice',
    'nutty',
    'obedient',
    'obnoxious',
    'odd',
    'old-fashioned',
    'open',
    'outrageous',
    'outstanding',
    'panicky',
    'perfect',
    'plain',
    'pleasant',
    'poised',
    'poor',
    'powerful',
    'precious',
    'prickly',
    'proud',
    'puzzled',
    'quaint',
    'quizzical',
    'rambunctious',
    'real',
    'relieved',
    'repulsive',
    'rich',
    'scary',
    'selfish',
    'shiny',
    'shy',
    'silly',
    'sleepy',
    'smiling',
    'smoggy',
    'sore',
    'sparkling',
    'splendid',
    'spotless',
    'stormy',
    'strange',
    'stupid',
    'successful',
    'super',
    'talented',
    'tame',
    'tender',
    'tense',
    'terrible',
    'testy',
    'thankful',
    'thoughtful',
    'thoughtless',
    'tired',
    'tough',
    'troubled',
    'ugliest',
    'ugly',
    'uninterested',
    'unsightly',
    'unusual',
    'upset',
    'uptight',
    'vast',
    'victorious',
    'vivacious',
    'wandering',
    'weary',
    'wicked',
    'wide-eyed',
    'wild',
    'witty',
    'worrisome',
    'worried',
    'wrong',
    'zany',
    'zealous'
  ];

  public $nouns = [
    'apple', 'banana', 'cherry', 'dog', 'elephant', 'fish', 'grape', 'horse',
    'ice cream', 'jazz',
    'kangaroo', 'lemon', 'mango', 'noodle', 'orange', 'pear', 'quilt', 'rabbit',
    'sunset', 'turtle',
    'umbrella', 'violin', 'watermelon', 'xylophone', 'yellow', 'zebra',
    'airplane', 'ball', 'car', 'desk',
    'egg', 'flower', 'guitar', 'hat', 'island', 'jacket', 'kite', 'lamp',
    'moon', 'notebook',
    'ocean', 'piano', 'queen', 'rose', 'ship', 'train', 'umbrella', 'volcano',
    'wallet', 'xylophone',
    'yacht', 'zeppelin', 'apple', 'banana', 'cherry', 'dog', 'elephant', 'fish',
    'grape', 'horse', 'ice cream',
    'jazz', 'kangaroo', 'lemon', 'mango', 'noodle', 'orange', 'pear', 'quilt',
    'rabbit', 'sunset',
    'turtle', 'umbrella', 'violin', 'watermelon', 'xylophone', 'yellow',
    'zebra', 'airplane', 'ball', 'car',
    'desk', 'egg', 'flower', 'guitar', 'hat', 'island', 'jacket', 'kite',
    'lamp', 'moon',
    'notebook', 'ocean', 'piano', 'queen', 'rose', 'ship', 'train', 'umbrella',
    'volcano', 'wallet',
    'xylophone', 'yacht', 'zeppelin', 'apple', 'banana', 'cherry', 'dog',
    'elephant', 'fish', 'grape',
    'horse', 'ice cream', 'jazz', 'kangaroo', 'lemon', 'mango', 'noodle',
    'orange', 'pear', 'quilt',
    'rabbit', 'sunset', 'turtle', 'umbrella', 'violin', 'watermelon',
    'xylophone', 'yellow', 'zebra',
    'airplane', 'ball', 'car', 'desk', 'egg', 'flower', 'guitar', 'hat',
    'island', 'jacket',
    'kite', 'lamp', 'moon', 'notebook', 'ocean', 'piano', 'queen', 'rose',
    'ship', 'train',
    'umbrella', 'volcano', 'wallet', 'xylophone', 'yacht', 'zeppelin', 'apple',
    'banana', 'cherry', 'dog',
    'elephant', 'fish', 'grape', 'horse', 'ice cream', 'jazz', 'kangaroo',
    'lemon', 'mango', 'noodle',
    'orange', 'pear', 'quilt', 'rabbit', 'sunset', 'turtle', 'umbrella',
    'violin', 'watermelon', 'xylophone',
    'yellow', 'zebra', 'airplane', 'ball', 'car', 'desk', 'egg', 'flower',
    'guitar', 'hat', 'island',
    'jacket', 'kite', 'lamp', 'moon', 'notebook', 'ocean', 'piano', 'queen',
    'rose', 'ship',
    'train', 'umbrella', 'volcano', 'wallet', 'xylophone', 'yacht', 'zeppelin',
    'apple', 'banana', 'cherry',
    'dog', 'elephant', 'fish', 'grape', 'horse', 'ice cream', 'jazz',
    'kangaroo', 'lemon', 'mango',
    'noodle', 'orange', 'pear', 'quilt', 'rabbit', 'sunset', 'turtle',
    'umbrella', 'violin', 'watermelon',
    'xylophone', 'yellow', 'zebra', 'airplane', 'ball', 'car', 'desk', 'egg',
    'flower', 'guitar',
    'hat', 'island', 'jacket', 'kite', 'lamp', 'moon', 'notebook', 'ocean',
    'piano', 'queen',
    'rose', 'ship', 'train', 'umbrella', 'volcano', 'wallet', 'xylophone',
    'yacht', 'zeppelin'
    // Add more nouns as needed
  ];


	////////////////////////////////////////////////////////////
	// 
	// FUTURE EVENTS
	//
	
									// TODO actually use this parameter
	
	public function future_events($club_acp_code=null){  
		
		$event_errors=[];
		$event_list=[];
		
		$minimum_app_version = $this->minimum_app_version;
		
		
		if($this->model_parando->cache_enable) 	$this->output->cache($this->model_parando->cache_minutes);
		
		if(empty($club_acp_code) || !is_numeric($club_acp_code)){
			$club_acp_code = $this->model_parando->club['acp_code'];
		}
		
		$club = $this->model_parando->get_club_by_code($club_acp_code);
		
		if(empty($club)){
			$event_errors[]="Club ACP code $club_acp_code not found";
		}else{

			$club_id = $club['id'];

			$future_events=$this->model_parando->get_future_events_for_club($club_id);
			foreach($future_events as $es){
			
				extract($es);	//    $local_event_id, $event, $schedule	
				
				if(empty($event['map'])) continue;
				
				$event_status = $event['status'];
				if($event_status == 'hidden' || $event_status == 'canceled') continue;	
			
				if(empty($event['date']) || empty($event['start_time'])){
					$event_errors[]="No Date or Time for Event $local_event_id, skipped";
					continue; 
				}
			
				$mu=(isset($event['map']))?$event['map']:'';
				$route_id=$this->rwgps->extract_route_id($mu);

				if($route_id==null)  {
					$event_errors[]="No RWGPS map for Event $local_event_id, skipped";
					continue;  // will only consider RWGPS maps
				}
		
				$route=$this->rwgps->get_route($route_id);
				$event['has_rwgps_route']=true;
				$event['rwgps_url']=$this->rwgps->make_route_url($route_id);
				$event_info_url=site_url("info/event/$local_event_id");

				extract($event);

				$club_name=$club['name']; // $club array should be part of event
				$club_logo_url=$club['logo_url'];
				$region=$club['region'];
				$club_acp_code=$club['acp_code'];
				$club_website_url=$club['website_url'];
				$event_tzname=$club['tzname']; // Assumes clubs will always have events in their own timezone.
				$event_tz=new DateTimeZone( $event_tzname );
				
				$checkin_post_url = site_url("/ebrevet/post_checkin/$club_acp_code");

				$event_id="$club_acp_code-$local_event_id";

				$od=$this->model_parando->get_organizer($event);
				$organizer_name=$od['organizer_name'];
				$organizer_phone=$od['organizer_phone'];
					
				date_default_timezone_set('UTC'); 
				$utc_tz=new DateTimeZone('UTC');
				$route_updated_at=date("c",$route['updated_at']); 

				$event_datetime=@date_create($date.' '.$start_time, $event_tz);
				if(false == $event_datetime) continue;

				$event_datetime->SetTimezone($event_tz);
				$start_datetime_at_event = $event_datetime->format('Y-m-d H:i T');
				$event_datetime->SetTimezone($utc_tz);
				
				$start_datetime_utc = $event_datetime->format('c'); // Y-m-d H:i T';);
					
				$end_datetime=$schedule['cutoff_datetime'];
				$end_datetime->SetTimezone($utc_tz);
				$end_datetime_utc = $end_datetime->format('c'); // Y-m-d H:i T';);
				
				
				$start_time_window = [
				  'on_time' => $start_datetime_utc,
				  'start_style' => 'massStart'
				  ];
			
				list($controles, $controle_warnings) = $this->rwgps->extract_controles($route);
					
				$event_distance=$event['distance'];	
				$event_gravel_distance=$event['gravel_distance'];	
				$event_type=strtolower($event['sanction']);
				$route_event=compact('event_datetime', 'event_type', 'event_distance','event_gravel_distance','event_tz');
			
				$this->controletimes->compute_open_close($controles,$route_event);

				if(sizeof($controles)==0){
					$event_errors[]="No controls for Event $local_event_id, skipped";
					continue; 
				}

				if(sizeof($controle_warnings)>0){
					$event_errors[]="Errors or warnings in controls for Event $local_event_id, skipped";
					continue; 
				}
			

				$controls=[];
				foreach ($controles as $cdata){

					$a=$cdata['attributes'];

				//	$sif=(array_key_exists('start', $cdata))?'start':
				//		((array_key_exists('finish', $cdata))?'finish':'intermediate');

					if(empty($cdata['open'])||empty($cdata['close']))
	$this->die_error(__METHOD__, "Controls for event $local_event_id: " . print_r($controles, true));

					$openDatetime=$cdata['open'];
					$closeDatetime=$cdata['close'];
					$openDatetime->setTimezone($utc_tz);
					$closeDatetime->setTimezone($utc_tz);
				
					$reclass=$this->route_event;
				
					$cd_mi=round($cdata['d']/($reclass::m_per_km*$reclass::km_per_mi),1);
					$cd_km=round($cdata['d']/($reclass::m_per_km),1);
				
					$question=(array_key_exists('question', $a))?$a['question']:'';

					$controls[]=[
					'dist_mi'=>$cd_mi,
					// 'dist_km'=>$cd_km,
					'long'=>$cdata['x'],
					'lat'=>$cdata['y'],
					'name'=>$a['name'],
					'style'=>$a['style'],
					'address'=>$a['address'],
					'open'=>$openDatetime->format('c'),
					'close'=>$closeDatetime->format('c')
					// 'question'=>$question,
					// 'sif'=>$sif
		
					];
				
				}

				$published_edata=compact('event_id','name','distance','gravel_distance','sanction','type',
					'start_city','start_state','cue_version',
					// 'club_name',
					'club_acp_code',
					// 'region','club_logo_url',
					// 'club_website_url',
					'checkin_post_url','event_info_url',
					// 'event_tzname',
					'organizer_name','organizer_phone',
					'start_time_window',
					'controls'
					);

				$event_list[]=$published_edata;
			}
		}

		$this->emit_json(compact('minimum_app_version','event_list','event_errors'));
	}
	
	
	private function get_future_events($rusa_id){
		$m=$this->model_parando->get_member_by_rusa_id($rusa_id);
		if(empty($m)) return [];
		extract($m); $rider_info=compact('first_name','last_name');
		
		$event_list=$this->model_parando->get_events_for_rider($rusa_id);
		if(empty($event_list)) return [];

		return(compact('rider_info', 'event_list'));
	}
	
		
	private function emit_json($data){
		$j=json_encode($data);
		header("Content-Type: application/json; charset=UTF-8");
        echo $j;
        exit();
	}

}
