<?php
defined('BASEPATH') OR exit('No direct script access allowed');

 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

class Info extends MY_Controller {

	private $cache_enable;
	private $cache_minutes;

	public function __construct() {
		parent::__construct();
		$this->cache_enable=(!empty($this->model_parando->cache_enable));
		$this->cache_minutes=$this->model_parando->cache_enable;
		$this->load->library('controletimes');
	}
	
	public function index()
	{
		$this->home();
	}
	
	private $social_media_links_bot=<<<EOT
<a title="Facebook" href="https://www.facebook.com/groups/115936382421548/" class="fab fa-facebook" style="color: #3B5998;"></a>
&nbsp;
<a title="Blogger" href="http://parandonneurs.blogspot.com/" class="fab fa-blogger" style="color: #f4933e;"></a>
&nbsp;
EOT;

	private $social_media_links_top=<<<EOT
<a title="Facebook" href="https://www.facebook.com/groups/115936382421548/" class="fab fa-facebook" style="color: #FFFFFF; padding-left: 4px; padding-right: 4px;"></a>
<a title="Blogger" href="http://parandonneurs.blogspot.com/" class="fab fa-blogger" style="color: #FFFFFF; padding-left: 4px; padding-right: 4px;"></a>
&nbsp;
EOT;
	
	private function info_view($view='info_three_column',$page_styles=[],$body_data=[],$club=null){
	
        if($club===null) $club=$this->model_parando->default_club;
		$parking_disclaimer=$this->model_parando->get_paragraph('parking_disclaimer');
        
        $head_data['page_styles']=$page_styles;
		$head_data['topnav']=(!empty($body_data['topnav']))?$body_data['topnav']:$this->_topnav_home();
		
		$this_organization=$club_name=$club['name'];
		$head_data['header_title']=(!empty($body_data['header_title']))?$body_data['header_title']:$club_name;
		$head_data['header_subtitle']=(!empty($body_data['header_subtitle']))?$body_data['header_subtitle']:$club['slogan'];
		$head_data['this_organization']=$club_name;
		$head_data['title']=(!empty($body_data['tab_title']))?$body_data['tab_title']:strip_tags($head_data['header_title']);

		
		$club_logo_url=$club['logo_url'];
		$club_website_url=$club['website_url'];
		$head_data['header_logolink']="<A HREF='$club_website_url'><img src='$club_logo_url' alt='$club_name' border=0 width=50%></a>";

		$body_data=array_merge($body_data, ['this_organization'=>$club_name,'club_name'=>$club_name,'parking_disclaimer'=>$parking_disclaimer]);
		
		$foot_data['social_media_links']=$this->social_media_links_bot;

// <a href="https://groups.google.com/forum/#!forum/pa-randonneurs" class="fab fa-google" style="color: #5188ED;"></a>
// &nbsp;
		
		$this->load->view('info_header',$head_data); 
		$this->load->view($view,$body_data);
		$this->load->view('info_footer',$foot_data);
	}


  private function _topnav_home(){
		$topnav=
		"<a href=" . base_url('') . ">Home</a>" .
		"<a href=" . site_url('info/volunteer') . ">Volunteer!</a>" .
//		"<a href=" . base_url('member/join') . ">Join/Renew</a>" .
		"<a href=" . site_url('info/resources') . ">Resources</a>" .
		"<A HREF=" . site_url('store') . ">Store</a>" .
		"<A HREF=" . site_url('info/contact') . ">Contact</a>" .
		'<span class="float-right">&nbsp;' . $this->social_media_links_top . '&nbsp;&nbsp;<a href=' . site_url("login") . ' class="fas fa-cogs"></a></span>';

		return $topnav;
	}


	// Create HTML table of events

	private function schedule_table($rows,$full=false){

		$output="";
		
		if($full){
			$headings=['date','sanction','dist','cues','event','register_report','roster_results'];
			$heading_html="<TH style='text-align:center'>" . implode("</TH><TH style='text-align:center'>",$headings) . "</TH>";
			$num_cols=count($headings);
			$schedule_div = 'full-schedule';
		}else{
			$headings=['date','sanction','distance_infolink','register_report','roster_results'];
			$heading_html="<TH style='text-align:center'>" . implode("</TH><TH style='text-align:center'>",$headings) . "</TH>";
			$num_cols=count($headings);
			$schedule_div = 'schedule';
		}

	   if(count($rows) > 0){

			$output .= "<div class='$schedule_div'>";

			if($full){
				$this->load->model('results_parando');
				for($y=$this->results_parando->results_epoch; $y <=  $this->results_parando->y_now; $y++){
					$this->results_parando->event_calc($y);
					$this->results_parando->results_calc($y);
					$this->results_parando->summary_calc();
					$n_events[$y] = $this->results_parando->n_events;
					$total_finishers[$y] = $this->results_parando->total_finishers;
					$total_starters[$y] = $this->results_parando->total_starters;
					$total_percent[$y] = $this->results_parando->total_percent;
					$total_km[$y] = $this->results_parando->total_km;
				}
				$overall_total_events=number_format(array_sum($n_events));
				$overall_total_finishers=number_format(array_sum($total_finishers));
				$overall_total_km=number_format(array_sum($total_km));
				$overall_years=1 + $this->results_parando->y_now - $this->results_parando->results_epoch;

				$output .= "<h3 class=text-center>Years: $overall_years; Events Organized: $overall_total_events; Finished Rides: $overall_total_finishers; Total Kilometers: $overall_total_km</h3>";
			}
		
			$output .= "<table width=100% align=center>\n";


			$start_year=0;
			foreach($rows as $rownum=>$row) {
			
			
			  if($this->model_parando->event_status_q($row,'canceled') && 
			  $this->model_parando->event_status_q($row,'hidden')) continue;

			  $event_id=$row['id'];
			  $info=$row['info'];
			  $sanction=$row['sanction'];
		    $dist=($row['type']=='fleche')?"Fl&egrave;che":$this->model_parando->make_dist($row);
			  $distance_infolink=$this->model_parando->makeinfolink($row,$dist,false);
			  $cues=$this->model_parando->makecuelink($row);
			  $event=$this->model_parando->makeinfolink($row,$row['name'],false);
			  $schedule=$this->model_parando->event_schedule($row);
			  $date=$schedule['start_monthday_str'];
			  $event_datetime=$schedule['start_datetime'];

			  $register_report=$this->model_parando->makereglink($row);
			  $roster_results=$this->model_parando->makerosterlink($row); 
				if($this->model_parando->event_status_q($row,'canceled')){			  
				  $register_report = "<span class=grayed>Canceled</span>";
					$roster_results= '';
				}elseif($schedule['event_completed']){
				  $row['has_db_results']=$this->model_parando->dbResultsQ($event_id);
			  	$register_report=$this->model_parando->makelink($row['report'],"Report");
			  	$roster_results=$this->model_parando->makeResultsLink($row,"Results");
			  }elseif($this->model_parando->event_status_q($row,'suspended')){
				  $register_report = "<span class=grayed>Suspended</span>";
			  }elseif($schedule['event_begun']){
				  $register_report = "<span class=red><em>Underway!</em></span>";
			  }elseif($schedule['registration_closed']){
				  $register_report = "<span class=grayed>Register</span>";
			  }
			  
			  if($start_year != $schedule['start_year']){
			  	$start_year = $schedule['start_year'];
			  	if($full){
			  		$output .= "<TR><td ID='full-yearbreak' COLSPAN=$num_cols>$start_year</td></TR>";
						$detail_link = anchor(site_url("results/annual_summary/$start_year"),"Detailed Results for $start_year","TITLE='Detailed Results for $start_year'");
						$year_summary = sprintf('Events: %d; Total Finishers: %d; Total km: %d; %s', 
							$n_events[$start_year], $total_finishers[$start_year], $total_km[$start_year], $detail_link);
						$output .= "<TR><td ID='endyear' COLSPAN=$num_cols>$year_summary</td></TR>";
					}else $output .= "<TR><td ID='yearbreak' COLSPAN=$num_cols>$start_year</td></TR>";

					
			  }

			  $output .= "  <tr>\n";			
				foreach ($headings as $heading)
					$output .= '<td>' . $$heading . "</td>\n";
			  $output .= "  </tr>\n";

			}
			$output .= "</table></div>\n";
	  }
		return $output;
	}

	private function list_events($event_list,$filter=null,$value=true){

		$output="";
		$count=0;

		foreach ($event_list as $next_event){

			// Cancelled events don't appear in event lists
			if($this->model_parando->event_status_q($next_event,'canceled')) continue;

		  if($this->model_parando->eventDescribedQ($next_event)){
			  $schedule=$this->model_parando->event_schedule($next_event);

				if(empty($filter) || ($schedule[$filter]==$value)){

					$name=$next_event['name'];
					$distance=$this->model_parando->make_dist($next_event);
					$date=date_format(date_create($next_event['date']),"F j");
					$infolink=$this->model_parando->makeinfolink($next_event,'Ride Details',true,'#A0A0A0');
					$register=$this->model_parando->makereglink($next_event);
					$roster=$this->model_parando->makerosterlink($next_event,'Rider List'); 
	
					$output .= "<B>$date<br>$name $distance</b><br>";
					$output .= "$infolink<br>";
	
					if($this->model_parando->event_status_q($next_event,'canceled')){
						$output .= "<span class=dark-grayed>Event Canceled</span><br>\n";
					}elseif($schedule['event_completed']){
						$results=$this->model_parando->makeResultsLink($next_event,'Results',true);
						$report=$this->model_parando->makelink($next_event['report'],'Ride Report',true,'dark-grayed');
						$output .= "$results<br>\n";
						$output .= "$report<br>\n";
					}elseif($this->model_parando->event_status_q($next_event,'suspended')){
						$output .= "<span class=dark-grayed>Event Suspended</span><br>\n";
						$output .= "$roster<br>\n";
					}elseif($schedule['event_begun']){
						$output .= "<span class=red><em>Underway!</em></span><br>\n";
						$output .= "$roster<br>\n";
					}elseif($schedule['registration_closed']){
						$output .= "<span class=dark-grayed>Registration Closed</span><br>\n";
						$output .= "$roster<br>\n";
					}else{
						$output .= "$register<br>\n";
						$output .= "$roster<br>\n";
					}
	
					$output .= "<br>";
					$count++;

				}
		  }
		}

		return ['output'=>$output, 'count'=>$count];
	}
	
	private function interpolate_strings($s,$map){
			$vars=[];
			foreach ($map as $k => $v){
				if((is_string($v) || is_int($v) || is_float($v)) && !empty($k)){
					$tag = '{$' . $k . '}';
					$vars[$tag]=$v . '';
				}
			}
			$s_interp=strtr($s,$vars);
			//$this->die_error(__METHOD__, '<pre>'. print_r($vars,true) . '----\n' . print_r($s,true). '----\n' . print_r($s_interp,true) .'</pre>');
			return $s_interp; 
	}


	public function home()
	{

		$vurl=$this->model_parando->volunteer_url;

		$club=$this->model_parando->default_club;
		$this_organization=$club_name=$club['name'];


		$results_epoch=$this->model_parando->results_epoch;
		$tz=$this->model_parando->get_local_time_zone();
		$now = new DateTime("now",$tz);
		$m_now=$now->format('n');
		$y_now=$now->format('Y');
		$now_date = $now->format("Y-m-d");
		
		$data=[
			'this_organization'=>$this_organization,
			'results_epoch'=>$results_epoch,
			'y_now'=>$y_now,
			'm_now'=>$m_now
		];

		
		$data['event_archives']=anchor(site_url('info/event_history'),'Past Events',"TITLE='Full List of Past Events'");   // implode(', ',$a);

		$stmt = "SELECT * FROM event where date between   DATE_ADD('$now_date', INTERVAL -1 YEAR) and '$now_date' order by date desc"; 
		$query = $this->db->query($stmt);
		$completed = array_reverse($query->result_array());
		$data['schedule_table_completed']=$this->schedule_table($completed);

		$stmt = "SELECT * FROM event where date between   DATE_ADD('$now_date', INTERVAL -14 DAY)  and DATE_ADD('$now_date', INTERVAL 14 DAY) order by date desc, distance desc"; 
		$query = $this->db->query($stmt);
//		$data['num_last_n_events']=$query->num_rows();
		$last_next_events = $query->result_array();

		$events_underway=[];
		foreach ($last_next_events as $ei=>$e){
			$last_next_events[$ei]['has_db_results']=
				$this->model_parando->dbResultsQ($e['id']);
				
			$sched=$this->model_parando->event_schedule($e);
			$last_next_events[$ei]['schedule']=$sched;
			if (!empty($sched['event_underway']) && $sched['event_underway']) $events_underway[$e['id']]=$e;
			
		}
		$e=$this->list_events($last_next_events,'event_completed');
		$data['list_events_last_n_events']=$e['output'];
		$data['num_last_n_events']=$e['count'];
		
		$data['events_underway']=$events_underway;

		if(!empty($events_underway)){
			
		
			$events_underway_preds = 
				array_map(
				function($i){return "event_id = $i";},array_keys($events_underway));
			$events_underway_sql = implode(' OR ', $events_underway_preds);
		
			$stmt = "SELECT * FROM checkin where 
			 $events_underway_sql order by created desc, time desc limit 12"; 
			$query = $this->db->query($stmt);
			$recent_checkins = $query->result_array();
			$data['recent_checkins']=$recent_checkins;
		
		}else{
			$data['recent_checkins']=[];
		}

		$stmt = "SELECT * FROM event where '$now_date'<date order by date"; 
		$query = $this->db->query($stmt);
		$future = $query->result_array();
		$data['schedule_table_future']=$this->schedule_table($future);

		$e=$this->list_events($last_next_events,'event_completed',false);
		$data['list_events_next_n_events']=$e['output'];
		$data['num_next_n_events']=$e['count'];

		$stmt = "SELECT * FROM paragraph where location='announce' and hidden=0 order by sort_priority DESC, description desc"; 
		$query = $this->db->query($stmt);
		$a = $query->result_array();
		$announce_text="";
		foreach ($a as $f){
			$announce_text.=$f['text'];
		}
		$data['announce_text']=$announce_text;
		
		$volunteer_text =<<<EOT
<h3>Events In Need of Volunteers</h3>
<p>PA Randonneurs <em>always</em> needs volunteers to help out with brevets. Even with minimally supported 
brevets volunteers are needed to staff the start/finish zone and, occasionally, staff intermediate 
controls along the route. For more information about volunteering for $this_organization 
<A HREF='$vurl'>click here</a>.</p>
EOT;
// 
// 		$e=$this->model_parando->get_volunteers_needed_by_event();
// 
// 		if(!empty($e)){
// 			$volunteer_text.="<p>The following events have specific volunteering needs:</p>";
// 		}
// 			
// 		foreach ($e as $id => $ev){
// 			$volunteer_text .= '<h5>' . $ev['description'] . '</h4><P>Event Start: ' . $ev['datetime'] . '</p>';
// 			$volunteer_text .= '<ul>';
// 			foreach($ev['jobs'] as $j){
// 				$volunteer_text .= '<li>' . $j . '</li>';
// 			}
// 			$volunteer_text .= '</ul>';
// 			$url = base_url("info/contact/$id");
// 			$volunteer_text .= "<p><A HREF='$url'>Contact Organizer</a> to Volunteer.</p>";
// 		}		
// 		$data['volunteer_text']=(!empty($e))?$volunteer_text:"";
 		$data['volunteer_text']=$volunteer_text;

		// $data['honor_roll_title']=$this->model_parando->get_paragraph('honor_roll_title');
		$data['honor_roll_r12']=$this->model_parando->get_paragraph('honor_roll_r12');
		$data['honor_roll_sr']=$this->model_parando->get_paragraph('honor_roll_sr');
		$data['leaderboard']=$this->model_parando->get_paragraph('leaderboard');
		
		$this->info_view('info_home',['schedule','honor'],$data);
	}

	public function event_history(){

		if($this->cache_enable) $this->output->cache($this->cache_minutes);
		
		$org=$this->model_parando->default_club_name;
		$results_epoch=$this->model_parando->results_epoch;

		$title = "$org Past Events";
		$data=[	'title'=>$title,
				'this_organization'=>$org, 'body'=>''];

		$headings=['Date','Sanction','Distance','Event','Finishers'];
		$heading_html="<TH style='text-align:center'>" . implode("</TH><TH style='text-align:center'>",$headings) . "</TH>";
		$num_cols=count($headings);


		$data['body']=<<<EOT
			<div class='narrower'>
			<h2>$org Event History</h2>
EOT;

		$stmt = "SELECT * FROM event where date<now() order by date desc"; 
		$query = $this->db->query($stmt);
		$completed = ($query->result_array());
		$data['body'].=$this->schedule_table($completed,true);

		$this->load->view('simple_header',array_merge($data,['page_styles'=>['schedule']]));
		$this->load->view('simple_body',$data);
		$this->load->view('simple_footer',$data);

	}

	public function event_archive($year=null){
		$org=$this->model_parando->default_club_name;
		$results_epoch=$this->model_parando->results_epoch;
		$tz=$this->model_parando->get_local_time_zone();
		$now = new DateTime("now",$tz);
		$m_now=$now->format('n');
		$y_now=$now->format('Y');
		$now_date = $now->format("Y-m-d");
		if(empty($year) || $year<$results_epoch || $year>$y_now){$this->die_error(__METHOD__,"Year out of range [$results_epoch,$y_now]");}
		$this->load->model('results_parando');

		$this->results_parando->event_calc($year);
		$this->results_parando->results_calc($year);
		$this->results_parando->summary_calc();
		
		$n_events = $this->results_parando->n_events;
		$total_finishers = $this->results_parando->total_finishers;
		$total_starters = $this->results_parando->total_starters;
		$total_percent = $this->results_parando->total_percent;
		$total_km = $this->results_parando->total_km;

		$summary=<<<EOT
<TABLE CLASS="summary_results wide">
  <TR><TD>Events Organized:</TD><TD>$n_events</TD></TR>
  <TR><TD>Total Finishes:</TD><TD>$total_finishers</TD></TR>
  <TR><TD>Total Finished Km:</TD><TD>$total_km</TD></TR>
</TABLE>
EOT;

//  <TR><TD>Finish Percentage:</TD><TD>$total_percent%</TD></TR>
		
		$completed = array_values($this->results_parando->event_data);
		$annual_summary_url=base_url("results/annual_summary");
		$annual_summary_link = "<A ID=linkbutton HREF='$annual_summary_url/$year' TITLE='Detailed results for $year'>Detailed results For $year</a>";
		
		$left_column = "<h3>Event Schedule for $year</h3>";
		$left_column .= $this->schedule_table($completed);

		$honorees=$this->results_parando->honorees($this->results_parando->member_has['SR'],$year,'current');		
		$sr_txt=(empty($honorees))?"":"<h4>$year PA Super Randonneurs</h4><div>" . implode('<br>', $honorees) . "</div>"; 

		$honorees=$this->results_parando->honorees($this->results_parando->member_has['R12'],$year,'current');		
		$r12_txt=(empty($honorees))?"":"<h4>$year PA R-12</h4><div>" . implode('<br>', $honorees) . "</div>"; 
			
		$center_column = "<h3>$year Results Summary</h3>$summary<div>$annual_summary_link</div>";
		
		$right_column = "<h3>Honor Roll for $year</h3>";
		$right_column .= "<div class=honor>";
		$right_column .= $sr_txt;
		$right_column .= "<div class=vspace></div>";
		$right_column .= $r12_txt;
		$right_column .= "</div>";
		

		$data=[	'title'=>'Event Archive $year',
				'this_organization'=>$org,
				'y_now'=>$y_now,
				'left_column'=>$left_column,
				'center_column'=>$center_column,
				'right_column'=>$right_column];

		$this->info_view('info_three_column',['schedule','results','honor'],$data);
	}


	public function event($event_id=-1,$dist=200){

		$event_id=$event_id;

		if($event_id==-1){
			$event_id=$this->model_parando->next_event_id();
		}elseif(preg_match('/\d{4}-\d{1,2}-\d{1,2}/',$event_id)){
			$event_id = $this->model_parando->get_event_id_by_date_dist($event_id,$dist);
		}elseif(!preg_match('/\d+/',$event_id)){
			$this->die_error(__METHOD__,"Bad event id");
		}

		$event = $this->model_parando->get_event($event_id);
		if(empty($event)){
			$this->model_parando->die_error('Event Error', 'Event (' . $event_id . ') not found.');
		}
		
		$club=$event['club'];
		$this_organization=$club_name=$club['name'];
		$data=array('this_organization'=>$club_name, 'club_name'=>$club_name);
		$club_region=$club['region'];
		

		if($event['start_id']===null||$event['start_time']===null||$event['member_price']===null){
			$this->model_parando->die_error('Event Error', 'Detailed information for Event ID (' . $event_id . ') is not available.');
		}


		$this->load->model('accounting_parando');
		$late_fee=$data['late_fee']=$this->accounting_parando->get_product_price('late_fee');
		$data['guest_fee']=$this->accounting_parando->get_product_price('guest_fee');
		$data['guest_fee_special']=$this->accounting_parando->get_product_price('guest_fee_special');

    	$event['has_db_results']=$this->model_parando->dbResultsQ($event_id);
    	$event['id']=$event_id; // fix overwriting by start.id

		$data['event_id']=$event_id;


		
		$info_text=($event['sanction']=='ACP')?
			$this->model_parando->get_paragraph('general_info_acp'):
			$this->model_parando->get_paragraph('general_info_rusa');
		$info_text=$this->interpolate_strings($info_text,$data);
		$data['info_text']=$info_text;
		
		$data['night_text']=$this->model_parando->get_paragraph('night_warning');
		$schedule=$this->model_parando->event_schedule($event);
		$data=array_merge($data,$schedule);
		
		if(empty($event['special_announcement'])){
			$data['special_announcement']='';
		}else{
			$data['special_announcement']=interpolate_strings($event['special_announcement'],$event);
		}

		$data['distance']=$this->model_parando->make_distance($event);

		if($event['start_id']>0){
		$data['directions_link']='<A HREF="'. $event['directions_url'].'"><i class="fas fa-map-marker-alt" style="color: #355681;"></i></a>';
		$data['start_city']=$event['start_city'];
		$data['start_state']=$event['start_state'];
		$data['start_zip']=$event['start_zip'];
		}else{
			array_merge($data,array_fill_keys(['directions_link','start_city','start_state','start_zip'],""));
		}


		$data['results']=$this->model_parando->makeResultsLink($event,'Results');
		$data['report']=$this->model_parando->makelink($event['report'],'Ride Report');
		$data['info_url']=site_url("info/event/") . $event['date'] . '/' . $event['distance'];
		$data['event_home']="<A HREF='" . $data['info_url'] . "'>Event</A>";


		$payment_method_description=[
			'pay_online'=>'Pay now online with PayPal or Credit Card (lowest cost)',
			'pay_mail'=>'Pay by mail prior to the event',
			'pay_event'=>"Pay at the start of the event (\$$late_fee extra)"
			];

		$payment_methods=explode(',',$event['payment_methods']);
		if(empty($payment_methods) || empty($payment_methods[0])) $this->die_error(__METHOD__, 'No payment method defined for event.' );
		$options=[];
		foreach($payment_methods as $m){
			$options[$m]=$payment_method_description[$m];
		}

		if(empty($options['pay_event'])){
			$data['payment_options']="Pre-payment only. Day-of-event payment <em>is not</em> available for this event.";
		}else{
			$data['payment_options']="Prices include \$$late_fee discount for pre-payment."; 
		}
	
		if ($event['type']=='fleche'){
                $fleche_text=$this->model_parando->get_paragraph('fleche_info');
				$data['fleche_text']=$this->interpolate_strings($fleche_text,$data);
				$team_url=($this->model_parando->event_status_q($event,'canceled'))?null:site_url("info/teams/$event_id");
				$data['teams']=$this->model_parando->makelink($team_url,'Teams');
		}else{
// 				$data['cue']=$this->model_parando->makelink($event['cuesheet'],'Cue Sheet');
// 				$data['map']=$this->model_parando->makelink($event['map'],'Map and Profile');
				$routeinfo_url=(empty($event['cuesheet']) && 
					empty($event['map']) && 
					empty($event['cue_version']))?null:site_url("route/info/$event_id");
				$data['routeinfo']=$this->model_parando->makelink($routeinfo_url,'GPS/Cuesheet');
		}

		$data['roster']=$this->model_parando->makerosterlink($event,'Roster',true,true);
		$data['blog']='<A Title="PA Rando Blog" HREF="http://parandonneurs.blogspot.com/">Message Board</a>';

		$schedule=$this->model_parando->event_schedule($event);
		$data['schedule']=$schedule;
// 		$data['reg_cutoff_datetime']=$schedule['reg_cutoff_datetime'];
// 		$data['reg_cutoff_datetime_str2']=$schedule['reg_cutoff_datetime_str2'];

		$tz=$this->model_parando->tzname;
		date_default_timezone_set($tz);
		$start_datetime=$schedule['start_datetime'];
		$cutoff_datetime=$schedule['cutoff_datetime'];
		
		$sun_info=date_sun_info($start_datetime->getTimestamp(), 40.6884, -75.2207); // Easton, PA
		$data['sunrise_str'] = date('H:i', $sun_info['sunrise']);
		$data['sunset_str'] =  date('H:i', $sun_info['sunset']);
		$data['riding_at_night'] = 
			$sun_info['sunrise'] > $start_datetime->getTimestamp() || 
			$sun_info['sunset']  < $cutoff_datetime->getTimestamp();


		$jobs=$this->model_parando->event_volunteers_needed($event_id);
		if(!empty($jobs)){
			$volunteer_text  = "<h3>Volunteer</h3>";
			$volunteer_text .= "<p>This event needs volunteers for the following jobs:</p>";
			$volunteer_text .= '<ul>';
			foreach($jobs as $j){
				$volunteer_text .= '<li>' . $j['description'] . '</li>';
			}
			$volunteer_text .= '</ul>';
			$url = base_url("info/contact/$event_id");
			$volunteer_text .= "<p><A HREF='$url'>Contact Organizer</a> to Volunteer.</p>";
			$data['volunteer_text']=$volunteer_text;
		}		

		$event_name=$event['name'];
		$event_distance=$data['distance'];
		$start_date_str=$data['start_date_str'];

		
		if ($event['type']=='fleche')
            $data['header_title']="<div>The $club_region</div> <div>$event_name</div>";
        else
            $data['header_title']="<div>$event_name</div> <div>$event_distance</div>";

		$start_time_text=$data['start_time_str'] . (($event['type']=='fleche')?" Earliest Start Time":" Start Time");

		if($this->model_parando->event_status_q($event,['suspended','canceled'])){
			$s=($this->model_parando->event_status_q($event,'suspended'))?"SUSPENDED":"CANCELED";
			$data['header_subtitle']=<<<EOT
		   <font style="FONT-SIZE:1.2em" color="red">EVENT $s</font><br>
		   <font style="FONT-SIZE:1em" color="gray">$start_date_str</font><br>
		   <font style="FONT-SIZE:0.8em" color="gray">$start_time_text<br><br></font>
EOT;
		}else{
			$data['header_subtitle']=<<<EOT
		   <font style="FONT-SIZE:1.2em" color="#355681">$start_date_str</font><br>
		   <font style="FONT-SIZE:1em" color="#355681">$start_time_text<br><br></font>
EOT;
		}

if ($event['type']=='fleche'){
$data['topnav']= 
	$data['event_home'].
  $data['teams'].
  $data['blog'].
  $data['results'].
  $data['report'];
}else{
$data['topnav']=
	$data['event_home'].
  $data['routeinfo'].
  $data['roster'].
  $data['blog'].
  $data['results'].
  $data['report'];
}

	$course_history=$this->model_parando->event_course_history($event);
	$data['course_history']='';
  if(!empty($course_history) && !empty($course_history['events'])){

//$this->die_error(__METHOD__, print_r($course_history,true));

		$events=$course_history['events'];
		$data['course_history'].="<H4>Course History</H4><TABLE class=course-history width=80%><TR><TH>Date</TH><TH>Finishers</TH><TR>";
		foreach($events as $e){
			$date=$e['date']; $nf=$e['num_finishers']; $eid=$e['id'];
			$results_link=anchor($this->model_parando->event_results_url . "/$eid", $nf, 'TITLE="Detailed Results"');
			$data['course_history'].="<TR><TD>$date</TD><TD>$results_link</TD></TR>";
		}
		$data['course_history'].="</TABLE>";
		$cr=$course_history['course_record'];
		$crd=$cr['date']; $crn=$cr['names']; $crt=$cr['elapsed_time']; $crs=$cr['speed'];
		$data['course_history'].="<div class='text-center fine-print'><b>Course Record</b> $crd: $crn ($crt, $crs kph)</div>";

	}

        $event['description']=$this->interpolate_strings($event['description'],$data);
		$data['event']=$event;

		$this->info_view('info_event',['info_event'],$data);

	}

	public function teams($event_id){

		$org=$this->model_parando->organization;
		$data=[	
				'title'=>'Fleche Teams',
				'this_organization'=>$org
		];

		if(preg_match('/\d+/',$event_id)){
			$event = $this->model_parando->get_event($event_id);
			if(empty($event)){
				$this->die_error(__METHOD__, 'Event (' . $event_id . ') not found.');
			}elseif($event['type']!='fleche'){
				$this->die_error(__METHOD__, 'Not a team event.');
			}
		}else{
			$this->die_error(__METHOD__,"Bad event id");
		}

		$data['event']=$event;
		$data['event_id']=$event_id;

		$this->load->model('fleche_parando');
		$this->load->model('accounting_parando');
		$data['this_organization']=$this->model_parando->organization;

		$marker_invisible='<i class="fas fa-map-marker-alt" style="visibility: hidden;"></i>';
		$marker_personal='<i class="fas fa-map-marker-alt" style="color: #355681;"></i>';
		$marker_club='<i class="fas fa-map-marker-alt" style="color: #ff824c;"></i>';
		$club_tracker=$this->model_parando->get_club_trackers();
		$country_fullname=$this->model_parando->get_countries();
		$tandem_img="<IMG TITLE='Tandem' SRC='" . base_url('images/tandem.png') . "'>";
		$tandem_ivs="<IMG TITLE='Tandem' STYLE='visibility: hidden;' SRC='" . base_url('images/tandem.png') . "'>";


		if ($event['type']=='fleche'){
               $fleche_text=$this->model_parando->get_paragraph('fleche_info');
				$data['fleche_text']=$this->interpolate_strings($fleche_text,$data);
				$data['teams']=$this->model_parando->makelink(site_url("info/teams/$event_id"),'Teams');
		}else{
				$data['cue']=$this->model_parando->makelink($event['cuesheet'],'Cue Sheet');
				$data['map']=$this->model_parando->makelink($event['map'],'Map and Profile');
		}

    $event['has_db_results']=$this->model_parando->dbResultsQ($event_id);
		$data['roster']=$this->model_parando->makerosterlink($event,'Roster',true,true);
		$data['blog']='<A Title="PA Rando Blog" HREF="http://parandonneurs.blogspot.com/">Message Board</a>';
		$data['results']=$this->model_parando->makeResultsLink($event,'Results');
		$data['report']=$this->model_parando->makelink($event['report'],'Ride Report');
		$data['info_url']=site_url("info/event/") . $event['date'] . '/' . $event['distance'];
		$data['event_home']="<A HREF='" . $data['info_url'] . "'>Event</A>";

		$data['distance']=$this->model_parando->make_distance($event);
		$data['start_city']=(isset($event['start_city']))?$event['start_city']:'';
		$data['start_state']=(isset($event['start_state']))?$event['start_state']:'';
		$data=array_merge($data,$this->model_parando->event_schedule($event));

		$fleche_teams=$this->fleche_parando->get_fleche_teams_by_event_id((int)$event_id);

		$body="";
		foreach($fleche_teams as $team){
			$fleche_team_id=$team['id'];
			extract($this->fleche_parando->fleche_team_status($fleche_team_id));
// 'riders','route_approved','num_members','num_riders','num_paid','all_paid',
//					'too_many','too_few','just_right','good_to_go'

			$release_status=($release_received)?"OK":"Pending";
			$route_status=($route_approved)?"OK":"Under RBA Review";
			$membership_status=($too_few)?"Too Few ($num_members < 3 minimum)":(($too_many)?"Too Many ($num_members > 5 maximum)":"OK");
			$payment_status=(!$all_paid)?"Only $num_paid of $num_riders riders have paid":"OK";
			$team_status = ($good_to_go)?"<i class='fas fa-thumbs-up'></i> Good to Go!":"Final Approval: $release_status<br>Route: $route_status<br>Rider Count: $membership_status<br>Payment: $payment_status";

			$color=(true)?"":"style='color: #C0C0C0;'";
			$fleche_team_schedule=$this->fleche_parando->calc_fleche_team_schedule($event_id, $team['start_date'] . ' ' . $team['start_time']); 
			extract($team); extract($fleche_team_schedule);
			$c=$this->model_parando->members_by_id[$captain_id];
			$captain_name=$c['first_name'].'&nbsp;'.$c['last_name'];
			$contact_url=site_url("info/contact/fleche_team/$event_id/$fleche_team_id");

			$map_embed="";
			if(!empty($map)){
				if(preg_match("!ridewithgps\.com/routes/(\d+)!",$map,$m)){
					$rwgps_route=$m[1];
					$map_embed=<<<EOT
<div class=twocolumn>
<iframe src="https://ridewithgps.com/embeds?type=route&id=$rwgps_route&sampleGraph=true" style="width: 1px; min-width: 90%; height: 400px; border: none;" scrolling="no"></iframe>
</div>
EOT;
				}elseif(preg_match("/(\.jpg|\.jpeg|\.png)$/i",$map,$m)){
					$map_embed=<<<EOT
<div class=twocolumn>
<iframe src="$map" style="width: 1px; min-width: 90%; height: 600px; border: none;" scrolling="no"></iframe>
</div>
EOT;
				}
			}

			if(!empty($photo_url)){
				$photo_text="<div class=narrower><IMG TITLE='$name' SRC='$photo_url' WIDTH=100%></DIV>";
			}else{
				$photo_text="";
			}


			$body.=<<<EOT
<DIV class=fleche-team>
<h1>$name</h1>
<div class=row>
<div class=twocolumn>
<TABLE ID=team-summary Width=90%>
<TR><TD>Start Time</TD><TD>$start_dow_time_str</TD></TR>
<TR><TD>Start Location</TD><TD>$start_city, $start_state</TD></TR>
<TR><TD>Mission</TD><TD>$description</TD></TR>
<TR><TD>Status</TD><TD>$team_status</TD></TR>
<TR><TD>Route</TD><TD><A HREF='$map'><span $color><i class='fas fa-map-marker-alt' $color></i> Map</span></A></TD></TR>
<TR><TD>Captain</TD><TD><A HREF=$contact_url>$captain_name</A> <A HREF=$contact_url><i class='fa fa-envelope'></A></TD></TR>
</TABLE>
</div>
$map_embed
</div>
EOT;

			$body.="<DIV class=roster><table width=90%>";
     	$body.="<TR><TH ID=firstcol></TH><TH>Name</TH><TH>Address</TH><TH ID=firstcol></TH></TR>";

			$i=0;
			foreach($riders as $row){
				$tracker_url=$row->tracker; // from member
				$club_tracker_id=$row->tracker_id; // from roster
				$is_captain=($row->member_id==$captain_id)?" (Captain)":"";

				if(!empty($club_tracker_id)){
					$url=$club_tracker['url'][$club_tracker_id];		   
					$tag=$club_tracker['tag'][$club_tracker_id];		   
					$tracker_link='<A HREF="' . $url . '" TITLE="Club Satellite Tracker ' . $tag . '">' . $marker_club . "</A>";
				}elseif(!empty($tracker_url)){		   
					$tracker_link="<A HREF=\"$tracker_url\" TITLE='Personal Satellite Tracker'>$marker_personal</A>";
				}else{
					$tracker_link=$marker_invisible;
				}
				$grayed = ($row->result == "DNS")?"STYLE='color:#d0d0d0'":"";
				$rusa_id=$row->rusa_id;
				$rusa_link=($row->rusa_id > 0) ? "<A $grayed HREF=https://rusa.org/cgi-bin/resultsearch_PF.pl?mid=$rusa_id>$rusa_id</a>":'N/A';
				$state=($row->m_country != "US")?$country_fullname[$row->m_country]:$row->m_state;
				
				$on_tandem=(!empty($row->tandem))?$tandem_img:"$tandem_ivs";

				$body.= "<TR $grayed>";
				$body.= '<TD ID=firstcol>' . $tracker_link . '</TD>';
				$body.= '<TD>' . $row->first_name . ' ' . $row->last_name . $is_captain . '</TD>';
				$body.= '<TD>' . $row->m_city . ', ' . $state . '</TD>';
				$body.= "<TD>" . $on_tandem . '</TD>';
				$body.= '</TR>';
				$i++;

			}
			$body.="</TABLE></DIV>$photo_text</DIV>";

		}

		$data['body']=$body;

		$data['teams']=$this->model_parando->makelink(site_url("info/teams/$event_id"),'Teams');
		$data['blog']='<A Title="PA Rando Blog" HREF="http://parandonneurs.blogspot.com/">Message Board</a>';
		$data['results']=$this->model_parando->makeResultsLink($event,'Results');
		$data['report']=$this->model_parando->makelink($event['report'],'Ride Report');

		$data['topnav']= 
			$data['event_home'].
		  $data['teams'].
		  $data['blog'].
		  $data['results'].
		  $data['report'];

		$data['event']=$event;
		$event_name=$event['name'];
		$event_distance=$data['distance'];
		$start_date_str=$data['start_date_str'];
		
		$data['header_title']=<<<EOT
     <div>$event_name</div>
     <div>$event_distance</div><div>Teams</div>
EOT;

		$start_time_text=$data['start_time_str'] . (($event['type']=='fleche')?" Earliest Start Time":" Start Time");
		$data['header_subtitle']=<<<EOT
     <font style="FONT-SIZE:1.2em" color="#355681">$start_date_str</font><br>
     <font style="FONT-SIZE:1em" color="#355681">$start_time_text<br><br></font>
EOT;

//		$data['header_subtitle']="Team Rosters";

		$this->info_view('info_fleche_teams',['form','roster','fleche'],$data);


	}


	public function tracker(){
		$org=$this->model_parando->default_club['name'];
		
		$stmt = "SELECT tag,url FROM tracker order by tag"; 
		$query = $this->db->query($stmt);
		$club = $query->result_array();
		
//		$stmt = "SELECT first_name,last_name,tracker FROM member where not tracker='' order by last_name,first_name"; 
//		$query = $this->db->query($stmt);
//		$personal = $query->result_array();
		
		$left_column = $this->model_parando->get_paragraph('tracker_info');
		
		$center_column = "<h3>$org Club SPOT Trackers</h3>";
		$center_column .= "<div class='clublinks'>";
		foreach ($club as $spot){
			$url=$spot['url'];
			$name=$spot['tag'];
			$center_column .= "<A href='$url'>$name</A> <BR>";
		}
		$center_column .= "</div><div class='trackerimg'>";
		$center_column .= "<img TITLE='SPOT Tracker' WIDTH=100% SRC='" . base_url('images/SpotTracker.jpg'). "'></div>";

//		$right_column = '<h3>Personal SPOT Trackers</h3>';
//		foreach ($personal as $spot){
//			$url=$spot['tracker'];
//			$name=$spot['first_name'].' '.$spot['last_name'];
//			$right_column .= "<A href='$url'>$name</A> <BR>";
//		}

		$data=[	'title'=>'Satellite Trackers',
				'left_column'=>$left_column,
				'right_column'=>$center_column];

		$this->info_view('info_two_column',['info_tracker'],$data);
	}

// 	public function oldresources(){
// 		
// 		$left_column = '<h3>Read These First</h3>';
// 		$left_column .= $this->model_parando->get_paragraph('read_these_first');
// 
// 		$center_column = '<h3>General Resources</h3>';
// 		$center_column .= $this->model_parando->get_paragraph('general_resources');
// 
// 		$right_column = '<h3>Useful Links</h3>';
// 		$right_column .= $this->model_parando->get_paragraph('useful_links');
// 		
// 
// 		$data=[	'title'=>'Rider Resources',
// 				'left_column'=>$left_column,
// 				'center_column'=>$center_column,
// 				'right_column'=>$right_column];
// 
// 
// 		$data['topnav']=$this->topnav_home();
// 		$this->info_view('info_three_column',[],$data);
// 	}

	public function resources(){
		$org=$this->model_parando->default_club['name'];
		
		$multi_column = '<h3>Read These First</h3>';
		$multi_column .= $this->model_parando->get_paragraph('read_these_first');

		$multi_column .= '<h3>General Resources</h3>';
		$multi_column .= $this->model_parando->get_paragraph('general_resources');

		$multi_column .= '<h3>Useful Links</h3>';
		$multi_column .= $this->model_parando->get_paragraph('useful_links');

		$multi_column .= "<h3>About $org</h3>";
		$multi_column .= $this->model_parando->get_paragraph('about_this_organization');
		

		$data=[	'title'=>'Rider Resources',
				'multi_column'=>$multi_column];

        $this->info_view('info_multi_column',[],$data);
	}

	public function volunteer(){
		$org=$this->model_parando->default_club['name'];
		
		$jobs = $this->model_parando->get_volunteer_job_descriptions();
		
		$left_column = "<h3>Volunteering for $org</h3>";
		$left_column .= "<DIV CLASS='narrower'><IMG WIDTH = 100% SRC='" . base_url('images/tandem.jpg') . "'></DIV>";
		$left_column .= "<DIV CLASS='vspace'></DIV>";
		$left_column .= $this->model_parando->get_paragraph('volunteering_info');

		$center_column = "<h3>Volunteer Jobs</h3>";
		foreach ($jobs as $j){
			$description=$j['description'];
			$text=$j['text'];
			$center_column .= "<dt>$description</dt><dd>$text</dd>";
		}

		$right_column = '<h2>Events In Need of Volunteers</h2>';
		$e=$this->model_parando->get_volunteers_needed_by_event();
		
		
		foreach ($e as $id => $ev){
			$right_column .= '<h3>' . $ev['description'] . '</h3><P>Event Start: ' . $ev['datetime'] . '</p>';
			$right_column .= '<ul>';
			foreach($ev['jobs'] as $j){
				$right_column .= '<li>' . $j . '</li>';
			}
			$right_column .= '</ul>';
			$url = base_url("info/contact/$id");
			$right_column .= "<p><A HREF='$url'>Contact Organizer</a> to Volunteer.</p>";
		}		
		

		$data=[	'title'=>"Volunteering for $org",
				'left_column'=>$left_column,
				'center_column'=>$right_column,
				'right_column'=>$center_column];

		$this->info_view('info_three_column',[],$data);
	}
	


	private function _webmaster_data(){
		$club=$this->model_parando->default_club;
		$club_name=$this_organization=$club['name'];
		$club_logo_url=$club['logo_url'];
		$club_website_url=$club['website_url'];

		$general_contact_url=site_url("info/contact");
		
		$w=$this->model_parando->get_webmaster();
		$recipient_email=$w['webmaster_email'];
		$recipient_name=$w['webmaster_name'];
		$contact_url=site_url("info/contact/webmaster");
		$recipient_title='Webmaster';
		$event_description='Webmaster Inquiry';
		$other_form="For general inquiries concerning $club_name, use the 
			<A HREF='$general_contact_url' TITLE='Contact $club_name'>general contact</a> link. ";
		$other_form.="For inquiries concerning specific events, use 
		the <em>Ask the Organizer</em> link on the <em>Ride Details</em> page for that event, 
		accessible from the $club_name <A HREF='$club_website_url' TITLE='$club_name home page'>home page</a>.";
		
		$contact_text=<<<EOT
<p>If you have questions about the $club_name Web site, you can use this form to contact 
the $recipient_title, $recipient_name.</p> 
<p>$other_form</p>
EOT;
		return compact('contact_url','contact_text','this_organization',
			'event_description','recipient_email','recipient_name','recipient_title');
	}

	private function _member_data($member_id){
		$token=$this->model_parando->make_member_code($member_id);
		$contact_url=site_url("info/contact/member/$token");
		$general_contact_url=site_url("info/contact");

		$this_organization=$this->model_parando->default_club['name'];

		$member=$this->model_parando->get_member($member_id);
		if(empty($member)) exit; // trigger_error("No data for member ID='$member_id'", E_USER_ERROR);
		$recipient_email=$member['m_email'];
		$recipient_name=$member['first_name'] . ' ' . $member['last_name'];
		$recipient_title='';
		$home_url=site_url('');
		$event_description='Inquiry';
		
		$contact_text=<<<EOT
<p>You can use this form to contact $this_organization member $recipient_name.</p> 
EOT;
		return compact('contact_url','contact_text','this_organization',
			'event_description','recipient_email','recipient_name','recipient_title');
	}
	
	private function _default_contact_data(){

		$webmaster_contact_url=site_url("info/contact/webmaster");

		$this_club=$this->model_parando->default_club;
		$this_organization=$this_club['name'];
		$club_state=$this->model_parando->get_state_code($this_club['state_id']);
		$club_csz=$this_club['city']. ', ' . $club_state . ' ' . $this_club['zip'];
		$usps_array=[$this_organization,$this_club['street'],$club_csz];
		$usps_contact=implode('<br>',$usps_array);

            $contact_url=site_url("info/contact");
			$event_description=$this_organization;
			$rba=$this->model_parando->get_rba();
			$recipient_email=$rba['m_email'];
			$rba_first_name=$rba['first_name'];
			$rba_last_name=$rba['last_name'];
			$recipient_name="$rba_first_name $rba_last_name";
			$recipient_title='RBA';
		$event_description=$this_organization; $home_url=site_url('');
			$other_form="For inquiries concerning specific events, use the <em>Ask the Organizer</em> link 
on the <em>Ride Details</em> page for that event, accessible from 
the $this_organization <A HREF='$home_url' TITLE='$this_organization home page'>home page</a>. For bug reports or questions about this
web site, you can contact the <A HREF=$webmaster_contact_url>Webmaster</A>.";
		

		$contact_text=<<<EOT
<p>If you have questions about $event_description, you can use this form to contact the $recipient_title, $recipient_name.</p> 
<p>$other_form</p><p>Cards, letters, and packages for $this_organization can be shipped to: <div class='narrower italic text-center'>$usps_contact</div></p>
EOT;
		return compact('contact_url','contact_text','this_organization',
			'event_description','recipient_email','recipient_name','recipient_title');
	}


	private function _organizer_data($event_id){

		$webmaster_contact_url=site_url("info/contact/webmaster");

		if($event_id>0){
			$contact_url=site_url("info/contact/$event_id");
			$event=$this->model_parando->get_event($event_id);
			$club=$event['club'];
			$this_organization=$club['name'];
            $event_description='Question for Organizer';

            $event_description=$event['name'] . ' ' . $this->model_parando->make_distance($event);
			$odata=$this->model_parando->get_organizer($event);
			$recipient_name=$odata['organizer_name'];
			$recipient_email=$odata['organizer_email'];
			$recipient_title='Event Organizer';
			$contact_url=site_url("info/contact/$event_id");
			$general_contact_url=site_url("info/contact");
			$other_form="For general inquiries concerning $this_organization, use the <A HREF='$general_contact_url' TITLE='Contact $this_organization'>general contact</a> link.";
		}else{
            $this->die_error(__METHOD__, "Event not specified. Can't figure out who the contacts are.");
		}

		$contact_text=<<<EOT
<p>If you have questions about $event_description, you can use this form to contact the $recipient_title, $recipient_name.</p> 
<p>$other_form</p>
EOT;
		return compact('contact_url','contact_text','this_organization',
			'event_description','recipient_email','recipient_name','recipient_title');
	}

	private function _fleche_team_data($team_id){

 				$org=$this->model_parando->default_club['name'];
 				$this_organization="[[$org]]";

        $team_id=(int)$team_id;
		$this->load->model('fleche_parando');
		$team=$this->fleche_parando->get_fleche_team_by_id($team_id);
		if(empty($team)){$this->die_error(__METHOD__, "Invalid team.");}
		$team_name=$team['name'];
		$this_organization="Fleche Team $team_name";
		$event_id=$team['event_id'];
		$event=$this->model_parando->get_event($event_id);
		$event_distance=$this->model_parando->make_distance($event);
		$event_distance=strtr($event_distance,['&egrave;'=>'e']);
		$event_description=$event['name'] . ' ' . $event_distance;
		$event_date=$event['date'];
		$captain=$this->model_parando->members_by_id[$team['captain_id']];
		$recipient_name=$captain['first_name'] . ' ' . $captain['last_name'];
		$recipient_email=$captain['m_email'];
		$recipient_title="Captain of the Fleche Team $team_name";
		$contact_url=site_url("info/contact/fleche_team/$event_id/$team_id");
		$organizer_contact_url=site_url("info/contact/$event_id");
		$general_contact_url=site_url("info/contact");
		$other_form="For general info about the overall event, The $event_description held $event_date, please <A HREF=$organizer_contact_url>contact the event organizer</a>.";

		$contact_text=<<<EOT
<p>If you have questions about <em>$this_organization</em>, you can use this form to contact its Captain, $recipient_name.</p> 
<p>$other_form</p>
EOT;
		return compact('contact_url','contact_text','this_organization',
			'event_description','recipient_email','recipient_name','recipient_title','team_name');
	}

	
	public function contact($type='default',$event_id=null,$team_id=null){
	
        if(is_numeric($type)){  // Legacy parameters with "event" implied
            $event_id=$type;
            $type='event';
        }

		if('POST' == $this->input->method(TRUE) && 
			$this->input->post('submit') == 'Send'){
				$this->_contact_action($type,$event_id,$team_id);
		}else{
			$this->_contact_display($type,$event_id,$team_id);
		}
	}

	private function _contact_display($type,$event_id,$team_id){

		$this->load->library('randosession',['tag' => 'contact_session_data']);
		$this->load->library('form_validation');

		switch($type){
			case 'default':
				$data=$this->_default_contact_data();
				break;
			case 'webmaster':
				$data=$this->_webmaster_data();
				break;
			case 'fleche_team':
				$data=$this->_fleche_team_data($team_id);
				break;
			case 'member':
				$a=explode('-',$team_id);
				if(count($a)==3) $team_id=$a[0]; // if it was a member token, no security for display
				$data=$this->_member_data($team_id);
				break;
			case 'event':
				$data=$this->_organizer_data($event_id);
				break;
			default:
				$this->die_error(__METHOD__, "Unknown contact type: '$type'");
				break;
		}

		$this->randosession->init([]);

		$isBike=array();
		$not_bikes=array('fas fa-car','fas fa-truck','fas fa-plane','fas fa-rocket','fas fa-taxi','fas fa-space-shuttle');
		$vehicle_checkboxes = "";
		$one_bike=mt_rand(0,7);
		for($i=0;$i<8;$i++){
			if($i==$one_bike || mt_rand(0,1)==1){
				$isBike[$i]='Yes';
				$icon='fas fa-bicycle';
			}else{
				$isBike[$i]='No';
				$icon=$not_bikes[mt_rand(1,count($not_bikes))-1];
			}
			$vehicle_checkboxes .= "<input type='checkbox' name='v[]' value='v$i'><i class='$icon'></i> ";
		}
		$data['vehicle_checkboxes']=$vehicle_checkboxes;
		$this->randosession->set_data('isBike',$isBike);

		
//$this->die_error(__METHOD__, print_r($data,true));


		$this->info_view('info_contact',['form'],$data);
	}

	private function _contact_action($type,$event_id,$team_id){

		$this->load->library('randosession',['tag' => 'contact_session_data']);		
		$this->load->library('email');
		$this->load->library('form_validation');

 				$org=$this->model_parando->default_club['name'];
 				$this_organization="[[$org]]";

//if(empty($team_id)) $this->die_error(__METHOD__, "Member/Team ID not set");

		switch($type){
			case 'default':
				$data=$this->_default_contact_data();
				break;
			case 'webmaster':
				$data=$this->_webmaster_data();
				break;
			case 'fleche_team':
				$data=$this->_fleche_team_data($team_id);
				break;
			case 'member':
				$a=$this->model_parando->check_member_code($team_id);
				if(!is_array($a)) $this->die_error(__METHOD__, $a);
				if(count($a)!=3) $this->die_error(__METHOD__, "Malformed member token");
				list($member_id, $e, $hash)=$a;
				$data=$this->_member_data($member_id);
				break;
			case 'event':
				$data=$this->_organizer_data($event_id);
				break;
			default:
				$this->die_error(__METHOD__, "Unknown contact type: '$type'");
				break;
		}
		extract($data);

		$this->form_validation->set_rules('email','Email Address', 'trim|required|valid_email');
		$this->form_validation->set_rules('name','Full Name', 'trim|required|regex_match[/^([a-zA-Z0-9]+ ?)+?$/]|min_length[6]|max_length[50]', array('regex_match'=>'Name must contain only letters, dashes, and single blanks'));
		$this->form_validation->set_rules('subject','Subject', 'trim|required|max_length[70]');
		$this->form_validation->set_rules('message','Message', 'trim|required|min_length[10]|max_length[1000]');
		$this->form_validation->set_rules('v','Bicycles', 'callback__bicycle_check');

		if($this->form_validation->run()==FALSE){
			$this->_contact_display($type,$event_id,$team_id);
		}else{
			$name=$this->input->post('name',true);
			$email=$this->input->post('email',true);
			$subject=$this->input->post('subject',true);
			$message=$this->input->post('message',true);
			$header=<<<EOT

Re: $event_description

Dear $recipient_name, $recipient_title:


EOT;

			$footer=<<<EOT


--
$name


-------------------------------------------
This message was sent by $name using 
the Contact form on the 
$this_organization web site. 
EOT;


			$this->email->from($email, $name, $this->model_parando->postmaster_email);
			$this->email->to($recipient_email);
			$this->email->subject($subject);
			$this->email->message($header.$message.$footer);
			$this->email->send();
			$this->load->view('errors/html/info_general',
				array('title'=>'Message Sent', 
					'heading'=>'Message Sent',
					  'message'=>"Your message was successfully sent to $recipient_name, $recipient_title."));
			$this->randosession->init([]);

	  	}
	}

	public function _bicycle_check($str){
		$bike_error=false;
		for($i=0;$i<8;$i++){
			$vi=$this->input->post("v");
			$isChecked=(isset($vi) && false!==array_search("v$i",$vi))?'Yes':'No';
			$v[$i]=$isChecked;
			$isBike = $this->randosession->get_data('isBike');
			if($isBike[$i]!=$isChecked){
				$bike_error=true;
			}
		}
		if($bike_error){
			$this->form_validation->set_message('_bicycle_check', 
			'You did not click all the bicycles, or you clicked things that were not bicycles.');
			return false;
		}else{return true;}

	}

}
