<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.


class Qr extends MY_Controller {


	// private $controller_name;

	function __construct(){
		parent::__construct();

		$this->load->library('rwgps');
		$this->load->library('controletimes');
 		$this->load->library('route_event');
// 		$this->load->library('map');
// 		$params = ['tag' => 'login_session_data'];
// 		$this->load->library('randosession',$params);

		// $this->controller_name=strtolower(get_class($this));
	}
	
	// STATUS OF CHECKINS
	
	public function status($event_id=null){
	
        if($event_id===null) 
            $this->die_error(__METHOD__, "Missing parameter.");
            
        // Establish 'event','route','controles','warnings','cues','route_event'
        extract($this->route_event->compute_all_event_data($event_id));
        $event_name_dist=$route_event['event_name_dist'];
        $roster=$this->model_parando->get_roster($event_id);
        $club_id=$route_event['club_acp_code'];

        $title="Control Check-Ins for $event_name_dist";
        $subject=$title;
        $form_body=<<<EOT
<div class='narrower'>
<H3>$event_name_dist</H3>
<h4>Control Check-In Status</h4>
<div class=vspace></div>
EOT;

        $headlist=[];
        $controle_num=0;
        foreach($controles as $c){
            $controle_num++;
            $cd_mi=round($c['d']/(route_event::m_per_km*route_event::km_per_mi),1) . ' mi';
            $cd_km=round($c['d']/(route_event::m_per_km),1) . ' km';
            $is_start=isset($c['start']);
            $is_finish=isset($c['finish']);
            $number=($is_start)?"START":(($is_finish)?"FINISH":"Control $controle_num");
            $open=$c['open']->format('D-H:i');
            $close=$c['close']->format('D-H:i');
            $name=$c['attributes']['name'];
            $headlist[]=compact('number','cd_mi','cd_km','is_start','is_finish','open','close','name');
        }
        $headlist=$this->flipDiagonally($headlist);
        foreach($headlist as $key=>$row){
        	$head_row[$key]= '<TR><TH></TH><TH>' . implode('</TH><TH>',$row) . '</TH></TR>';
        }
        $form_body.=<<<EOT
<div class='cktable'>
<TABLE WIDTH=100%>
EOT;

		$form_body.=$head_row['number'];
		$form_body.=$head_row['name'];
		$form_body.=$head_row['cd_mi'];
		$form_body.=$head_row['close'];

		$ncontroles=count($controles);
        foreach($roster as $r){    
            $first_name=$r->first_name;
            $last_name=$r->last_name;
            $member_id=$r->member_id;
            $rusa_id=$r->rusa_id;
            $rider="$first_name $last_name";
            $checklist=[];
            for($i=0; $i<$ncontroles; $i++){
            	$open=$controles[$i]['open'];
            	$close=$controles[$i]['close'];
                $checkin_datetime=$this->model_parando->get_checkin_datetime($event_id,$member_id,$i+1); 
                if(null===$checkin_datetime){
                    $checklist[]='-';
                }else{
                    $checkin_datetime->setTimezone($this->model_parando->get_local_time_zone());
                    if($i>0){
						$el="";
						if($i>0 && $checkin_datetime<$open) $el="<br><span class='red italic sans smaller'>EARLY!</span>";
						if($checkin_datetime>$close) $el="<br><span class='red italic sans smaller'>LATE!</span>";
						$checklist[]=$checkin_datetime->format('H:i') . $el;
                    }else{
						if($checkin_datetime<$close)
							$checklist[]=$open->format('H:i');
                    	else
							$checklist[]=$checkin_datetime->format('H:i') . "<br><span class='red italic sans smaller'>LATE!</span>";
                    }
                }
            }
            $checkins=implode('</TD><TD>',$checklist);
            $form_body.="<TR><TD>$rider</TD><TD>$checkins</TD></TR>";

        }

        $form_body.=<<<EOT
</TABLE></DIV></DIV>
EOT;


        $body=$form_body;

		$view_data=compact(
			'title',
			'subject',
			'body'
		);
            
		$this->load->view('simple_header',array_merge($view_data,['page_styles'=>['table']]));
		$this->load->view('simple_body',$view_data);
		$this->load->view('simple_footer',$view_data);

    }
    
	private function flipDiagonally($arr) {
		$out = array();
		foreach ($arr as $key => $subarr) {
			foreach ($subarr as $subkey => $subvalue) {
				$out[$subkey][$key] = $subvalue;
			}
		}
		return $out;
	}


	// QR CHECKIN QR CHECKIN QR CHECKIN QR CHECKIN QR CHECKIN QR CHECKIN QR CHECKIN 
	// QR CHECKIN QR CHECKIN QR CHECKIN QR CHECKIN QR CHECKIN QR CHECKIN QR CHECKIN 
	// QR CHECKIN QR CHECKIN QR CHECKIN QR CHECKIN QR CHECKIN QR CHECKIN QR CHECKIN 	
	
	private $qrck_action;
	
	public function ck($event_id=null,$control_number=null,$info_code=null,$rusa_id=null){
	
        if($event_id===null || $control_number===null || $info_code===null) 
            $this->die_error(__METHOD__, "Missing parameter.");
        
        // Establish 'event','route','controles','warnings','cues','route_event'
		extract($this->route_event->compute_all_event_data($event_id));
		
		$ncontroles=count($controles);
		if($control_number<1 || $control_number>$ncontroles) 
            $this->die_error(__METHOD__, "Control $control_number does not exist for this event.");
		
		if($controles[$control_number-1]['info_code']!==$info_code) 
            $this->die_error(__METHOD__, "Invalid parameter.");
        
        // URL of this method
        $this->qrck_action=site_url(strtolower(str_replace('::','/',__METHOD__))) . "/$event_id/$control_number/$info_code";	
				
		// Rider Identification
        if($rusa_id===null) $rusa_id=$this->input->post('rusa_id');
        if($rusa_id===null) $rusa_id=$this->get_qrchk_rusa_id_cookie();
        if($rusa_id===null) {
            $view_data=$this->identify_rider($route_event,$controles,$control_number);
        }else{
        
            $this->load->library('rusa');
            $m=$this->rusa->get_member($rusa_id);
            if($m===null) 
                $this->die_error(__METHOD__, "Invalid RUSA ID.");
                
            $member_id=$m['id'];
            
            // Did rider already check in? 
            $checkin_datetime=$this->model_parando->get_checkin_datetime($event_id,$member_id,$control_number); 
            if(null===$checkin_datetime){ // NO
            
            	// Is the rider checking in NOW
            		$checkin_choice=$this->input->post('checkin');
            		if($checkin_choice=="CANCEL"){ // Don't want to check in -- wipe their cookie and start over.
            			$this->wipe_qrchk_rusa_id_cookie();
            			$view_data=$this->identify_rider($route_event,$controles,$control_number);
            		}elseif($checkin_choice=="CONFIRM"){
            			$this->record_checkin($route_event,$controles,$control_number,$m);
                		$view_data=$this->checkin_complete($route_event,$controles,$control_number,$m,$info_code);
            		}else{  // then give them a chance to confirm their checkin
                 		$view_data=$this->rider_confirmation($route_event,$controles,$control_number,$m); // Not yet checked in, must confirm
           			}
            
            
            }else{ // YES
            
            	// Do they want to UN_CHECKIN
            	$checkin_choice=$this->input->post('checkin');
            	if($checkin_choice=="DELETE"){ 
            		$this->model_parando->delete_checkin($event_id,$member_id,$control_number);
					$view_data=$this->rider_confirmation($route_event,$controles,$control_number,$m); // Not yet checked in, must confirm
				}else{
					$this->set_qrchk_rusa_id_cookie($rusa_id);
					$view_data=$this->checkin_complete($route_event,$controles,$control_number,$m,$info_code);
				}            
            }
        }

		$this->load->view('form_header',array_merge($view_data,['page_styles'=>['form']]));
		$this->load->view('form_simple',$view_data);
		$this->load->view('form_footer',$view_data);


	}
	
	private $rusa_id_cookie_name='qrck_rusa_id';

	private function set_qrchk_rusa_id_cookie($rusa_id){
                $parsed=parse_url(current_url());
                $domain=$parsed['host'];
                $cookie = [
                    'name'   => $this->rusa_id_cookie_name,
                    'value'  => $rusa_id,
                    'expire' => '86500000', // 1000 Days
                    'domain' => $domain,
                    'path'   => '/',
                    'prefix' => '',
                    'secure' => TRUE
                ];
                return $this->input->set_cookie($cookie);
    }

	private function wipe_qrchk_rusa_id_cookie(){
                $parsed=parse_url(current_url());
                $domain=$parsed['host'];
                $cookie = [
                    'name'   => $this->rusa_id_cookie_name,
                    'value'  => 0,
                    'expire' => '86500000', // 1000 Days
                    'domain' => $domain,
                    'path'   => '/',
                    'prefix' => '',
                    'secure' => TRUE
                ];
                return $this->input->set_cookie($cookie);
    }
    
    private function get_qrchk_rusa_id_cookie(){
    	return  $this->input->cookie($this->rusa_id_cookie_name);
    }
	
  // Identify Rider Form
  
    private function identify_rider($route_event,$controles,$control_number){
		$event_name_dist=$route_event['event_name_dist'];
		$form_subject = "Check Into Control $control_number for the $event_name_dist";
		$form_title = $form_subject;
		$form_action = $this->qrck_action;
 		$form_body=<<<EOT
<div class=form-group>
<label for="rusa_id"><b>RUSA Number</b></label>
<input type="text" placeholder="Enter your RUSA number" name="rusa_id" required>
</div>
EOT;

		$form_submit = '<button type="submit">Continue</button>';
	
		$data=compact(
			'form_title',
			'form_subject',
			'form_fineprint',
			'form_action',
			'form_body',
			'form_submit'
		);
	
		return $data; 
		
    }
    
    // Checkin confirmation
    
    private function rider_confirmation($route_event,$controles,$control_number,$rusa_m){
    
		// Get information about event and control
		$event_name_dist=$route_event['event_name_dist'];
		$club_name=$route_event['club_name'];
		$i=$control_number-1;
		$control_name=$controles[$i]['attributes']['name'];
		$control_address=$controles[$i]['attributes']['address'];
		$is_start=isset($controles[$i]['start']);
		$is_finish=isset($controles[$i]['finish']);

        // Time in bank
        $open=$controles[$i]['open'];
        $close=$controles[$i]['close'];
        $open_time_str = $open->format($this->controletimes->event_datetime_format);
        $close_time_str = $close->format($this->controletimes->event_datetime_format);
        $now = $route_event['now'];
        $now_str = $route_event['now_str'];
        $too_early=$now<$open;
        $too_late=$now>$close;
        $control_open=!$too_early && !$too_late;
        $control_state=($control_open)?"OPEN":"<span class=red>CLOSED</span>";
        $interval_format='%a days, %H hrs, %i min';
        if($too_early){
            $interval=$now->diff($open);
            $interval_str=$interval->format($interval_format);
            $inbank="will OPEN $interval_str from now";
        }elseif($control_open){
            $interval=$now->diff($close);
            $interval_str=$interval->format($interval_format);
            $inbank="will CLOSE $interval_str from now";
        }elseif($too_late){
            $interval=$close->diff($now);
            $interval_str=$interval->format($interval_format);
            $inbank="has been CLOSED since $interval_str ago";
        }else{
            $this->die_error(__METHOD__, "This can't happen.");
        }
           
        extract($rusa_m);
        $state=($country != "US")?($state . ' (' . $country_fullname[$country] . ')'):$state;

 		$form_subject = "Checkin Confirmation";
		$form_title = $form_subject;
		$form_action = $this->qrck_action . "/$rusa_id";
 		$form_body=<<<EOT
<div class=narrower>
<h4>Control $control_number</h4>
<DIV class='indent tt bordered'>
$control_name<br/>
$control_address<br/>
</DIV>
<div class='narrower text-center'>
<P>This control is now $control_state. It $inbank.</P>
<P><i>Press CONFIRM CHECK IN to register your arrival at control $control_number.</i></P>
<DIV class='bordered large-print sans'>
$first_name $last_name<br/>
RUSA: $rusa_id<br/>
</DIV>
</div>
</div>
EOT;

        $cancel_url=$this->qrck_action . "?CANCEL";
        
        $form_fineprint=<<<EOT
EOT;

		$form_submit =<<<EOT
<button type='submit' style='padding-top: 4em; padding-bottom: 4em' name='checkin' value='CONFIRM'><span class='large-print'>CONFIRM CHECK IN</span></button>
<button style='width: 20%; margin-left:40%; margin-right: 40%; padding-top: 1em; padding-bottom: 1em' type='submit' name='checkin' value='CANCEL'>CANCEL</button>
EOT;
	
		$data=compact(
			'form_title',
			'form_subject',
			'form_fineprint',
			'form_action',
			'form_body',
			'form_submit'
		);
	
		return $data;
    
    
    }
    
    private function record_checkin($route_event,$controles,$control_number,$rusa_m){
        $rusa_id=$rusa_m['rusa_id'];
        $event_id=$route_event['event_id'];
        $this->set_qrchk_rusa_id_cookie($rusa_id);
        $this->model_parando->put_checkin_datetime($event_id,$member_id,$control_number);
        // record checkin in database
    
    }

    private function checkin_complete($route_event,$controles,$control_number,$rusa_m,$info_code){

		// Get information about event and control
		$event_name_dist=$route_event['event_name_dist'];
		$club_name=$route_event['club_name'];
		$control_name=$controles[$control_number-1]['attributes']['name'];
		$control_address=$controles[$control_number-1]['attributes']['address'];
		$is_start=isset($controles[$control_number-1]['start']);
		$is_finish=isset($controles[$control_number-1]['finish']);
		$event_id=$route_event['event_id'];
		$rusa_id=$rusa_m['rusa_id'];

        $checkin_datetime=$this->model_parando->get_checkin_datetime($event_id,$member_id,$control_number);
        if(empty($checkin_datetime)) $this->die_error(__METHOD__,"This can't happen! Checkin completed,
         but somehow the database says RUSA ID $rusa_id is not checked in to event $event_id at control $control_number.");
		$tz=$this->model_parando->get_local_time_zone(); // Checkins are stored as UTC
		$checkin_datetime->setTimezone($tz);
		$checkin_time_txt=$checkin_datetime->format('Y-m-d H:i:s T');
		$checkin_hhmm=$checkin_datetime->format('H:i');

		
		if($is_start){
            $text=<<<EOT
<H3>Bonne Route</H3>
<P>You have successfully <b>started</b> the <i>$club_name $event_name_dist</i>.</P>
EOT;
		}elseif($is_finish){
            $text=<<<EOT
<H3>Congratulations!</H3>
<P>You have successfully <b>finished</b> the <i>$club_name $event_name_dist</i> at $checkin_time_txt.</P>
EOT;
		}else{
            $text=<<<EOT
<H4>Check In OK</H4>
<P>You have successfully checked into control $control_number ($control_name, $control_address) for the <i>$club_name $event_name_dist</i> at $checkin_time_txt.</P>
EOT;
		}
		
        extract($rusa_m);
        $state=($country != "US")?($state . ' (' . $country_fullname[$country] . ')'):$state;

       $text.=<<<EOT
<DIV class='text-center large-print sans'>
<IMG SRC='https://parando.org/images/task-done-outline/256x256.png' WIDTH=30%><br/>
$first_name $last_name<br/>
RUSA: $rusa_id<br/>
</DIV>
EOT;
        if(!$is_start) $text.="<div class=vspace></div><div class='half-width text-center bordered sans'>You should record on your brevet card your checkin time (<b>$checkin_hhmm</b>) and the info code (<b>$info_code</b>) for this control.</div>";
         
 		$form_subject = "Control Check-in Complete";
		$form_title = $event_name_dist;
		$form_action = $this->qrck_action . "/$rusa_id";
 		$form_body=$text;
		$form_submit =<<<EOT
<button style='width: 20%; margin-left:40%; margin-right: 40%; padding-top: 1em; padding-bottom: 1em' type='submit' name='checkin' value='DELETE'>UNDO CHECKIN</button>
EOT;
		
		$data=compact(
			'form_title',
			'form_subject',
			'form_action',
			'form_body',
			'form_submit'
		);

		
		
		return $data;

    }
 }
 ?>
