<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.


class Route extends MY_Controller {

	// private $controller_name;

	function __construct(){
		parent::__construct();

//		$this->load->library('wizard');
		$this->load->library('route_event');
		$this->load->library('rwgps');
		$this->load->library('controletimes');
		$this->load->library('map');
		$params = ['tag' => 'login_session_data'];
		$this->load->library('randosession',$params);

		// $this->controller_name=strtolower(get_class($this));
	}


    //////////////////////////////////////////////////////////////////////////
    // PUBLIC CONTROLLER FUNCTIONS

    // EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT 
    // EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT 
    // EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT 

    // General PA Rando Event Route Information page and/or Cue Wizard Interface
  
    public function info($event_id) {$this->event($event_id,'info');}
    public function wizard($event_id) {$this->event($event_id,'wizard');}
   public function map($event_id) {$this->event($event_id,'map');}

 	public function event($event_id, $view=null){
		
        // Establish 'event','route','controles','warnings','cues','route_event'
		extract($this->route_event->compute_all_event_data($event_id));
		
		// And view the result
		
		if($view===null)$view=$this->input->post('view');
		
		if(empty($view) || $view=='info'){
			$this->view_info($route_event, $controles, $warnings);
		}elseif($view=='controls'){
			$this->view_controls($route_event, $controles, $warnings);		
		}else{
            // ALL other views require admin or organizer of THIS event  
            $this->randosession->login_check($event['organizer']); 
            $this->{'view_'.$view}($route_event, $controles, $warnings);
		}
	}

    // DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD
    // DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD
    // DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD
    
	public function recache($event_id){
		list($event, $route) = $this->route_event->get_event_and_route($event_id);
        $this->randosession->login_check($event['organizer']); 
		$route_id=$route['id'];
		if($this->rwgps->is_good_route_id($route_id)){
			$result=$this->rwgps->download_route_data($route_id);
			if($result!==true)
				$this->die_error(__METHOD__, $result);
			else
				redirect(site_url($this->class_name . "/wizard/$event_id"));
		}else{
			$this->die_error(__METHOD__,"Invalid parameters.");
		}
	}
	

    // PUBLISH PUBLISH PUBLISH PUBLISH PUBLISH PUBLISH 
    // PUBLISH PUBLISH PUBLISH PUBLISH PUBLISH PUBLISH 
    // PUBLISH PUBLISH PUBLISH PUBLISH PUBLISH PUBLISH 

 	// BUG????? Does this publish cards? 
 	
 	// TODO Publish CARDS and QR CODE Sheets and ROUTE FILES  -- all docs should be static
	
   public function publish_cuesheet($event_id){

        // Establish 'event','route','controles','warnings','cues','route_event'
		extract($this->route_event->compute_all_event_data($event_id));
		
		// And die if there are any.
		$this->die_view_warnings($warnings);
		
		$size='letter';
		$orientation='P';
		$params=['event'=>$route_event, 'orientation'=>$orientation, 'size'=>$size];
		$this->load->library('cuesheet', $params);  

		$route_event['cue_version']=$cue_version=1+$route_event['cue_version'];	
		$route_event['cue_version_str']="$cue_version";
		
		$orientation='P';
		$cue_data_P=$this->generate_pdf_cuesheet($route_event, $cues, $controles, $orientation, $size);

		$orientation='L';
		$cue_data_L=$this->generate_pdf_cuesheet($route_event, $cues, $controles, $orientation, $size);

		$cue_data_C=$this->generate_csv_cuesheet($route_event, $cues, $controles);

		
		$this->model_parando->set_event_cuesheet_version($event_id,$cue_version);
		
		// Publishing success page

		$event_name_dist=$route_event['event_name_dist'];
		$cue_url_L=$cue_data_L['cue_url'];
		$cue_url_P=$cue_data_P['cue_url'];
		$cue_url_C=$cue_data_C['cue_url'];
		$wizard_url=site_url(strtolower(get_class($this))."/wizard/$event_id");
		$info_url=site_url(strtolower(get_class($this))."/info/$event_id");
		$event_url=site_url("info/event/$event_id");
		
		$left_column=<<<EOT
<H3>Cue Sheet Published</H3>
<p>Cue Sheets (version $cue_version) successfully published to event database 
for $event_name_dist.  Don't refresh or reverse or you might accidentally publish again. Just press one of the buttons below.</p>
<ul>
<li><A HREF="$cue_url_L">PDF File Landscape</A>
<li><A HREF="$cue_url_P">PDF File Portrait</A>
<li><A HREF="$cue_url_C">Unformatted CSV File</A>
</ul>
<div class="button-container text-center">
<A HREF=$wizard_url>Return to Wizard for this Event</A>
<A HREF=$info_url>View Published Route</A>
<A HREF=$event_url>Go to Published Event Page</A>
</div>
EOT;

		$data=['title'=>"Cue Sheet Published", 'left_column'=>$left_column, 'right_column'=>''];
		$this->simple_view('info_one_column',['buttonlink'],$data);

	}
	
	private function generate_csv_cuesheet($route_event, $cues, $controles){
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$cue_version=$route_event['cue_version'];
		$cue_basename="$event_tagname-CueSheetV$cue_version";
		$cue_filename=Cuesheet::cuesheet_path . "/" . $cue_basename . ".csv";
		$cue_url=Cuesheet::cuesheet_baseurl . "/" . $cue_basename . ".csv";
		$this->cuesheet->set_controle_date_format($route_event);
		$header_text=$this->cuesheet->header_text_array($route_event);
		$cue_text=$this->cuesheet->cue_text_array($cues, $controles);
		$this->emit_csv(array_merge($header_text,$cue_text), $cue_filename, true);
		return compact('cue_url','cue_filename','cue_version');
	}

	private function generate_pdf_cuesheet($route_event, $cues, $controles, $orientation, $size){
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$cue_version=$route_event['cue_version'];
		$cue_basename="$event_tagname-CueSheetV$cue_version";
		$params=['event'=>$route_event, 'orientation'=>$orientation, 'size'=>$size];
		$cuesheet=new Cuesheet($params);
		$cuesheet->set_controle_date_format($route_event);
		$cuesheet->AddPage();
		$cuesheet->draw_cuesheet_pages($route_event, $cues, $controles);
		$cue_filename=Cuesheet::cuesheet_path . "/" . $cue_basename . "-$orientation.pdf";
		$cue_url=Cuesheet::cuesheet_baseurl . "/" . $cue_basename . "-$orientation.pdf";
		$cuesheet->Output("F", $cue_filename);
		$fstat=@stat($cue_filename);
		if($fstat===false || empty($fstat['size'])) $die->error(__METHOD__, "Failed to create cuesheet file '$cue_filename'");
		return compact('cue_url','cue_filename','cue_version');
	}
	
   
    private function format_rusa_data($m){
    return $text;
    }

	
  // Generic Non-Event Cue Wizard DEPRECIATED
	public function id($route_id=0, $view=null){
		
	$this->die_error(__METHOD__,"This route/id interface to cue wizard is currently disabled and it's future availability is uncertain. <A HREF='https://parando.org/info/contact/webmaster'>Contact the webmaster</a> for more info.");

	}

// PRIVATE FUNCTIONS


	

// VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS
// VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS
// VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS

	// General Administrator/Organizer Wizard view, and INFO view of route
	
	private function view_wizard($re, $controles, $warnings){
        $this->_generate_view_html($re, $controles, $warnings, true);
	}
	
	private function view_info($re, $controles, $warnings){
        $this->_generate_view_html($re, $controles, $warnings, false);
	}
	

	private function _generate_view_html($re, $controles, $warnings, $wizard=false){

		extract($re); // All route_event variables are now local

		$event_tagname=$this->model_parando->make_event_tagname($re);
		$rusa_route_str=(empty($rusa_route))?"None":"$rusa_route";
		$terrain=empty($terrain)?'':ucfirst($terrain);
		$surface=empty($surface)?'':ucfirst($surface);
		$difficulty=empty($difficulty)?'':"($difficulty)";
		$unpaved_pct=empty($unpaved_pct)?'':"($unpaved_pct% unpaved)";
		$ogd=($event_gravel_distance>0)?
		"<TR><TD>Official Gravel Distance</TD><TD>$event_gravel_distance km</TD></TR>":"";

		
		$event_type_uc=strtoupper($event_type);
		$general_info=<<<EOT
<div class='routeinfo'>
<A HREF='$club_website_url'><IMG SRC=$club_logo_url WIDTH=15.8%></A>
<H4>GENERAL INFO</h4>
<div class='narrower'> 
<TABLE WIDTH=100%>
<TR><TD>Start Date/Time</TD><TD>$event_datetime_str</TD></TR>
<TR><TD>Event Type</TD><TD>$event_type_uc</TD></TR>
<TR><TD>Location</TD><TD>$event_location</TD></TR>
<TR><TD>Club</TD><TD>$club_name</TD></TR>
<TR><TD>Official Distance</TD><TD>$event_distance km</TD></TR>
$ogd
<TR><TD>Route Distance</TD><TD>$distance_mi mi / $distance_km km</TD></TR>
<TR><TD>Climbing</TD><TD>$climbing_ft ft</TD></TR>
<TR><TD>Surface</TD><TD>$pavement_type $unpaved_pct</TD></TR>
<TR><TD>RUSA Route ID</TD><TD>$rusa_route_str</TD></TR>
<TR><TD>Event Tagname</TD><TD>$event_tagname</TD></TR>
</TABLE></DIV></DIV>
EOT;

		if($has_rwgps_route){
            $available_route_data=<<<EOT
<H4>GPS ROUTE DATA</h4>
<div class='narrower routeinfo'>
<TABLE WIDTH=100%>
<TR><TD>RWGPS Route Name</TD><TD>$route_name</TD></TR>
<TR><TD>Last Modified</TD><TD>$last_update</TD></TR>
<TR><TD>RWGPS Link URL</TD><TD><A HREF=$route_url>$route_url</a></TD></TR>
<TR><TD>GPS File Download</TD><TD>$df_links_txt</TD></TR>
</TABLE></DIV>
EOT;
		}elseif(!empty($map_url)){
			$available_route_data=<<<EOT
<H4>MAP/PROFILE</h4>
<p>Unfortunately, at this time there is no GPS data for this route. Only a static (non-GPS) map and elevation profile is available.</P>
<div class='button-container text-center'><A HREF=$map_url>Download Map and Profile Info</A></DIV>
EOT;
		// No Map
		}else{
			$available_route_data=<<<EOT
<H4>MAP/PROFILE</h4>
<p>Unfortunately, at this time no GPS data, map, or elevation profile information is available for this event.</p>
EOT;
		}

		
        // Route Description Tags
        if($wizard){
            $route_tag_data=""; // "<H4>DESCRIPTION TAGS</H4>";
            if(!empty($route_tags['unrecognized'])){
                $route_tag_data.="<span class=red>WARNING: Unrecognized tags found in RWGPS route Description.</span> These tags have been ignored. Please delete them!<br/><div class='half-width-indented bordered'>";
                $route_tag_data.=implode(', ', $route_tags['unrecognized']);
                $route_tag_data.="</div>";
                unset($route_tags['unrecognized']);
            }
            if(empty($route_tags)){
                $route_tag_data.="<p>No VALID tags found in route Description. (Consider adding #pavement_type=whatever to the RWGPS route Description)</p>";
            }else{
                $route_tag_data.="VALID tags found in route Description:<br/><div class=vspace></div><div class='indent smaller tt'>";
                $route_tag_data.=$this->route_event->format_attributes($route_tags);
                $route_tag_data.="</div>";
                $route_tag_data.="<div class=vspace></div>";
            }
        }else{
            $route_tag_data="";
        }
		
		
		// CUESHEETS CUESHEETS CUESHEETS CUESHEETS CUESHEETS CUESHEETS CUESHEETS CUESHEETS CUESHEETS 
		
             $cue_sheet_info="<H4>CUE SHEETS</h4>";
 
             // No Cues
            if($has_cuesheet===false){
                $cue_sheet_info.="<p>At this time no cue sheet is available for this event.</p>";
                $published_at=0;
                $cuesheet_gentime_str="Never";
               
            // Cue Wizard Cuesheet
            }elseif($cuesheet_location=='auto'){

                $cue_basename="$event_tagname-CueSheetV$cue_version";
                $csv_filename=$this->model_parando->cuesheet_path . "/" . $cue_basename . ".csv";
                if(file_exists($csv_filename))
                    $published_at=filectime($csv_filename);
                else
                    $published_at=0;
                
                if($cue_version>0 && $published_at>0){
                    date_default_timezone_set($event_tzname);
                    $cuesheet_gentime_str=date("Y-m-j H:i:s T",$published_at);
                    $cuesheet_version_str="$cue_version";
                }else{
                    $this->die_error(__METHOD__, "This can't happen. Cuesheet unexpectedly missing. CSV File: $csv_filename");
                }
                
                $cuesheet_url_P=$this->model_parando->cuesheet_baseurl . "/" . $cue_basename . "-P.pdf";
                $cuesheet_url_L=$this->model_parando->cuesheet_baseurl . "/" . $cue_basename . "-L.pdf";
                $cuesheet_url_C=$this->model_parando->cuesheet_baseurl . "/" . $cue_basename . ".csv";
                $cue_sheet_info.=<<<EOT
<div class='narrower routeinfo'><TABLE WIDTH=100%>
<TR><TD>Cuesheet Generated</TD><TD>$cuesheet_gentime_str</TD></TR>
<TR><TD>Cuesheet Version</TD><TD>$cue_version</TD></TR>
</TABLE></DIV>
EOT;
                $buttons ="<A HREF=$cuesheet_url_P>Cue Sheet (Portrait)</A>";
                $buttons.="<A HREF=$cuesheet_url_L>Cue Sheet (Landscape)</A>";
                $buttons.="<A HREF=$cuesheet_url_C>Cue Sheet (CSV)</A>";
                $cue_sheet_info.="<div class='button-container text-center'>$buttons</DIV>";

            // Static cue link
            }else{
                $cue_sheet_info.=<<<EOT
<p>A legacy Cuesheet is available for this event.
<div class='narrower routeinfo'><TABLE WIDTH=100%>
<TR><TD>Cuesheet</TD><TD><A HREF=$cuesheet_url>$cuesheet_url</a></TD></TR>
</TABLE></DIV>
EOT;
                $buttons ="<A HREF=$cuesheet_url>Download Cue Sheet</A>";
                $cue_sheet_info.="<div class='button-container text-center'>$buttons</DIV>";
            }

        // More simplified version for wizards
        
        if($wizard){
            $cue_sheet_info="<H4>PUBLISHED CUE SHEETS</h4>";
            if($has_cuesheet===false){
                $cue_sheet_info.="<p>At this time no cue sheet is available for this event.</p>";
            }elseif($cuesheet_location!='auto'){
                $cue_sheet_info.="<p>WARNING: A Legacy Cue Sheet is available for this route.</p>";
            }else{
                $cue_sheet_info.=<<<EOT
<div class='narrower routeinfo'><TABLE WIDTH=100%>
<TR><TD>Last Published</TD><TD>$cuesheet_gentime_str</TD></TR>
<TR><TD>Published Version</TD><TD>$cue_version_str</TD></TR>
<TR><TD>Published Cue Files</TD><TD><A HREF=$cuesheet_url_P>Portrait</A>, 
<A HREF=$cuesheet_url_L>Landscape</A>, <A HREF=$cuesheet_url_C>CSV</A></TD></TR>
</TABLE></DIV>
EOT;
            }
        }

         // Controle table
		$ncontroles=count($controles);
		$control_table_style=($wizard)?'wizard':'info';
		$controles_table=$this->route_event->make_controles_table($controles,$control_table_style);
		
		if($wizard){
            $wizard_controles_table=$controles_table;
            $user_controles_table="";
        }else{
            $wizard_controles_table="";
            $user_controles_table=$controles_table;
        }
        
		// Wizard Text
		
		$wizard_body="";
		$warning_body="";
		$download_body="";
		$generate_form="";
		
		if($wizard){
		
            $wizard_body="<H3>CUE WIZARD</H3>";
            
            if($updated_at > $published_at) 
                $warnings[]="Route data newer than published cuesheets.";
 
            if(!empty($warnings)){
                $cw=implode('</li><li>',$warnings);
                $warning_body =<<<EOT
<h4>ROUTE DATA VALIDATION</H4>
<div class="bordered narrower sans red">
<div class="vspace"></div>
<p>Errors found in the route data</p>
<ul><li>$cw</li></ul>
<p>Fix these Errors by previewing to check, and then publish again.</p>
</div><div class="vspace"></div>
EOT;
            }else{
                $warning_body =<<<EOT
<h4>ROUTE DATA VALIDATION</H4>
<p>No errors or warnings.</p>
EOT;
}
		
            // Various URLs for download forms and buttons
            $this_url=site_url(strtolower(get_class($this)));
            $route_event_id="$route_id/$event_id";
            $download_url="$this_url/recache/$event_id";
            $event_url="$this_url/event/$event_id";
            $publish_url="$this_url/publish_cuesheet/$event_id";

            $download_body=<<<EOT
<h4>DOWLOAD LATEST ROUTE DATA</h4>
<P>If you made changes in the route on RWGPS that 
affect the published cues, brevet cards, etc... you must re-dowload the data here
and then publish again.</p> 
<div class="bordered narrower text-center">
  $download_note<br/>
  <div class="button-container"><A HREF=$download_url>Re-download updated route from RWGPS</A></div>
  <P>Last Download: $last_download</P>
</div>
<div class="vspace"></div>
EOT;

// IS IT TRUE THAT SOME PAPERWORK GOES LIVE INSTANTLY (EG BREVET CARDS) OR ARE THEY PUBLISHED TOO?  BUG?

            $generate_form=<<<EOT
<h4>CUESHEET AND BREVET CARD PREVIEW</h4>
<P>Press the buttons below for <b>preview versions</b> of the cuesheet and brevet cards generated
now based on the last route data downloaded. This paperwork won't go live till you press
the 'Publish Cuesheets to Event' button.</P>
<FORM ACTION=$event_url METHOD=POST  enctype="multipart/form-data">
<div class="narrower button-stack">
    <BUTTON TYPE=SUBMIT NAME='view' value='pdf_cue_portrait'>PDF Cuesheet (portrait)</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='pdf_cue_landscape'>PDF Cuesheet (landscape)</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='csv_cue'>CSV Cue Sheet</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='search_replace_changes'>Cue Sheet Search Replace Changes</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='card_outside_blank'>Brevet Card Outside Blank</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='card_outside_roster'>Brevet Card Outside Roster</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='card_inside'>Brevet Card Inside</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='qrpdf'>QR Codes</BUTTON>
</DIV><div class=vspace></div>

<h4>CUESHEET PUBLISH</h4>
<p>Once you are happy with the cuesheets generated above, press the button below 
to publish this new version of the cuesheet to the $this_organization event info page. <B>Don't
forget to publish after you make changes!</b></P>
<div class="bordered narrower text-center">
Last Published on: $cuesheet_gentime_str, Version: $cue_version_str<BR/>
<div class="button-container"><A HREF=$publish_url>Publish New (Ver $cue_next_version) Cuesheets to Event</A></div>
</div>
<div class="vspace"></div>
</FORM>
EOT;
        }
        
        // MAP and Elevation Profile
        $map_divid='randomap'; // must match ID in randomap.css
		$graph_divid='epdivid'; // must match ID in randomap.css
		$route=$this->rwgps->get_route($route_id);
		$map_script=$this->map->generate_map_script($route,$controles,$map_divid);
		$ep_script=$this->map->generate_ep_script($route, $controles, $graph_divid);
		$map_body=<<<EOT
<H4>MAP</H4>
<div class='narrower text-center'>
<div id=$map_divid></div>
<A HREF=$route_url>View in Ride With GPS</a>
<div class=bigskip></div>
<div id=$graph_divid style="margin-left:10%; margin-right:10%; width:80%; height:180px;"></div>
</div>
$map_script
$ep_script
EOT;

		// Wizard User Disclaimer
        $wizard_fineprint=$this->route_event->disclaimer_html;

        // General Disclaimer Paragraph
		$route_fineprint=($wizard)?"":"<DIV CLASS='narrower fine-print bordered'><p>" . $this->model_parando->get_paragraph("auto_cue") . "</p></div>";
		
		// PUT THE PAGE TOGETHER
		// PUT THE PAGE TOGETHER
		// PUT THE PAGE TOGETHER
		// PUT THE PAGE TOGETHER
		// PUT THE PAGE TOGETHER

		$page_body=<<<EOT
<!-- All -->
<H3>$event_name_dist</H3>
$general_info
$available_route_data

<!-- Wizard Only -->
$wizard_body
$warning_body
$route_tag_data

<!-- All -->
$cue_sheet_info

<!-- Wizard Only -->
$download_body
$generate_form

<!-- User Only -->
$route_fineprint

<!-- All -->
$map_body
$controles_table

<div class=bigskip></div>
$wizard_fineprint
EOT;

		$data=['title'=>$event_name_dist, 'left_column'=>$page_body, 'right_column'=>""];
		$this->simple_view('info_one_column',['randomap','table','buttonlink','form'],$data);
	
	}
	
	// OTHER VIEWS OTHER VIEWS OTHER VIEWS OTHER VIEWS OTHER VIEWS OTHER VIEWS
	// OTHER VIEWS OTHER VIEWS OTHER VIEWS OTHER VIEWS OTHER VIEWS OTHER VIEWS
	// OTHER VIEWS OTHER VIEWS OTHER VIEWS OTHER VIEWS OTHER VIEWS OTHER VIEWS
	
	private function view_controls($re, $controls, $warnings){
	
		$jkassen_time_api_url="https://rusa.jkassen.org/time/rusa-time-api.php";
				
		$control_list=[];
		$route_distance=0;
		foreach($controls as $c){
		    $dist_km = $c['d']/1000;
		    $name = $c['attributes']['name'];
			$control_list[] = [ 'DISTANCE'=> "{$dist_km}k", 'NAME'=> $name ];
			$route_distance=$dist_km;
		}
		
	
		// $this->die_error(__METHOD__, print_r($re,true));
	
		$kti_parms=[
			'event_distance'=>$re['event_distance'] . 'k',
			'route_distance'=> "{$route_distance}k",// last control distance
			'gravel_distance'=> 0,
			'start_date' => $re['event_date'],
			'start_time' => $re['event_time'],
			'controls' => json_encode($control_list)
		];
		
		$kti_parms_text=print_r($kti_parms,true);
		
		//$this->die_error(__METHOD__, $kti_parms_text);

$options = array(
  'http' => array(
    'header'  => "Content-type: application/x-www-form-urlencoded",
    'method'  => 'POST',
    'content' => http_build_query($kti_parms)
  )
);
$context  = stream_context_create($options);
$resp = file_get_contents($jkassen_time_api_url, false, $context);

		$resp_array=json_decode($resp,true);
		
$resp_array_text=print_r($resp_array,true);

// Array ( [META] => Array ( [API_VERSION] => 1.1 [API_CONTACT] => Jake Kassen - me@jkassen.org [ERROR] => ) 
//			[EVENT] => Array ( [EVENT_DISTANCE_KM] => 1234 [EVENT_DISTANCE_MILE] => 766 [ROUTE_DISTANCE_KM] => 1234 [ROUTE_DISTANCE_MILE] => 767 [MAX_TIME] => 92h 33m [MIN_TIME] => 42h 5m [START_DATE] => 2024-09-25 [START_TIME] => 04:00:00 [START_DATE_PRINTABLE] => September 25th @ 4:00am [GRAVEL_DISTANCE_KM] => 0 [GRAVEL_DISTANCE_MILE] => 0 [GRAVEL_PERCENT] => 0 [GRAVEL_EXTRA_TIME] => 0h 0m [GRAVEL_MAX_TIME] => 92h 33m [CALC_METHOD] => BREVET ) 
//            [CONTROLS] => Array ( [0] => Array ( [CONTROL_NUMBER] => 0 [CONTROL_NAME] => S...

		
		//$this->die_error(__METHOD__, print_r($resp_array,true));

	
		$controles_table=$this->make_control_comparison_table($controls,$resp_array['CONTROLS']);
		$page_body=<<<EOF

<pre>
$kti_parms_text
</pre>		

		  $controles_table;
		  
<h4>Full API Response</h4>
$resp_array_text
EOF;

		$data=['title'=>$re['event_name_dist'], 'left_column'=>$page_body, 'right_column'=>""];
		$this->simple_view('info_one_column',['randomap','table','buttonlink','form'],$data);
		
	
	}
	
	
	public function make_control_comparison_table($controles,$k){
        $controles_table= "";
        $ncontroles=count($controles);

		$controles_table ="<H4>CONTROLS</H4>";
		$controles_table.="<div class='narrower ftable'><TABLE WIDTH=100%>";
		$controles_table.= "<TR><TH>Distance PA</TH><TH>Distance Kassen</TH><TH>Open/Close PA</TH><TH>Open/Close Kassen</TH></TR>";

		
		
		for($i=0; $i<$ncontroles; $i++){
			
			$cd_mi=($controles[$i]['d']/(route_event::m_per_km*route_event::km_per_mi));
			$cd_km=($controles[$i]['d']/(route_event::m_per_km));
			$is_start=(isset($controles[$i]['start']))?" [START]":"";
			$is_finish=(isset($controles[$i]['finish']))?" [FINISH]":"";
			$controle_num=$i+1;
			$open_str=$controles[$i]['open']->format('H:i M d');
			$close_str=$controles[$i]['close']->format('H:i M d');
			$ca=$this->route_event->format_attributes($controles[$i]['attributes']);
			$qrcode_url=$controles[$i]['qrcode_url'];
			$qrcode_checkin_url=$controles[$i]['qrcode_checkin_url'];
			$cn=(isset($controles[$i]['n']))?$controles[$i]['n']:"";
			
			extract($k[$i]);
                
// $k[$i]['CONTROL_NUMBER']
// $k[$i]['CONTROL_NAME']
// $k[$i]['CONTROL_META_NAME']
// $k[$i]['CONTROL_DISTANCE_KM']
// $k[$i]['CONTROL_DISTANCE_MILE']
// $k[$i]['OPEN']
// $k[$i]['CLOSE']
// $k[$i]['RELATIVE_OPEN']
// $k[$i]['RELATIVE_CLOSE']
// $k[$i]['GRAVEL_CLOSE']
// $k[$i]['GRAVEL_CLOSE_RELATIVE']

if($open_str != $OPEN )
   $o_style = 'STYLE="background-color: yellow;"';
else
   $o_style = '';
                 
if($close_str != $CLOSE)
   $c_style = 'STYLE="background-color: yellow;"';
else
   $c_style = '';
                 
                
			$controles_table.= "<TR>";
			$controles_table.= "<TD>$cd_mi mi<br>$cd_km km</TD>";
			$controles_table.= "<TD>$CONTROL_DISTANCE_MILE mi<br>$CONTROL_DISTANCE_KM km</TD>";
			$controles_table.= "<TD><span $o_style>$open_str</span><br><span $c_style>$close_str</span></TD>";
			$controles_table.= "<TD><span $o_style>$OPEN</span><br><span $c_style>$CLOSE</span></TD>";
			$controles_table.= "</TR>";
                        
                   
		}
        $controles_table.="</TABLE></DIV>";
        return $controles_table;
	}


	

	// Raw JSON View
	
	private function view_json($route_event, $controles, $warnings){
		$route=$this->rwgps->get_route($route_event['route_id']);
		header("Content-Type: application/json; charset=UTF-8");
		echo json_encode($route);
		exit();
	}

	// Cue processing SEARCH/REPLACE VIEW

	private function view_search_replace_changes($route_event, $controles, $warnings){

		$ncontroles=count($controles);
		extract($route_event);


		$route=$this->rwgps->get_route($route_id);
		list($cues, $cue_warnings)=$this->rwgps->extract_cues($route);
		$warnings=array_merge($warnings, $cue_warnings);
		$this->die_view_warnings($warnings);

		$params=['event'=>$route_event];
		$this->load->library('cuesheet', $params);
		$this->cuesheet->set_controle_date_format($route_event);
		// $header_text=$this->cuesheet->header_text_array($route_event);
		$cue_text=$this->cuesheet->cue_text_array($cues, $controles);
		
		$change_log=[];
		foreach($cue_text as $line){
			$controle_i=array_shift($line);
			if(empty($controle_i)){
				$line[$this->cuesheet->dist_cols+1]=$this->cuesheet->clean_string($line[$this->cuesheet->dist_cols+1]); // clean note
				$line_r=$this->cuesheet->replace_cues($line);
					$dist=$line[0];
					$dir=$line[$this->cuesheet->dist_cols+0];
					$dir_r=$line_r[$this->cuesheet->dist_cols+0];
					$note=$line[$this->cuesheet->dist_cols+1];
					$note_r=$line_r[$this->cuesheet->dist_cols+1];
				if($note_r != $note){
		      $change_log[]=[$dist, "$dir: $note", ">>>>>", "$dir_r: $note_r"];
				}
			}
		}



		if(!empty($warnings)){
		$cw=implode('</li><li>',$warnings);
		$warning_text=<<<EOT
<div class="bordered narrower red">
<div class="vspace"></div>
<div class="large-print sans">ERRORS:</div>
<ul><li>$cw</li></ul>
EOT;
		}else{$warning_text='';}

		$left_column=<<<EOT
<H3>$event_name_dist</H3>
$warning_text
<H4>Cue Search/Replace Changes</H4>
<div class='narrower ftable'><TABLE WIDTH=100%><TR><TD>
EOT;
		$func=function($a){
			return implode("</TD><TD>",$a);
		};
		$left_column .= implode("</TD></TR><TR><TD>", array_map($func ,$change_log));
		$left_column .=<<<EOT
</TD></TR></TABLE></DIV>

EOT;


		$data=['title'=>$event_name_dist, 'left_column'=>$left_column, 'right_column'=>''];
		$this->simple_view('info_one_column',['table'],$data);
	}
	
	// CUE SHEET VIEWS
	// CUE SHEET VIEWS
	// CUE SHEET VIEWS
	// PDF Rendered cue_sheet Views
	
	private function view_pdf_cue($route_event, $controles, $warnings){
		$this->_view_pdf_cue($route_event, $controles, $warnings, 'P');
	
	}
	private function view_pdf_cue_portrait($route_event, $controles, $warnings){
		$this->_view_pdf_cue($route_event, $controles, $warnings, 'P');
	
	}
	private function view_pdf_cue_landscape($route_event, $controles, $warnings){
		$this->_view_pdf_cue($route_event, $controles, $warnings, 'L');
	
	}

	private function _view_pdf_cue($route_event, $controles, $warnings, $orientation='P', $size='letter'){
	
		$route=$this->rwgps->get_route($route_event['route_id']);
		list($cues, $cue_warnings)=$this->rwgps->extract_cues($route);
		$warnings=array_merge($warnings, $cue_warnings);
		$this->die_view_warnings($warnings);
		$params=['event'=>$route_event, 'orientation'=>$orientation, 'size'=>$size];
		$this->load->library('cuesheet', $params);
		$this->cuesheet->AddPage();

		$this->cuesheet->set_controle_date_format($route_event);
		$this->cuesheet->draw_cuesheet_pages($route_event, $cues, $controles);
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$this->cuesheet->Output("I", "$event_tagname-CueSheet-$orientation.pdf");

	}
	

	private function view_csv_cue($route_event, $controles, $warnings){
	
		$route=$this->rwgps->get_route($route_event['route_id']);
		list($cues, $cue_warnings)=$this->rwgps->extract_cues($route);
		$warnings=array_merge($warnings, $cue_warnings);
		$this->die_view_warnings($warnings);

		$params=['event'=>$route_event];
		$this->load->library('cuesheet', $params);
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$csv_filename="$event_tagname-CueSheet.csv";

		$header_text=$this->cuesheet->header_text_array($route_event);
		$cue_text=$this->cuesheet->cue_text_array($cues, $controles);
		$this->emit_csv(array_merge($header_text,$cue_text), $csv_filename);
		exit();

	}
	
	private function emit_csv($array,$filename='data.csv',$write=false){
		if($write){
			$output = fopen($filename,'w') or die("Can't open $filename");
		}else{
			$output = fopen("php://output",'w') or die("Can't open php://output");
			header("Content-Type:application/csv"); 
			header("Content-Disposition:attachment;filename=$filename"); 
		}
		foreach($array as $row) {
			fputcsv($output, $row);
		}
		fclose($output) or die("Can't close output.");	
	}

	// BREVET CARD VIEWS
	// BREVET CARD VIEWS
	// BREVET CARD VIEWS
		
	// PDF Rendered Brevet Card Views

	private function view_card_inside ($route_event, $controles, $warnings){
		$this->view_card_inside_withoptions($route_event, $controles, $warnings, ['validate_first'=>true]);
	}

	private function view_card_inside_novalidatefirst ($route_event, $controles, $warnings){
		$this->view_card_inside_withoptions($route_event, $controles, $warnings, []);
	}

	private function view_card_inside_withoptions ($route_event, $controles, $warnings, $opts=[] ){
	
		$this->die_view_warnings($warnings);

		if(count($controles)>15){
			$route_event['page_orientation'] = "L";
			$route_event['cards_per_page'] = 1;
		}
		
		$this->load->library('brevetcard', $route_event);

		while(count($controles)>($this->brevetcard->cpf*$this->brevetcard->n_folds)){ 
			$this->brevetcard->n_folds++;
		}

		$this->brevetcard->AddPage();
		$this->brevetcard->set_controle_date_format($route_event);

		// set false if you don't want the first controle validated when cards are prined
		$logo_url=(isset($opts['validate_first']) && isset($route_event['logo_url']))?$route_event['logo_url']:null;

		$this->brevetcard->draw_card_inside($controles,$logo_url);
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$this->brevetcard->Output("I", "$event_tagname-CardInside.pdf");
	
	}	

	private function view_card_outside_blank ($route_event, $controles, $warnings){
	
		$this->die_view_warnings($warnings);

		if(count($controles)>15){
			$route_event['page_orientation'] = "L";
			$route_event['cards_per_page'] = 1;
		}
		
		if(!empty($this->model_parando->page3_image))
			$route_event['page3_image']=$this->model_parando->page3_image;

		$this->load->library('brevetcard', $route_event);

		while(count($controles)>($this->brevetcard->cpf*$this->brevetcard->n_folds)){ 
			$this->brevetcard->n_folds++;
		}
		
		$this->brevetcard->AddPage();
		$this->brevetcard->draw_card_outside($route_event);
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$this->brevetcard->Output("I", "$event_tagname-CardOutsideBlank.pdf");
	
	}	

	private function view_card_outside_roster ($route_event, $controles, $warnings){
	
		$this->die_view_warnings($warnings);
		
		if(empty($route_event['event_roster'])) $this->die_error(__METHOD__, "No roster for event.");
		$roster=$route_event['event_roster']; // $route$this->model_parando->get_roster($route_event['event_id']);
		
		if(count($controles)>15){
			$route_event['page_orientation'] = "L";
			$route_event['cards_per_page'] = 1;
		}

		$this->load->library('brevetcard', $route_event);

		while(count($controles)>($this->brevetcard->cpf*$this->brevetcard->n_folds)){ 
			$this->brevetcard->n_folds++;
		}
		
			
		$n_riders=count($roster);
		$n_cards = $this->brevetcard->n_cards;
		
		for($i=0; $i<$n_riders; $i+=$n_cards){
			$r=array_slice($roster, $i, $n_cards);
			$this->brevetcard->AddPage();
			$this->brevetcard->draw_card_outside($route_event, $r);
		}
		
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$this->brevetcard->Output("I", "$event_tagname-CardOutsideRoster.pdf");
	
	}	
	
    // MAP AND EP ONLY
	
	private function view_map($route_event, $controles, $warnings){
	
		extract($route_event); // All route_event variables are now local
		$route=$this->rwgps->get_route($route_id);

		$provider='mapbox';
			
		$name=$route_name;
		$title = "$name (RWGPS #$route_id)";
		$data=[	'title'=>$title,
				'this_organization'=>$club_name];
				
				
		$map_divid='randomap';
		$graph_divid='eprofile';
		$map_script=$this->map->generate_map_script($route, $controles, $map_divid,'randomapv',$provider);
		$ep_script=$this->map->generate_ep_script($route, $controles, $graph_divid);

		$data['body']=<<<EOT
<div class='narrower'>
	<h1>$title</h1>
	<div id=$map_divid></div>
	<div class=bigskip></div>
	<div id=$graph_divid style="margin-left:10%; margin-right:10%; width:80%; height:180px;"></div>
	<div class=bigskip></div>
</div>

$map_script
$ep_script
EOT;

		$this->load->view('simple_header',array_merge($data,['page_styles'=>['randomap']]));
		$this->load->view('simple_body',$data);
		$this->load->view('simple_footer',$data);
	}

    // QRCODES


	private function view_qrpdf($route_event, $controles, $warnings){
		$this->controlqr->make_qr_images($route_event, $controles, true);
		$this->controlqr->draw_qr_pages($controles);
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$this->controlqr->Output("I", "$event_tagname-QRCodes.pdf");
	}
	
	


	private function die_view_warnings($warnings){ // for views that want to die if there are warnings
		
		if(!empty($warnings)){
			$cw=implode('</li><li>',$warnings);
			$left_column =<<<EOT
<p>The requested function is not available because of Errors in route data.</p>
<ul><li>$cw</li></ul>
<p>Fix these Errors by editing the RWGPS route, saving in RWGPS, and re-downloading.</p>
EOT;
			$this->die_error('Route Errors', $left_column);
		}
		
	}
	
}
