<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.


class Route extends MY_Controller {


	// private $controller_name;

	function __construct(){
		parent::__construct();

		$this->load->library('wizard');
		$this->load->library('rwgps');
		$this->load->library('controletimes');
		$this->load->library('map');
		$params = ['tag' => 'login_session_data'];
		$this->load->library('randosession',$params);

		// $this->controller_name=strtolower(get_class($this));
	}


    //////////////////////////////////////////////////////////////////////////
    // PUBLIC CONTROLLER FUNCTIONS

    // EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT 
    // EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT 
    // EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT 

    // General PA Rando Event Route Information page and/or Cue Wizard Interface
  
    public function info($event_id) {$this->event($event_id,'info');}
    public function wizard($event_id) {$this->event($event_id,'wizard');}

 	public function event($event_id, $view=null){
		
        // Establish 'event','route','controles','warnings','cues','route_event'
		extract($this->compute_all_event_data($event_id));
		
		// And view the result
		
		if($view===null)$view=$this->input->post('view');
		
		if(empty($view) || $view=='info'){
			$this->view_info($route_event, $controles, $warnings);
		}else{
            // ALL other views require admin or organizer of THIS event  
            $this->randosession->login_check($event['organizer']); 
            $this->{'view_'.$view}($route_event, $controles, $warnings);
		}
	}

    // DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD
    // DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD
    // DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD DOWNLOAD
    
	public function recache($event_id){
		list($event, $route) = $this->get_event_and_route($event_id);
        $this->randosession->login_check($event['organizer']); 
		$route_id=$route['id'];
		if($this->rwgps->is_good_route_id($route_id)){
			$result=$this->rwgps->download_route_data($route_id);
			if($result!==true)
				$this->die_error(__METHOD__, $result);
			else
				redirect(site_url($this->class_name . "/wizard/$event_id"));
		}else{
			$this->die_error(__METHOD__,"Invalid parameters.");
		}
	}
	

    // PUBLISH PUBLISH PUBLISH PUBLISH PUBLISH PUBLISH 
    // PUBLISH PUBLISH PUBLISH PUBLISH PUBLISH PUBLISH 
    // PUBLISH PUBLISH PUBLISH PUBLISH PUBLISH PUBLISH 

 	// BUG????? Does this publish cards? 
 	
 	// TODO Publish CARDS and QR CODE Sheets  -- all docs should be static
	
   public function publish_cuesheet($event_id){

        // Establish 'event','route','controles','warnings','cues','route_event'
		extract($this->compute_all_event_data($event_id));
		
		// And die if there are any.
		$this->die_view_warnings($warnings);
		
		$size='letter';
		$orientation='P';
		$params=['event'=>$route_event, 'orientation'=>$orientation, 'size'=>$size];
		$this->load->library('cuesheet', $params);  

		$route_event['cue_version']=$cue_version=1+$route_event['cue_version'];	
		$route_event['cue_version_str']="$cue_version";
		
		$orientation='P';
		$cue_data_P=$this->generate_pdf_cuesheet($route_event, $cues, $controles, $orientation, $size);

		$orientation='L';
		$cue_data_L=$this->generate_pdf_cuesheet($route_event, $cues, $controles, $orientation, $size);

		$cue_data_C=$this->generate_csv_cuesheet($route_event, $cues, $controles);

		
		$this->model_parando->set_event_cuesheet_version($event_id,$cue_version);
		
		// Publishing success page

		$event_name_dist=$route_event['event_name_dist'];
		$cue_url_L=$cue_data_L['cue_url'];
		$cue_url_P=$cue_data_P['cue_url'];
		$cue_url_C=$cue_data_C['cue_url'];
		$wizard_url=site_url(strtolower(get_class($this))."/wizard/$event_id");
		$info_url=site_url(strtolower(get_class($this))."/info/$event_id");
		$event_url=site_url("info/event/$event_id");
		
		$left_column=<<<EOT
<H3>Cue Sheet Published</H3>
<p>Cue Sheets (version $cue_version) successfully published to event database 
for $event_name_dist.  Don't refresh or reverse or you might accidentally publish again. Just press one of the buttons below.</p>
<ul>
<li><A HREF="$cue_url_L">PDF File Landscape</A>
<li><A HREF="$cue_url_P">PDF File Portrait</A>
<li><A HREF="$cue_url_C">Unformatted CSV File</A>
</ul>
<div class="button-container text-center">
<A HREF=$wizard_url>Return to Wizard for this Event</A>
<A HREF=$info_url>View Published Route</A>
<A HREF=$event_url>Go to Published Event Page</A>
</div>
EOT;

		$data=['title'=>"Cue Sheet Published", 'left_column'=>$left_column, 'right_column'=>''];
		$this->simple_view('info_one_column',['buttonlink'],$data);

	}
	
	private function generate_csv_cuesheet($route_event, $cues, $controles){
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$cue_version=$route_event['cue_version'];
		$cue_basename="$event_tagname-CueSheetV$cue_version";
		$cue_filename=Cuesheet::cuesheet_path . "/" . $cue_basename . ".csv";
		$cue_url=Cuesheet::cuesheet_baseurl . "/" . $cue_basename . ".csv";
		$this->cuesheet->set_controle_date_format($route_event);
		$header_text=$this->cuesheet->header_text_array($route_event);
		$cue_text=$this->cuesheet->cue_text_array($cues, $controles);
		$this->emit_csv(array_merge($header_text,$cue_text), $cue_filename, true);
		return compact('cue_url','cue_filename','cue_version');
	}

	private function generate_pdf_cuesheet($route_event, $cues, $controles, $orientation, $size){
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$cue_version=$route_event['cue_version'];
		$cue_basename="$event_tagname-CueSheetV$cue_version";
		$params=['event'=>$route_event, 'orientation'=>$orientation, 'size'=>$size];
		$cuesheet=new Cuesheet($params);
		$cuesheet->set_controle_date_format($route_event);
		$cuesheet->AddPage();
		$cuesheet->draw_cuesheet_pages($route_event, $cues, $controles);
		$cue_filename=Cuesheet::cuesheet_path . "/" . $cue_basename . "-$orientation.pdf";
		$cue_url=Cuesheet::cuesheet_baseurl . "/" . $cue_basename . "-$orientation.pdf";
		$cuesheet->Output("F", $cue_filename);
		$fstat=@stat($cue_filename);
		if($fstat===false || empty($fstat['size'])) $die->error(__METHOD__, "Failed to create cuesheet file '$cue_filename'");
		return compact('cue_url','cue_filename','cue_version');
	}
	
	public function qrck($event_id=null,$control_number=null,$info_code=null,$rusa_id=null){
	
        if($event_id===null || $control_number===null || $info_code===null) 
            $this->die_error(__METHOD__, "Missing parameter.");
        
        // Establish 'event','route','controles','warnings','cues','route_event'
		extract($this->compute_all_event_data($event_id));
		
		$ncontroles=count($controles);
		if($control_number<1 || $control_number>$ncontroles) 
            $this->die_error(__METHOD__, "Control $control_number does not exist for this event.");
		
		if($controles[$control_number-1]['info_code']!==$info_code) 
            $this->die_error(__METHOD__, "Invalid parameter.");
        
        // URL of this method
        $action=site_url(strtolower(str_replace('::','/',__METHOD__))) . "/$event_id/$control_number/$info_code";	
				
		// Rider Identification
        if($rusa_id===null) $rusa_id=$this->input->post('rusa_id');
        if($rusa_id===null) $rusa_id=$this->input->cookie('qrck_rusa_id');
        if($rusa_id===null) {
            $this->identify_rider($route_event,$controles,$control_number,$action);
        }else{
        
            $this->load->library('rusa');
            $m=$this->rusa->get_member($rusa_id);
            if($m===null) 
                $this->die_error(__METHOD__, "Invalid RUSA ID.");
            
            // Did rider already check in? 
            $checkin_datetime=$this->get_checkin_datetime($event_id,$control_number,$rusa_id); 
            if(null===$checkin_datetime){ // NO
                $this->rider_confirmation($route_event,$controles,$control_number,$m,$action); // Not yet checked in, must confirm
            }else{ // YES
                $this->set_qrchk_rusa_id_cookie($rusa_id);
                $this->checkin_complete($route_event,$controles,$control_number,$m);
            }
        }
	}

	private function set_qrchk_rusa_id_cookie($rusa_id){
                $parsed=parse_url(current_url());
                $domain=$parsed['host'];
                $cookie = [
                    'name'   => 'qrck_rusa_id',
                    'value'  => $rusa_id,
                    'expire' => '86500000', // 1000 Days
                    'domain' => $domain,
                    'path'   => '/',
                    'prefix' => '',
                    'secure' => TRUE
                ];
                return $this->input->set_cookie($cookie);
    }
	
  // Identify Rider Form
  
    private function identify_rider($route_event,$controles,$control_number,$action){
		$event_name_dist=$route_event['event_name_dist'];
		$form_subject = "Check Into Control $control_number for the $event_name_dist";
		$form_title = $form_subject;
		$form_action = $action;
 		$form_body=<<<EOT
<div class=form-group>
<label for="rusa_id"><b>RUSA Number</b></label>
<input type="text" placeholder="Enter your RUSA number" name="rusa_id" required>
</div>
EOT;

		$form_submit = '<button type="submit">Continue</button>';
	
		$data=compact(
			'form_title',
			'form_subject',
			'form_fineprint',
			'form_action',
			'form_body',
			'form_submit'
		);
	
		$this->load->view('form_header',array_merge($data,['page_styles'=>['form']]));
		$this->load->view('form_simple',$data);
		$this->load->view('form_footer',$data);

    }
    
    // Checkin predicate
    
    private function get_checkin_datetime($event_id,$control_number,$rusa_id){
        $this->db->where(compact('event_id','control_number','rusa_id'));
        $q=$this->db->get('checkin');
		$result=$q->row_array();
		if(empty($result)) return null;
		$tz=new DateTimeZone('UTC'); // Checkins are stored as UTC
		$checkin_time=new DateTime($result['time'],$tz);
    }
    
    // Checkin confirmation
    
    private function rider_confirmation($route_event,$controles,$control_number,$rusa_m,$action){
    
		// Get information about event and control
		$event_name_dist=$route_event['event_name_dist'];
		$club_name=$route_event['club_name'];
		$i=$control_number-1;
		$control_name=$controles[$i]['attributes']['name'];
		$control_address=$controles[$i]['attributes']['address'];
		$is_start=isset($controles[$i]['start']);
		$is_finish=isset($controles[$i]['finish']);

        // Time in bank
        $open=$controles[$i]['open'];
        $close=$controles[$i]['close'];
        $open_time_str = $open->format($this->controletimes->event_datetime_format);
        $close_time_str = $close->format($this->controletimes->event_datetime_format);
        $now = $route_event['now'];
        $now_str = $route_event['now_str'];
        $too_early=$now<$open;
        $too_late=$now>$close;
        $control_open=!$too_early && !$too_late;
        $control_state=($control_open)?"OPEN":"<span class=red>CLOSED</span>";
        $interval_format='%a days, %H hrs, %i min';
        if($too_early){
            $interval=$now->diff($open);
            $interval_str=$interval->format($interval_format);
            $inbank="will OPEN $interval_str from now";
        }elseif($control_open){
            $interval=$now->diff($close);
            $interval_str=$interval->format($interval_format);
            $inbank="will CLOSE $interval_str from now";
        }elseif($too_late){
            $interval=$close->diff($now);
            $interval_str=$interval->format($interval_format);
            $inbank="has been CLOSED since $interval_str ago";
        }else{
            $this->die_error(__METHOD__, "This can't happen.");
        }
           
        extract($rusa_m);
        $state=($country != "US")?($state . ' (' . $country_fullname[$country] . ')'):$state;

 		$form_subject = "Checkin Confirmation";
		$form_title = $form_subject;
		$form_action = "$action/$rusa_id";
 		$form_body=<<<EOT
<div class=narrower>
<h4>Control $control_number</h4>
<DIV class='indent tt bordered'>
$control_name<br/>
$control_address<br/>
</DIV>
<div class='narrower text-center'>
<P>This control is now $control_state. It $inbank.</P>
<P><i>Press CONFIRM CHECK IN to register your arrival at control $control_number.</i></P>
<DIV class='bordered large-print sans'>
$first_name $last_name<br/>
$city, $state<br/>
RUSA: $rusa_id<br/>
</DIV>
</div>
</div>
EOT;

        $cancel_url="$action?CANCEL";
        
        $form_fineprint=<<<EOT
EOT;

		$form_submit =<<<EOT
<button type='submit' style='padding-top: 4em; padding-bottom: 4em' name='response' value='CONFIRM'><span class='large-print'>CONFIRM CHECK IN</span></button>
<button style='width: 20%; margin-left:40%; margin-right: 40%; padding-top: 1em; padding-bottom: 1em' type='submit' name='response' value='CANCEL'>CANCEL</button>
EOT;
	
		$data=compact(
			'form_title',
			'form_subject',
			'form_fineprint',
			'form_action',
			'form_body',
			'form_submit'
		);
	
		$this->load->view('form_header',array_merge($data,['page_styles'=>['form']]));
		$this->load->view('form_simple',$data);
		$this->load->view('form_footer',$data);
    
    
    }
    
    private function checkin_complete($route_event,$controles,$control_number,$rusa_m){

		// Get information about event and control
		$event_name_dist=$route_event['event_name_dist'];
		$club_name=$route_event['club_name'];
		$control_name=$controles[$control_number-1]['attributes']['name'];
		$control_address=$controles[$control_number-1]['attributes']['address'];
		$is_start=isset($controles[$control_number-1]['start']);
		$is_finish=isset($controles[$control_number-1]['finish']);

		if($is_start){
            $text=<<<EOT
<H3>Bonne Route</H3>
<P>You have successfully <b>started</b> the <i>$club_name $event_name_dist</i>.</P>
EOT;
		}elseif($is_finish){
            $text=<<<EOT
<H3>Congratulations!</H3>
<P>You have successfully <b>finished</b> the <i>$club_name $event_name_dist</i>.</P>
EOT;
		}else{
            $text=<<<EOT
<H3>Check In OK</H3>
<P>You have successfully checked into control $control_number ($control_name, $control_address) for the <i>$club_name $event_name_dist</i>.</P>
EOT;
		}
		
        extract($rusa_m);
        $state=($country != "US")?($state . ' (' . $country_fullname[$country] . ')'):$state;

       $text.=<<<EOT
<DIV class='text-center large-print sans'>
<IMG SRC='https://parando.org/images/task-done-outline/256x256.png' WIDTH=50%><br/>
$first_name $last_name<br/>
$city, $state<br/>
RUSA: $rusa_id<br/>
</DIV>
EOT;
         
		$data=['title'=>$event_name_dist, 'left_column'=>$text, 'right_column'=>""];
		$this->simple_view('info_one_column',[],$data);

    }
    
    private function format_rusa_data($m){
    return $text;
    }

	
  // Generic Non-Event Cue Wizard DEPRECIATED
	public function id($route_id=0, $view=null){
		
	$this->die_error(__METHOD__,"This route/id interface to cue wizard is currently disabled and it's future availability is uncertain. <A HREF='https://parando.org/info/contact/webmaster'>Contact the webmaster</a> for more info.");

	}

// PRIVATE FUNCTIONS


	
	// EVENT AND ROUTE FUNCTIONS
	// EVENT AND ROUTE FUNCTIONS
	// EVENT AND ROUTE FUNCTIONS
	// EVENT AND ROUTE FUNCTIONS
	
	
	// One function to rule them all
	
    private function compute_all_event_data($event_id, $from_scratch=false){

		list($event, $route) = $this->get_event_and_route($event_id);

		// Extract controls and cues from the route
		list($controles, $controle_warnings) = $this->rwgps->extract_controles($route);
		list($cues, $cue_warnings) = $this->rwgps->extract_cues($route);
		
		// Create a merged route+event
		list($route_event, $re_warnings) = $this->merge_route_event_data($route,$event);
		
		// Consolodate the warnings
		$warnings=array_merge($controle_warnings, $re_warnings,$cue_warnings);
		
		// Now we can compute the control times
		$this->controletimes->compute_open_close($controles,$route_event);
		
		// In case these are needed (and SIDE EFFECT load the controlqr library
		$this->compute_info_codes($route_event, $controles);

		// and make sure the QR files are all there
		$this->controlqr->make_qr_images($route_event, $controles, $from_scratch);

        return compact('event','route','controles','warnings','cues','route_event');
    }

    // Get the basic event and route data -- not yet merged into a route event
	 
	private function get_event_and_route($event_id){

        // Get the event
        $event=$this->model_parando->get_event($event_id);
		if(empty($event['map'])) $this->die_error(__METHOD__,"No event, or no map URL set for event $event_id");
				
		// Get the route
		$map_url=(isset($event['map']))?$event['map']:'';
		$route_id=$this->rwgps->extract_route_id($map_url);

        if($route_id!==null){
            $route=$this->rwgps->get_route($route_id);
			$event['has_rwgps_route']=true;
			$event['rwgps_url']=$this->rwgps->make_route_url($route_id);
			$event['map_url']="";
		}else{
			$event['has_rwgps_route']=false;
			$event['map_url']=make_site_url($map_url);
			$event['rwgps_url']="";
			$route=null;
		}

		return [$event, $route];
	}
	
	// MERGE MERGE MERGE MERGE MERGE MERGE MERGE MERGE MERGE MERGE MERGE MERGE MERGE MERGE MERGE MERGE MERGE MERGE
	//
    // Merge, validate, and harmonize route and event into a route_event. It produces a route_event array, along with 
    // a list of warnings. 

	private function merge_route_event_data($route, $event){		

		$warnings=[];
		$re=['is_route_event'=>true];
		
        // ROUTE ROUTE ROUTE ROUTE ROUTE ROUTE ROUTE ROUTE ROUTE ROUTE ROUTE ROUTE
		// This function assumes a valid $route with certain basic fields that 
		// should be guaranteed from the RWGPS data. 

		$required_route_keys=[
                                'id','distance','elevation_gain',
                                'name','description','download_note',
                                'updated_at','downloaded_at','route_datafile'
                            ];		
		
		// Sanity check of route
		if(empty($route)) $this->die_error(__METHOD__, "This can't happen: Empty route"); 
		foreach($required_route_keys as $k) 
			if(!array_key_exists($k, $route)) $this->die_error(__METHOD__,"Missing route field: $k");
		
		// Put all these route strings and numbers into route_event (NOT the array route itself)
		// The keys are exactly the same -- no 'route_' prefix when put in the $re array
		foreach($route as $key=>$val){
			if(is_string($val) || is_numeric($val)) $re[$key]=$val;
		}

		// In case the spelling isn't already there
		$re['route_id']=$route_id=$route['id'];

		// Calculate various additional route statistics in the usual units
		$re['distance_km']=$distance_km=round($route['distance']/rwgps::m_per_km,1);
		$re['distance_mi']=$distance_mi=round($route['distance']/rwgps::m_per_km/rwgps::km_per_mi,1);
		$re['climbing_ft']=$climbing_ft=round($route['elevation_gain']*rwgps::ft_per_m,1);
				
		// Other route strings
		$re['route_url']=$this->rwgps->make_route_url($route_id);
		$re['route_filename']=$route_filename=$this->rwgps->make_route_filename($route['id']);
		$re['route_file_basename']=basename($route_filename);
		$re['download_note']=$route['download_note']; // Did this route come from the cache
		$re['route_name']=$route['name'];
		
        // RWGPS Route Description tags
        
        if(!empty($route['description']))
            $re['route_tags']=$route_tags=$this->rwgps->parse_description($route['description'],$this->rwgps->valid_event_description_keys);
        else
            $route_tags=[];

        // Maybe someday this can be automatically computed from the RWGPS data? 
		$re['pavement_type']=(empty($route_tags['pavement_type']))?"Unspecified":$route_tags['pavement_type'];  

		
		// Data Files
		
        $df_links=[];
        foreach($route['route_datafile'] as $ext=>$fn){
            $uc_ext=strtoupper($ext);
            $base_fn=basename($fn);
            $df_links[]="<A TITLE='$uc_ext file download' HREF='" . $route['saved_route_url'][$ext] . "'>$uc_ext</A>"; 
        }
        $re['df_links_txt']=$df_links_txt=implode(', ', $df_links);

        // EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT EVENT 
		// This function assumes a valid $event with certain basic fields that 
		// should be guaranteed from the database fetch

		$required_event_keys=['id','name','distance',
            'date','sanction','type','start_time','start_city',
            'start_state','organizer','club_id','rusa_route','cue_version'];		
		
		// Sanity check of event 
		if(empty($event)) $this->die_error(__METHOD__, "This can't happen: Empty event"); 
		foreach($required_event_keys as $k)
			if(!array_key_exists($k, $event) /*|| empty($event[$k]) */ ) {
                $this->die_error(__METHOD__,"Missing event field: $k<br>Event: " . print_r(array_keys($event),true));
            }
		
		// Copy into RE various event fields. These may require some calculation or respelling. Many (but not all) are given the event_ prefix
		// There is no indiscriminate copying like there was with the route object
		
		$re['event_id']=$event_id=$event['id'];	
		$re['event_name']=$event_name=$event['name'];	
		$re['event_distance']=$event_distance=$event['distance'];	
		$re['event_date']=$event_date=$event['date'];	

		$re['has_rwgps_route']=$event['has_rwgps_route'];
		$re['rwgps_url']=$event['rwgps_url'];
		$re['map_url']=$event['map_url'];
		
        $re['rusa_route']=$rusa_route=$event['rusa_route'];	

		$od=$this->model_parando->get_organizer($event);
		$re['organizer_name']=$organizer_name=$od['organizer_name'];
		$re['organizer_phone']=$organizer_phone=$od['organizer_phone'];
		
        // Fields in event that are a function of the club
		$re['club']=$club=$event['club'];
		$re['club_name']=$club_name=$club['name'];
		$re['this_organization']=$this_organization=$club['name'];
        $re['logo_url']=$club['logo_url'];
        $re['club_logo_url']=$club['logo_url'];
        $re['club_website_url']=$club['website_url'];
        $re['event_tzname']=$event_tzname=$club['tzname'];
		
		$re['event_name_dist']=$event_name_dist=$event['name'] . ' ' . $this->model_parando->make_distance($event);
		$re['event_type']=$event_type=strtolower($event['sanction']);
		$re['event_style']=$event_style=strtolower($event['type']);
		$re['event_time']=$event_time=$event['start_time'];
		$re['event_location']=$event_location=$event['start_city'] . ' ' . $event['start_state'];
	
		$re['event_tz']=$event_tz=new DateTimeZone( $event_tzname );
		$re['event_roster']=$event_roster=$this->model_parando->get_roster($event_id);
        $re['event_tagname']=$this->model_parando->make_event_tagname($event);
		
		if(!empty($event['cuesheet'])){
			$re['cuesheet_url']=make_site_url($event['cuesheet']);
			$re['has_cuesheet']=true; $re['cuesheet_location']='url'; 
		}else	if($event['has_rwgps_route'] && isset($event['cue_version']) && $event['cue_version']>0){
			$re['has_cuesheet']=true; $re['cuesheet_location']='auto'; $re['cuesheet_url']=null;
		}else{
			$re['has_cuesheet']=false; $re['cuesheet_location']=null; $re['cuesheet_url']=null;
		}
		
		$re['cue_version']=$cue_version=(empty($event['cue_version']))?0:($event['cue_version']);
        $re['cue_version_str']=($cue_version>0)?"$cue_version":"None";
		$re['cue_next_version']=$cue_version+1;
		
		// Now that all info is in, do  some validation

		if(empty($event_location)){
			$re['event_location']=$event_location="UNKNOWN, XX";
			$warnings[]="Event location not set. Please set the 'City, State' of event start.";
		}
		
		if(empty($re['event_distance'])){ 
			$re['event_distance']=$event_distance=ceil($re['distance_km']);
			$warnings[]="Official distance not specified. Assuming $event_distance K";
		}

		if($event_distance>$distance_km){
			$warnings[]="Route is too short. Route distance $distance_km km < Official distance $event_distance km.";
		}
		
		$vet=$this->controletimes->valid_event_types;
		if( !empty($event_type) && !array_key_exists($event_type,$vet)) {
			$this->die_error(__METHOD__, "Unsupported event type: $event_type. Valid types are: " . implode(', ', array_keys($vet)));
        }
		if(empty($event_type)){
			$re['event_type']=$event_type='unknown';
			$warnings[]="Event type not set. Set type equal to one of the following:" . implode(', ', array_keys($vet));
		}

		if($event_type=='permanent' && !isset($re['organizer_rusa_id'])) 
			$warnings[]="Event is permanent. Must set organizer_rusa_id";

		if($event_type=='permanent' && !isset($re['rusa_route_id'])) 
			$warnings[]="Event is permanent. Must set rusa_route_id";

		// TIME AND DATE

		date_default_timezone_set($event_tzname); 
		$re['last_update']=date("Y-m-j H:i:s T",$re['updated_at']); 
		$re['last_download']=date("Y-m-j H:i:s T",$re['downloaded_at']); 

		
		$re['now']=$now=new DateTime('now',$event_tz);
		$re['now_str']=$now->format($this->controletimes->event_datetime_format);
		
		
        if(empty($re['event_date']) || $re['event_date']==$this->controletimes->default_event_date){
			$re['event_date']=$event_date=$this->controletimes->default_event_date;
			$warnings[]="Event date not set. Please set the start date. Default is " . $this->controletimes->default_event_date;
		}
		
		if(empty($re['event_time']) || $re['event_time']==$this->controletimes->default_event_time){
			$re['event_time']=$event_time=$this->controletimes->default_event_time;
			$warnings[]="Event time not set. Please to set the start time. Default is " . $this->controletimes->default_event_time;
		}
		

		// Attempt to make datetime object for start 
		$re['event_datetime'] = $event_datetime = $this->controletimes->make_event_datetime($re);
		

		if(false == $event_datetime){ 
			$dtz= "D=" . $re['event_date'] . "; T=" . $re['event_time'] . "; Z=" . print_r($re['event_tz'],true);
			$this->die_error(__METHOD__,"Invalid or missing date, time, or timezone. DTZ=$dtz");
		}
		
		$re['event_datetime_str'] = $event_datetime_str = $event_datetime->format($this->controletimes->event_datetime_format);
		$re['event_datetime_str_verbose'] = $event_datetime_str_verbose = $event_datetime->format($this->controletimes->event_datetime_format_verbose);
		
		return [$re, $warnings];
	}

	
// VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS
// VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS
// VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS VIEWS

	// General Administrator/Organizer and INFO Cue Wizard view of route
	
	private function view_wizard($re, $controles, $warnings){
        $this->_generate_view_html($re, $controles, $warnings, true);
	}
	
	private function view_info($re, $controles, $warnings){
        $this->_generate_view_html($re, $controles, $warnings, false);
	}

	private function _generate_view_html($re, $controles, $warnings, $wizard=false){

		extract($re); // All route_event variables are now local

		$event_tagname=$this->model_parando->make_event_tagname($re);
		$rusa_route_str=(empty($rusa_route))?"None":"$rusa_route";
		
		$event_type_uc=strtoupper($event_type);
		$general_info=<<<EOT
<div class='routeinfo'>
<A HREF='$club_website_url'><IMG SRC=$club_logo_url WIDTH=15.8%></A>
<H4>GENERAL INFO</h4>
<div class='narrower'> 
<TABLE WIDTH=100%>
<TR><TD>Start Date/Time</TD><TD>$event_datetime_str</TD></TR>
<TR><TD>Event Type</TD><TD>$event_type_uc</TD></TR>
<TR><TD>Location</TD><TD>$event_location</TD></TR>
<TR><TD>Club</TD><TD>$club_name</TD></TR>
<TR><TD>Official Distance</TD><TD>$event_distance km</TD></TR>
<TR><TD>Route Distance</TD><TD>$distance_mi mi / $distance_km km</TD></TR>
<TR><TD>Climbing</TD><TD>$climbing_ft ft</TD></TR>
<TR><TD>Pavement Type</TD><TD>$pavement_type</TD></TR>
<TR><TD>RUSA Route ID</TD><TD>$rusa_route_str</TD></TR>
<TR><TD>Event Tagname</TD><TD>$event_tagname</TD></TR>
</TABLE></DIV></DIV>
EOT;

		if($has_rwgps_route){
            $available_route_data=<<<EOT
<H4>GPS ROUTE DATA</h4>
<div class='narrower routeinfo'>
<TABLE WIDTH=100%>
<TR><TD>RWGPS Route Name</TD><TD>$route_name</TD></TR>
<TR><TD>Last Modified</TD><TD>$last_update</TD></TR>
<TR><TD>RWGPS Link URL</TD><TD><A HREF=$route_url>$route_url</a></TD></TR>
<TR><TD>GPS File Download</TD><TD>$df_links_txt</TD></TR>
</TABLE></DIV>
EOT;
		}elseif(!empty($map_url)){
			$available_route_data=<<<EOT
<H4>MAP/PROFILE</h4>
<p>Unfortunately, at this time there is no GPS data for this route. Only a static (non-GPS) map and elevation profile is available.</P>
<div class='button-container text-center'><A HREF=$map_url>Download Map and Profile Info</A></DIV>
EOT;
		// No Map
		}else{
			$available_route_data=<<<EOT
<H4>MAP/PROFILE</h4>
<p>Unfortunately, at this time no GPS data, map, or elevation profile information is available for this event.</p>
EOT;
		}

		
        // Route Description Tags
        if($wizard){
            $route_tag_data=""; // "<H4>DESCRIPTION TAGS</H4>";
            if(!empty($route_tags['unrecognized'])){
                $route_tag_data.="<span class=red>WARNING: Unrecognized tags found in RWGPS route Description.</span> These tags have been ignored. Please delete them!<br/><div class='half-width-indented bordered'>";
                $route_tag_data.=implode(', ', $route_tags['unrecognized']);
                $route_tag_data.="</div>";
                unset($route_tags['unrecognized']);
            }
            if(empty($route_tags)){
                $route_tag_data.="<p>No VALID tags found in route Description. (Consider adding #pavement_type=whatever to the RWGPS route Description)</p>";
            }else{
                $route_tag_data.="VALID tags found in route Description:<br/><div class=vspace></div><div class='indent smaller tt'>";
                $route_tag_data.=$this->wizard->format_attributes($route_tags);
                $route_tag_data.="</div>";
                $route_tag_data.="<div class=vspace></div>";
            }
        }else{
            $route_tag_data="";
        }
		
		
		// CUESHEETS CUESHEETS CUESHEETS CUESHEETS CUESHEETS CUESHEETS CUESHEETS CUESHEETS CUESHEETS 
		
             $cue_sheet_info="<H4>CUE SHEETS</h4>";
 
             // No Cues
            if($has_cuesheet===false){
                $cue_sheet_info.="<p>At this time no cue sheet is available for this event.</p>";
                $published_at=0;
                $cuesheet_gentime_str="Never";
               
            // Cue Wizard Cuesheet
            }elseif($cuesheet_location=='auto'){

                $cue_basename="$event_tagname-CueSheetV$cue_version";
                $csv_filename=$this->model_parando->cuesheet_path . "/" . $cue_basename . ".csv";
                if(file_exists($csv_filename))
                    $published_at=filectime($csv_filename);
                else
                    $published_at=0;
                
                if($cue_version>0 && $published_at>0){
                    date_default_timezone_set($event_tzname);
                    $cuesheet_gentime_str=date("Y-m-j H:i:s T",$published_at);
                    $cuesheet_version_str="$cue_version";
                }else{
                    $this->die_error(__METHOD__, "This can't happen. Cuesheet unexpectedly missing. CSV File: $csv_filename");
                }
                
                $cuesheet_url_P=$this->model_parando->cuesheet_baseurl . "/" . $cue_basename . "-P.pdf";
                $cuesheet_url_L=$this->model_parando->cuesheet_baseurl . "/" . $cue_basename . "-L.pdf";
                $cuesheet_url_C=$this->model_parando->cuesheet_baseurl . "/" . $cue_basename . ".csv";
                $cue_sheet_info.=<<<EOT
<div class='narrower routeinfo'><TABLE WIDTH=100%>
<TR><TD>Cuesheet Generated</TD><TD>$cuesheet_gentime_str</TD></TR>
<TR><TD>Cuesheet Version</TD><TD>$cue_version</TD></TR>
</TABLE></DIV>
EOT;
                $buttons ="<A HREF=$cuesheet_url_P>Cue Sheet (Portrait)</A>";
                $buttons.="<A HREF=$cuesheet_url_L>Cue Sheet (Landscape)</A>";
                $buttons.="<A HREF=$cuesheet_url_C>Cue Sheet (CSV)</A>";
                $cue_sheet_info.="<div class='button-container text-center'>$buttons</DIV>";

            // Static cue link
            }else{
                $cue_sheet_info.=<<<EOT
<p>A legacy Cuesheet is available for this event.
<div class='narrower routeinfo'><TABLE WIDTH=100%>
<TR><TD>Cuesheet</TD><TD><A HREF=$cuesheet_url>$cuesheet_url</a></TD></TR>
</TABLE></DIV>
EOT;
                $buttons ="<A HREF=$cuesheet_url>Download Cue Sheet</A>";
                $cue_sheet_info.="<div class='button-container text-center'>$buttons</DIV>";
            }

        // More simplified version for wizards
        
        if($wizard){
            $cue_sheet_info="<H4>PUBLISHED CUE SHEETS</h4>";
            if($has_cuesheet===false){
                $cue_sheet_info.="<p>At this time no cue sheet is available for this event.</p>";
            }elseif($cuesheet_location!='auto'){
                $cue_sheet_info.="<p>WARNING: A Legacy Cue Sheet is available for this route.</p>";
            }else{
                $cue_sheet_info.=<<<EOT
<div class='narrower routeinfo'><TABLE WIDTH=100%>
<TR><TD>Last Published</TD><TD>$cuesheet_gentime_str</TD></TR>
<TR><TD>Published Version</TD><TD>$cue_version_str</TD></TR>
<TR><TD>Published Cue Files</TD><TD><A HREF=$cuesheet_url_P>Portrait</A>, 
<A HREF=$cuesheet_url_L>Landscape</A>, <A HREF=$cuesheet_url_C>CSV</A></TD></TR>
</TABLE></DIV>
EOT;
            }
        }

         // Controle table
		$ncontroles=count($controles);
		$controles_table=$this->make_controles_table($controles,$wizard);
		
		if($wizard){
            $wizard_controles_table=$controles_table;
            $user_controles_table="";
        }else{
            $wizard_controles_table="";
            $user_controles_table=$controles_table;
        }
        
		// Wizard Text
		
		$wizard_body="";
		$warning_body="";
		$download_body="";
		$generate_form="";
		
		if($wizard){
		
            $wizard_body="<H3>CUE WIZARD</H3>";
            
            if($updated_at > $published_at) 
                $warnings[]="Route data newer than published cuesheets.";
 
            if(!empty($warnings)){
                $cw=implode('</li><li>',$warnings);
                $warning_body =<<<EOT
<h4>ROUTE DATA VALIDATION</H4>
<div class="bordered narrower sans red">
<div class="vspace"></div>
<p>Errors found in the route data</p>
<ul><li>$cw</li></ul>
<p>Fix these Errors by previewing to check, and then publish again.</p>
</div><div class="vspace"></div>
EOT;
            }else{
                $warning_body =<<<EOT
<h4>ROUTE DATA VALIDATION</H4>
<p>No errors or warnings.</p>
EOT;
}
		
            // Various URLs for download forms and buttons
            $this_url=site_url(strtolower(get_class($this)));
            $route_event_id="$route_id/$event_id";
            $download_url="$this_url/recache/$event_id";
            $event_url="$this_url/event/$event_id";
            $publish_url="$this_url/publish_cuesheet/$event_id";

            $download_body=<<<EOT
<h4>DOWLOAD LATEST ROUTE DATA</h4>
<P>If you made changes in the route on RWGPS that 
affect the published cues, brevet cards, etc... you must re-dowload the data here
and then publish again.</p> 
<div class="bordered narrower text-center">
  $download_note<br/>
  <div class="button-container"><A HREF=$download_url>Re-download updated route from RWGPS</A></div>
  <P>Last Download: $last_download</P>
</div>
<div class="vspace"></div>
EOT;

// IS IT TRUE THAT SOME PAPERWORK GOES LIVE INSTANTLY (EG BREVET CARDS) OR ARE THEY PUBLISHED TOO?  BUG?

            $generate_form=<<<EOT
<h4>CUESHEET AND BREVET CARD PREVIEW</h4>
<P>Press the buttons below for <b>preview versions</b> of the cuesheet and brevet cards generated
now based on the last route data downloaded. This paperwork won't go live till you press
the 'Publish Cuesheets to Event' button.</P>
<FORM ACTION=$event_url METHOD=POST  enctype="multipart/form-data">
<div class="narrower button-stack">
    <BUTTON TYPE=SUBMIT NAME='view' value='pdf_cue_portrait'>PDF Cuesheet (portrait)</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='pdf_cue_landscape'>PDF Cuesheet (landscape)</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='csv_cue'>CSV Cue Sheet</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='search_replace_changes'>Cue Sheet Search Replace Changes</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='card_outside_blank'>Brevet Card Outside Blank</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='card_outside_roster'>Brevet Card Outside Roster</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='card_inside'>Brevet Card Inside</BUTTON>
    <BUTTON TYPE=SUBMIT NAME='view' value='qrpdf'>QR Codes</BUTTON>
</DIV><div class=vspace></div>

<h4>CUESHEET PUBLISH</h4>
<p>Once you are happy with the cuesheets generated above, press the button below 
to publish this new version of the cuesheet to the $this_organization event info page. <B>Don't
forget to publish after you make changes!</b></P>
<div class="bordered narrower text-center">
Last Published on: $cuesheet_gentime_str, Version: $cue_version_str<BR/>
<div class="button-container"><A HREF=$publish_url>Publish New (Ver $cue_next_version) Cuesheets to Event</A></div>
</div>
<div class="vspace"></div>
</FORM>
EOT;
        }
        
        // MAP and Elevation Profile
        $map_divid='randomap'; // must match ID in randomap.css
		$graph_divid='epdivid'; // must match ID in randomap.css
		$route=$this->rwgps->get_route($route_id);
		$map_script=$this->map->generate_map_script($route,$controles,$map_divid);
		$ep_script=$this->map->generate_ep_script($route, $controles, $graph_divid);
		$map_body=<<<EOT
<H4>MAP</H4>
<div class='narrower text-center'>
<div id=$map_divid></div>
<A HREF=$route_url>View in Ride With GPS</a>
<div class=bigskip></div>
<div id=$graph_divid style="margin-left:10%; margin-right:10%; width:80%; height:180px;"></div>
</div>
$map_script
$ep_script
EOT;

		// Wizard User Disclaimer
        $wizard_fineprint=$this->wizard->disclaimer_html;

        // General Disclaimer Paragraph
		$route_fineprint=($wizard)?"":"<DIV CLASS='narrower fine-print bordered'><p>" . $this->model_parando->get_paragraph("auto_cue") . "</p></div>";
		
		// PUT THE PAGE TOGETHER
		// PUT THE PAGE TOGETHER
		// PUT THE PAGE TOGETHER
		// PUT THE PAGE TOGETHER
		// PUT THE PAGE TOGETHER

		$page_body=<<<EOT
<!-- All -->
<H3>$event_name_dist</H3>
$general_info
$available_route_data

<!-- Wizard Only -->
$wizard_body
$warning_body
$route_tag_data

<!-- All -->
$cue_sheet_info

<!-- Wizard Only -->
$download_body
$generate_form

<!-- User Only -->
$route_fineprint

<!-- All -->
$map_body
$controles_table

<div class=bigskip></div>
$wizard_fineprint
EOT;

		$data=['title'=>$event_name_dist, 'left_column'=>$page_body, 'right_column'=>""];
		$this->simple_view('info_one_column',['randomap','table','buttonlink','form'],$data);
	
	}
	
	// Might this be best in some library? 

	private function make_controles_table($controles,$verbose=true){
        $controles_table= "";
        $ncontroles=count($controles);
		if($ncontroles>0){
            $controles_table ="<H4>CONTROLES</H4>";
            $controles_table.="<div class='narrower ftable'><TABLE WIDTH=100%>";
            
            if($verbose)
                $controles_table.= "<TR><TH>Controle</TH><TH>Distance</TH><TH>Open/Close</TH><TH>Note</TH><TH>Description (attributes)</TH></TR>";
            else
                $controles_table.= "<TR><TH>Controle</TH><TH>Distance</TH><TH>Open/Close</TH><TH>Location</TH></TR>";
                
            for($i=0; $i<$ncontroles; $i++){
                $cd_mi=round($controles[$i]['d']/(rwgps::m_per_km*rwgps::km_per_mi),1);
                $cd_km=round($controles[$i]['d']/(rwgps::m_per_km),1);
                $is_start=(isset($controles[$i]['start']))?" [START]":"";
                $is_finish=(isset($controles[$i]['finish']))?" [FINISH]":"";
                $controle_num=$i+1;
                $open_str=$controles[$i]['open']->format('m-d H:i');
                $close_str=$controles[$i]['close']->format('m-d H:i');
                if($verbose){
                    $ca=$this->wizard->format_attributes($controles[$i]['attributes']);
                    $qrcode_url=$controles[$i]['qrcode_url'];
                    $qrcode_checkin_url=$controles[$i]['qrcode_checkin_url'];
                    $ca.="QR CODE: <A HREF=$qrcode_url>" . $controles[$i]['info_code'] . "</A>, Check in <A HREF=$qrcode_checkin_url>NOW</A><br/>";
                   $cn=(isset($controles[$i]['n']))?$controles[$i]['n']:"";
                    $controles_table.= "<TR><TD>$controle_num$is_start$is_finish</TD><TD>$cd_mi mi<br>$cd_km km</TD><TD>$open_str<br>$close_str</TD><TD>$cn</TD><TD>$ca</TD></TR>";
                }else{
                    $cd=$this->wizard->format_control_description_table($controles[$i]['attributes']); 
                    $controles_table.= "<TR><TD>$controle_num$is_start$is_finish</TD><TD>$cd_mi mi<br>$cd_km km</TD><TD>$open_str<br>$close_str</TD><TD>$cd</TD></TR>";
                }
            }
            $controles_table.="</TABLE></DIV>";
        }
        return $controles_table;
	}


	// Raw JSON View
	
	private function view_json($route_event, $controles, $warnings){
		$route=$this->rwgps->get_route($route_event['route_id']);
		header("Content-Type: application/json; charset=UTF-8");
		echo json_encode($route);
		exit();
	}

	// Cue processing debug log view

	private function view_search_replace_changes($route_event, $controles, $warnings){

		$ncontroles=count($controles);
		extract($route_event);


		$route=$this->rwgps->get_route($route_id);
		list($cues, $cue_warnings)=$this->rwgps->extract_cues($route);
		$warnings=array_merge($warnings, $cue_warnings);
		$this->die_view_warnings($warnings);

		$params=['event'=>$route_event];
		$this->load->library('cuesheet', $params);
		$this->cuesheet->set_controle_date_format($route_event);
		// $header_text=$this->cuesheet->header_text_array($route_event);
		$cue_text=$this->cuesheet->cue_text_array($cues, $controles);
		
		$change_log=[];
		foreach($cue_text as $line){
			$controle_i=array_shift($line);
			if(empty($controle_i)){
				$line[$this->cuesheet->dist_cols+1]=$this->cuesheet->clean_string($line[$this->cuesheet->dist_cols+1]); // clean note
				$line_r=$this->cuesheet->replace_cues($line);
					$dist=$line[0];
					$dir=$line[$this->cuesheet->dist_cols+0];
					$dir_r=$line_r[$this->cuesheet->dist_cols+0];
					$note=$line[$this->cuesheet->dist_cols+1];
					$note_r=$line_r[$this->cuesheet->dist_cols+1];
				if($note_r != $note){
		      $change_log[]=[$dist, "$dir: $note", ">>>>>", "$dir_r: $note_r"];
				}
			}
		}



		if(!empty($warnings)){
		$cw=implode('</li><li>',$warnings);
		$warning_text=<<<EOT
<div class="bordered narrower red">
<div class="vspace"></div>
<div class="large-print sans">ERRORS:</div>
<ul><li>$cw</li></ul>
EOT;
		}else{$warning_text='';}

		$left_column=<<<EOT
<H3>$event_name_dist</H3>
$warning_text
<H4>Cue Search/Replace Changes</H4>
<div class='narrower ftable'><TABLE WIDTH=100%><TR><TD>
EOT;
		$func=function($a){
			return implode("</TD><TD>",$a);
		};
		$left_column .= implode("</TD></TR><TR><TD>", array_map($func ,$change_log));
		$left_column .=<<<EOT
</TD></TR></TABLE></DIV>

EOT;


		$data=['title'=>$event_name_dist, 'left_column'=>$left_column, 'right_column'=>''];
		$this->simple_view('info_one_column',['table'],$data);
	}
	
	// PDF Rendered cue_sheet Views
	
	private function view_pdf_cue($route_event, $controles, $warnings){
		$this->_view_pdf_cue($route_event, $controles, $warnings, 'P');
	
	}
	private function view_pdf_cue_portrait($route_event, $controles, $warnings){
		$this->_view_pdf_cue($route_event, $controles, $warnings, 'P');
	
	}
	private function view_pdf_cue_landscape($route_event, $controles, $warnings){
		$this->_view_pdf_cue($route_event, $controles, $warnings, 'L');
	
	}

	private function _view_pdf_cue($route_event, $controles, $warnings, $orientation='P', $size='letter'){
	
		$route=$this->rwgps->get_route($route_event['route_id']);
		list($cues, $cue_warnings)=$this->rwgps->extract_cues($route);
		$warnings=array_merge($warnings, $cue_warnings);
		$this->die_view_warnings($warnings);
		$params=['event'=>$route_event, 'orientation'=>$orientation, 'size'=>$size];
		$this->load->library('cuesheet', $params);
		$this->cuesheet->AddPage();

		$this->cuesheet->set_controle_date_format($route_event);
		$this->cuesheet->draw_cuesheet_pages($route_event, $cues, $controles);
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$this->cuesheet->Output("I", "$event_tagname-CueSheet-$orientation.pdf");

	}

	private function view_csv_cue($route_event, $controles, $warnings){
	
		$route=$this->rwgps->get_route($route_event['route_id']);
		list($cues, $cue_warnings)=$this->rwgps->extract_cues($route);
		$warnings=array_merge($warnings, $cue_warnings);
		$this->die_view_warnings($warnings);

		$params=['event'=>$route_event];
		$this->load->library('cuesheet', $params);
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$csv_filename="$event_tagname-CueSheet.csv";

		$header_text=$this->cuesheet->header_text_array($route_event);
		$cue_text=$this->cuesheet->cue_text_array($cues, $controles);
		$this->emit_csv(array_merge($header_text,$cue_text), $csv_filename);
		exit();

	}
	
	private function emit_csv($array,$filename='data.csv',$write=false){
		if($write){
			$output = fopen($filename,'w') or die("Can't open $filename");
		}else{
			$output = fopen("php://output",'w') or die("Can't open php://output");
			header("Content-Type:application/csv"); 
			header("Content-Disposition:attachment;filename=$filename"); 
		}
		foreach($array as $row) {
			fputcsv($output, $row);
		}
		fclose($output) or die("Can't close output.");	
	}

	
		
	// PDF Rendered Brevet Card Views

	private function view_card_inside ($route_event, $controles, $warnings){
		$this->view_card_inside_withoptions($route_event, $controles, $warnings, ['validate_first'=>true]);
	}

	private function view_card_inside_novalidatefirst ($route_event, $controles, $warnings){
		$this->view_card_inside_withoptions($route_event, $controles, $warnings, []);
	}

	private function view_card_inside_withoptions ($route_event, $controles, $warnings, $opts=[] ){
	
		$this->die_view_warnings($warnings);

		$this->load->library('brevetcard', $route_event);

		while(count($controles)>($this->brevetcard->cpf*$this->brevetcard->n_folds)){ 
			$this->brevetcard->n_folds++;
		}

		$this->brevetcard->AddPage();
		$this->brevetcard->set_controle_date_format($route_event);

		// set false if you don't want the first controle validated when cards are prined
		$logo_url=(isset($opts['validate_first']) && isset($route_event['logo_url']))?$route_event['logo_url']:null;

		$this->brevetcard->draw_card_inside($controles,$logo_url);
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$this->brevetcard->Output("I", "$event_tagname-CardInside.pdf");
	
	}	

	private function view_card_outside_blank ($route_event, $controles, $warnings){
	
		$this->die_view_warnings($warnings);

		$this->load->library('brevetcard', $route_event);

		while(count($controles)>($this->brevetcard->cpf*$this->brevetcard->n_folds)){ 
			$this->brevetcard->n_folds++;
		}
		
		$this->brevetcard->AddPage();
		$this->brevetcard->draw_card_outside($route_event);
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$this->brevetcard->Output("I", "$event_tagname-CardOutsideBlank.pdf");
	
	}	

	private function view_card_outside_roster ($route_event, $controles, $warnings){
	
		$this->die_view_warnings($warnings);
		
		if(empty($route_event['event_roster'])) $this->die_error(__METHOD__, "No roster for event.");
		$roster=$route_event['event_roster']; // $route$this->model_parando->get_roster($route_event['event_id']);
		
		$this->load->library('brevetcard', $route_event);

		while(count($controles)>($this->brevetcard->cpf*$this->brevetcard->n_folds)){ 
			$this->brevetcard->n_folds++;
		}
			
		$n_riders=count($roster);
		$n_cards = $this->brevetcard->n_cards;
		
		for($i=0; $i<$n_riders; $i+=$n_cards){
			$r=array_slice($roster, $i, $n_cards);
			$this->brevetcard->AddPage();
			$this->brevetcard->draw_card_outside($route_event, $r);
		}
		
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$this->brevetcard->Output("I", "$event_tagname-CardOutsideRoster.pdf");
	
	}	
	
    // MAP AND EP ONLY
	
	private function view_map($route_event, $controles, $warnings){
	
		extract($route_event); // All route_event variables are now local
		$route=$this->rwgps->get_route($route_id);

		$provider='mapbox';
			
		$name=$route_name;
		$title = "$name (RWGPS #$route_id)";
		$data=[	'title'=>$title,
				'this_organization'=>$club_name];
				
				
		$map_divid='randomap';
		$graph_divid='eprofile';
		$map_script=$this->map->generate_map_script($route, $controles, $map_divid,'randomapv',$provider);
		$ep_script=$this->map->generate_ep_script($route, $controles, $graph_divid);

		$data['body']=<<<EOT
<div class='narrower'>
	<h1>$title</h1>
	<div id=$map_divid></div>
	<div class=bigskip></div>
	<div id=$graph_divid style="margin-left:10%; margin-right:10%; width:80%; height:180px;"></div>
	<div class=bigskip></div>
</div>

$map_script
$ep_script
EOT;

		$this->load->view('simple_header',array_merge($data,['page_styles'=>['randomap']]));
		$this->load->view('simple_body',$data);
		$this->load->view('simple_footer',$data);
	}

    // QRCODES


	private function view_qrpdf($route_event, $controles, $warnings){
		$this->controlqr->make_qr_images($route_event, $controles, true);
		$this->controlqr->draw_qr_pages($controles);
		$event_tagname=$this->model_parando->make_event_tagname($route_event);
		$this->controlqr->Output("I", "$event_tagname-QRCodes.pdf");
	}
	
	
	public function compute_info_codes($route_event,&$controles){
		$params=[
			'route_event'=>$route_event, 
			'orientation'=>'P', 
			'size'=>'letter'
		];
		
		$this->load->library('controlqr', $params);  // SIDE EFFECT
		for($i=0; $i<count($controles); $i++){ 
            $control_number=$i+1;
            $qrp=$this->controlqr->make_qr_paths($route_event,$control_number);
			$controles[$i]['info_code']=$qrp['info_code'];
			$controles[$i]['qrcode_checkin_url']=$qrp['qrcode_checkin_url'];
			$controles[$i]['qrcode_url']=$qrp['qrcode_url'];
			$controles[$i]['qrcode_file']=$qrp['qrcode_file'];
		}
	}


	private function die_view_warnings($warnings){ // for views that want to die if there are warnings
		
		if(!empty($warnings)){
			$cw=implode('</li><li>',$warnings);
			$left_column =<<<EOT
<p>The requested function is not available because of Errors in route data.</p>
<ul><li>$cw</li></ul>
<p>Fix these Errors by editing the RWGPS route, saving in RWGPS, and re-downloading.</p>
EOT;
			$this->die_error('Route Errors', $left_column);
		}
		
	}
	



	
}
