<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
 
 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

class Utility extends MY_Controller {

    // WARNING SECURITY RISK -- KEEP DISABLED (set false)
    // WARNING SECURITY RISK -- KEEP DISABLED (set false)
    // WARNING SECURITY RISK -- KEEP DISABLED (set false)
    // WARNING SECURITY RISK -- KEEP DISABLED (set false)
    // WARNING SECURITY RISK -- KEEP DISABLED (set false)

	private $allow_insecure_methods=false;

	
  // CONSTRUCTOR

	public function __construct() {
		parent::__construct();
	}

  public function query_rusa_id($rusa_id){
		$this->load->library('rusa');
		$m=$this->rusa->query_rusa_id($rusa_id);
		$m=($m===false)?'ID not found in RUSA database.':$m;
		$this->die_info(__METHOD__, print_r($m,true));
  }

  public function rusa_update(){
		$this->load->library('rusa');
		$m=$this->rusa->get_member_list();
		$n=count($m);
		foreach ($m as $rusa_id=>$mdata){
			if(false===$this->db->replace('rusa',$mdata)) $this->die_error(__METHOD__, "Could not replace record for RUSA ID $rusa_id");  
		}
		
		$this->die_info(__METHOD__, "Loaded $n RUSA members on " . $this->model_parando->timestamp());
  }
  
    // WARNING SECURITY RISK -- KEEP DISABLED (set false)
    
 	public function show_session(){
		if($this->allow_insecure_methods){
		$this->load->library('session');
 			$this->die_error( '['. get_class($this). ']: ' . 'Session Variables', 
 				'<br><pre>' . print_r($this->session->userdata,true) . '</pre>');
		}
 	}

	public function clear_session(){
		$this->session->sess_destroy();
		$this->die_error( __METHOD__, "Done");
	}

	public function delete_orphan_items(){

		$check=[
			'purchase_item'=>'purchase',
			'fleche_team_member'=>'fleche_team',
			'fleche_team'=>'event'
		];

		$ts=$this->model_parando->timestamp();
		$log="<p>On $ts<br><br>";
		foreach($check as $child=>$parent){
			$sql="delete from {$child} where {$parent}_id not in (select id from {$parent})";
			$this->db->query($sql);
			$n=$this->db->affected_rows(); 
			$log .= "Deleted $n records from $child<br>";
		}

		$this->die_info(__METHOD__, $log);

	}
	
	
		public function regions(){
		$this->load->library('regions');
		
		$body="<pre>region_map : {\n" ;
		foreach ($this->regions->region_list as $r){
		  extract($r);
 		  $body.=<<<EOF
  $club_code : {
    'state_code' : '$state_code',
    'state_name' : '$state_name', 
    'region_name' : '$region_name',
    'club_name' : '$club_name', 
    'event_url' : '$url',
  },
  
EOF;

		}
			$body_data['body']="$body\n}</pre>";
		    $this->utility_view('Regions',$body_data,['table']);

		}
	
	    const rusa_clubsearch_url="";
		const rusa_resultsearch_url="https://rusa.org/cgi-bin/resultsearch_PF.pl";
		const rusa_check_members_url="https://rusa.org/cgi-bin/check_members.pl";
		const rusa_membership_url="https://rusa.org/cgi-bin/memberlist_PF.pl?type=1";
		const rusa_regid=46;
		
		// Function that attempts to scrape the RUSA website for event ids for a given year. 
		// It will write them to our database if found. 
		// Some fuzzy matching needed for the fleche date 
		
		public function get_rusa_eid($year){
			$query_url=self::rusa_resultsearch_url . "?regid=" . self::rusa_regid . "&date=$year&esortby=cert";

			$c = curl_init();
			curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($c, CURLOPT_URL, $query_url);
			curl_setopt($c, CURLOPT_SSL_VERIFYPEER, false);
			// curl_setopt($c, CURLOPT_SSL_VERIFYSTATUS, false);
			$result = curl_exec($c);
			if(! $result)	$this->die_error(__METHOD__, "Could not fetch $query_url<br>" . curl_error($c));
        	curl_close($c);
        	
        	
			$match_pattern='!There were multiple matching events.*?</thead>(.*?)</table>!is';

			$rc=preg_match($match_pattern,$result,$m);
			if($rc===false) $this->die_error(__METHOD__,"Error matching RUSA event query response");
			if($rc===0) $this->die_error(__METHOD__,"Unrecognized RUSA event query response.<br>$result");
			$table_body=$m[1];
			
//			$match_pattern='!align=right>(\d+)</TD>.*?align=left>(\d{4}/\d{2}/\d{2}).*?eid=(\d+)[^\d]!si';
			$match_pattern='!<TD.*?>([A-Z]{4,5})</TD>\s+<TD.*?>(\d{3,4})</TD>\s+<TD.*?>(\d{4}/\d{2}/\d{2})</TD>.*?eid=(\d+)[^\d]!si';

			$rc=preg_match_all($match_pattern,$table_body,$m,PREG_PATTERN_ORDER);
			if($rc===false) $this->die_error(__METHOD__,"Error matching table body");
			if($rc===0) $this->die_error(__METHOD__,"Unrecognized table body.<br>$table_body");
			
			array_shift($m); // get rid of the full matches, only want the parethesized subpatterns
			$event_list=array_map(null, ...$m); // quirky PHP 2d matrix transpose
			
			$body="";
			foreach($event_list as $e){
				list($type,$dist,$date,$eid)=$e;
				$date=str_replace('/','-',$date);
				list($y,$m,$d)=explode('-',$date);
				if($type=='ACPF'){ 
					$sql="SELECT id FROM event where type='fleche' and year(date)=$y LIMIT 1";
					$q=$this->db->query($sql);
					$row = $q->row_array();
					$event_id=$row['id'];
				}else{
					$event_id=$this->model_parando->get_event_id_by_date_dist($date, $dist);
				}
				if(empty($event_id)){
				  $update="ERROR: No $dist K $type found on $date (eid=$eid)";
				  $event=null;
				  $name='?';
				}else{
				  $event=$this->model_parando->get_event($event_id);
					$name=$event['name'];
					if(empty($event['rusa_eid'])){
						$this->db->where('id',$event_id);
						$this->db->update('event',['rusa_eid'=>$eid]);					
						$update='RUSA EID Set';
					}else{
						$update='';
					}
				}
				
				$body.= "<TR><TD>$type</TD><TD>$dist</TD><TD>$date</TD><TD>$eid</TD><TD>$name</TD><TD>$update</TD></TR>";
			}

			$body_data['body']="";
//        	$body_data['body']="QUERY: $query_url<br>";
        	$body_data['body'].="<TABLE class=ftable>";
        	$header=['Type','Distance','Date','RUSA EID','Name','Action'];   	
        	$body_data['body'].="<TR><TH>" . implode('</TH><TH>',$header) . "</TH><TR>";   	
        	$body_data['body'].="$body</TABLE>";   	
        	$this->utility_view('RUSA Events',$body_data,['table']);
		}



	public function get_certs($year){
	
		$log=[];
		$log[]="Getting Certs for Year=$year";
	
		// Get list of events
		$sql="SELECT * FROM event where  rusa_eid>0 AND year(date)=$year order by date";  // not (type='fleche') AND
		$q=$this->db->query($sql);
		$event_list = $q->result_array();
		$ne=count($event_list);
		$log[]="Found $ne events";

		// For each event / event_id/rusa_eid
		foreach($event_list as $event){
			$event_id=$event['id'];
			extract($event);
			$log[]="<BR>EVENT: $date $type $distance $name EID=$rusa_eid";
			
			if(empty($rusa_eid)) $this->die_error(__METHOD__, "No RUSA EID for event: $date $type $distance $name"); 

			//   get PAR results
			$sql="SELECT roster.id as roster_id, first_name, last_name, rusa_id, cert FROM roster,member WHERE roster.result='FINISH' AND roster.member_id=member.id AND roster.event_id=$event_id";
			$q=$this->db->query($sql);
			$par_results = $q->result_array();
			$nf=count($par_results);
			$log[]="$nf PA Rando Finishers";
			
			if($nf==0) continue;
			
			//   get RUSA results
			$query_url=self::rusa_resultsearch_url . "?eid=$rusa_eid&esortby=cert";
			$c = curl_init();
			curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($c, CURLOPT_URL, $query_url);
			curl_setopt($c, CURLOPT_SSL_VERIFYPEER, false);
			// curl_setopt($c, CURLOPT_SSL_VERIFYSTATUS, false);
			$result = curl_exec($c);
			if(! $result)	$this->die_error(__METHOD__, "Could not fetch $query_url<br>" . curl_error($c));
        	curl_close($c);
		
			//   parse RUSA results (with cert)
			//   Table Body
			$match_pattern='!Cert#.*?</thead>(.*?)</table>!is';
			$rc=preg_match($match_pattern,$result,$m);
			if($rc===false) $this->die_error(__METHOD__,"Error matching RUSA result query response<br>Query=$query_url");
			if($rc===0) $this->die_error(__METHOD__,"Unrecognized RUSA result query response.<br>Query=$query_url<br>$result");
			$table_body=$m[1];
			
			// Row fields Cert, RUSA ID, Last/First
			$match_pattern='!<TR>\s+<TD.*?>([^<]*?)</TD>\s+<TD.*?>(\d+)</TD>\s+<TD.*?>([^<]*?)</TD>.*?</TR>!si';
			$rc=preg_match_all($match_pattern,$table_body,$m,PREG_PATTERN_ORDER);
			if($rc===false) $this->die_error(__METHOD__,"Error matching result table body");
			if($rc===0) $this->die_error(__METHOD__,"Unrecognized result table body.<br>$table_body");
			
			// Result array RUSA
			array_shift($m); // get rid of the full matches, only want the parethesized subpatterns
			$rusa_results=array_map(null, ...$m); // quirky PHP 2d matrix transpose
			$nrf=count($rusa_results);
			$log[]="$nrf RUSA finishers";
			if($nf!=$nrf) $log[]="ERROR: Number of PA Finishers doesn't equal number of RUSA Finishers";
			
			// Index RUSA results by RUSA ID
			$rusa_results_by_rusa_id=[];
			foreach($rusa_results as $r){
			  list($cert,$rusa_id,$last_first)=$r;
			  $rusa_results_by_rusa_id[$rusa_id]=compact('cert','rusa_id','last_first');
			}
			
			//   for each rider attempt to match RUSA and PAR results
			foreach($par_results as $r){
				extract($r);
				if(empty($rusa_results_by_rusa_id[$rusa_id])){ 
					$rusa_cert=null;
					$last_first='';
					$log[]="ERROR: Could not find RUSA Result for rider RUSA ID $rusa_id ($first_name $last_name) in event ID=$event_id";
				}else{
				  $rr=$rusa_results_by_rusa_id[$rusa_id];
				  $rusa_cert=$rr['cert'];
				  $last_first=$rr['last_first'];
			      $log[]="$first_name $last_name ($last_first): Cert PA=$cert; RUSA=$rusa_cert;";
				}
				
				//  if missing, update cert into PAR roster			
				if(empty($cert) && !empty($rusa_cert)){
						$this->db->where('id',$roster_id);
						$this->db->update('roster',['cert'=>$rusa_cert]);					
						$log[]="RUSA Cert ($rusa_cert) set at roster_id=$roster_id";
				}
			}		
		}
	
	
	    foreach($log as $i=>$e)
	      if(strstr($e,"ERROR")!==false) $log[$i]="<SPAN class=red>$e</SPAN>";
	      	
		$log[]='';
		
		

		$body_data['body']="";
		$body_data['body'].=implode('<BR>',$log);
		$this->utility_view('RUSA Certs',$body_data,['table']);
 	}	
	
	private function utility_view($title,$body_data,$page_styles=[]){
	
        $head_data['page_styles']=$page_styles;
		$head_data['title']=$title;
		
		$this->load->view('simple_header',$head_data); 
		$this->load->view('simple_body',$body_data);
		$this->load->view('simple_footer',[]);
	}

	
	public function mint_coupon($issuer){
		$this->load->model('coupon');
		$c=$this->coupon->mint($issuer,['free_event'=>'323']);
		$got=$this->coupon->get($c);
		if($got===false)$this->die_error(__METHOD__,"Bad coupon: $c");
		$this->die_info(__METHOD__,"minted: $c; contents: ".print_r($got, true));
	}

	public function check_coupon($c){
		$c=strtoupper($c);
		$this->load->model('coupon');
		$got=$this->coupon->get($c);
		if($got===false)$this->die_error(__METHOD__,"Bad coupon: $c");
		$spent_str=($got['spent'])?'Spent':'Not spent';
		$this->die_info(__METHOD__,"Coupon $c is valid; $spent_str; contents: ".print_r($got, true));
	}

	public function spend_coupon($c,$purchase_id,$spender_id){
		$c=strtoupper($c);
		$this->load->model('coupon');
		$rc=$this->coupon->spend($c,$purchase_id,$spender_id);
		if($rc!==true)$this->die_error(__METHOD__,"Couldn't spend $c: $rc");
		$this->check_coupon($c);
	}
	
	// WARNING SECURITY RISK -- KEEP THIS DISABLED
	public function make_token($member_id){
		if($this->allow_insecure_methods){
			$member_code=$this->model_parando->make_member_code($member_id);
			$this->die_info(__METHOD__,"Member ID: $member_id; Code: $member_code");
		}
	}

}

