<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

  
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.


if ( ! function_exists('iconlink'))
{
	function iconlink($url,$icon,$title,$grayclass="grayed"){
		if(filter_var($url, FILTER_VALIDATE_URL) !== false)
			return "<A HREF='$url' TITLE='$title'><i class='$icon'></i></a>";
		else
			return "<span class=$grayclass TITLE='$title'><i class='$icon'></i></span>";
	}
}

if ( ! function_exists('textlink'))
{
	function textlink($url,$text,$title,$grayclass="grayed"){
		if(filter_var($url, FILTER_VALIDATE_URL) !== false)
			return "<A HREF='$url' TITLE='$title'>$text</a>";
		else
			return "<span class=$grayclass TITLE='$title'><i class='$icon'></i></span>";
	}
}


if ( ! function_exists('make_site_url'))
{
  function make_site_url($url,$folder=""){
		if (filter_var($url, FILTER_VALIDATE_URL) === false){
			$segments=explode('/',$url);
			$file=array_pop($segments);
			if(""==$file)
				return NULL;
			else{
				$new_segs=[$file];
				if($folder!="") array_unshift($new_segs,$folder);
				return base_url($new_segs,'https');
			}
		}else return $url;
	}
}

if ( ! function_exists('fieldsEmptyQ'))
{
	function fieldsEmptyQ($array,$fields){
	  $q=false;
	  foreach ($fields as $f){
	    if(empty($array[$f])){
	      $q=true;
	      break;
	    }
	  }
	  return $q;
	}
}

if ( ! function_exists('interpolate_strings'))
{
	function interpolate_strings($s,$map){
			$vars=[];
			foreach ($map as $k => $v){
				if((is_string($v) || is_int($v) || is_float($v)) && !empty($k)){
					$tag = '{$' . $k . '}';
					$vars[$tag]=$v . '';
				}
			}
			return strtr($s,$vars); // . '<pre>'. print_r($vars,true) . '</pre>';
	}
}


