<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

	class Regions {
	
	public $club_by_code=[];
	public $club_by_name=[];
	public $region_list=[];
	
	    public function __construct(){
        // parent::__construct();
        
        		foreach ($this->_club_list as $c){
		  list ($club_code, $state_name, $club_name, $active )=$c;
		  $this->club_by_code[$club_code]=compact('state_name','club_name','active');
		  $this->club_by_name[$club_name]=compact('state_name','club_code','active');
		}
		
		foreach ($this->_region_list as $r){
		  list ($state_code, $region_name, $club_name, $rusa_rid, $url, $rba_id, $rba_name )=$r;
		  if(key_exists($club_name, $this->club_by_name)){
		  $club=$this->club_by_name[$club_name];
		  $state_name=$club['state_name'];
		  $club_code=$club['club_code'];
		  }else{
		    $state_name='?'; $club_code='?';
		    }
		  $this->region_list[]=compact('state_code', 'state_name', 'region_name', 'club_name', 'rusa_rid', 
		          'url', 'rba_id', 'rba_name', 'club_code');
		  
		}

    }


private $_region_list=[
[ "AK", "Anchorage", "Denali Randonneurs", 64, "http://www.denalirandonneurs.com/", 8711,"Burnley R Willis"],
[ "AL", "Birmingham", "Alabama Randonneurs", 120, "http://www.mgmbikeclub.org/AlabamaRando", 11707,"Charles Christopher Argo"],
[ "AZ", "Phoenix", "Arizona Randonneurs", 3, "http://www.azbrevet.com", 1847,"Michael R Sturgill"],
[ "CA", "Davis", "Davis Bike Club", 4, "https://www.davisbikeclub.org/ultra-distance-brevets-and-randonneuring", 4405,"Debra C. Banks"],
[ "CA", "Humboldt", "Humboldt Randonneurs", 138, "http://www.humboldtrandonneurs.com/", 7247,"Eric O Larsen"],
[ "CA", "Los Angeles", "Pacific Coast Highway Randonneurs", 58, "http://www.pchrandos.com", 2060,"Kerin Huber"],
[ "CA", "San Diego", "San Diego Randonneurs", 9, "https://sdrandos.sdrandos.com", 9917,"Wei P Sun"],
[ "CA", "San Francisco", "San Francisco Randonneurs", 60, "http://sfrandonneurs.org/", 2515,"Rob Hawks"],
[ "CA", "San Luis Obispo", "San Luis Obispo Randonneurs", 6, "http://slorandonneur.org/", 9343,"Grant McAlister"],
[ "CA", "Santa Cruz", "Santa Cruz Randonneurs", 7, "http://www.santacruzrandonneurs.org", 7,"Bill Bryant"],
[ "CA", "Santa Rosa", "Santa Rosa Randonneurs", 8, "https://santarosarandos.org/", 8393,"Ryan Thompson"],
[ "CO", "Boulder", "Rocky Mountain Cycling Club", 10, "https://www.rmccrides.com/brevets.htm", 153,"John Lee Ellis"],
[ "FL", "Central", "Central Florida Randonneurs", 55, "http://floridarandonneurs.com/wordpress", 2955,"Paul G Rozelle"],
[ "FL", "Northeast", "Northeast Florida Randonneurs", 142, "http://www.cyclingforever.com/nefr.html", 4500,"Hamid Akbarian"],
[ "FL", "Southern", "South Florida Randonneurs", 79, "https://sflrando.weebly.com/", 7009,"Mark W Dennin"],
[ "GA", "Atlanta", "Audax Atlanta", 15, "http://www.audaxatlanta.com", 7825,"Wayne A King"],
[ "HI", "Maui", "Maui Randonneurs", 139, "https://sites.google.com/view/mauirandonneurs", 9527,"Lorin A Fowler"],
[ "IA", "Central", "Iowa Randonneurs", 122, "http://iowarandos.org/", 8170,"Gregory H Smith"],
[ "IL", "Chicago", "Great Lakes Randonneurs", 17, "http://www.glrrando.org/", 5558,"Michele S Brougher"],
[ "IL", "Quad Cities", "Quad Cities Randonneurs", 115, "https://www.qcrandonneurs.org", 8170,"Gregory H Smith"],
[ "IN", "Indianapolis", "Indiana Randonneurs", 130, "http://indyrando.ridestats.bike", 5365,"William Watts"],
[ "KY", "Louisville", "Louisville Bicycle Club", 57, "http://www.louisvillebicycleclub.org/", 3390,"David King"],
[ "MA", "Boston", "New England Randonneurs", 21, "https://ner.bike", 8394,"Sarah E Bergstrom"],
[ "MA", "Westfield", "New Horizons Cycling Club", 22, "http://www.GreatRiverRide.com", 30,"Don Podolski"],
[ "MD", "Capital Region", "DC Randonneurs", 112, "http://www.dcrand.org/dcr/", 9413,"Emily Ranson"],
[ "MI", "Detroit", "Detroit Randonneurs", 125, "http://detroitrandonneurs.org/", 7688,"Thomas H Dusky"],
[ "MN", "Twin Cities / Rochester", "Minnesota Randonneurs", 61, "http://www.mnrando.org/", 3737,"Rob Welsh"],
[ "MO", "Kansas City", "Audax Kansas City", 24, "http://www.audaxkc.com/", 1989,"Spencer Klaassen"],
[ "MT", "Bozeman", "Gallatin Valley Bicycle Club", 116, "http://sites.google.com/site/montanarando/Home", 4626,"Jason Karp"],
[ "NC", "Asheville", "Asheville International Randonneurs", 134, "https://air.bikeavl.com/", 7069,"Luke Heller"],
[ "NC", "High Point", "Bicycle For Life Club", 109, "http://www.bicycleforlife.org/rusa/index.html", 1526,"Tony R Goodnight"],
[ "NC", "Raleigh", "North Carolina Bicycle Club", 27, "https://raleighrando.web.unc.edu/", 306,"Alan M Johnson"],
[ "NE", "Omaha", "Nebraska Sandhills Randonneurs", 47, "http://www.nebraskasandhillsrandonneurs.com", 1989,"Spencer Klaassen"],
[ "NJ", "NYC and Princeton", "New Jersey Randonneurs", 108, "http://www.njrandonneurs.org", 2691,"Paul Samuel Kramer"],
[ "NY", "Central/Western", "Finger Lakes Randonneurs", 30, "http://www.distancerider.net", 25,"Peter W Dusel"],
[ "NY", "Long Island", "Long Island Randonneurs", 123, "http://lirando.org", 3747,"Steve Yesko"],
[ "OH", "Columbus", "Ohio Randonneurs", 32, "http://ohiorandonneurs.org", 12390,"Alex Bachmann"],
[ "OK", "Norman", "Oklahoma Randonneurs", 131, "https://www.facebook.com/groups/1514201805512796/", 1211,"Michael Schmit"],
[ "OR", "Eugene", "Willamette Randonneurs", 137, "http://will-rando.org", 5475,"Michal Young"],
[ "OR", "Portland", "Oregon Randonneurs", 34, "http://orrando.blogspot.com", 139,"Susan France"],
[ "PA", "Eastern", "Pennsylvania Randonneurs", 46, "http://www.parandonneurs.com", 5456,"Chris Nadovich"],
[ "PA", "Pittsburgh", "Western Pennsylvania Bicycle Club", 114, "http://www.pittsburghrandonneurs.com", 4664,"Daniel J Blumenfeld"],
[ "SD", "Sioux Falls", "Falls Area Randonneurs", 135, "https://fallsarearando.wordpress.com/", 7914,"Bruce A Jones"],
[ "TN", "Nashville", "Tennessee Randonneurs", 44, "http://tnrandonneurs.org", 1716,"David W. Penegar"],
[ "TX", "Austin", "Hill Country Randonneurs", 51, "http://www.hillcountryrandonneurs.org", 4574,"Jeff Newberry"],
[ "TX", "Central Texas", "Heart of Texas Randonneurs", 140, "http://Heartoftexasrandonneurs.org", 8132,"Gary Kanaby"],
[ "TX", "Dallas", "Lone Star Randonneurs", 37, "http://www.lonestarrandon.org/", 390,"Dan Driscoll"],
[ "TX", "Houston", "Houston Randonneurs", 41, "http://www.houstonrandonneurs.org", 7085,"Alison Carey"],
[ "TX", "West Texas", "West Texas Randonneurs", 117, "http://www.pbbatx.com//randonneuring/", 7560,"Charles J Adams"],
[ "UT", "Salt Lake City", "Salt Lake Randonneurs", 119, "http://www.SaltLakeRandos.org", 10738,"Ken Moss"],
[ "VA", "Northern", "Northern Virginia Randonneurs", 111, "http://www.cyclingforever.com/nvr.html", 4500,"Hamid Akbarian"],
[ "VA", "Tidewater", "Tidewater Randonneurs", 126, "http://tidewaterrando.com/", 11640,"John P Sprock"],
[ "WA", "Seattle", "Seattle International Randonneurs", 38, "http://www.seattlerandonneur.org", 10455,"Rose Cox"],
[ "WI", "Western", "Driftless Randonneurs", 132, "http://www.driftlessrandos.org", 8170,"Gregory H Smith"]];

private $_club_list=[
["11101", "Hawaii", "PC.Bonavista Manresa", "Yes"],
["11153", "Hawaii", "SC GRACIA (BARCELONA)", "Yes"],
["11302", "Hawaii", "Fredrikshofs If CK", "Yes"],
["11601", "Hawaii", "British Columbia Randonneurs", "Yes"],
["11700", "Hawaii", "Prairie Randonneurs Inc", "Yes"],
["11751", "Hawaii", "Manitoba Randonneurs", "Yes"],
["11801", "Hawaii", "Randonneurs Ontario - Toronto", "Yes"],
["11802", "Hawaii", "Ontario Randonneurs - Ottawa", "Yes"],
["11804", "Hawaii", "Ontario Randonneurs - Huron", "Yes"],
["11900", "Hawaii", "Randonneurs Alberta", "Yes"],
["11921", "Hawaii", "Alberta Randonneurs - Calgary", "Yes"],
["12001", "Idaho", "Audax UK", "Yes"],
["12454", "Idaho", "Kingston Wheelers", "Yes"],
["12980", "Idaho", "Central London CTC", "Yes"],
["15000", "Iowa", "Audax Ireland", "Yes"],
["21401", "Massachusetts", "Audax Randonneurs Danemark", "Yes"],
["110071", "Georgia", "Randonneurs Nederland", "Yes"],
["113004", "Illinois", "Randonneur Stockholm", "Yes"],
["113024", "Illinois", "CK Milslukaren", "Yes"],
["121001", "Massachusetts", "Randonneurs Polska", "Yes"],
["150015", "Wyoming", "Randonneurs Portugal", "Yes"],
["160087", "", "Cardiff Byways Cycling Club", "Yes"],
["160476", "", "Suffolk CTC", "Yes"],
["160514", "", "VC167", "Yes"],
["311501", "Hawaii", "Audax Australia", "Yes"],
["411501", "Hawaii", "Audax Australia - Victoria", "Yes"],
["412008", "Idaho", "Pedale Feltrino", "Yes"],
["600007", "", "Audax Japan", "Yes"],
["600019", "", "Audax Japan Chiba", "Yes"],
["600020", "", "Audax Saitama", "Yes"],
["600035", "", "Randonneurs Tamagawa", "Yes"],
["601023", "Alabama", "HYDERABAD RANDONNEURS", "Yes"],
["602001", "Alaska", "Audax Randonneurs Philippines", "Yes"],
["603000", "Arizona", "Korea Randonneurs", "Yes"],
["605500", "California", "Randonneurs Taiwan", "Yes"],
["605510", "California", "LDS Cycling Team - Taiwan", "Yes"],
["750128", "Wyoming", "Audax Club Parisien", "Yes"],
["808056", "Delaware", "Euraudax Randonnee Nederland", "Yes"],
["837481", "Oregon", "Argens Cyclo Carces", "Yes"],
["900095", "", "Randonneurs USA", "Yes"],
["901001", "Alabama", "Velo Avanti", "Yes"],
["901002", "Alabama", "Birmingham Bicycle Club", "Yes"],
["901003", "Alabama", "Druid City Bicycle Club", "Yes"],
["901004", "Alabama", "Alabama Randonneurs", "Yes"],
["901005", "Alabama", "Montgomery Bicycle Club", "Yes"],
["901006", "Alabama", "Dothan Area Cyclists", "Yes"],
["901007", "Alabama", "Major Taylor Cycling Club of Alabama", "Yes"],
["901008", "Alabama", "Spring City Cycling Club", "Yes"],
["901009", "Alabama", "Circle City People", "Yes"],
["901010", "Alabama", "East Alabama Cycling Club", "Yes"],
["901095", "Alabama", "Randonneurs USA", "Yes"],
["901099", "Alabama", "Independent", "Yes"],
["902001", "Alaska", "Audax Club Alaska", "Yes"],
["902002", "Alaska", "Fairbanks Cycling Club", "Yes"],
["902003", "Alaska", "Arctic Bicycle Club", "Yes"],
["902004", "Alaska", "Alaska Cycling Endeavors", "Yes"],
["902005", "Alaska", "Homer Cosmic Hams", "Yes"],
["902006", "Alaska", "Alaska Randonneurs", "Yes"],
["902007", "Alaska", "Denali Randonneurs", "Yes"],
["902095", "Alaska", "Randonneurs USA", "Yes"],
["902099", "Alaska", "Independent", "Yes"],
["903001", "Arizona", "Cactus Cycling Club", "Yes"],
["903002", "Arizona", "Red Mountain Brumbys", "Yes"],
["903003", "Arizona", "Yuma Bike Club", "Yes"],
["903004", "Arizona", "San Tan Racing", "Yes"],
["903005", "Arizona", "El Grupo", "Yes"],
["903006", "Arizona", "Phoenix Metro Bike Club", "Yes"],
["903007", "Arizona", "Yuma Athletics", "Yes"],
["903008", "Arizona", "Northern Arizona Randonneurs", "Yes"],
["903010", "Arizona", "High Desert Cycling Club", "Yes"],
["903011", "Arizona", "Bullshifters Bicycling Club", "Yes"],
["903012", "Arizona", "Cyclisme Veloce", "Yes"],
["903013", "Arizona", "Prescott Chain Bang", "Yes"],
["903014", "Arizona", "Wildcats", "Yes"],
["903015", "Arizona", "White Mountain Road Club", "Yes"],
["903016", "Arizona", "Greater Arizona Bicycle Club", "Yes"],
["903017", "Arizona", "Arizona Bicycle Club", "Yes"],
["903018", "Arizona", "Saddlebrooke Cyclemasters", "Yes"],
["903019", "Arizona", "Greater Arizona Bicycling Association", "Yes"],
["903020", "Arizona", "Arizona Randonneurs", "Yes"],
["903021", "Arizona", "Foothills Bicycle Club", "Yes"],
["903022", "Arizona", "Procon Cycling", "Yes"],
["903095", "Arizona", "Randonneurs USA", "Yes"],
["903099", "Arizona", "Independent", "Yes"],
["904001", "Arkansas", "Arkansas Bicycle Club", "Yes"],
["904002", "Arkansas", "Hot Springs Bicycle Association", "Yes"],
["904003", "Arkansas", "Central Arkansas Brevet Series", "Yes"],
["904095", "Arkansas", "Randonneurs USA", "Yes"],
["904099", "Arkansas", "Independent", "Yes"],
["905001", "California", "Touriste-Routier", "Yes"],
["905002", "California", "Redlands Water Bottle Transit Company", "Yes"],
["905003", "California", "Paso Robles Cyclonauts", "Yes"],
["905004", "California", "AdventureCORPS", "Yes"],
["905005", "California", "Encino Cyclery Cycling Club", "Yes"],
["905006", "California", "Swamis Athletic Association", "Yes"],
["905007", "California", "Different Spokes", "Yes"],
["905008", "California", "Conejo Valley Cyclists", "Yes"],
["905009", "California", "Team K-Man", "Yes"],
["905010", "California", "Almaden Cycle Touring Club", "Yes"],
["905011", "California", "Holy Jim", "Yes"],
["905012", "California", "SCOR Cardiac Cyclists", "Yes"],
["905013", "California", "Chico Velo", "Yes"],
["905014", "California", "Davis Bike Club", "Yes"],
["905015", "California", "Cyclo Vets", "Yes"],
["905016", "California", "Empire Wheelmen", "Yes"],
["905017", "California", "Whittier Wheelman", "Yes"],
["905018", "California", "Grizzly Peak Cyclists", "Yes"],
["905019", "California", "Los Angeles Racing Team", "Yes"],
["905020", "California", "Monticello Cycle", "Yes"],
["905021", "California", "Long Beach Velo", "Yes"],
["905022", "California", "Marin Cyclists", "Yes"],
["905023", "California", "Badwater Boys Club", "Yes"],
["905024", "California", "Los Gatos Bicycle Racing Club", "Yes"],
["905025", "California", "Orange County Wheelmen", "Yes"],
["905026", "California", "South Bay Wheelmen", "Yes"],
["905027", "California", "Crown City Cyclists", "Yes"],
["905028", "California", "Bicycle Club of Irvine", "Yes"],
["905029", "California", "Watrous Cycling", "Yes"],
["905030", "California", "San Francisco Randonneurs", "Yes"],
["905031", "California", "Sacramento Bikehikers", "Yes"],
["905032", "California", "San Fernando Valley Bicycle Club", "Yes"],
["905033", "California", "Gold Coast Velo", "Yes"],
["905034", "California", "Rainbow Sports", "Yes"],
["905035", "California", "San Luis Obispo Bicycle Club", "Yes"],
["905036", "California", "Barden City Cyclists", "Yes"],
["905037", "California", "Team Sacramento Wheelmen", "Yes"],
["905038", "California", "Valley Spokesmen Bicycle Touring Club", "Yes"],
["905039", "California", "Ojai Valley", "Yes"],
["905040", "California", "Wandervogel World Bicycling Touring Association", "Yes"],
["905041", "California", "North County Cycling Club", "Yes"],
["905042", "California", "Western Wheelers", "Yes"],
["905043", "California", "Sausalito Cyclists", "Yes"],
["905044", "California", "Club Wheel", "Yes"],
["905045", "California", "Berkeley Bicycle Club", "Yes"],
["905046", "California", "Alto Velo", "Yes"],
["905047", "California", "Pen Velo", "Yes"],
["905048", "California", "Santa Rosa Cycling Club", "Yes"],
["905049", "California", "Shasta Wheelmen", "Yes"],
["905050", "California", "Sun Coast Velo", "Yes"],
["905051", "California", "Pacific Coast Highway Randonneurs", "Yes"],
["905052", "California", "ADO Gang", "Yes"],
["905053", "California", "Eagle Cycling", "Yes"],
["905054", "California", "Stanislaus County Bicycle Club", "Yes"],
["905055", "California", "Seabright Cyclists", "Yes"],
["905056", "California", "Bicycle Touring Santa Cruz", "Yes"],
["905057", "California", "Amador Velo", "Yes"],
["905058", "California", "Fresno Cycling Club", "Yes"],
["905059", "California", "Single Cyclists", "Yes"],
["905060", "California", "RSVP", "Yes"],
["905061", "California", "International Christian Bicycle Club", "Yes"],
["905062", "California", "Velo Southern California Club", "Yes"],
["905063", "California", "Los Angeles Wheelmen", "Yes"],
["905064", "California", "San Jose Cyclists", "Yes"],
["905065", "California", "Lompoc Valley  Bicycle Club", "Yes"],
["905066", "California", "Twin City Bicycle Club", "Yes"],
["905067", "California", "Stockton Bicycle Club", "Yes"],
["905068", "California", "Cherry City Cyclists", "Yes"],
["905069", "California", "Fremont Freewheelers Bicycle Club", "Yes"],
["905070", "California", "Napa Valley Velo", "Yes"],
["905071", "California", "Santa Clarita Velo", "Yes"],
["905073", "California", "Valhalla Cyclists", "Yes"],
["905074", "California", "Lake Oroville Bicycle Organization", "Yes"],
["905075", "California", "Inland Sunset Velo", "Yes"],
["905076", "California", "Kern Wheelmen", "Yes"],
["905077", "California", "Riverside Bicycle Club", "Yes"],
["905078", "California", "Velo Club La Grange Westwood", "Yes"],
["905079", "California", "Bicycles of Ojai", "Yes"],
["905080", "California", "Velo Club of Monterey County", "Yes"],
["905081", "California", "Team Tam", "Yes"],
["905082", "California", "Channel Islands Bike Club", "Yes"],
["905083", "California", "Veloce Santiago", "Yes"],
["905084", "California", "Mercury Cycling Club", "Yes"],
["905085", "California", "Planet Ultra", "Yes"],
["905086", "California", "San Diego Bicycle Club", "Yes"],
["905087", "California", "Santa Cruz County Cycling Club", "Yes"],
["905088", "California", "Covina Cycling Club", "Yes"],
["905089", "California", "Caltech Velo", "Yes"],
["905095", "California", "Randonneurs USA", "Yes"],
["905099", "California", "Independent", "Yes"],
["905100", "California", "Cycle Couriers of San Francisco", "Yes"],
["905101", "California", "Velo Allegro Cycling Club", "Yes"],
["905102", "California", "LA Tri Club", "Yes"],
["905103", "California", "Cerritos Cyclepaths", "Yes"],
["905104", "California", "Sierra Express Bicycle Club", "Yes"],
["905105", "California", "Excel Sports", "Yes"],
["905106", "California", "Santa Cruz Randonneurs", "Yes"],
["905107", "California", "Goleta Valley Cycling Club", "Yes"],
["905108", "California", "Diablo Cyclists", "Yes"],
["905109", "California", "Knickerbikers", "Yes"],
["905110", "California", "San Diego Longriders", "Yes"],
["905111", "California", "Roaring Mouse Cycles", "Yes"],
["905112", "California", "Bicicleta Chico", "Yes"],
["905113", "California", "Squadra Ovest", "Yes"],
["905114", "California", "San Diego Triathlon Club", "Yes"],
["905115", "California", "L'Union Pacifique", "Yes"],
["905116", "California", "High Desert Cyclists", "Yes"],
["905117", "California", "Peninsula Velo Cycling Club", "Yes"],
["905118", "California", "Bigfoot Bicycle Club", "Yes"],
["905119", "California", "Othello Bicycle Club", "Yes"],
["905120", "California", "Benicia Bicycle Club", "Yes"],
["905121", "California", "San Diego Cyclo-Vets", "Yes"],
["905122", "California", "Ranchos Cycling Club", "Yes"],
["905123", "California", "Oakland Yellowjackets", "Yes"],
["905124", "California", "San Diego Wheelmen", "Yes"],
["905125", "California", "Cayucos Cycling Club", "Yes"],
["905126", "California", "Sacramento Wheelmen", "Yes"],
["905127", "California", "Fightin Bobas", "Yes"],
["905128", "California", "San Diego Century Riders", "Yes"],
["905129", "California", "Stockton Bicycle Club", "Yes"],
["905130", "California", "Plumas Sierra Bicycle Club", "Yes"],
["905131", "California", "Touchstone Bike Club", "Yes"],
["905132", "California", "Orange County Rebel Riders", "Yes"],
["905133", "California", "Team Bikeaholics", "Yes"],
["905134", "California", "Old Kranks Bicycle Club", "Yes"],
["905135", "California", "Ermas Diner", "Yes"],
["905136", "California", "Swarm", "Yes"],
["905137", "California", "High Sierra Cyclists", "Yes"],
["905138", "California", "Velo Club Fairfax", "Yes"],
["905139", "California", "San Jose Bicycle Club", "Yes"],
["905140", "California", "San Diego Randonneurs", "Yes"],
["905141", "California", "Southern Sierra Cyclists", "Yes"],
["905142", "California", "Eastside Velo", "Yes"],
["905143", "California", "Lamorinda Cycling Club", "Yes"],
["905144", "California", "Valle Verde Velo", "Yes"],
["905145", "California", "Mount Shasta Pedali", "Yes"],
["905146", "California", "Team Oakland Cycling", "Yes"],
["905147", "California", "Foothill Cycle Club", "Yes"],
["905148", "California", "Swami's Cycling Club", "Yes"],
["905149", "California", "Sierra Foothills Cycling Club", "Yes"],
["905150", "California", "Adobo Velo Filipino - American Cycling Club", "Yes"],
["905151", "California", "Lightning Velo", "Yes"],
["905152", "California", "Team Stanley", "Yes"],
["905153", "California", "Bike Buddies Cycling Club", "Yes"],
["905154", "California", "Kovarus / Wells Fargo Racing Team", "Yes"],
["905155", "California", "Beach Cities Cycling Club", "Yes"],
["905156", "California", "Hammerin Wheels", "Yes"],
["905157", "California", "Yuba-Sutter Cycling", "Yes"],
["905158", "California", "Pasadena Athletic Association", "Yes"],
["905159", "California", "Central Valley Velo", "Yes"],
["905160", "California", "Marc Pro - Strava", "Yes"],
["905161", "California", "Barangay NorCal", "Yes"],
["905162", "California", "REV Cycling", "Yes"],
["905163", "California", "Sub5 Cycling", "Yes"],
["905164", "California", "United Velo Cycling Club", "Yes"],
["905165", "California", "Claremont Senior Bicycle Group", "Yes"],
["905166", "California", "San Luis Obispo Randonneurs", "Yes"],
["905167", "California", "Team Velocity", "Yes"],
["905168", "California", "Petaluma Wheelmen", "Yes"],
["905169", "California", "Cycle Folsom", "Yes"],
["905170", "California", "Redwood Coast Mountain Bike Association", "Yes"],
["905171", "California", "Santa Rosa Randonneurs", "Yes"],
["905172", "California", "BOBies", "Yes"],
["905173", "California", "Team Ironfly", "Yes"],
["905174", "California", "Xe Dap Viet", "Yes"],
["905175", "California", "C4Racing - Contra Costa Cycling Club", "Yes"],
["905176", "California", "Humboldt Randonneurs", "Yes"],
["905177", "California", "DePedal Cycling Club", "Yes"],
["905178", "California", "SERIOUS CYCLING", "Yes"],
["905179", "California", "Route 1 Velo", "Yes"],
["905180", "California", "Diablo Multisport Connection", "Yes"],
["905181", "California", "Orange Coast Velo", "Yes"],
["905182", "California", "Sunnyvale-Cupertino Cycling Club", "Yes"],
["905183", "California", "Coureur Cycling", "Yes"],
["905184", "California", "Coureur - Canyon Elite Cycling", "Yes"],
["905185", "California", "Team Coconut", "Yes"],
["905186", "California", "Team Asha Silicon Valley", "Yes"],
["905187", "California", "Canyon Velo", "Yes"],
["905188", "California", "Padyak Racing Team", "Yes"],
["905189", "California", "Cast a Shadow", "Yes"],
["905200", "California", "Grand Masters Cycling Club", "Yes"],
["905201", "California", "Global Elliptigo Riders Club", "Yes"],
["906001", "Colorado", "Boulder Velo", "Yes"],
["906002", "Colorado", "Rocky Mountain Cycling Club", "Yes"],
["906003", "Colorado", "Fort Collins Cycling and Racing Club", "Yes"],
["906004", "Colorado", "Team Rio Grande", "Yes"],
["906005", "Colorado", "International Christian Cycling Club", "Yes"],
["906006", "Colorado", "Colorado Springs Cycling Club", "Yes"],
["906007", "Colorado", "Durango Wheel Club", "Yes"],
["906008", "Colorado", "Ciclistas del Rio", "Yes"],
["906009", "Colorado", "Colorado Riders Club", "Yes"],
["906010", "Colorado", "West Elk Road Club", "Yes"],
["906095", "Colorado", "Randonneurs USA", "Yes"],
["906099", "Colorado", "Independent", "Yes"],
["907001", "Connecticut", "Southern Connecticut Cycling Club", "Yes"],
["907002", "Connecticut", "Springfield Bike Club", "Yes"],
["907003", "Connecticut", "Laurel Bicycle Club", "Yes"],
["907004", "Connecticut", "Mystic Velo", "Yes"],
["907005", "Connecticut", "Thread City Cyclers", "Yes"],
["907006", "Connecticut", "Expo Wheelmen Cycling Club", "Yes"],
["907007", "Connecticut", "Eastern Bloc Cycling Club", "Yes"],
["907008", "Connecticut", "True Cyclery", "Yes"],
["907009", "Connecticut", "New Haven Bicycling Club", "Yes"],
["907040", "Connecticut", "Eastern Connecticut Velo", "Yes"],
["907041", "Connecticut", "Central Conneticut Cycling Club", "Yes"],
["907042", "Connecticut", "Capital Velo", "Yes"],
["907043", "Connecticut", "Pequot Cyclists", "Yes"],
["907044", "Connecticut", "Hat City", "Yes"],
["907045", "Connecticut", "Yankee Pedalers", "Yes"],
["907046", "Connecticut", "Sound Cyclists Bicycle Club", "Yes"],
["907047", "Connecticut", "Tokeneke Road Club", "Yes"],
["907048", "Connecticut", "Bethel Cycle Club", "Yes"],
["907049", "Connecticut", "Quinebaug Valley Velo Club", "Yes"],
["907095", "Connecticut", "Randonneurs USA", "Yes"],
["907099", "Connecticut", "Independent", "Yes"],
["908001", "Delaware", "White Clay Bicycling Club", "Yes"],
["908042", "Delaware", "First State Velo Sport", "Yes"],
["908095", "Delaware", "Randonneurs USA", "Yes"],
["908099", "Delaware", "Independent", "Yes"],
["909001", "Florida", "South Broward Wheelers", "Yes"],
["909002", "Florida", "Polk Area Bicycle Assoc", "Yes"],
["909003", "Florida", "Spacecoast Freewheelers", "Yes"],
["909004", "Florida", "Orlando Road Club", "Yes"],
["909005", "Florida", "Gainesville Cycling Club", "Yes"],
["909006", "Florida", "Panama City Flyers", "Yes"],
["909007", "Florida", "South Florida Recumbent Riders", "Yes"],
["909008", "Florida", "Team New Tampa Velo Club", "Yes"],
["909009", "Florida", "Space Coast Velo Sport", "Yes"],
["909010", "Florida", "Treasure Coast Cycling Association", "Yes"],
["909011", "Florida", "Team Memorial", "Yes"],
["909012", "Florida", "VeloBrew Bicycle Club", "Yes"],
["909013", "Florida", "Weston Flyers", "Yes"],
["909014", "Florida", "South Florida Randonneurs", "Yes"],
["909015", "Florida", "Saint Petersburg Bicycle Club", "Yes"],
["909016", "Florida", "Everglades Bicycling Club", "Yes"],
["909017", "Florida", "Florida Wheelers", "Yes"],
["909019", "Florida", "West Palm Beach Bicycle Club", "Yes"],
["909020", "Florida", "Caloosa Riders", "Yes"],
["909021", "Florida", "North Florida Bicycle Club", "Yes"],
["909022", "Florida", "Florida Freewheelers", "Yes"],
["909023", "Florida", "Winter Springs Cycling", "Yes"],
["909024", "Florida", "Eastside Cycle Club", "Yes"],
["909025", "Florida", "zMotion", "Yes"],
["909026", "Florida", "Four Seasons Multisport Club", "Yes"],
["909027", "Florida", "Florida Masters Cycling", "Yes"],
["909028", "Florida", "Hammer Down Multi-Sport", "Yes"],
["909029", "Florida", "Galiz Cycling Club", "Yes"],
["909030", "Florida", "Mosquito Lagoon Bicycle Club", "Yes"],
["909031", "Florida", "Peace River Riders Bicycle Club", "Yes"],
["909032", "Florida", "Vero Cycling Inc", "Yes"],
["909033", "Florida", "Women of Westside", "Yes"],
["909034", "Florida", "Northeast Florida Randonneurs", "Yes"],
["909046", "Florida", "Boca Raton Bicycle Club", "Yes"],
["909047", "Florida", "Broward Wheelmen Bicycle Club", "Yes"],
["909049", "Florida", "Fayette Biking for Life", "Yes"],
["909050", "Florida", "Capital City Cyclists", "Yes"],
["909051", "Florida", "Villages Cycling Association", "Yes"],
["909052", "Florida", "West Florida Wheelmen", "Yes"],
["909053", "Florida", "West Central Florida Adventure Racing Club", "Yes"],
["909054", "Florida", "Tampa Palms Cycling Club", "Yes"],
["909055", "Florida", "Tampa Bay Freewheelers", "Yes"],
["909056", "Florida", "Coastal Cruisers Bicycle Club", "Yes"],
["909057", "Florida", "Sarasota Manatee Bicycle Club", "Yes"],
["909058", "Florida", "Motorola Cycling League", "Yes"],
["909059", "Florida", "Daytona Beach Bicycle Club", "Yes"],
["909060", "Florida", "Suncoast Cycling Club", "Yes"],
["909061", "Florida", "Bobbies", "Yes"],
["909062", "Florida", "Central Florida Randonneurs", "Yes"],
["909095", "Florida", "Randonneurs USA", "Yes"],
["909099", "Florida", "Independent", "Yes"],
["910000", "Georgia", "North Atlanta Road Club", "Yes"],
["910001", "Georgia", "Chicken City Cyclists", "Yes"],
["910002", "Georgia", "Middle Georgia Bicycle Club", "Yes"],
["910003", "Georgia", "Bicycle Club of Atlanta", "Yes"],
["910004", "Georgia", "Audax Atlanta", "Yes"],
["910005", "Georgia", "Metro Atlanta Cycling Club", "Yes"],
["910006", "Georgia", "Namimals", "Yes"],
["910008", "Georgia", "Gwinnett Touring Club", "Yes"],
["910009", "Georgia", "Faster Mustache", "Yes"],
["910010", "Georgia", "Middle Georgia Cyclists", "Yes"],
["910011", "Georgia", "Southern Crescent Cycling", "Yes"],
["910012", "Georgia", "Southside Cycling", "Yes"],
["910013", "Georgia", "Velo Atlanta Cycling Club", "Yes"],
["910014", "Georgia", "Sorella Cycling", "Yes"],
["910025", "Georgia", "Bicycle Association of North Georgia", "Yes"],
["910026", "Georgia", "Coosa Valley Cyclists", "Yes"],
["910027", "Georgia", "Southern Bicycle League", "Yes"],
["910028", "Georgia", "Augusta Freewheelers", "Yes"],
["910029", "Georgia", "Southern Off-Road Bicycle Association", "Yes"],
["910030", "Georgia", "Georgia Velo", "Yes"],
["910031", "Georgia", "Meehan Cycleworks", "Yes"],
["910032", "Georgia", "Team NADS", "Yes"],
["910095", "Georgia", "Randonneurs USA", "Yes"],
["910099", "Georgia", "Independent", "Yes"],
["911001", "Hawaii", "Team Boca", "Yes"],
["911002", "Hawaii", "Hawaii Bicycling League", "Yes"],
["911003", "Hawaii", "Maui Randonneurs", "Yes"],
["911095", "Hawaii", "Randonneurs USA", "Yes"],
["911099", "Hawaii", "Independent", "Yes"],
["912001", "Idaho", "Yellowstone-Area Randonneurs", "Yes"],
["912095", "Idaho", "Randonneurs USA", "Yes"],
["912099", "Idaho", "Independent", "Yes"],
["913001", "Illinois", "Aurora Bike Club", "Yes"],
["913002", "Illinois", "Blackhawk Bicycle and Ski Club", "Yes"],
["913003", "Illinois", "Spring City Spinners", "Yes"],
["913004", "Illinois", "Calumet Crank Club", "Yes"],
["913005", "Illinois", "Great Lakes Randonneurs", "Yes"],
["913006", "Illinois", "Cream City Cyclists", "Yes"],
["913007", "Illinois", "Midwest Randonneurs", "Yes"],
["913008", "Illinois", "Evanston Bicycle Club", "Yes"],
["913010", "Illinois", "Fox Valley Gary", "Yes"],
["913011", "Illinois", "Joliet Bicycle Club", "Yes"],
["913012", "Illinois", "McHenry County Bicycle Club", "Yes"],
["913013", "Illinois", "Oak Park Cycling Club", "Yes"],
["913014", "Illinois", "Arling Road Club", "Yes"],
["913015", "Illinois", "Naperville Bicycle Club", "Yes"],
["913016", "Illinois", "Elmhurst Bicycle Club", "Yes"],
["913017", "Illinois", "Illinois Valley Wheelmen", "Yes"],
["913018", "Illinois", "Peoria Bicycle Club", "Yes"],
["913019", "Illinois", "Springfield Bicycle Club", "Yes"],
["913020", "Illinois", "Team Apache", "Yes"],
["913022", "Illinois", "Vagabond Touring", "Yes"],
["913023", "Illinois", "West Suburban Wheelmen", "Yes"],
["913024", "Illinois", "McClean County Wheelmen", "Yes"],
["913025", "Illinois", "Team White Dog", "Yes"],
["913026", "Illinois", "Ori Cycling Team", "Yes"],
["913027", "Illinois", "Arlington Flyers", "Yes"],
["913028", "Illinois", "South Chicago Wheelmen", "Yes"],
["913029", "Illinois", "Big Dogs Endurance Cycling", "Yes"],
["913030", "Illinois", "Chicago Urban Bicycling Society", "Yes"],
["913031", "Illinois", "Team MACK", "Yes"],
["913032", "Illinois", "Midwest Masters Cycling Team", "Yes"],
["913033", "Illinois", "Chicago Cycling Club", "Yes"],
["913034", "Illinois", "Chain Link Cyclist", "Yes"],
["913035", "Illinois", "Bicycle Club of Lake County", "Yes"],
["913036", "Illinois", "Decatur Bicycle Club", "Yes"],
["913037", "Illinois", "GOATS Bicycling Club of Galena", "Yes"],
["913038", "Illinois", "International Christian Cycling Club", "Yes"],
["913039", "Illinois", "Athletes By Design Cycling Club", "Yes"],
["913040", "Illinois", "River to River Cycling Club", "Yes"],
["913041", "Illinois", "Yorkville Bicycle Club", "Yes"],
["913042", "Illinois", "Quad Cities Randonneurs", "Yes"],
["913043", "Illinois", "University of Chicago Velo Club", "Yes"],
["913044", "Illinois", "Little Egypt Randonneurs", "Yes"],
["913045", "Illinois", "Barrington Bicycle Club", "Yes"],
["913046", "Illinois", "Spidermonkey Cycling", "Yes"],
["913047", "Illinois", "Wild Card Cycling", "Yes"],
["913048", "Illinois", "TEN27 Cycling Club", "Yes"],
["913049", "Illinois", "Paniagua Racing", "Yes"],
["913050", "Illinois", "Illinois Randonneurs", "Yes"],
["913051", "Illinois", "XXX Racing - Athletico", "Yes"],
["913095", "Illinois", "Randonneurs USA", "Yes"],
["913099", "Illinois", "Independent", "Yes"],
["914001", "Indiana", "Delaware Cycling Club", "Yes"],
["914002", "Indiana", "Evansville Bicycle Club", "Yes"],
["914003", "Indiana", "Southern Indiana Wheelmen", "Yes"],
["914004", "Indiana", "Breakaway Bicycle Club", "Yes"],
["914005", "Indiana", "Indiana Randonneurs", "Yes"],
["914006", "Indiana", "Js Bikes Racing", "Yes"],
["914007", "Indiana", "Madison Area Bicycle Club Inc.", "Yes"],
["914008", "Indiana", "Break-Away Bicycle Club", "Yes"],
["914009", "Indiana", "Three Rivers Velo Sport", "Yes"],
["914010", "Indiana", "Bloomington Bicycle Club", "Yes"],
["914011", "Indiana", "Central Indiana Bicycling Association", "Yes"],
["914013", "Indiana", "Wabash River Cycling Club", "Yes"],
["914014", "Indiana", "Speedway Wheelmen", "Yes"],
["914047", "Indiana", "Spoke and Wheel", "Yes"],
["914095", "Indiana", "Randonneurs USA", "Yes"],
["914099", "Indiana", "Independent", "Yes"],
["915001", "Iowa", "Lake Country Cyclists", "Yes"],
["915002", "Iowa", "Iowa City Cycling Club", "Yes"],
["915003", "Iowa", "Keokuk Bike Club", "Yes"],
["915004", "Iowa", "Tall Dog Bike Club", "Yes"],
["915005", "Iowa", "Iowa Randonneurs", "Yes"],
["915006", "Iowa", "Double I Cycling Experience", "Yes"],
["915007", "Iowa", "Tall Dogs Bike Club", "Yes"],
["915008", "Iowa", "SCRC  Serious Coin Running-Riding Club", "Yes"],
["915011", "Iowa", "Iowa Ultra Events", "Yes"],
["915012", "Iowa", "Bike Burlington", "Yes"],
["915013", "Iowa", "Bicyclists of Iowa City", "Yes"],
["915014", "Iowa", "Rainbow Bicycle Club", "Yes"],
["915015", "Iowa", "Cedar Valley Cyclists", "Yes"],
["915020", "Iowa", "Des Moines Cycle Club", "Yes"],
["915021", "Iowa", "Quad Cities Bicycle Club", "Yes"],
["915022", "Iowa", "Sioux Land Cyclists", "Yes"],
["915023", "Iowa", "Hawkeye Bicycle Association", "Yes"],
["915024", "Iowa", "Melon City Bike Club", "Yes"],
["915025", "Iowa", "Chain Reaction Bike Club", "Yes"],
["915026", "Iowa", "Iowa Valley Bicycle Club", "Yes"],
["915027", "Iowa", "Dodger Cyclists", "Yes"],
["915028", "Iowa", "Central Iowa Cycling Club", "Yes"],
["915029", "Iowa", "Team Hubris", "Yes"],
["915095", "Iowa", "Randonneurs USA", "Yes"],
["915099", "Iowa", "Independent", "Yes"],
["916001", "Kansas", "Lawrence Bicycle Club", "Yes"],
["916002", "Kansas", "Major Taylor Cycling Club - Hillstreet Spinners", "Yes"],
["916003", "Kansas", "Kansas City Metro Bicycle Club", "Yes"],
["916004", "Kansas", "LocalCycling.Com-Kansas City", "Yes"],
["916005", "Kansas", "KCOI Boulevard Racing", "Yes"],
["916031", "Kansas", "Oz Bicycle Club", "Yes"],
["916032", "Kansas", "Wichita Mountains Bicycle Club", "Yes"],
["916033", "Kansas", "Wyandotte Cycling Club", "Yes"],
["916034", "Kansas", "Johnson County Bicycle Club", "Yes"],
["916035", "Kansas", "Mokan Bicycle Club", "Yes"],
["916036", "Kansas", "Blue River Bicycle Club", "Yes"],
["916037", "Kansas", "Free State Racing", "Yes"],
["916038", "Kansas", "Prairie Village Yacht Club", "Yes"],
["916039", "Kansas", "Slimen und Grossen", "Yes"],
["916095", "Kansas", "Randonneurs USA", "Yes"],
["916099", "Kansas", "Independent", "Yes"],
["917001", "Kentucky", "Bluegrass Cycling Club", "Yes"],
["917002", "Kentucky", "Louisville Bicycle Club", "Yes"],
["917003", "Kentucky", "Bowling Green League of Bicyclists", "Yes"],
["917004", "Kentucky", "Little River Cycling Club", "Yes"],
["917005", "Kentucky", "Ohio Valley Velo", "Yes"],
["917006", "Kentucky", "Ashland Cycling Enthusiasts", "Yes"],
["917007", "Kentucky", "Pennyrile Area Cyclists", "Yes"],
["917095", "Kentucky", "Randonneurs USA", "Yes"],
["917099", "Kentucky", "Independent", "Yes"],
["918001", "Louisiana", "Red Strick Racers", "Yes"],
["918002", "Louisiana", "Crescent City Randonneurs", "Yes"],
["918003", "Louisiana", "Crescent City Cyclists", "Yes"],
["918004", "Louisiana", "Tiger Cycling Foundation", "Yes"],
["918005", "Louisiana", "Baton Rouge Bike Club", "Yes"],
["918006", "Louisiana", "Bayou Country Cyclists", "Yes"],
["918007", "Louisiana", "New Orleans Bicycle Club", "Yes"],
["918095", "Louisiana", "Randonneurs USA", "Yes"],
["918099", "Louisiana", "Independent", "Yes"],
["919001", "Maine", "Southern Maine Cycling Club", "Yes"],
["919002", "Maine", "Casco Bay Bicycle Club", "Yes"],
["919003", "Maine", "Maine Cycling Club", "Yes"],
["919004", "Maine", "Western Maine Velo", "Yes"],
["919005", "Maine", "Community Cycling Club of Portland", "Yes"],
["919006", "Maine", "Portland velo club", "Yes"],
["919007", "Maine", "Merrymeeting Wheelers", "Yes"],
["919095", "Maine", "Randonneurs USA", "Yes"],
["919099", "Maine", "Independent", "Yes"],
["920001", "Maryland", "Annapolis Bicycle Club", "Yes"],
["920002", "Maryland", "Baltimore Bicycle Club", "Yes"],
["920003", "Maryland", "Oxon Hill Bicycle Club", "Yes"],
["920004", "Maryland", "Cumberland Valley Cycling Club", "Yes"],
["920005", "Maryland", "Chesapeake Wheelmen", "Yes"],
["920006", "Maryland", "Patuxent Area Cycling Enthusiasts", "Yes"],
["920007", "Maryland", "Squadra Coppi", "Yes"],
["920008", "Maryland", "Wheelbase", "Yes"],
["920009", "Maryland", "Adventures For The Cure", "Yes"],
["920010", "Maryland", "Potomac Pedalers Touring Club", "Yes"],
["920011", "Maryland", "Charm City Cycling", "Yes"],
["920012", "Maryland", "Kelly Benefit Strategies LSV", "Yes"],
["920013", "Maryland", "Solomons Island Cycling", "Yes"],
["920014", "Maryland", "Velo City Riders Cycling Club", "Yes"],
["920021", "Maryland", "Tri-City Cyclists", "Yes"],
["920022", "Maryland", "Frederick Pedalers", "Yes"],
["920023", "Maryland", "Patuxent  Velo", "Yes"],
["920024", "Maryland", "Artemis", "Yes"],
["920025", "Maryland", "Severna Park Peloton", "Yes"],
["920095", "Maryland", "Randonneurs USA", "Yes"],
["920099", "Maryland", "Independent", "Yes"],
["921001", "Massachusetts", "Seven Hills Wheelmen", "Yes"],
["921002", "Massachusetts", "Cambridge River Wheelmen", "Yes"],
["921003", "Massachusetts", "Boston Montreal Boston", "Yes"],
["921004", "Massachusetts", "Mass Bay Road Club", "Yes"],
["921005", "Massachusetts", "New England Randonneurs", "Yes"],
["921006", "Massachusetts", "Blue Hills Cycling Club", "Yes"],
["921007", "Massachusetts", "Ride Studio Cafe Club", "Yes"],
["921008", "Massachusetts", "Northampton Cycling Club", "Yes"],
["921009", "Massachusetts", "New Horizons Cycling Club", "Yes"],
["921010", "Massachusetts", "Team Pegasus", "Yes"],
["921011", "Massachusetts", "Monsters Cycling Club", "Yes"],
["921012", "Massachusetts", "Rippers", "Yes"],
["921030", "Massachusetts", "Boston Brevet Series", "Yes"],
["921031", "Massachusetts", "Berkshire", "Yes"],
["921033", "Massachusetts", "Northeast Sport Cyclists", "Yes"],
["921034", "Massachusetts", "Charles River Wheelmen", "Yes"],
["921035", "Massachusetts", "Northeast Bicycle Club", "Yes"],
["921036", "Massachusetts", "Warwick Cycling Club", "Yes"],
["921037", "Massachusetts", "Franklin-Hampshire Freewheelers", "Yes"],
["921038", "Massachusetts", "State Line Cycle Club", "Yes"],
["921039", "Massachusetts", "U-Masters", "Yes"],
["921040", "Massachusetts", "Dreambikes", "Yes"],
["921041", "Massachusetts", "Boston Chapter AMC", "Yes"],
["921042", "Massachusetts", "BTTB", "Yes"],
["921043", "Massachusetts", "Essex County Velo", "Yes"],
["921044", "Massachusetts", "Nashoba Valley Pedalers", "Yes"],
["921045", "Massachusetts", "Team Bicycle Alley", "Yes"],
["921046", "Massachusetts", "Swansea Velo", "Yes"],
["921047", "Massachusetts", "North Shore Cyclists", "Yes"],
["921048", "Massachusetts", "Minuteman Road Club", "Yes"],
["921049", "Massachusetts", "Bunch of Bikers", "Yes"],
["921050", "Massachusetts", "Crack O Dawn Riders", "Yes"],
["921051", "Massachusetts", "Cape Cod Cyclist", "Yes"],
["921052", "Massachusetts", "Northeastern University Cycling", "Yes"],
["921095", "Massachusetts", "Randonneurs USA", "Yes"],
["921099", "Massachusetts", "Independent", "Yes"],
["922001", "Michigan", "Kalamazoo Bicycle Club", "Yes"],
["922002", "Michigan", "Tri-County Bicycle Association", "Yes"],
["922003", "Michigan", "Pink Leopard", "Yes"],
["922004", "Michigan", "Clinton River Rider Bicycle Club", "Yes"],
["922005", "Michigan", "On Two Wheels", "Yes"],
["922006", "Michigan", "Wheel Suckers", "Yes"],
["922007", "Michigan", "Rapid Wheelmen", "Yes"],
["922008", "Michigan", "Ford Cycling Club", "Yes"],
["922009", "Michigan", "Battlecreek Bike Club", "Yes"],
["922010", "Michigan", "AYH", "Yes"],
["922011", "Michigan", "Downriver Cycling Club", "Yes"],
["922012", "Michigan", "Tri-City-Cyclists", "Yes"],
["922013", "Michigan", "West Michigan Coast Riders", "Yes"],
["922014", "Michigan", "Cherry Capital Cycling Club", "Yes"],
["922015", "Michigan", "Detroit Randonneurs", "Yes"],
["922016", "Michigan", "Team Velo City Cycles", "Yes"],
["922017", "Michigan", "RACING GREYHOUNDS", "Yes"],
["922018", "Michigan", "CFT-Sinas Dramis Law Cycling Team", "Yes"],
["922019", "Michigan", "Ann Arbor Triathlon Club", "Yes"],
["922020", "Michigan", "Team O2-Cadieux Bicycle Club", "Yes"],
["922021", "Michigan", "Clinton River Riders Bicycle Club", "Yes"],
["922030", "Michigan", "Ann Arbor Bicycle Touring Society", "Yes"],
["922031", "Michigan", "Wolverine Sports Club", "Yes"],
["922032", "Michigan", "Ann Arbor Velo Club", "Yes"],
["922033", "Michigan", "Flying Rhino Cycling Club", "Yes"],
["922095", "Michigan", "Randonneurs USA", "Yes"],
["922099", "Michigan", "Independent", "Yes"],
["923001", "Minnesota", "Lakeside Velo", "Yes"],
["923002", "Minnesota", "Twin Cities Spoke - IC3", "Yes"],
["923003", "Minnesota", "Minnesota Randonneurs", "Yes"],
["923004", "Minnesota", "Great Scott Cycling Club", "Yes"],
["923005", "Minnesota", "Team Balance", "Yes"],
["923011", "Minnesota", "Cycling Club of Rochester", "Yes"],
["923012", "Minnesota", "Big River Bicycle Club", "Yes"],
["923013", "Minnesota", "Twin Cities Bicycling Club", "Yes"],
["923014", "Minnesota", "Gopher Wheelmen", "Yes"],
["923039", "Minnesota", "Rochester Active Sports Club", "Yes"],
["923040", "Minnesota", "Minnesota Cycling Team", "Yes"],
["923041", "Minnesota", "Lanterne Rouge", "Yes"],
["923042", "Minnesota", "Birchwood Bike Team", "Yes"],
["923043", "Minnesota", "St Paul Bicycle Racing Club", "Yes"],
["923095", "Minnesota", "Randonneurs USA", "Yes"],
["923099", "Minnesota", "Independent", "Yes"],
["924001", "Missisippi", "Jackson Metro Cyclists", "Yes"],
["924002", "Missisippi", "Magnolia State Randonneurs", "Yes"],
["924003", "Missisippi", "Natchez Bicycle Club", "Yes"],
["924095", "Missisippi", "Randonneurs USA", "Yes"],
["924099", "Missisippi", "Independent", "Yes"],
["925001", "Missouri", "Kansas City Ultra Cycling", "Yes"],
["925002", "Missouri", "St Louis Sunset Cyclery", "Yes"],
["925003", "Missouri", "Team Revolution", "Yes"],
["925004", "Missouri", "Team Sho-Air KC/PrologueCycling.com", "Yes"],
["925005", "Missouri", "Audax Kansas City", "Yes"],
["925006", "Missouri", "St Louis Randonneurs", "Yes"],
["925007", "Missouri", "Big Tree Cycling", "Yes"],
["925030", "Missouri", "Kansas City Bicycle Club", "Yes"],
["925031", "Missouri", "Gateway Council HI AYH", "Yes"],
["925032", "Missouri", "Springbike Bicycle Club", "Yes"],
["925033", "Missouri", "Northland", "Yes"],
["925034", "Missouri", "St Louis Cycling Club", "Yes"],
["925036", "Missouri", "Jackson County Wheelmen", "Yes"],
["925037", "Missouri", "Johnson City Bicycle Club", "Yes"],
["925038", "Missouri", "Kaw Valley Bicycle Club", "Yes"],
["925039", "Missouri", "K. Bicycle Touring Club", "Yes"],
["925040", "Missouri", "Columbia Bicycle Club", "Yes"],
["925043", "Missouri", "Capital City", "Yes"],
["925044", "Missouri", "Midwest Junior Cyclists", "Yes"],
["925045", "Missouri", "Pedro's Mountain Bike", "Yes"],
["925046", "Missouri", "AYH Council of Greater St. Louis", "Yes"],
["925047", "Missouri", "St. Louis Bicycle Touring Society", "Yes"],
["925048", "Missouri", "Velo Girardeau", "Yes"],
["925049", "Missouri", "Kirksville Bicycle Club", "Yes"],
["925050", "Missouri", "St Joesph Bicycle Club", "Yes"],
["925051", "Missouri", "West Plains Regional Bicycle Club", "Yes"],
["925095", "Missouri", "Randonneurs USA", "Yes"],
["925099", "Missouri", "Independent", "Yes"],
["926001", "Montana", "Gallatin Valley Bicycle Club", "Yes"],
["926002", "Montana", "Billings Bicycle Club", "Yes"],
["926095", "Montana", "Randonneurs USA", "Yes"],
["926099", "Montana", "Independent", "Yes"],
["927001", "Nebraska", "Omaha Pedalers", "Yes"],
["927002", "Nebraska", "Husker Road Club", "Yes"],
["927003", "Nebraska", "Great Plains Bicycle Club", "Yes"],
["927004", "Nebraska", "Highgear LBC Racing", "Yes"],
["927005", "Nebraska", "Nebraska Sandhills Randonneurs", "Yes"],
["927006", "Nebraska", "Greenstreet Velo Club", "Yes"],
["927007", "Nebraska", "Nebraska Randonneurs", "Yes"],
["927008", "Nebraska", "Bellevue Bicycle Club", "Yes"],
["927095", "Nebraska", "Randonneurs USA", "Yes"],
["927099", "Nebraska", "Independent", "Yes"],
["928001", "Nevada", "Green Valley Cyclists", "Yes"],
["928027", "Nevada", "Reno Wheelmen", "Yes"],
["928030", "Nevada", "Alta Alpina Cycling Club", "Yes"],
["928031", "Nevada", "Carson City Cyclists", "Yes"],
["928095", "Nevada", "Randonneurs USA", "Yes"],
["928099", "Nevada", "Independent", "Yes"],
["929002", "New Hampshire", "Putney/West Hill", "Yes"],
["929003", "New Hampshire", "New Hampshire Cycling Club", "Yes"],
["929004", "New Hampshire", "Sunapee/S&amp;W Racing Team", "Yes"],
["929005", "New Hampshire", "Claremont Cycle Depot Bike Club", "Yes"],
["929010", "New Hampshire", "Granite State Wheelmen", "Yes"],
["929011", "New Hampshire", "Riverside Cycles", "Yes"],
["929012", "New Hampshire", "Heart of New England Cycling Club", "Yes"],
["929095", "New Hampshire", "Randonneurs USA", "Yes"],
["929099", "New Hampshire", "Independent", "Yes"],
["930001", "New Jersey", "Central Jersey Bicycle Club", "Yes"],
["930002", "New Jersey", "Jersey Shore Touring Society", "Yes"],
["930003", "New Jersey", "South Jersey Wheelmen", "Yes"],
["930004", "New Jersey", "Newton Bicycle Club", "Yes"],
["930005", "New Jersey", "Bicycle Club of Philadelphia", "Yes"],
["930006", "New Jersey", "Outdoor Club of South Jersey", "Yes"],
["930007", "New Jersey", "Merck Cycling Club", "Yes"],
["930008", "New Jersey", "Orange County Bicycle Club", "Yes"],
["930009", "New Jersey", "Bicycle Touring Club of North Jersey", "Yes"],
["930010", "New Jersey", "Team Echelon", "Yes"],
["930011", "New Jersey", "Century Road Club of America", "Yes"],
["930012", "New Jersey", "Atlantic Bicycle Club", "Yes"],
["930013", "New Jersey", "Hb Cycle Club", "Yes"],
["930014", "New Jersey", "Team Evesham", "Yes"],
["930015", "New Jersey", "Major Taylor Cycling Club of New Jersey", "Yes"],
["930024", "New Jersey", "Morris Freewheelers", "Yes"],
["930025", "New Jersey", "Western Jersey Wheelmen", "Yes"],
["930026", "New Jersey", "Ridge Velo", "Yes"],
["930027", "New Jersey", "Princeton Freewheelers", "Yes"],
["930028", "New Jersey", "Liberty Cycle", "Yes"],
["930029", "New Jersey", "New Jersey Randonneurs", "Yes"],
["930030", "New Jersey", "Skylands Cycling", "Yes"],
["930031", "New Jersey", "Shore Cycle Club", "Yes"],
["930095", "New Jersey", "Randonneurs USA", "Yes"],
["930099", "New Jersey", "Independent", "Yes"],
["931001", "New Mexico", "Albuquerque", "Yes"],
["931002", "New Mexico", "New Mexico Touring Society", "Yes"],
["931003", "New Mexico", "New Mexico Brevet Series", "Yes"],
["931004", "New Mexico", "Olev Rapido", "Yes"],
["931095", "New Mexico", "Randonneurs USA", "Yes"],
["931099", "New Mexico", "Independent", "Yes"],
["932001", "New York", "Audax New York City", "Yes"],
["932002", "New York", "Rochester Institute of Technology Cycling Club", "Yes"],
["932003", "New York", "Rogue Race Team", "Yes"],
["932004", "New York", "Tarmac Cycling", "Yes"],
["932005", "New York", "Long Island Randonneurs", "Yes"],
["932006", "New York", "HRRT", "Yes"],
["932007", "New York", "Finger Lakes Randonneurs", "Yes"],
["932008", "New York", "New York City Adventure Cycling Club", "Yes"],
["932009", "New York", "Westchester cycle club", "Yes"],
["932010", "New York", "Adirondack Ultra Cycling", "Yes"],
["932011", "New York", "Big Horn Velo", "Yes"],
["932012", "New York", "German Bicycle Club", "Yes"],
["932013", "New York", "Century Road Club Association", "Yes"],
["932014", "New York", "Country Cycle Club", "Yes"],
["932015", "New York", "Kissena Cycling", "Yes"],
["932016", "New York", "Finger Lakes Cycling Club", "Yes"],
["932017", "New York", "Genesee Valley", "Yes"],
["932018", "New York", "Five Borough Bicycle Club", "Yes"],
["932019", "New York", "Lake City", "Yes"],
["932020", "New York", "Huntington Bicycle Club", "Yes"],
["932021", "New York", "Long Island Bicycle Club", "Yes"],
["932022", "New York", "Its Just a Hill", "Yes"],
["932023", "New York", "Mohawk Hudson Cycling Club", "Yes"],
["932025", "New York", "New York Cycle Club", "Yes"],
["932026", "New York", "Saratoga Cycle Center", "Yes"],
["932027", "New York", "Onondaga Cycling Club", "Yes"],
["932028", "New York", "Peachtown Velo", "Yes"],
["932031", "New York", "Syracuse Section IR", "Yes"],
["932032", "New York", "Lackawanna Bicycle Club", "Yes"],
["932033", "New York", "Staten Island Bicycle Club", "Yes"],
["932034", "New York", "Upstate NY Brevet Series", "Yes"],
["932035", "New York", "Transportational Alternatives", "Yes"],
["932036", "New York", "Elmira/Kingsbury's", "Yes"],
["932037", "New York", "Mid-Hudson Bicycle Club", "Yes"],
["932038", "New York", "Hudson Valley", "Yes"],
["932039", "New York", "Massapequa Park Bicycle Club", "Yes"],
["932040", "New York", "Orange County Bicycle Club", "Yes"],
["932041", "New York", "Westchester Cycle Club", "Yes"],
["932042", "New York", "Niagara Frontier Bicycle Club", "Yes"],
["932043", "New York", "Mercury Web Solutions Velo Cycling", "Yes"],
["932044", "New York", "Hells Kitchen Cycling Team", "Yes"],
["932045", "New York", "Unione Sportiva Italiana", "Yes"],
["932046", "New York", "VO2 Velo", "Yes"],
["932047", "New York", "Suffolk Bicycle Riders Association", "Yes"],
["932095", "New York", "Randonneurs USA", "Yes"],
["932099", "New York", "Independent", "Yes"],
["933001", "North Carolina", "Greensboro Velo Club", "Yes"],
["933002", "North Carolina", "North Raleigh Gyros", "Yes"],
["933003", "North Carolina", "Slow Spokes", "Yes"],
["933004", "North Carolina", "Brushy Mountain Cyclists Club", "Yes"],
["933005", "North Carolina", "Boone Area Cyclists", "Yes"],
["933006", "North Carolina", "Cross Creek Cycling Club", "Yes"],
["933007", "North Carolina", "Southern Appalachian Bicycling Association", "Yes"],
["933008", "North Carolina", "Blue Ridge Bicycle Club Western North Carolina", "Yes"],
["933009", "North Carolina", "Chair City Cyclists", "Yes"],
["933010", "North Carolina", "River City Cycling Club", "Yes"],
["933011", "North Carolina", "Asheville International Randonneurs", "Yes"],
["933012", "North Carolina", "Sandhills Cycling Club", "Yes"],
["933040", "North Carolina", "Cape Fear Cyclists", "Yes"],
["933041", "North Carolina", "Catawba Valley Cyclists", "Yes"],
["933044", "North Carolina", "High Point Bicycle Club", "Yes"],
["933045", "North Carolina", "North Carolina Bicycle Club", "Yes"],
["933046", "North Carolina", "Coastal Cyclists", "Yes"],
["933047", "North Carolina", "Carolina Tarwheels", "Yes"],
["933048", "North Carolina", "Land/Sky Race", "Yes"],
["933050", "North Carolina", "Lake Norman Touring Club", "Yes"],
["933051", "North Carolina", "Pro-Bikes", "Yes"],
["933052", "North Carolina", "Piedmont Flyers", "Yes"],
["933053", "North Carolina", "Tarheel Cyclist", "Yes"],
["933054", "North Carolina", "East Carolina Velo", "Yes"],
["933055", "North Carolina", "Marion Foothills Cyclists", "Yes"],
["933056", "North Carolina", "Hearts Racing Club", "Yes"],
["933057", "North Carolina", "Bicycle For Life Club", "Yes"],
["933058", "North Carolina", "Alamance-Burlington Bicycle Club", "Yes"],
["933059", "North Carolina", "Asheville Womens Cycling - Team Prestige Subaru", "Yes"],
["933060", "North Carolina", "Asheville Bicycle Racing Club", "Yes"],
["933061", "North Carolina", "Tailwind Tandem Club", "Yes"],
["933062", "North Carolina", "International Christian Bicycle Club", "Yes"],
["933095", "North Carolina", "Randonneurs USA", "Yes"],
["933099", "North Carolina", "Independent", "Yes"],
["934095", "North Dakota", "Randonneurs USA", "Yes"],
["934099", "North Dakota", "Independent", "Yes"],
["935001", "Ohio", "Western Reserve Wheelers", "Yes"],
["935002", "Ohio", "Westerville Bicycle Club", "Yes"],
["935003", "Ohio", "Toledo Area Bicyclists", "Yes"],
["935004", "Ohio", "Team Roll", "Yes"],
["935005", "Ohio", "Northwest Ohio Pedalers", "Yes"],
["935009", "Ohio", "Team Speranza", "Yes"],
["935010", "Ohio", "Cincinnati Cycle Club", "Yes"],
["935011", "Ohio", "French Toast Bicycle Club", "Yes"],
["935012", "Ohio", "Ohio Randonneurs", "Yes"],
["935013", "Ohio", "Columbus Outdoor Pursuits", "Yes"],
["935014", "Ohio", "Dayton Cycling Club", "Yes"],
["935015", "Ohio", "Queen City Wheels", "Yes"],
["935016", "Ohio", "Team Columbus", "Yes"],
["935017", "Ohio", "Knox County Bicycle Club", "Yes"],
["935018", "Ohio", "Lake Erie Wheelmen", "Yes"],
["935019", "Ohio", "Oxford Cycling Club", "Yes"],
["935021", "Ohio", "Summitt Freewheelers", "Yes"],
["935022", "Ohio", "Akron Bicycle Club", "Yes"],
["935023", "Ohio", "Northeast Ohio", "Yes"],
["935024", "Ohio", "Westgate Wheelers", "Yes"],
["935025", "Ohio", "Delaware Bicycle Club", "Yes"],
["935027", "Ohio", "Heart of Ohio Tailwinds", "Yes"],
["935028", "Ohio", "Lima Roadrunners", "Yes"],
["935029", "Ohio", "Maumee Valley Wheelmen", "Yes"],
["935030", "Ohio", "Outspokin Wheelmen", "Yes"],
["935031", "Ohio", "Michiana Bike Association", "Yes"],
["935032", "Ohio", "Athens Bicycle Club", "Yes"],
["935033", "Ohio", "Cleveland Touring Club", "Yes"],
["935034", "Ohio", "Team Dayton", "Yes"],
["935035", "Ohio", "Chamption City Cycling", "Yes"],
["935036", "Ohio", "Dayton Velo", "Yes"],
["935095", "Ohio", "Randonneurs USA", "Yes"],
["935099", "Ohio", "Independent", "Yes"],
["936001", "Oklahoma", "Bartlesville Pedalers", "Yes"],
["936002", "Oklahoma", "Oklahoma Brevet Series", "Yes"],
["936003", "Oklahoma", "Red Dirt Pedalers", "Yes"],
["936004", "Oklahoma", "Eastern Oklahoma", "Yes"],
["936005", "Oklahoma", "Oklahoma Bicycle Society", "Yes"],
["936006", "Oklahoma", "Oklahoma Randonneurs", "Yes"],
["936007", "Oklahoma", "Team Warmup", "Yes"],
["936095", "Oklahoma", "Randonneurs USA", "Yes"],
["936099", "Oklahoma", "Independent", "Yes"],
["937001", "Oregon", "Mid-Valley Bicycle Club", "Yes"],
["937002", "Oregon", "Sorella Forte Cycling Club", "Yes"],
["937003", "Oregon", "South Willamette Randonneurs", "Yes"],
["937004", "Oregon", "Willamette Randonneurs", "Yes"],
["937005", "Oregon", "Cottonwood Stream Randonneurs", "Yes"],
["937011", "Oregon", "Eugene Cycling Club", "Yes"],
["937012", "Oregon", "Klamath Freewheelers", "Yes"],
["937013", "Oregon", "Team Methane", "Yes"],
["937015", "Oregon", "Portland Wheelmen Touring Club", "Yes"],
["937016", "Oregon", "Salem Bicycle Club", "Yes"],
["937017", "Oregon", "Half Fast Velo", "Yes"],
["937018", "Oregon", "Umpqua Velo Club", "Yes"],
["937019", "Oregon", "Portland Velo", "Yes"],
["937020", "Oregon", "Oregon Randonneurs", "Yes"],
["937021", "Oregon", "Siskiyou Velo", "Yes"],
["937095", "Oregon", "Randonneurs USA", "Yes"],
["937099", "Oregon", "Independent", "Yes"],
["938001", "Pennsylvania", "Kindle Hill Cycling Club", "Yes"],
["938002", "Pennsylvania", "Tri County Pedalers", "Yes"],
["938003", "Pennsylvania", "White Clay Bicycle Club", "Yes"],
["938004", "Pennsylvania", "Lehigh Wheelmen", "Yes"],
["938005", "Pennsylvania", "Adventure Cycling", "Yes"],
["938006", "Pennsylvania", "Lancaster Bicycle Club", "Yes"],
["938007", "Pennsylvania", "Allen Athletic Club", "Yes"],
["938008", "Pennsylvania", "Indiana Bicycle Club", "Yes"],
["938009", "Pennsylvania", "Brandywine Bicycle Club", "Yes"],
["938010", "Pennsylvania", "Central Bucks Bicycle Club", "Yes"],
["938011", "Pennsylvania", "Two-Tired Bicycle Club", "Yes"],
["938012", "Pennsylvania", "Berks County Bicycle Club", "Yes"],
["938013", "Pennsylvania", "Bicycle Club of Philadelphia", "Yes"],
["938014", "Pennsylvania", "Suburban Cyclists Unlimited", "Yes"],
["938015", "Pennsylvania", "Harrisburg Bicycle Club", "Yes"],
["938016", "Pennsylvania", "Western Pennsylvania Bicycle Club", "Yes"],
["938017", "Pennsylvania", "Pennsylvania Randonneurs", "Yes"],
["938018", "Pennsylvania", "West Chester Cycling Club", "Yes"],
["938019", "Pennsylvania", "Presque Isle Cycling Club", "Yes"],
["938020", "Pennsylvania", "Susquehanna Valley Velo Club", "Yes"],
["938021", "Pennsylvania", "Lehigh Valley Road and Mountain Biking Group", "Yes"],
["938022", "Pennsylvania", "Franklin and Marshall College", "Yes"],
["938023", "Pennsylvania", "Philadelphia Bicycle Messenger Association", "Yes"],
["938024", "Pennsylvania", "Delaware Valley Bicycle Club", "Yes"],
["938025", "Pennsylvania", "G-Riders", "Yes"],
["938026", "Pennsylvania", "We Bike PHL Racing", "Yes"],
["938027", "Pennsylvania", "Kings Rule Together", "Yes"],
["938028", "Pennsylvania", "The Big Heat", "Yes"],
["938029", "Pennsylvania", "Keystone Racing", "Yes"],
["938095", "Pennsylvania", "Randonneurs USA", "Yes"],
["938099", "Pennsylvania", "Independent", "Yes"],
["939001", "Rhode Island", "Aquidneck Bicycle Club", "Yes"],
["939002", "Rhode Island", "Swamp Yankee Road Club", "Yes"],
["939037", "Rhode Island", "Narragansett Bay Wheelmen", "Yes"],
["939095", "Rhode Island", "Randonneurs USA", "Yes"],
["939099", "Rhode Island", "Independent", "Yes"],
["940001", "South Carolina", "First Flight Bicycle Club", "Yes"],
["940002", "South Carolina", "Electric City Cycling Club", "Yes"],
["940003", "South Carolina", "Augusta Freewheelers", "Yes"],
["940004", "South Carolina", "Blue Ridge Bicycle Club", "Yes"],
["940005", "South Carolina", "Tri City", "Yes"],
["940006", "South Carolina", "ALveLo riders club", "Yes"],
["940007", "South Carolina", "Rock Hill Bicycle Club", "Yes"],
["940040", "South Carolina", "South Carolina Bamberg Club", "Yes"],
["940041", "South Carolina", "Carolina Cyclers", "Yes"],
["940042", "South Carolina", "Orangeburg Riders", "Yes"],
["940043", "South Carolina", "Greenville Spinners Bicycle Club", "Yes"],
["940044", "South Carolina", "South Carolina Sports Club", "Yes"],
["940045", "South Carolina", "Land of Sky Bicycle Club", "Yes"],
["940046", "South Carolina", "Freewheelers of Spartanburg", "Yes"],
["940047", "South Carolina", "Gaston County Cyclists", "Yes"],
["940048", "South Carolina", "Pedal Pack of the Pee Dee", "Yes"],
["940049", "South Carolina", "Greenwood Cycling Club", "Yes"],
["940095", "South Carolina", "Randonneurs USA", "Yes"],
["940099", "South Carolina", "Independent", "Yes"],
["941001", "South Dakota", "Black Hills Bicycling Association", "Yes"],
["941002", "South Dakota", "Falls Area Bicyclists", "Yes"],
["941003", "South Dakota", "Barking Dog Cycling Club", "Yes"],
["941004", "South Dakota", "Palace City Pedalers", "Yes"],
["941005", "South Dakota", "Falls Area Randonneurs", "Yes"],
["941095", "South Dakota", "Randonneurs USA", "Yes"],
["941099", "South Dakota", "Independent", "Yes"],
["942002", "Tennessee", "Fogbees", "Yes"],
["942003", "Tennessee", "Jackson Spokes", "Yes"],
["942004", "Tennessee", "Chattanooga Bicycle Club", "Yes"],
["942005", "Tennessee", "Scenic City Velo", "Yes"],
["942006", "Tennessee", "Team Bubba", "Yes"],
["942007", "Tennessee", "Tennessee Randonneurs", "Yes"],
["942040", "Tennessee", "Memphis Hightailers", "Yes"],
["942041", "Tennessee", "Smoky Mountain Wheelmen", "Yes"],
["942042", "Tennessee", "Kingsport Bicycle Association", "Yes"],
["942043", "Tennessee", "Nashville Bicycle Club", "Yes"],
["942044", "Tennessee", "Murfreesboro Bicycle Club", "Yes"],
["942045", "Tennessee", "Tri-Cities Road Club", "Yes"],
["942046", "Tennessee", "Harpeth Bicycle Club", "Yes"],
["942047", "Tennessee", "Knoxville Revolution", "Yes"],
["942048", "Tennessee", "Sonic Gran Fondo Cycling Club", "Yes"],
["942095", "Tennessee", "Randonneurs USA", "Yes"],
["942099", "Tennessee", "Independent", "Yes"],
["943001", "Texas", "Austin Cycling Association", "Yes"],
["943002", "Texas", "El Paso Bicycle Club", "Yes"],
["943003", "Texas", "West Texas Randonneurs", "Yes"],
["943004", "Texas", "Texoma Cycling Club", "Yes"],
["943005", "Texas", "RGV Randos", "Yes"],
["943006", "Texas", "Bat City Cycling", "Yes"],
["943007", "Texas", "Team Snacks", "Yes"],
["943008", "Texas", "Team SUN City", "Yes"],
["943009", "Texas", "Bike McAllen", "Yes"],
["943010", "Texas", "Fort Worth Bicycling Association", "Yes"],
["943011", "Texas", "Permian Basin Bicycle Association", "Yes"],
["943012", "Texas", "Chapparal Cycling Club", "Yes"],
["943013", "Texas", "Williamson County Cycling Club", "Yes"],
["943014", "Texas", "Lubbock Bicycle Club", "Yes"],
["943015", "Texas", "Texas Tech University Cycling Team", "Yes"],
["943016", "Texas", "Wichmo Mountain Bicycle Club", "Yes"],
["943017", "Texas", "Greater Dallas Bicycle Club", "Yes"],
["943018", "Texas", "Texas Wheels", "Yes"],
["943020", "Texas", "Houston Bicycle Club", "Yes"],
["943021", "Texas", "Big Country Bicycle Association", "Yes"],
["943022", "Texas", "Denton Bicycle Club", "Yes"],
["943023", "Texas", "North Texas Bicycle Club", "Yes"],
["943024", "Texas", "Mirage Cycling Team", "Yes"],
["943025", "Texas", "Hill Country Randonneurs", "Yes"],
["943026", "Texas", "Lone Star Randonneurs", "Yes"],
["943027", "Texas", "Mid Cities Wheelmen", "Yes"],
["943028", "Texas", "The Woodlands Cycling Club", "Yes"],
["943029", "Texas", "Team Bicycle Inc", "Yes"],
["943030", "Texas", "Houston Randonneurs", "Yes"],
["943031", "Texas", "Cycling Crusaders", "Yes"],
["943032", "Texas", "Brazos Valley Cyclists", "Yes"],
["943033", "Texas", "CCRiders Cycling Team", "Yes"],
["943034", "Texas", "Gulf Coast Cycling Association", "Yes"],
["943035", "Texas", "Longview Bicycle Club", "Yes"],
["943036", "Texas", "Space City Cycling Club", "Yes"],
["943037", "Texas", "Hell Week Randonneurs", "Yes"],
["943038", "Texas", "San Antonio Wheelmen", "Yes"],
["943039", "Texas", "Southwest Cycling Club", "Yes"],
["943040", "Texas", "Violet Crown Sports Association", "Yes"],
["943041", "Texas", "Team Bent", "Yes"],
["943042", "Texas", "Plano Bicycle Association", "Yes"],
["943043", "Texas", "San Angelo Brevet Series", "Yes"],
["943044", "Texas", "Northwest Cycling Club", "Yes"],
["943045", "Texas", "San Angelo Bicycle Association", "Yes"],
["943046", "Texas", "Del Rio Fitness and Racing Team", "Yes"],
["943047", "Texas", "Circle C Ranch Cycling Club", "Yes"],
["943048", "Texas", "TexSun Randonneurs", "Yes"],
["943049", "Texas", "Heart of Texas Randonneurs", "Yes"],
["943095", "Texas", "Randonneurs USA", "Yes"],
["943099", "Texas", "Independent", "Yes"],
["944001", "Utah", "Red Rocks Tour", "Yes"],
["944002", "Utah", "NEBO Cycling", "Yes"],
["944003", "Utah", "Bonneville Cycling Club", "Yes"],
["944004", "Utah", "Bonneville Bicycle and Tandem Club", "Yes"],
["944005", "Utah", "Utah Velo Club", "Yes"],
["944006", "Utah", "Logan Race Club", "Yes"],
["944007", "Utah", "Southern Utah Brevet", "Yes"],
["944008", "Utah", "Salt Lake Randonneurs", "Yes"],
["944095", "Utah", "Randonneurs USA", "Yes"],
["944099", "Utah", "Independent", "Yes"],
["945001", "Vermont", "Stone Bicycle Club", "Yes"],
["945002", "Vermont", "Killington Pico Cycling Club", "Yes"],
["945003", "Vermont", "Middlebury Bike Club", "Yes"],
["945004", "Vermont", "Mad River Riders", "Yes"],
["945005", "Vermont", "Green Mountain Bicycle Club", "Yes"],
["945006", "Vermont", "Middlebury Road Club", "Yes"],
["945007", "Vermont", "Audax Vermont", "Yes"],
["945008", "Vermont", "Woodstock Bicycle Club", "Yes"],
["945009", "Vermont", "Velo Mont Vert", "Yes"],
["945095", "Vermont", "Randonneurs USA", "Yes"],
["945099", "Vermont", "Independent", "Yes"],
["946001", "Virginia", "Victory Velo", "Yes"],
["946002", "Virginia", "Tidewater Randonneurs", "Yes"],
["946003", "Virginia", "Richmond Area Bicycling Association", "Yes"],
["946004", "Virginia", "Blacksburg Wheelmen", "Yes"],
["946005", "Virginia", "Nantucket Nectars", "Yes"],
["946006", "Virginia", "Reston Bike Club", "Yes"],
["946007", "Virginia", "Mid Atlantic Off Road Enthusiasts", "Yes"],
["946008", "Virginia", "Monticello Velo Club", "Yes"],
["946009", "Virginia", "East Coasters Race Team", "Yes"],
["946010", "Virginia", "New River Valley Bicycle Association", "Yes"],
["946011", "Virginia", "Richmond Ciclismo", "Yes"],
["946012", "Virginia", "DC Randonneurs", "Yes"],
["946013", "Virginia", "Randonneurs of the Mid-Atlantic", "Yes"],
["946014", "Virginia", "Peninsula Bicycling Association", "Yes"],
["946015", "Virginia", "Babes on Bikes", "Yes"],
["946016", "Virginia", "US Military Endurance Sports", "Yes"],
["946017", "Virginia", "Chuckatuck Chainring", "Yes"],
["946018", "Virginia", "Fredericksburg Cyclists Club", "Yes"],
["946020", "Virginia", "Northern Virginia Randonneurs", "Yes"],
["946095", "Virginia", "Randonneurs USA", "Yes"],
["946099", "Virginia", "Independent", "Yes"],
["947001", "Washington", "Vancouver Bicycle Club", "Yes"],
["947002", "Washington", "Cucina Fresca", "Yes"],
["947003", "Washington", "West Sound Cycling Club", "Yes"],
["947004", "Washington", "Desert River Randonneurs", "Yes"],
["947005", "Washington", "Port Townsend Bicycle Association", "Yes"],
["947006", "Washington", "PCP Racing", "Yes"],
["947007", "Washington", "Point 83", "Yes"],
["947008", "Washington", "The Green Bike Team", "Yes"],
["947009", "Washington", "Mount Baker Bicycle Club", "Yes"],
["947010", "Washington", "Baddlands Cycling Club", "Yes"],
["947011", "Washington", "Alki Velo Club", "Yes"],
["947013", "Washington", "Cascade Bicycle Club", "Yes"],
["947014", "Washington", "Green River Bicycle Club", "Yes"],
["947015", "Washington", "Redmond Cycling Club", "Yes"],
["947016", "Washington", "Road Toads", "Yes"],
["947017", "Washington", "Team Washington", "Yes"],
["947018", "Washington", "Seattle International Randonneurs", "Yes"],
["947019", "Washington", "Capital Bicycling Club", "Yes"],
["947020", "Washington", "Wheatland Wheelers", "Yes"],
["947095", "Washington", "Randonneurs USA", "Yes"],
["947099", "Washington", "Independent", "Yes"],
["948030", "West Virginia", "Mountain State Wheelers", "Yes"],
["948095", "West Virginia", "Randonneurs USA", "Yes"],
["948099", "West Virginia", "Independent", "Yes"],
["949001", "Wisconsin", "Ridge Riders", "Yes"],
["949002", "Wisconsin", "Belle City Bicycle Club", "Yes"],
["949003", "Wisconsin", "Bombay Bicycle Club", "Yes"],
["949004", "Wisconsin", "Team 242", "Yes"],
["949005", "Wisconsin", "PAC Tour", "Yes"],
["949006", "Wisconsin", "Wausau Wheelers Bicycle Club", "Yes"],
["949007", "Wisconsin", "Driftless Randonneurs", "Yes"],
["949008", "Wisconsin", "Heartland Bike Club", "Yes"],
["949014", "Wisconsin", "Kenosha Velo Sport", "Yes"],
["949015", "Wisconsin", "Cream City Bicycle Club", "Yes"],
["949016", "Wisconsin", "Velo Club Ole", "Yes"],
["949017", "Wisconsin", "Janesville Velo Club", "Yes"],
["949018", "Wisconsin", "Kenosha Racine Bike Club", "Yes"],
["949095", "Wisconsin", "Randonneurs USA", "Yes"],
["949099", "Wisconsin", "Independent", "Yes"],
["950001", "Wyoming", "United Cyclists of Jackson Hole", "Yes"],
["950095", "Wyoming", "Randonneurs USA", "Yes"],
["950099", "Wyoming", "Independent", "Yes"],
["951001", "D.C.", "National Capital Velo Club", "Yes"],
["951002", "D.C.", "District of Columbia Velo Club", "Yes"],
["951003", "D.C.", "Washington Area Bicycle Association", "Yes"],
["951095", "D.C.", "Randonneurs USA", "Yes"],
["951099", "D.C.", "Independent", "Yes"],
["952001", "Puerto Rico", "San Juan Cycling Club", "Yes"],
["952002", "Puerto Rico", "Isla Cycling Team", "Yes"],
["952003", "Puerto Rico", "Puerto Rico Randonneurs", "Yes"],
["952004", "Puerto Rico", "CMR", "Yes"],
["952095", "Puerto Rico", "Randonneurs USA", "Yes"],
["952099", "Puerto Rico", "Independent", "Yes"],
["971001", "", "Bermuda Bicycle Association", "Yes"],
["980008", "", "Audax Rio", "Yes"]];




}