<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

	class Registerpages {

		public function __construct(){
		}
	 	
		public $page = [
		
                // DETERMINE THE RIDER
                
				'find_member' =>
						[
							'title' => 'Registration',
							'fields' => [
								['first_name','First Name','Enter first name', true, "trim|required|regex_match[/^([a-zA-Z0-9]+ ?)+?$/]|max_length[50]"], 
								['last_name','Last Name','Enter last name',true, "trim|required|regex_match[/^([a-zA-Z0-9']+ ?)+?$/]|max_length[50]"],
								['rusa_id','RUSA Number','RUSA Membership number',false,'trim|is_natural_no_zero|less_than[100000]']
							]
						],
				'register_pick_member' =>
						[
							'title' => 'Select Rider',
							'show' => ['rider'=>true],
							'form_body' => 'pick_member_form_body'
						],
				'register_unknown' =>
						[
							'title' => 'Welcome New Rider',
							'next_page' => 'get_new_member_data',
							'fields' => [],
							'comment' => <<<'EOT'
<h2>Welcome new rider!</h2>
<p>Welcome to {$this_organization}. If you are new to our sport, 
you can learn <A HREF="{$base_url}WhatToExpect.pdf">what to expect on a {$this_organization} event</a> from our <A HREF="{$base_url}info/resources">General Information</a> page.
Even if you are an experienced cyclist or visiting randonneur you will find useful information there. <em>All
riders</em> must be familiar with the <A HREF="{$base_url}SafetyInstructions.pdf">Safety Instructions</a>.</p>
<p>To begin your registration for this event, as you were not found in the {$this_organization} rider database,
please click "continue" and enter your contact information. </p>
EOT
						],
				'get_new_member_data' =>
						[
							'title' => 'Rider Info',
							'comment' => '<p>As a rider with  {$this_organization} we need to obtain your contact information. Starred items are required. Please enter your information below:</p>',
							'form_fineprint' => '<p>Privacy Policy: This information is used by {$this_organization} <em>only</em> to contact you with respect to this event, to notify you and simplify your 
										registration with respect to future events, and in case of emergency. For more details see full <A HREF="{$base_url}privacy.html">privacy policy</a>.</p>',
							'fields' => [
								['contact_street','Street Address','Enter Street Address',true, 'trim|required|max_length[250]'],
								['contact_city','City','Enter City',true, 'trim|required|max_length[250]'],
								['contact_state','State','Select State or N/A for Non-US',true,'required','select','get_state_options'],
								['contact_zip','Postal Code','Enter Postal Code',true, 'trim|required|alpha_dash|min_length[5]|max_length[10]'],
								['contact_country','Nationality','Select your nationality',true,'required','select','get_country_options'],
								['contact_tracker','Tracker URL','Enter Tracker URL (optional)',false, 'trim|valid_url|min_length[5]|max_length[250]'],
								['contact_email','Email','Enter Email',true, 'trim|required|valid_email|max_length[250]'],
								['contact_phone','Cell Phone','Your phone number on the bike',true, 'trim|min_length[10]|max_length[25]|callback__phone_check'],
								['contact_phone_alt','Phone (alternative)','Enter alternative phone (optional)',false, 'trim|min_length[10]|max_length[25]|callback__phone_check'],
								['contact_emergency_name','Emergency contact name','Enter Emergency contact name',true, 'trim|required|max_length[250]'],
								['contact_emergency_phone','Emergency contact phone','Enter Emergency contact phone',true, 'trim|required|min_length[10]|max_length[25]'],
								['contact_emergency_phone_alt','Emergency contact phone (alternative)','Enter alternative emergency contact phone (optional)',false, 'trim|min_length[10]|max_length[25]'],
								['password','Password','Enter a password for access to your member profile (optional)',false, 'trim|min_length[8]|max_length[25]','password']

							]
						],
						
                // JOIN THE CLUB OPTION

				'choose_join' =>
						[
							'title' => 'Join {$this_organization}',
							'show' => [],
							'fields' => [
								['join_renew','Club Membership','',true,'required','radio',
									['join'=>'<span style="font-size: 120%;">Yes, I\'d like to join now</span>', 
									 'no'=>'No, I do not want to join at this time.']]
							],
							'comment' => 'Consider joining {$this_organization} now. Annual membership dues are ${$new_member_join}. 
							    With membership, special events are free, and you receive a discount of ${$guest_fee_normal} 
								for our regular events all year. If you join now, your membership applies to 
								this event and will expire {$membership_new_expires}. Your dues help support randonneuring in {$this_region}.</p>'
						],
				'choose_rejoin' =>
						[
							'title' => 'Re-Join {$this_organization}',
							'show' => [],
							'fields' => [
								['join_renew','Club Membership','',true,'required','radio',
									['rejoin'=>'<span style="font-size: 120%;">Yes, I\'d like to rejoin now</span>', 
									 'no'=>'No, I do not want to rejoin at this time.']]
							],
							'comment' => 'Your {$this_organization} membership expired {$expires}. Consider rejoining now. Annual membership dues are ${$expired_renew}. 
							    With membership, special events are free, and you receive a discount of ${$guest_fee_normal} 
								for our regular events all year. If you join now, your membership applies to 
								this event and will expire {$membership_new_expires}. Your dues help support randonneuring in {$this_region}.</p>'
						],
				'choose_renew' =>
						[
							'title' => 'Renew your Membership in {$this_organization}',
							'show' => [],
							'fields' => [
								['join_renew','Club Membership','',true,'required','radio',
									['renew'=>'<span style="font-size: 120%;">Yes, I\'d like to renew now</span>', 
									 'no'=>'No, I do not want to renew at this time.']]
							],
							'comment' => 'Your {$this_organization} membership expires {$expires}. Consider renewing your membership now. Annual membership renewal is ${$current_renew}. 
							    With membership, special events are free, and you receive a discount of ${$guest_fee_normal} 
								for our regular events all year. If you renew now, your membership will be extended 
								to {$membership_new_expires}. Your dues help support randonneuring in {$this_region}.</p>'
						],

                // LODGING OPTION
						
                'select_lodging' =>
						[
							'title' => 'Select Lodging',
							'show' => [],
							'fields' => [
								['lodging','Choice of lodging','',true,'required','radio','get_lodging_options']
							],
							'comment'=>'This event includes optional lodging provided by the club. <b>Lodging is subject to availability.</b> Precedence for beds goes to riders on longer events. If we can\'t accomodate your request, we\'ll let you know and any extra fees will be refunded.'
						],
						

                // REVIEW CHARGES BEFORE WAIVER
                'review_charges' =>
						[
							'title' => 'Review Charges',
                            'show'=>['event'=>true,'charges'=>true],
							'form_body' => 'review_charges_body',
							'next_page' => 'smartwaiver'
						],




                // WAIVER CAPTURE
                
                'smartwaiver' =>
						[
							'title' => 'Release and Waiver of Liability',
							'form_body' => 'smartwaiver_form_body',
							'show' => [],
							'submit' => []
						],


                'smartwaiver_old' =>
						[
							'title' => 'Release and Waiver of Liability',
							'show' => [],
							'comment' => '<div class="vspace"></div><div class="text-center bigger sans">All riders who start this event must agree to a waiver of liability.</div>
							<div class="narrower bordered italic"><p>These events are not for beginners.  The courses are hilly. You may face extremes of weather: heat, cold, wind, rain. The roads are unmarked and open to automobile traffic. There will be night riding in the longer events.  If you understand these risks, and still want to ride, you will need to sign a RUSA waiver to that effect.</P></div><P style="text-align: center;">Enter your <B>date of birth</B> and press the button below to be redirected to the RUSA "Smart" Waiver System.</p>',
                            'fields'=>[
                            ['birth_year','Year','Select birthday year',false,'required|callback__birthday_check','select','get_year_options'],
                            ['birth_month','Month','Select birthday month',false,'required','select','get_month_options'],
                            ['birth_day','Day','Select birthday day',false,'required','select','get_day_options']
                           ],
							'submit' => [['tag'=>'yes','text'=>'Sign the Liability Waiver'],['tag'=>'cancel','text'=>'Cancel']]
						],


                'smartwaiver_complete' =>
						[
							'title' => 'Waiver Complete',
							'show' => [],
							'comment' => 'We made it back!'
						],

						
				// PAYMENT CAPTURE
				
				'pay_online' =>
						[
							'title' => 'Pay Online',
							'show' => ['charges'=>true],
							'submit' => [
														['tag'=>'confirm', 'text'=>'Pay Online Now'],
														['tag'=>'cancel', 'text'=>'Cancel']
													],
							'comment' => '<p> Now click "Pay Online Now" and you will be transferred to PayPal for online payment
							of the ${$total_fee} total fee charged for this event. After PayPal gathers your payment information, 
							you will be returned to the {$this_organization} web site to complete your registration.</p>
							<br><br>
<div class="text-center"><img src="https://www.paypalobjects.com/webstatic/en_US/i/buttons/cc-badges-ppmcvdam.png" width=50% alt="Pay now with PayPal" /></div>'
						],


				// REGISTRATION COMPLETE
                'register_done' =>
						[
							'title' => 'Registration Complete',
							'submit' => [],
							'comment' => <<<'EOT'
<div class=vspace></div><div class=narrower><p>You have successfully registered for the {$event_name} {$event_distance}. 
An email confirmation has been sent to  <tt>{$contact_email}</tt> </p>

<p> Please take a moment to verify your contact information:</p>
<div class='narrower bordered rider-info'>
{$contact_text}
</div>
<div class='narrower bigger text-center italic'>If any of this contact information is incorrect, please <A HREF='{$profile_edit_url}'>click here</A> to edit
your member profile. </div><div class=vspace></div>
<p>That link has a time limit, so please use it immediately. At any later time your can 
update your member profile by <A HREF='{$admin_login_url}'>logging in</a> with your password, or by 
<A HREF='{$event_contact_url}'>contacting</a> the event organizer.</p>

<p>If this is your first brevet, 
you can learn <A HREF="{$base_url}WhatToExpect.pdf">what to expect on a {$this_organization} event</a> from 
our <A HREF="{$base_url}info/resources">General Information</a> page.
<em>All riders</em> must be familiar with the <A HREF="{$base_url}SafetyInstructions.pdf">Safety Instructions</a>.</p>

<p>Should you be unable to start the event (result will be DNS), 
you can use <A HREF='{$cancel_url}'>this link</a> to notify us. No
refunds are issued for pre-paid registration fees. 

<p>If you have any questions for the event organizer, {$organizer_name},   <A HREF='{$event_contact_url}'>click here</a>.</p>

<hr width=61.8%>

<p>Return to the <A HREF='{$base_url}'>{$this_organization} Home Page</a></p></div>					

EOT
						],

						
				// CANCELLATION OF REGISTRATION
                'register_cancel' =>
						[
							'title' => 'Registration Canceled',
							'submit' => [],
							'view_body' => 'form_simple',
							'comment' => '<p>Return to the <A HREF="{$base_url}">{$this_organization} Home Page</a></p>'
						],
				'cancel_confirm' =>
						[
							'title' => 'Confirm Event Cancellation',
							'submit' => [
														['tag'=>'cancel_reg', 'text'=>'Cancel Registration']
													],
							'next_page' => 'cancel_done',
							'comment' => '<p>Click "Cancel Registration" if you would like to withdraw from this event.</p> ',
							'form_fineprint'=>	'<p>Return to the <A HREF="{$base_url}">{$this_organization} Home Page</a>, or 
                                           you may <A HREF="{$event_contact_url}">contact the organizer</a>.</p>'
						],
				'cancel_done' =>
						[
							'title' => 'Registration Cancelled',
							'submit' => [],
							'comment' => '<p>You have successfully cancelled your registration.</p> 
																<p>Return to the <A HREF="{$base_url}">{$this_organization} Home Page</a>.</p>'
						],

				// FLECHE SPECIFIC REGISTRATION		
				'register_fleche' =>
						[
							'title' => 'Registering for the Flèche',
							'form_body' => 'register_fleche_form_body',
							'comment' => 	'<p>This event is a randonneur-style, <A HREF=http://www.rusa.org/teamrando.html>flèche</a> team event. 
								You may register as team captain to create a new team, or you may join an existing team.</p>'
						],
				'join_fleche_team' =>
						[
							'title' => 'Join an Existing Flèche Team',
							'next_page' => 'bike_style',
							'fields' => [
								['fleche_team_id','Fleche Team','Select team you wish to join',true,'required','select','get_fleche_teams_options']
							],

							'comment' => 	'<p>You may join an existing flèche team by selecting a team below. 
								Please speak to the team captain or <A HREF={$event_contact_url}>contact the RBA</a> 
								to coordinate team membership. There can be three, four, or five bikes in a viable flèche team.</p>'
						],
				'create_fleche_team' =>
						[
							'title' => 'Create a New Flèche Team',
							'next_page' => 'create_fleche_team_confirm',
							'fields' => [
								['fleche_team_name','Team Name','Enter your team name',true, 'trim|required|min_length[8]|max_length[250]|callback__fleche_team_name_check'],
								['fleche_team_description','Team Description','Describe your route, your team philosophy, motto, or whatever (500 chars max)...',true,
									 'required|min_length[16]|max_length[500]','textarea'],
								['fleche_team_start_city','Start City','Enter City where your fleche route begins',true, 'trim|required|max_length[250]'],
								['fleche_team_start_state','Start State','Select State  where your fleche route begins',true,'required','select','get_state_options'],
								['fleche_team_start_day','Start Day','Select the <em>day</em> you will start riding',true, 'required|callback__fleche_team_schedule_check','select',['Thursday','Friday','Saturday']],
								['fleche_team_start_hour','Start Hour','Select the <em>hour</em> you will start riding',true,'required|callback__fleche_team_schedule_check','select',['12 midnight','1 AM','2 AM','3 AM','4 AM','5 AM','6 AM','7 AM','8 AM','9 AM','10 AM','11 AM','12 noon','1 PM','2 PM','3 PM','4 PM','5 PM','6 PM','7 PM','8 PM','9 PM','10 PM','11 PM']],
								['fleche_team_start_minute','Start minute','Select the <em>minute</em> you will start riding',true,'required|callback__fleche_team_schedule_check','select',[':00',':15',':30',':45']],
								['fleche_team_map','Map','Enter URL of your route map',true,'required']
							],
							'comment' => 	'<p>Create a new flèche team and register as its captain by filling out the following form. All data entered here is 
														subject to review and approval by the RBA. Please   
							  						<A target="_blank" HREF="{$event_contact_url}">contact the RBA</a> directly to negotiate team details. Give careful consideration to 
														your start time with respect to the {$event_time_zone} time zone. Preferred start time is 8-9 AM on Saturday. 
														Allowable start times are from noon Thursday through 10 AM on Saturday.</p>'
						],
				'create_fleche_team_confirm' =>
						[
							'title' => 'Confirm New Flèche Team',
							'next_page' => 'bike_style',
							'comment' => 	'<p>The following flèche team will be created for this event.</p>',
							'form_body' => 'create_fleche_team_confirm_body',
							'submit' => [['tag'=>'yes','text'=>'Create New Team'],['tag'=>'no','text'=>'Cancel']]
						],

				'bike_style' =>
						[
							'title' => 'Bike Style',
							'comment' => 	'<p>Will you be riding a two-rider (tandem) bicycle for this event?</p>',
							'fields' => [
								['bike_style','Bike Style','',true,'required','radio',
									['solo'=>'Solo (one rider) Bike', 
									 'tandem'=>'Tandem (two rider) bike'],'solo']
							]
						],
				'tandem_partner' =>
						[
							'title' => 'Tandem Partner',
							'comment' => 	'<p>Who is your expected tandem partner? It\'s OK if your partner hasn\'t registered yet, or is still being decided. Just take your best guess.</p>',
							'fields' => [
								['tandem_partner','Tandem Partner','Enter the name of your tandem partner',true, 'trim|required|max_length[40]|regex_match[/^[\s\w\d.\'-]+$/]'],
							]
						],


				// ERROR PAGE
                'error' =>
						[
							'title' => 'Whoops!',
							'submit'=> [],
							'comment' => '<p>Something has gone wrong. Not sure what.</p> 
																<p>Return to the <A HREF="{$base_url}">{$this_organization} Home Page</a></p>'				
						]
				];

				
 	}
	
?>
