<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

	class Registerpages {

		public function __construct(){
		}
	 	
		public $page = [
				'find_member' =>
						[
							'title' => 'Event Registration',
							'fields' => [
								['first_name','First Name','Enter first name', true, 'trim|required|regex_match[/^([a-zA-Z0-9]+ ?)+?$/]|max_length[50]'], 
								['last_name','Last Name','Enter last name',true, 'trim|required|regex_match[/^([a-zA-Z0-9]+ ?)+?$/]|max_length[50]'],
								['rusa_id','RUSA Number','RUSA Membership number',false,'trim|is_natural_no_zero|less_than[100000]']
							]
						],
				'register_unknown' =>
						[
							'title' => 'Welcome New Rider',
							'next_page' => 'get_new_member_data',
							'fields' => [],
							'comment' => <<<'EOT'
<h2>Welcome new rider!</h2>
<p>Welcome to {$this_organization}. If you are new to our sport, 
you can learn <A HREF="{$base_url}WhatToExpect.pdf">what to expect on a {$this_organization} event</a> from our <A HREF="{$base_url}info/resources">General Information</a> page.
Even if you are an experienced cyclist or visiting randonneur you will find useful information there. <em>All
riders</em> must be familiar with the <A HREF="{$base_url}SafetyInstructions.pdf">Safety Instructions</a>.</p>
<p>To begin your registration for this event, as you were not found in the {$this_organization} rider database,
please click "continue" and enter your contact information. </p>
EOT
						],
				'get_new_member_data' =>
						[
							'title' => 'Rider Info',
							'comment' => '<p>As a rider with  {$this_organization} we need to obtain your contact information. Starred items are required. Please enter your information below:</p>',
							'form_fineprint' => '<p>Privacy Policy: This information is used by {$this_organization} <em>only</em> to contact you with respect to this event, to notify you and simplify your 
										registration with respect to future events, and in case of emergency. For more details see full <A HREF="{$base_url}privacy.html">privacy policy</a>.</p>',
							'fields' => [
								['contact_street','Street Address','Enter Street Address',true, 'trim|required|max_length[250]'],
								['contact_city','City','Enter City',true, 'trim|required|max_length[250]'],
								['contact_state','State','Select State or N/A for Non-US',true,'required','select','get_state_options'],
								['contact_zip','Postal Code','Enter Postal Code',true, 'trim|required|alpha_dash|min_length[5]|max_length[10]'],
								['contact_country','Nationality','Select your nationality',true,'required','select','get_country_options'],
								['contact_tracker','Tracker URL','Enter Tracker URL (optional)',false, 'trim|valid_url|min_length[5]|max_length[250]'],
								['contact_email','Email','Enter Email',true, 'trim|required|valid_email|max_length[250]'],
								['contact_phone','Cell Phone','Your phone number on the bike',true, 'trim|min_length[10]|max_length[25]|callback__phone_check'],
								['contact_phone_alt','Phone (alternative)','Enter alternative phone (optional)',false, 'trim|min_length[10]|max_length[25]|callback__phone_check'],
								['contact_emergency_name','Emergency contact name','Enter Emergency contact name',true, 'trim|required|max_length[250]'],
								['contact_emergency_phone','Emergency contact phone','Enter Emergency contact phone',true, 'trim|required|min_length[10]|max_length[25]'],
								['contact_emergency_phone_alt','Emergency contact phone (alternative)','Enter alternative emergency contact phone (optional)',false, 'trim|min_length[10]|max_length[25]'],
								['password','Password','Enter a password for access to your member profile (optional)',false, 'trim|min_length[8]|max_length[25]','password']

							]
						],
				'register_pick_member' =>
						[
							'title' => 'Select Rider',
							'form_body' => 'pick_member_form_body'
						],

				// Not used
				'register_volunteer' =>
						[
							'title' => 'Volunteer for This Event',
							'form_body' => 'volunteer_form_body',
							'form_fineprint' => 	'<p>More info about Volunteering, and detailed 
							descriptions of volunteer jobs can be found <A target="_blank" HREF={$base_url}info/volunteer>here.</a></p>'
						],


				'register_fleche' =>
						[
							'title' => 'Registering for the Flèche',
							'form_body' => 'register_fleche_form_body',
							'comment' => 	'<p>This event is a randonneur-style, <A HREF=http://www.rusa.org/teamrando.html>flèche</a> team event. 
								You may register as team captain to create a new team, or you may join an existing team.</p>'
						],
				'join_fleche_team' =>
						[
							'title' => 'Join an Existing Flèche Team',
							'next_page' => 'bike_style',
							'fields' => [
								['fleche_team_id','Fleche Team','Select team you wish to join',true,'required','select','get_fleche_teams_options']
							],

							'comment' => 	'<p>You may join an existing flèche team by selecting a team below. 
								Please speak to the team captain or <A HREF={$event_contact_url}>contact the RBA</a> 
								to coordinate team membership. There can be three, four, or five bikes in a viable flèche team.</p>'
						],
				'create_fleche_team' =>
						[
							'title' => 'Create a New Flèche Team',
							'next_page' => 'create_fleche_team_confirm',
							'fields' => [
								['fleche_team_name','Team Name','Enter your team name',true, 'trim|required|min_length[8]|max_length[250]|callback__fleche_team_name_check'],
								['fleche_team_description','Team Description','Describe your route, your team philosophy, motto, or whatever (500 chars max)...',true,
									 'required|min_length[16]|max_length[500]','textarea'],
								['fleche_team_start_city','Start City','Enter City where your fleche route begins',true, 'trim|required|max_length[250]'],
								['fleche_team_start_state','Start State','Select State  where your fleche route begins',true,'required','select','get_state_options'],
								['fleche_team_start_day','Start Day','Select the <em>day</em> you will start riding',true, 'required|callback__fleche_team_schedule_check','select',['Thursday','Friday','Saturday']],
								['fleche_team_start_hour','Start Hour','Select the <em>hour</em> you will start riding',true,'required|callback__fleche_team_schedule_check','select',['12 midnight','1 AM','2 AM','3 AM','4 AM','5 AM','6 AM','7 AM','8 AM','9 AM','10 AM','11 AM','12 noon','1 PM','2 PM','3 PM','4 PM','5 PM','6 PM','7 PM','8 PM','9 PM','10 PM','11 PM']],
								['fleche_team_start_minute','Start minute','Select the <em>minute</em> you will start riding',true,'required|callback__fleche_team_schedule_check','select',[':00',':15',':30',':45']],
								['fleche_team_map','Map','Enter URL of your route map',true,'required']
							],
							'comment' => 	'<p>Create a new flèche team and register as its captain by filling out the following form. All data entered here is 
														subject to review and approval by the RBA. Please   
							  						<A target="_blank" HREF="{$event_contact_url}">contact the RBA</a> directly to negotiate team details. Give careful consideration to 
														your start time with respect to the {$event_time_zone} time zone. Preferred start time is 8-9 AM on Saturday. 
														Allowable start times are from noon Thursday through 10 AM on Saturday.</p>'
						],
				'create_fleche_team_confirm' =>
						[
							'title' => 'Confirm New Flèche Team',
							'next_page' => 'bike_style',
							'comment' => 	'<p>The following flèche team will be created for this event.</p>',
							'form_body' => 'create_fleche_team_confirm_body',
							'submit' => [['tag'=>'yes','text'=>'Create New Team'],['tag'=>'no','text'=>'Cancel']]
						],

// need to unlink release from the flow -- it should be call_page() to it
// perhaps create a "page_list" to sequentially call pages from 
// pages shouldn't directly link other pages unless they are interelated
// and need to calculate what comes next --- hmm complexity, but we want 
// to reduce the difficulty of rearranging sequences

// and these page definitions should be in a different file, dontcha think? 

				'bike_style' =>
						[
							'title' => 'Bike Style',
							'comment' => 	'<p>Will you be riding a two-rider (tandem) bicycle for this event?</p>',
							'fields' => [
								['bike_style','Bike Style','',true,'required','radio',
									['solo'=>'Solo (one rider) Bike', 
									 'tandem'=>'Tandem (two rider) bike'],'solo']
							]
						],
				'tandem_partner' =>
						[
							'title' => 'Tandem Partner',
							'comment' => 	'<p>Who is your expected tandem partner? It\'s OK if your partner hasn\'t registered yet, or is still being decided. Just take your best guess.</p>',
							'fields' => [
								['tandem_partner','Tandem Partner','Enter the name of your tandem partner',true, 'trim|required|max_length[40]|regex_match[/^[\s\w\d.\'-]+$/]'],
							]
						],

				'release' =>
						[
							'title' => 'Release and Waiver of Liability',
							'form_body' => 'release_form_body',
							'view_body' => 'form_simple',
							'submit' => [['tag'=>'no','text'=>'Cancel'],['tag'=>'yes','text'=>'I Agree']],
						],
				'smartwaiver' =>
						[
							'title' => 'Release and Waiver of Liability',
							'comment' => '<div class="text-center bigger sans">All riders who start this event must agree to a waiver of liability.</div>
							<p>These events are not for beginners.  The courses are hilly. You may face extremes of weather: heat, cold, wind, rain. The roads are unmarked and open to automobile traffic. There will be night riding in the longer events.  If you understand these risks, and still want to ride, you will need to sign a waiver to that effect.',
							'submit' => [['tag'=>'no','text'=>'Cancel'],['tag'=>'yes','text'=>'Sign the Waiver']]
						],
				'thank_offer' =>
						[
							'title' => 'Thank You for Offering',
							'next_page' => 'RETURN',
							'comment' => 	'<p><em>Thank you for offering to volunteer.</em> Please continue to register
								as a regular rider and prepare to ride as usual on the scheduled event date and time. You will be contacted by the  
							  event organizer <A target="_blank" HREF="{$event_contact_url}">{$organizer_name}</a> if your 
								volunteering offer is accepted. The organizer will confirm your duties and 
								coordinate any pre ride.</p><p>Thanks again!</p>'
						],
				'free_event' =>
						[
							'title' => 'Free Event!',
							'submit' => [
														['tag'=>'cancel', 'text'=>'Cancel'],
														['tag'=>'confirm', 'text'=>'Confirm Registration']
													],
							'comment' => '<div class="text-center bigger sans">There is a no fee for this event. {$free_event_comment}</div>'
						],
				'pay_event' =>
						[
							'title' => 'Pay Day of Event',
							'submit' => [
														['tag'=>'cancel', 'text'=>'Cancel'],
														['tag'=>'confirm', 'text'=>'Confirm Registration']
													],
							'comment' => '<p> You selected payment by cash or check tendered when you arrive at the start controle.   
								<em>An additional ${$possible_late_fee} will be added</em> to the amount due.</p>'
						],
				'pay_mail' =>
						[
							'title' => 'Mailing Payment',
							'submit' => [
														['tag'=>'cancel', 'text'=>'Cancel'],
														['tag'=>'confirm', 'text'=>'Confirm Registration']
													],
							'comment' => '<p> You selected payment by mail. Please mail {$this_organization} 
								a Check or Money Order for ${$total_fee} USD to the following address:</p>
								<div class=indented-tt>{$organizer_name}<br>{$this_organization}<br>{$organizer_address}</div>
								<p>Please include with your payment your full name along with the date and distance of this event. 
								Please mail your payment early so it will be received before
								the registration cutoff ({$event_reg_cutoff}).</p>'
								
						],
				'pay_online' =>
						[
							'title' => 'Pay Online',
							'submit' => [
														['tag'=>'cancel', 'text'=>'Cancel'],
														['tag'=>'confirm', 'text'=>'Pay Online Now']
													],
							'comment' => '<p> Now click "Pay Online Now" and you will be transferred to PayPal for online payment
							of the ${$total_fee} total fee charged for this event. After PayPal gathers your payment information, 
							you will be returned to the {$this_organization} web site to complete your registration.</p>
							<br><br>
<div class="centered"><img src="https://www.paypalobjects.com/webstatic/en_US/i/buttons/cc-badges-ppmcvdam.png" width=70% alt="Pay now with PayPal" /></div>'
						],
				'choose_join' =>
						[
							'title' => 'Join {$this_organization}',
							'fields' => [
								['join_renew','Club Membership','',true,'required','radio',
									['join'=>'<span style="font-size: 120%;">Yes, I\'d like to join now</span>', 
									 'no'=>'No, I do not want to join at this time.']]
							],
							'comment' => 'Consider joining {$this_organization} now. Annual membership dues are ${$new_member_join}. 
							    With membership, special events are free, and you receive a discount of ${$guest_fee_normal} 
								for our regular events all year. If you join now, your membership applies to 
								this event and will expire {$membership_new_expires}. Your dues help support randonneuring in {$this_region}.</p>'
						],
				'choose_rejoin' =>
						[
							'title' => 'Re-Join {$this_organization}',
							'fields' => [
								['join_renew','Club Membership','',true,'required','radio',
									['rejoin'=>'<span style="font-size: 120%;">Yes, I\'d like to rejoin now</span>', 
									 'no'=>'No, I do not want to rejoin at this time.']]
							],
							'comment' => 'Your {$this_organization} membership expired {$expires}. Consider rejoining now. Annual membership dues are ${$expired_renew}. 
							    With membership, special events are free, and you receive a discount of ${$guest_fee_normal} 
								for our regular events all year. If you join now, your membership applies to 
								this event and will expire {$membership_new_expires}. Your dues help support randonneuring in {$this_region}.</p>'
						],
				'choose_renew' =>
						[
							'title' => 'Renew your Membership in {$this_organization}',
							'fields' => [
								['join_renew','Club Membership','',true,'required','radio',
									['renew'=>'<span style="font-size: 120%;">Yes, I\'d like to renew now</span>', 
									 'no'=>'No, I do not want to renew at this time.']]
							],
							'comment' => 'Your {$this_organization} membership expires {$expires}. Consider renewing your membership now. Annual membership renewal is ${$current_renew}. 
							    With membership, special events are free, and you receive a discount of ${$guest_fee_normal} 
								for our regular events all year. If you renew now, your membership will be extended 
								to {$membership_new_expires}. Your dues help support randonneuring in {$this_region}.</p>'
						],
// ADD FLAG TO FORCE PRE-PAY ONLY "FLECH STYLE" PAYMENT
				'choose_payment_method' =>
						[
							'title' => 'Choose Payment Method',
							'fields' => [
								['payment_method','Payment Method','Select your method of payment',true,'required','select','get_payment_method_options']
							]
						],
				'register_cancel' =>
						[
							'title' => 'Registration Canceled',
							'submit' => [],
							'view_body' => 'form_simple',
							'comment' => '<p>Return to the <A HREF="{$base_url}">{$this_organization} Home Page</a></p>'
						],
				'register_done' =>
						[
							'title' => 'Registration Complete',
							'submit' => [],
							'comment' => <<<'EOT'
<p>You have successfully registered for the {$event_name} {$event_distance}.</p>

<p>An email confirmation has been sent to  <tt>{$contact_email}</tt><em></p> <p>If the above 
email address is not correct</em>, please update your <A HREF='{$admin_login_url}'>member profile</a> immediately.</p>

<p>If this is your first brevet, 
you can learn <A HREF="{$base_url}WhatToExpect.pdf">what to expect on a {$this_organization} event</a> from 
our <A HREF="{$base_url}info/resources">General Information</a> page.
<em>All riders</em> must be familiar with the <A HREF="{$base_url}SafetyInstructions.pdf">Safety Instructions</a>.</p>

<p>Should you be unable to start the event (result will be DNS), 
you can use <A HREF='{$cancel_url}'>this link</a> to notify us. No
refunds are issued for pre-paid registration fees. 

<p>If you have any questions for the event organizer, {$organizer_name},   <A HREF='{$event_contact_url}'>click here</a>.</p>

<hr width=61.8%>

<p>Return to the <A HREF='{$base_url}'>{$this_organization} Home Page</a></p>							

EOT
						],
				'select_lodging' =>
						[
							'title' => 'Select Lodging',
							'submit' => 'Continue',
							'comment' => "Not yet defined."
						],
				'cancel_confirm' =>
						[
							'title' => 'Confirm Event Cancellation',
							'submit' => [
														['tag'=>'cancel_reg', 'text'=>'Cancel Registration']
													],
							'next_page' => 'cancel_done',
							'comment' => '<p>Click "Cancel Registration" if you would like to withdraw from this event.</p> ',
							'form_fineprint'=>	'<p>Return to the <A HREF="{$base_url}">{$this_organization} Home Page</a>, or 
                                           you may <A HREF="{$event_contact_url}">contact the organizer</a>.</p>'
						],
				'cancel_done' =>
						[
							'title' => 'Registration Cancelled',
							'submit' => [],
							'comment' => '<p>You have successfully cancelled your registration.</p> 
																<p>Return to the <A HREF="{$base_url}">{$this_organization} Home Page</a>.</p>'
						],

				'error' =>
						[
							'title' => 'Whoops!',
							'submit'=> [],
							'comment' => '<p>Something has gone wrong. Not sure what.</p> 
																<p>Return to the <A HREF="{$base_url}">{$this_organization} Home Page</a></p>'				
						]
				];
				
	
	}
	
?>
