<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

	class Shoppages {

		public function __construct(){
		}
	 	
		public $page = [
				'shop' =>
						[
							'title' => 'Purchase PA Rando Gear and Trinkets',
							'next_page' => 'options',
							'form_body' => 'shop_form_body',
							'submit' => [['tag'=>'show_cart','text'=>'Show Cart']]
						],
				'options' =>
						[
							'title' => 'Item Options',
							'form_body' => 'options_form_body',
							'next_page' => 'show_cart'
						],
				'show_cart' =>
						[
							'title' => 'Shopping Cart',
							'form_body' => 'show_cart_form_body',
							'next_page' => 'shop',
							'submit' => [['tag'=>'shop','text'=>'Continue Shopping'],['tag'=>'checkout','text'=>'Checkout']]
						],
// 				'always_shipping' =>
// 						[
// 							'title' => 'Shipping',
// 							'next_page' => 'name_and_number',
// 							'comment' => '<p>Your items will be shipped to your address of record, which 
// will appear in the confirmation email for your verification. The cost
// of shipping is {$order_shipping_fee_text}</p>
// <p> If you have any questions 
// or concerns about shipping, please <A HREF={$contact_url}>contact {$this_organization}</a>.</p>'
// 						],
				'checkout' =>
						[
							'title' => 'Shipping Method',
							'next_page' => 'name_and_number',
							'comment' => <<<'EOT'
<p>Please choose which delivery 
option you would prefer. Your order can be picked up at a {$this_organization} event for free, or it can be 
shipped to your physical address of record. Shipping for this order is {$order_shipping_fee_text} </p>
EOT
,
							'fields' => [
								['shipping_method','Shipping Method','',true,'required','radio',
									'get_known_shipping_methods',null]
							]
						],
				'pick_member' =>
						[
							'title' => 'Select Rider',
							'form_body' => 'pick_member_form_body'
						],
				'new_member' =>
						[
							'title' => 'Welcome New Rider',
							'next_page' => 'get_new_member_data',
							'fields' => [],
							'comment' => <<<'EOT'
<h2>Welcome guest!</h2>
<p>You were not found in the {$this_organization} rider database. </p>
<p>Please click "continue" and enter your contact information. </p>
EOT
						],
				'get_new_member_data' =>
						[
							'title' => 'New Rider Info',
							'next_page' => 'pay_for_item',
							'comment' => '<p>To purchase items from  {$this_organization} we need to obtain your contact information. Starred items are required. Please enter your information below:</p>',
							'form_fineprint' => '<p>Privacy Policy: This information is used by {$this_organization} <em>only</em> to contact you with respect to this item, to simplify your 
										registration with respect to future events, and in case of emergency. For more details see full <A HREF="{$base_url}privacy.html">privacy policy</a>.</p>',
							'fields' => [
								['contact_street','Street Address','Enter Street Address',true, 'trim|required|max_length[250]'],
								['contact_city','City','Enter City',true, 'trim|required|max_length[250]'],
								['contact_state','State','Select State or N/A for Non-US',true,'required','select','get_state_options'],
								['contact_zip','Postal Code','Enter Postal Code',true, 'trim|required|alpha_dash|min_length[5]|max_length[10]'],
								['contact_country','Nationality','Select your nationality',true,'required','select','get_country_options'],
								['contact_tracker','Tracker URL','Enter Tracker URL',false, 'trim|valid_url|min_length[5]|max_length[250]'],
								['contact_email','Email','Enter Email',true, 'trim|required|valid_email|max_length[250]'],
								['contact_phone','Cell Phone','Your phone number on the bike',true, 'trim|min_length[10]|max_length[25]|callback__phone_check'],
								['contact_phone_alt','Phone (alternative)','Enter alternative phone (optional)',false, 'trim|min_length[10]|max_length[25]|callback__phone_check'],
								['contact_emergency_name','Emergency contact name','Enter Emergency contact name',true, 'trim|required|max_length[250]'],
								['contact_emergency_phone','Emergency contact phone','Enter Emergency contact phone',true, 'trim|required|min_length[10]|max_length[25]'],
								['contact_emergency_phone_alt','Emergency contact phone (alternative)','Enter alternative emergency contact phone (optional)',false, 'trim|min_length[10]|max_length[25]'],
								['password','Password','Enter a new password for access to your member profile',false, 'trim|min_length[8]|max_length[25]','password']
							]
						],

				'pay_for_item' =>
						[
							'title' => 'Confirm Item and Quantity',
							'next_page' => 'pay_for_item',
							'form_body' => 'pay_for_item_form_body',
							'submit' => [['tag'=>'yes','text'=>'Purchase'],['tag'=>'no','text'=>'Cancel']]
						],
				'order_cancel' =>
						[
							'title' => 'Order Canceled',
							'submit' => [],
							'view_body' => 'form_simple',
							'comment' => '<p>Return to the <A HREF="{$base_url}">{$this_organization} Home Page</a></p>'
						],
				'name_and_number' =>
						[
							'title' => 'Your Name and RUSA Number',
							'next_page' => 'undefined',
							'comment' => <<<'EOT'
<p>Please enter your basic info below.</p>
EOT
,
							'fields' => [
								['first_name','First Name','Enter first name', true, 'trim|required|regex_match[/^([a-zA-Z0-9]+ ?)+?$/]|max_length[50]'], 
								['last_name','Last Name','Enter last name',true, 'trim|required|regex_match[/^([a-zA-Z0-9]+ ?)+?$/]|max_length[50]'],
								['rusa_id','RUSA Number','Enter RUSA number (optional)',false,'trim|is_natural_no_zero|less_than[1000000]']
							]
						],

				'payment_credited' =>
						[
							'title' => 'Payment Credited',
							'submit' => [],
							'comment' => <<<'EOT'
<p>Your payment of ${$amount_paid} has been credited. Thank You! Payment credit
is contingent on receipt of funds through the payment service. A description
of your order is as follows:</p>

<p>
<div class='fee'>
<table>
<tr><td>Name:</td><td>{$first_name} {$last_name}</td></tr>
<tr><td>Amount Paid:</td><td>${$amount_paid}</td></tr>
<tr><td>Order ID:</td><td>{$invoice_number}</td></tr>
<tr><td>Shipping Method:</td><td>{$shipping_method}</td></tr>
<tr><td>Entered On:</td><td>{$entered_on}</td></tr>
</table>
</div>
<h2>Items</h2>
<br>
<div class='product-table'>
<TABLE width=100%>
<TR><TH>Quantity</TH><TH>Description</TH><TH>Option</TH><TH>Unit Price</TH><TH>Ext Price</TH></TR>
{$purchase_items_table_body}
</TABLE>
<div class=vspace></div>
</div>
</p>

An email confirmation has been sent to  <tt>{$contact_email}</tt> </p>

<p> Please take a moment to verify your contact/shipping information:</p>
<div class='narrower bordered rider-info'>
{$contact_text}
</div>
<div class='narrower bigger text-center italic'>If any of this contact information is incorrect, please <A HREF='{$profile_edit_url}'>click here</A> to edit
your member profile. </div><div class=vspace></div>
<p>That link has a time limit, so please use it immediately. At any later time your can 
update your member profile by <A HREF='{$admin_login_url}'>logging in</a> with your password, or by 
<A HREF='{$contact_url}'>contacting</a> {$this_organization}.</p>


<p>If you have any questions about this order, please <A HREF='{$contact_url}'>contact {$this_organization}</a>.</p><br>

<hr width=61.8%>

<p>Return to the <A HREF='{$base_url}'>{$this_organization} Home Page</a></p>							

EOT
						],

				'final' =>
						[
							
						]
				];
				
	


	}
	
?>
