<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
 
 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

class Accounting_parando extends CI_Model {

// 	protected $CI;

// 	public function __construct($){
//     	parent::__construct();
// 		$this->CI =& get_instance();
// 		$this->load->model('model_parando');
// 	}


	public function post_payment($purchase, $point_of_sale, $amount_paid, $transaction_info, $payer_name="", $transaction_id="", $transaction_fee=0){
		$tz = $this->model_parando->get_local_time_zone();
		$now = new DateTime("now", $tz);
		$now_str = $now->format("Y-m-d H:i:s");

		$pdata = [
			'member_id'=>$purchase['member_id'], 
			'purchase_id'=>$purchase['id'], 
			'amount'=>$amount_paid,
			'point_of_sale'=>$point_of_sale, 
			'transaction_info'=>$transaction_info, 
			'transaction_fee'=>$transaction_fee,
			'payer'=>trim($payer_name),
			'transaction_id'=>$transaction_id,
			'entered_on'=>$now_str];
		return $rc=$this->db->insert('payment', $pdata);	
	}
	
	public function get_payment($purchase_id){
		$sql="SELECT * FROM payment where purchase_id='{$purchase_id}'";
		$result=$this->db->query($sql);
		return $result->row_array();
	}

	public function get_purchase($invoice_number){
		$sql="SELECT * FROM purchase where invoice_number='{$invoice_number}'";
		$result=$this->db->query($sql);
		return $result->row_array();
	}

	public function get_purchase_by_id($purchase_id){
		$sql="SELECT * FROM purchase where id='{$purchase_id}'";
		$result=$this->db->query($sql);
		return $result->row_array();
	}

	public function get_purchase_by_roster($roster_id){
		$sql="SELECT purchase.* FROM roster,purchase where roster.event_id=purchase.event_id and roster.member_id=purchase.member_id AND roster.id='{$roster_id}'";
		$q=$this->db->query($sql);
		return $q->row_array();
	}

	public function delete_purchase_by_event($event_id,$member_id=null){
			if(!empty($member_id)){
				$and_member_id="AND purchase.member_id='{$member_id}'";
			}
			$sql="DELETE FROM purchase where purchase.event_id='{$event_id}' {$and_member_id}"; 
			$q=$this->db->query($sql);
			return $this->db->affected_rows(); 
	}

	public function get_purchase_by_event($event_id,$member_id=null){
		if(empty($member_id)){
			$sql="SELECT * FROM  purchase where purchase.event_id='{$event_id}'"; 
			$q=$this->db->query($sql);
			return $q->result_array(); // assume multiple results
		}else{
			$sql="SELECT * FROM  purchase where purchase.event_id='{$event_id}' AND purchase.member_id='{$member_id}'"; 
			$q=$this->db->query($sql);
			return $q->row_array(); // assume single result
		}
	}
	
	public function get_purchase_by_fleche_team_member($fleche_team_member_id){
			$sql="SELECT purchase.* FROM  purchase,fleche_team,fleche_team_member WHERE
			fleche_team_member.id='{$fleche_team_member_id}' AND
			fleche_team.id=fleche_team_member.fleche_team_id AND
			purchase.event_id=fleche_team.event_id AND 
			purchase.member_id=fleche_team_member.member_id"; 
			$q=$this->db->query($sql);
			return $q->row_array(); // assume single result
	}

	public function delete_purchase($invoice_number){
		$sql="DELETE FROM purchase where invoice_number='{$invoice_number}'";
		$this->db->query($sql);
		return $this->db->affected_rows(); 
	}

	public function get_purchase_items($purchase_id){
		$sql="SELECT purchase_item.*, catalog.description as description, catalog.price as catalog_price, catalog.sku as sku 
			FROM purchase_item,catalog where purchase_item.purchase_id='{$purchase_id}' and purchase_item.catalog_id=catalog.id order by purchase_item.sequence";
		$result=$this->db->query($sql);
		return $result->result_array();
	}

	public function get_purchase_items_nonfree($purchase_id){
		$sql="SELECT purchase_item.*, catalog.description as description, catalog.price as catalog_price, catalog.sku as sku 
						FROM purchase_item,catalog where purchase_item.unit_price>0 AND purchase_item.purchase_id='{$purchase_id}' and 
							purchase_item.catalog_id=catalog.id  order by purchase_item.sequence";
		$result=$this->db->query($sql);
		return $result->result_array();
	}

  public function get_items_for_sale(){
		$sql="SELECT * FROM catalog where for_sale=1";
		$result=$this->db->query($sql);
		return $result->result_array();
	}

	public function get_product($sku){
		$sql="SELECT * FROM catalog where sku='{$sku}'";
		$result=$this->db->query($sql);
		return $result->row_array();
	}

	public function get_catalog_id($id){
		$sql="SELECT * FROM catalog where id='{$id}'";
		$result=$this->db->query($sql);
		return $result->row_array();
	}

	public function get_product_price($sku){
		$sql="SELECT * FROM catalog where sku='{$sku}'";
		$result=$this->db->query($sql);
		$r=$result->row_array();
		return $r['price'];
	}

	public function get_product_item($sku,$value=""){
		$p=$this->get_product($sku);
		$item=['sku'=>$sku,'quantity'=>1,'description'=>$p['description'],'value'=>$value,'unit_price'=>$p['price']];
		return $item;
	}

	public function purchase_item_text($purchase){
		if(empty($purchase)){$this->die_error(__METHOD__,"Empty purchase.");}
		if(empty($purchase['id'])){$this->die_error(__METHOD__,"Empty or missing purchase ID.");}
		$items=$this->get_purchase_items($purchase['id']);
//		$items=$this->get_purchase_items_nonfree($purchase['id']);
		$text="";
		if(!empty($items)){
			foreach($items as $i){
				extract($i);
				$ext_price = ($quantity * $unit_price);
				$text .= "$quantity, $description, $value, \$$unit_price, \$$ext_price\n";
			}
		}else{
			$text="No items.\n";
		}
		return $text;
	}

	public function map_purchase_pos($value){
		$pos=$value;
		$a=explode(':',$value);
		$class=reset($a);
		$method=end($a);

		switch($class){
			case 'Register_new':
			case 'Register':
				switch($method){
					case 'pay_online':
						$pos="Reg/PayPal";
						break;
					case 'pay_event':
						$pos="Reg/AtEvent";
						break;
					case 'pay_mail':
						$pos="Reg/ByMail";
						break;
				}
				break;
			case 'Store_new':
			case 'Store':
				$pos="Store/Online";
				break;
			case 'Member':
				switch($method){
					case '_pay_for_membership':
						$pos="Mem/PayPal";
						break;
				}
				break;
		}

		return $pos;
  }

	public function map_payment_pos($value){
		$pos=$value;
		$a=explode(':',$value);
		$class=reset($a);
		$method=end($a);

		switch($class){
			case 'Accounting_parando':
			case 'Register_new':
			case 'Register':
				switch($method){
					case 'credit_paypal_payment':
						$pos="Reg/PayPal";
						break;
				}
				break;
			case 'Store_new':
			case 'Store':
				switch($method){
					case 'credit_paypal_payment':
						$pos="Store/PayPal";
						break;
				}
				break;
			case 'Member':
				switch($method){
					case 'pay_online':
					case 'credit_paypal_payment':
						$pos="Mem/PayPal";
						break;
				}
				break;
			case 'Admin':
				switch($method){
					case 'pay_for_order':
						$pos="Admin/Manual";
						break;
				}
				break;
		}

		return $pos;
  }

	public function purchase_item_table_body($purchase){
		$items=$this->get_purchase_items_nonfree($purchase['id']);
		$text="";
		if(!empty($items)){
			foreach($items as $i){
				extract($i);
				$u_price=number_format($unit_price,2,'.','');
				
				$ext_price = number_format(($quantity * $unit_price),2,'.','');
				$text .= "<TR><TD>$quantity</TD><TD>$description</TD><TD>$value</TD><TD>\$$u_price</TD><TD>\$$ext_price</TD></TR>";
			}
		}
		return $text;
	}

	public function items_table_body($items,$non_free=false){
		$text="";
		$total=0;
		if(!empty($items)){
			foreach($items as $i){
				extract($i);
				if(!$non_free || $unit_price>0){
					$ext_price = ($quantity * $unit_price);
					$total += $ext_price;
					$comma_value = (empty($value))?"":", $value";
					$text .= "<TR><TD>$description$comma_value</TD><TD>\$$ext_price</TD></TR>";
				}
			}
				$text .= "<TR><TD id=txt-right>Total:</TD><TD id=txt-right><div style='border-top: 2px solid black;'>\$$total</div></TD></TR>";
		}
		return $text;
	}

	public function purchase_item_json($purchase){
		$items=$this->get_purchase_items_nonfree($purchase['id']);
		$text="";
		$itemnumber=0;
		if(!empty($items)){
			foreach($items as $i){
				extract($i);
				$comma=($itemnumber>0)?",":"";
				$itemnumber++;
				$text .= $comma;
				$text .= <<<EOT
        {
          name: '$description',
          description: '$value',
          quantity: '$quantity',
          price: '$unit_price',
          currency: 'USD'
        }
EOT;
			}
		}
		return $text;
	}

	public function purchase_item_cart($purchase){
		$items=$this->get_purchase_items_nonfree($purchase['id']);
		$cart=[];
		$itemnumber=0;
		$subtotal=0;
		if(!empty($items)){
			foreach($items as $i){
				extract($i);				
				$cart['items'][] = array(
					'id' => "$sku",
					'name' => "$description",
					'description' => "$value",
					'qty' => "$quantity",
					'price' => number_format($unit_price,2, '.', '')
				);
				$itemnumber++;
				$subtotal+=$quantity*$unit_price;
			}
			$cart['shopping_cart'] = array(
				'items' => $cart['items'],
				'subtotal' => number_format($subtotal,2, '.', ''),
				'shipping' => 0,
				'handling' => 0,
				'tax' => 0,
			);
			$cart['shopping_cart']['grand_total'] = number_format($cart['shopping_cart']['subtotal'] + $cart['shopping_cart']['shipping'] + $cart['shopping_cart']['handling'] + $cart['shopping_cart']['tax'], 2, '.', '');
		}
		return $cart;
	}


	public function make_invoice_number($m,$e=null){
		if(empty($e)){$e=time();}
		return "$m-$e";
	}

	public function token_to_invoice_number($token){
		$a = explode("-", $token);
		list($m, $e, $hash)=$a;
		return "$m-$e";
	}

	public function make_order_token($invoice_number){
		return $this->model_parando->add_hash($invoice_number);
	}
	
	private $token_expire=7200; // two hours

	public function check_order_token($token){
		$result = 'Invalid token';
		$a = explode("-", $token);
		if( count($a) == 3 ){
			list($m, $e, $hash)=$a;
			$invoice_number=$this->make_invoice_number($m,$e);
			if($token == $this->make_order_token($invoice_number)){
				$member=$this->model_parando->get_member($m);
				$elapsed=time() - $e;
				if(empty($member)){
					$result="No member ($m)";
				}elseif($elapsed<=0){
					$result="Token from future ($elapsed s)";
				}elseif($elapsed>$this->token_expire){
					$result="Token expired ($elapsed s)";
				}else{
					$result=$a;
				}
			}
		}
		return $result;
	}
	
	public function items_total($items){
		$total=0;
		foreach ($items as $item){
			if(isset($item['unit_price'])){
				$unit_price=$item['unit_price'];
			}else{
				$sku=$item['sku'];
				if(empty($sku)){return "No SKU";}		
				$product=$this->get_product($sku);
				if(empty($product)){$this->die_error(__METHOD__,"No product for sku: $sku");}		
				$unit_price=$product['price'];
				// $item['price']=$price;
			}
			$quantity = (isset($item['quantity']))?$item['quantity']:1;
			$total += $unit_price * $quantity;
		}
		return $total;
}


	public function create_purchase_order($member_id,$items,$point_of_sale,$event_id=null,$description="",$shipping_method=""){


			if(!empty($event_id)){
				$sql="SELECT * FROM  purchase where event_id='{$event_id}' AND member_id='{$member_id}'"; 
				$q=$this->db->query($sql);
				if($q->num_rows() > 0){return "A purchase order already exists for this (member_id,event_id) = ($member_id,$event_id)";}
			}

			$invoice_number=$this->make_invoice_number($member_id);
			
			$tz = $this->model_parando->get_local_time_zone();
			$now = new DateTime("now", $tz);
			$now_str = $now->format("Y-m-d H:i:s");

			// form the item list from catalog entries and calculate total amount due
			$amount_due=0.0;
			$sequence=0;  
			$products=[];
			foreach ($items as $item){
				$sku=$item['sku'];
				if(empty($sku)){return "No SKU";}		
				$product=$this->get_product($sku);
				if(empty($product)){return "No product for sku: $sku";}		
				
				$sequence++;
				$unit_price = (isset($item['unit_price']))?$item['unit_price']:$product['price'];
				$value = (isset($item['value']))?$item['value']:'';
				$quantity = (isset($item['quantity']))?$item['quantity']:1;
				
				$idata = [
					'sequence' => $sequence,
					'quantity' => $quantity,
					'catalog_id' => $product['id'],
					'value' => $value,
					'unit_price' => $unit_price
				];
				$amount_due += $quantity * $unit_price;	
				$products[] = $idata;
			}			
			
			// save the purchase order
			$pdata = [
				'member_id'=>$member_id, 
				'invoice_number'=>$invoice_number, 
				'event_id'=>$event_id,
				'description'=>$description,
				'amount_due'=>$amount_due, 
				'n_items'=>$sequence,
				'point_of_sale'=>$point_of_sale, 
				'shipping_method'=>$shipping_method, 
				'entered_on'=>$now_str];
			$rc=$this->db->insert('purchase', $pdata);	
			if(FALSE==$rc){return "Failed to enter purchase order";}
			$purchase=$this->get_purchase($invoice_number);
			if(empty($purchase)){return "Failed purchase readback";}
			$purchase_id = $purchase['id'];
			
			// save the items
			foreach ($products as $p){
				$rc=$this->db->insert('purchase_item', array_merge(['purchase_id'=>$purchase_id],$p));	
				if(FALSE==$rc){return "Failed to enter purchase item";}
			}
			
			return $purchase;

	}

	public function total_order_paid($purchase_id){

		$po=$this->get_purchase_by_id($purchase_id);
		return $this->total_paid_on_purchase($po);

	}

	public function total_paid_on_purchase($po){

		$purchase_id=$po['id'];
		$total_order = (float) $po['amount_due'];
		$total_paid = 0.0;
		$sql="SELECT * FROM  payment where payment.purchase_id='{$purchase_id}'"; 
		$q=$this->db->query($sql);
		$pmts=$q->result();
		if(!empty($pmts)){
			foreach($pmts as $p){
				$total_paid += (float) $p->amount;
			}
		}
		
		$point_of_sale=$po['point_of_sale'];
		$total_due = $total_order - $total_paid;
		return compact('total_order','total_paid','total_due','point_of_sale');

	}

	public function event_total_order_paid($event_id,$member_id){

	// $sql="SELECT * FROM roster where event_id='{$event_id} AND member_id={$member_id}'";
	// $q=$this->db->query($sql);
	// $r=$q->row();
	// $total_fee=$r->total_fee;

		$total_order=0;
		$total_paid=0;
		$total_xaction_fee=0;
		$dues_paid=0;
		$point_of_sale="";
		$sql="SELECT id as purchase_id, amount_due, point_of_sale FROM  purchase where purchase.event_id='{$event_id}' AND purchase.member_id='{$member_id}'"; 
		$q=$this->db->query($sql);
		$po=$q->row();
		
		$dues_skus=['current_renew', 'expired_renew', 'new_member_join'];
		
		if(!empty($po)){
				$purchase_id=$po->purchase_id;
				$items=$this->get_purchase_items($purchase_id);
				foreach($items as $item){
					if(in_array($item['sku'], $dues_skus)) $dues_paid+=$item['catalog_price']*$item['quantity'];
				}
				$total_order+=$po->amount_due;
				$sql="SELECT * FROM  payment where payment.purchase_id='{$purchase_id}'"; 
				$q=$this->db->query($sql);
				$pmts=$q->result();
				if(!empty($pmts)){
					foreach($pmts as $p){
						$total_paid+=$p->amount;
						$total_xaction_fee+=$p->transaction_fee;
					}
				}
				$point_of_sale=$po->point_of_sale;
		}
		$total_due = $total_order - $total_paid;
		return compact('total_order','total_paid','total_due','point_of_sale','total_xaction_fee','dues_paid');

	}

	public function delete_orphan_items(){
		$sql="delete from purchase_item where purchase_id not in (select id from purchase)";
		$this->db->query($sql);
		return $this->db->affected_rows(); 
	}
	
	
	public function credit_paypal_payment($token, $fulfillment_callback=null, $point_of_sale=null){
		
		$status="UNKNOWN";
		
		if(empty($token)){
			$status = 'Missing order token.';
		}else{
			$result = $this->check_order_token($token);
			if(is_array($result)){
				list($member_id, $token_time, $hash)=$result;
				$invoice_number="$member_id-$token_time";
				
				$member=$this->model_parando->get_member($member_id);
				$this->multipage->load_memdata_into_session($member);	

				$purchase=$this->get_purchase($invoice_number);
				if(empty($purchase)){return'No such purchase.';}
				if(empty($purchase['amount_due'])){return "No payment due on purchase $invoice_number.";}
				$amount_due=$purchase['amount_due'];

				$payment=$this->get_payment($purchase['id']);
				$shipping_method=$purchase['shipping_method'];

				if(empty($payment)){ // not credited or fulfilled yet, so do it. Multiple payments on one purchase not allowed.

					$point_of_sale = (null===$point_of_sale)?__METHOD__:$point_of_sale;
					$cart = $this->session->userdata('shopping_cart');
					if(empty($cart)){return 'No shopping cart in session.';}
					if(empty($cart['shopping_cart']['grand_total'])){return 'Nothing paid.';}
					if(empty($cart['paypal_transaction_id'])){return 'Missing transaction ID.';}
					$paypal_transaction_id=$cart['paypal_transaction_id'];
					$paypal_fee=$cart['paypal_fee'];
					$transaction_info = json_encode($cart);
					$payer_name = (!empty($cart['first_name']) && !empty($cart['last_name']))?($cart['first_name'] . ' ' . $cart['last_name']):"";
					$payer_email = (!empty($cart['email']))?$cart['email']:"";
					$amount_paid=$cart['shopping_cart']['grand_total'];
					if($amount_paid < $amount_due){return "Payment of \$$amount_paid not equal to amount due \$$amount_due.";}
					$this->post_payment($purchase, $point_of_sale, $amount_paid, $transaction_info, $payer_name, $paypal_transaction_id,$paypal_fee);
					$payment=$this->get_payment($purchase['id']);
					if(empty($payment)){return "Failed transaction readback";}
				
					if(!empty($fulfillment_callback)){
						list($controller,$callback)=$fulfillment_callback;
						$rc=$controller->{$callback}($purchase);  
						if('OK'!=$rc){return "Could not fulfill purchase: $rc";}
					}
					
					$status="OK";
					
				}else{
					$status="DUPLICATE";
				}

				$amount_paid=$payment['amount'];
				$paypal_transaction_id=$payment['transaction_id'];
				$payer_name=$payment['payer'];
				$paypal_fee=$payment['transaction_fee'];
				
				$odata=array_merge($payment,
					[  
						'amount_paid'=>number_format($amount_paid,2,'.',''),
						'order_token'=>$token, 
						'invoice_number'=>$invoice_number, 
						'shipping_method'=>$shipping_method, 
						'paypal_transaction_id'=>$paypal_transaction_id,
						'paypal_fee'=>$paypal_fee,
						'payer_name'=>$payer_name,
						'purchase_items_text'=>$this->purchase_item_text($purchase),
						'purchase_items_table_body'=>$this->purchase_item_table_body($purchase)  ]
					);
				$this->multipage->set_data_array($odata);	
			
			}else{
				$status=$result; // Invalid order token
			}
		}
		
		return $status;
		
	}


}
