<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
 
 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

class Fleche_parando extends CI_Model {

	public function get_fleche_team_names($event_id){
		$sql="SELECT name FROM fleche_team WHERE event_id={$event_id} order by name";
		$names=[];
		$q=$this->db->query($sql);
		$rows = $q->result_array();
		foreach($rows as $row){
			$names[]=$row['name'];
		}
		return $names;
	}

	public function delete_fleche_team_by_data($data){
		$name=$data['name']; $event_id=$data['event_id'];
		$ename=$this->db->escape($name);
		$sql="DELETE FROM fleche_team where name={$ename} AND event_id='{$event_id}'";
		$q=$this->db->query($sql);
		return $this->db->affected_rows(); 
	}

	public function delete_fleche_team_by_name($event_id,$name){
		$ename=$this->db->escape($name);
		$sql="DELETE FROM fleche_team where name={$ename} AND event_id='{$event_id}'";
		$q=$this->db->query($sql);
		return $this->db->affected_rows(); 
	}

	public function delete_fleche_team_by_id($id){
		$sql="DELETE FROM fleche_team where id='{$id}'";
		$q=$this->db->query($sql);
		return $this->db->affected_rows(); 
	}

	public function get_fleche_team_by_name($event_id,$name){
		$ename=$this->db->escape($name);
		$sql="select * FROM fleche_team where name={$ename} AND event_id='{$event_id}'";
		$q=$this->db->query($sql);
		return $q->row_array(); 
	}

	public function flecheHasTeamQ($event){
		$event_id=$event['id'];
		$sql="select * FROM fleche_team where event_id='{$event_id}' order by name";
		$q=$this->db->query($sql);
		return count($q->result_array())>0; 
	}

	public function get_fleche_team_by_id($team_id){
		$sql="select * FROM fleche_team where id='{$team_id}'";
		$q=$this->db->query($sql);
		return $q->row_array(); 
	}

	public function get_fleche_teams_by_event_id($event_id){
		$sql="select * FROM fleche_team where event_id='{$event_id}' order by name";
		$q=$this->db->query($sql);
		return $q->result_array(); 
	}

	public function XXget_fleche_team_members($fleche_team_id){

		$sql="SELECT roster.*,member.*,
			CASE WHEN member.expires='0000-00-00' THEN 'guest' 
				WHEN member.administrator=1 THEN 'administrator' WHEN member.waive_fees=1 THEN 'volunteer' 
				WHEN member.expires<NOW() THEN 'terminated' ELSE 'member' END as membership
				 FROM roster,member,fleche_team,fleche_team_member WHERE 
					fleche_team.id={$fleche_team_id} AND
					fleche_team_member.fleche_team_id={$fleche_team_id} AND
					fleche_team_member.member_id=member.id AND 
					roster.member_id=member.id AND 
					roster.event_id=fleche_team.event_id 
					ORDER BY last_name,first_name";
		$q=$this->db->query($sql);
		return $q->result(); 
	}

	public function get_fleche_team_members($fleche_team_id){
		$sql="SELECT * FROM fleche_roster_member WHERE fleche_team_id={$fleche_team_id} ORDER BY last_name,first_name";
		$q=$this->db->query($sql);
		return $q->result(); 
	}

	public function get_fleche_roster($event_id){
		$sql="SELECT * FROM fleche_roster_member,member WHERE member.id=member_id AND event_id={$event_id} ORDER BY start_date,start_time,name,member.last_name,member.first_name";
		$q=$this->db->query($sql);
		return $q->result(); 
	}

	public function get_fleche_team_by_member($event_id,$member_id){
		$sql="select fleche_team.* FROM fleche_team_member,fleche_team WHERE 
							fleche_team.id=fleche_team_member.fleche_team_id AND 
							fleche_team.event_id='{$event_id}' AND 
							fleche_team_member.member_id='{$member_id}'";
		$q=$this->db->query($sql);
		$n=$q->num_rows();
		if($n>1){
			$heading=__METHOD__; $message="Member ID=$member_id is a member of two teams for event=$event_id. Tell the RBA!";
			$this->load->view('errors/html/error_general',array('title'=>$heading, 'heading'=>$heading,'message'=> $message));
			$this->output->_display();
			exit();
		}elseif($n==0){
			return null;
		}else{
			return $q->row_array(); 
		}
	}

	public function calc_fleche_team_schedule($event_id, $start){

		$e=$this->model_parando->get_event($event_id);
		$s=$this->model_parando->event_schedule($e);

		$earliest_start_datetime=$s['start_datetime'];
		$latest_start_datetime=$s['latest_start_datetime'];
		$start_check=$earliest_start_datetime->format('l H:i');
		if($start_check != 'Thursday 12:00'){$this->die_error(__METHOD__,"Fleche event incorrectly scheduled 
					in database. Earliest start is {$start_check}; but must be Thursday 12:00. Contact the RBA.");}

		if(is_array($start)){
			list($start_day, $start_hour, $start_min)=$start;
			$start_datetime = clone $earliest_start_datetime; 
			$start_datetime->sub(new DateInterval("PT12H")); // beginning of day assuming noon schedule start 
			$start_datetime->add(new DateInterval("P{$start_day}DT{$start_hour}H{$start_min}M")); // now fleche_team start datetime
		}elseif(is_object($start)){
			$start_datetime = clone $start;
		}elseif(is_string($start)){
			$start_datetime = new DateTime($start, $this->model_parando->get_local_time_zone());
		}else{
			$this->die_error(__METHOD__, "Unknown type for start time parameter");
		}

		$start_date_str = $start_datetime->format('Y-m-d');
		$start_time_str = $start_datetime->format('H:i:00');
		$start_dow_time_str = $start_datetime->format('l H:i T');
		$start_datetime_str = $start_datetime->format('l Y-m-d H:i:00 T');

		return compact('earliest_start_datetime','latest_start_datetime','start_datetime','start_date_str','start_time_str','start_dow_time_str','start_datetime_str');
	}

  public function num_riders_on_team($fleche_team_id){
		$sql="SELECT COUNT(member_id) as num_riders FROM fleche_team_member WHERE fleche_team_id={$fleche_team_id}";
		$q=$this->db->query($sql);
		$r=$q->row();
		return $r->num_riders; 
	}

  public function num_members_on_team($fleche_team_id){
		$sql="SELECT SUM(IF(ISNULL(tandem) OR tandem = '',1.0,0.5)) as num_members FROM fleche_roster_member WHERE  fleche_team_id={$fleche_team_id}";
		$q=$this->db->query($sql);
		$r=$q->row();
		return $r->num_members; 
	}

  public function paid_members_on_team($fleche_team_id){
		$sql="SELECT member_id,total_fee FROM fleche_roster_member WHERE  fleche_team_id={$fleche_team_id}";
		$q=$this->db->query($sql);
		$paid=[];
		foreach ($q->result() as $row){
			$paid[$row->member_id]=$row->total_fee;
		}
		return $paid;
	}

	public function fleche_team_status($fleche_team_id){
			$team=$this->get_fleche_team_by_id($fleche_team_id);
			$riders=$this->get_fleche_team_members($fleche_team_id);
			$num_members=0.0;			
			$num_riders=0;
			$num_paid=0;
			// $paid=$this->paid_members_on_team($fleche_team_id);
			foreach($riders as $row){
				$num_riders++;
				$num_members += ($row->result=="VOL" || $row->result=="DNS")?0.0:(($row->tandem)?0.5:1.0);
				
				$po=$this->accounting_parando->get_purchase($row->invoice_number);
				$tpop=$this->accounting_parando->total_paid_on_purchase($po);
				
				if($row->total_fee <= $tpop['total_paid']){$num_paid++;}
			}
			$release_received=($team['approved']==1);
			$route_approved=(!empty($team['final_km_dist']) && !empty($team['penult_km_dist']) && 
				$team['final_km_dist']>=360.0 && ($team['final_km_dist']-$team['penult_km_dist'])>=25.0 );
			$too_few = $num_members<3.0;
			$too_many = $num_members>5.0;
			$just_right = !$too_many && !$too_few;
			$all_paid=($num_paid>=$num_riders); 
			$good_to_go = $release_received && $route_approved && !$too_many && !$too_few && $all_paid;

			return compact('riders','release_received','route_approved','num_members','num_riders','num_paid','all_paid',
					'too_many','too_few','just_right','good_to_go');

	}

}


