<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
 
 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

class Model_parando extends CI_Model {

	public $stylesheet='http://parando.org/parandostyle.css';
	public $contact_url='https://parando.org/info/contact';
	public $webmaster_contact_url='https://parando.org/info/contact/webmaster';
	public $volunteer_url='https://parando.org/info/volunteer';
	public $admin_login_url='https://parando.org/login';
	public $event_register_url='https://parando.org/register/event';
	public $event_info_url='https://parando.org/info/event';
	public $event_roster_url='https://parando.org/roster/online';
	public $route_info_url='https://parando.org/route/info';
	public $fleche_roster_url='https://parando.org/info/teams';
	public $event_results_url='https://parando.org/roster/results';
	public $hdrimg = 'https://parando.org/images/parando-paypal-750x90.png';			
// URL for the image displayed as the header during PayPal checkout.  Max size of 750x90.  
	public $logoimg = 'https://parando.org/images/parando-paypal-190x60.jpg'; 		
// A URL to your logo image for PayPal.  Formats:  .gif, .jpg, .png.  190x60.

	public $cuesheet_path="/home/tomr/public_html/assets/parando/cuesheets";
	public $cuesheet_baseurl="https://parando.org/assets/parando/cuesheets";

	public $token_expire=3600; // seconds till password reset token expires
	
 	public $default_club;  // full club object (preferred).
	
	public function __construct() {
		parent::__construct();
		$this->init_settings();
		$this->init_members_by_id();
		
		$this->default_club=$this->get_club_by_name($this->default_club_name);
		$this->set_club_context($this->default_club);
		
		$this->organization= '['. $this->organization .']'; // OVERRIDE LEGACY ORG NAME WITH BRACKETS TO INDICATE THIS WAS DEFAULTED
		
		// WHATEVER METHOD ENDS UP WITH SHOWING THESE BRACKETS SHOULD HAVE CALLED set_club_context

		}
	
	private function init_settings(){
		$sql="SELECT * FROM settings";
		$q=$this->db->query($sql);
		foreach($q->result() as $s){
			$tag=$s->tag;
			$value=$s->value;
			if(!empty($tag)) $this->{$tag}=$value;
		}
	}
	
	// many of these are legacy globals, now set from club context
	
    public $club;
    public $club_name;
	public $organization; // default organization LEGACY NAME
    public $secret;
    public $tzname;
    public $info_phone_number;
    public $slogan;
    public $region;
    public $logo_url;
    public $org_abbrev;
    public $org_nickname;
    
	public function set_club_context($club){
		$this->club=$club;
        $this->club_name=$club['name'];
        $this->organization=$club['name'];
        $this->secret=$club['secret'];
        $this->tzname=$club['tzname'];
        $this->slogan=$club['slogan'];
        $this->region=$club['region'];
        $this->logo_url=$club['logo_url'];
        $this->org_abbrev=$club['acronym'];
        $this->org_nickname=$club['nickname'];
        $this->info_phone_number=$club['phone'];
        $this->club['state']=$this->get_state_code($club['state_id']);
	}

	public $members_by_id;
	
	private function init_members_by_id(){
		$sql="SELECT * FROM member order by last_name,first_name desc";
		$result=$this->db->query($sql);
		$this->members_by_id=[];
		foreach($result->result_array() as $row){
			$member_id=$row['id'];
			$this->members_by_id[$member_id]=$row;
		}
	}

	public function get_local_time_zone(){
		return new DateTimeZone( $this->tzname ); // "America/New_York" 
	}

	public function LocalDateTime($d="now"){
		$tz=$this->get_local_time_zone();
		return new DateTime($d,$tz);
	}

	public function timestamp(){
		$dt=$this->LocalDateTime();
		return $dt->format(DATE_RFC850);
	}

	
	public function contact_this_organization_link(){
		$contact_url=$this->contact_url;
		$this_organization=$this->organization;
		$cto="<A HREF=$contact_url TITLE='Contact $this_organization'>contact $this_organization</a>";
		return $cto;
	}
	
	public function get_rba($club_id=null){
        if($club_id===null){ 
            // $this->die_error(__METHOD__, "No club specified. Can't figure out who the RBA is.");
            // DEPRECIATED Fallback rba_id
            $club=$this->get_club_by_name($this->default_club_name);
        }else{
            $club=$this->get_club($club_id);
        }
        $rba=$club['rba'];
 		return $rba;
	}

	public function get_webmaster(){
        list($ln,$fn)=explode(',',$this->webmaster_name);
        $webmaster=$this->get_member_firstlast($fn,$ln);
		$webmaster_name=$webmaster['first_name'] . ' ' . $webmaster['last_name'];
		$webmaster_id=$webmaster['id'];
		$webmaster_phone=$webmaster['m_phone'];
		$webmaster_email=$webmaster['m_email'];
		$webmaster_data=compact('webmaster_id','webmaster_name','webmaster_phone','webmaster_email');
		return $webmaster_data;
	}

	public function get_countries(){
		$sql="SELECT code,fullname FROM country";
		$q=$this->db->query($sql);
		$country_fullname=array();
		foreach ($q->result() as $row)
		{
			$country_fullname[$row->code]=$row->fullname;
		}
		return $country_fullname;
	}

	public function get_states(){
		$sql="SELECT code,fullname FROM state";
		$q=$this->db->query($sql);
		$state_fullname=array();
		foreach ($q->result() as $row)
		{
			$state_fullname[$row->code]=$row->fullname;
		}
		return $state_fullname;
	}
	
	public function get_state_code($state_id){
        $this->db->where('id',$state_id);
        $q=$this->db->get('state');
		$r=$q->row();
		$code=$r->code;
		return $code;
	}
	
	public function get_volunteer_job_descriptions(){
		$stmt = "SELECT id,description,text FROM paragraph where location='volunteer' and hidden=0 order by id"; 
		$query = $this->db->query($stmt);
		$jobs = $query->result_array();
		return $jobs;
	}
	
	public function get_job_description_index(){
		$jobs = $this->get_volunteer_job_descriptions();
		$jd=[];
		foreach ($jobs as $j){
			$jd[$j['id']]=$j['description'];
		}
		return $jd;
	}
	
	public function get_lodging_for_event($event_id){
		$sql=<<<EOT
SELECT first_name,last_name,purchase_item.quantity*purchase_item.unit_price as total_price,purchase_item.value,purchase.entered_on,roster.member_id FROM member,roster,purchase,purchase_item,catalog 
	where 	roster.event_id='$event_id' 
		and member.id=roster.member_id 
		and roster.invoice_number=purchase.invoice_number 
		and purchase_item.purchase_id=purchase.id 
		and sku='lodging_fee' and catalog.id = purchase_item.catalog_id 
			order by purchase.entered_on 
EOT;
		$result=$this->db->query($sql);
		return $result->result_array();
	}

	
	public function get_volunteers_needed(){
		$tz = $this->get_local_time_zone();
		$now = new DateTime("now", $tz);
		$now_date = $now->format("Y-m-d");

			$stmt = "SELECT event_id,name,distance,type,date,start_time,job_id FROM volunteer_need,event WHERE 
				event.date>'$now_date' AND 
				event.id=event_id AND 
				NOT(event.status LIKE '%canceled%') 
				order by event.date,event.id"; 
			$query = $this->db->query($stmt);
			$needed = $query->result_array();
		return $needed;
	}
	
	public function get_volunteers_needed_by_event(){
		$e=[];
		$needed=$this->get_volunteers_needed();
		$jd=$this->get_job_description_index();
		foreach($needed as $n){
			if(!isset($e[$n['event_id']])){
				$tz = $this->get_local_time_zone();
				$start_datetime = new DateTime($n['start_time'] . ' ' . $n['date'], $tz);
				$start_datetime_str = $start_datetime->format('Y-m-d H:i:00');
				$e[$n['event_id']] = [	'description' => $n['name'] . ' ' . $this->make_dist($n), 
										'datetime' => $start_datetime_str,
										'jobs' => [] ];
			}
			$e[$n['event_id']]['jobs'][]=$jd[$n['job_id']];
		}
		return $e;
	}


	public function event_volunteers_needed($e){
		$stmt = "SELECT paragraph.id as job_id,description,text FROM volunteer_need,paragraph where event_id='{$e}' and job_id=paragraph.id and hidden=0"; 
		$query = $this->db->query($stmt);
		return $query->result_array();
  }

	public function add_volunteer_offer($event_id,$member_id,$job_id){
		if(empty($job_id) || $job_id == 'none'){return true;}
		$sql="SELECT * FROM volunteer_offer WHERE event_id={$event_id} and member_id={$member_id} and job_id={$job_id}";
		$q = $this->db->query($sql);
		if($q->num_rows()>0){
			return true;
		}else{
			$data=compact('event_id','member_id','job_id');
			return $this->db->insert('volunteer_offer', $data);
		}
	}



	public function next_event_id(){
		$tz = $this->get_local_time_zone();
		$now = new DateTime("now", $tz);
		$now_date = $now->format("Y-m-d");

		$sql="SELECT id FROM event where date>='$now_date' order by date LIMIT 1";
		$result=$this->db->query($sql);
		$event=$result->row_array();
		return $event['id'];
	}

	public function get_event($event_id){
		if(!is_numeric($event_id+0))$this->die_error(__METHOD__,"Invalid event ID: $event_id");
		$sql="SELECT * FROM event where event.id='{$event_id}' LIMIT 1";
		$result=$this->db->query($sql);
		$event=$result->row_array();
		if(empty($event)) 
			return null;
		else{
			if($event['start_id']>0){
		  	$sql="SELECT * FROM event,start where event.id='{$event_id}' and event.start_id=start.id LIMIT 1";
				$result=$this->db->query($sql);
				$event=$result->row_array();
				if(empty($event)) return null;
			}
			
			if(!empty($event['club_id'])) 
                $event['club']=$this->get_club($event['club_id']);
            else
                $this->die_error(__METHOD__, "Event has no associated club. Event ID=$event_id");
                
			$event['id']=$event_id;		// one might assume that these tags exist in the event array
			$event['event_id']=$event_id;
			return $event;
		}
	}
	
	public function get_future_brevets_for_rider($rusa_id){
		if(!is_numeric($rusa_id)) $this->die_error(__METHOD__, "Invalid RUSA ID");
		$sql="SELECT event.id as event_id
		FROM event, roster, member as rider WHERE 
			event.id=roster.event_id AND 
			rider.rusa_id=$rusa_id AND 
			roster.member_id=rider.id AND
			(event.type='brevet' OR event.type='populaire') order by date,start_time";
		$result=$this->db->query($sql);
		$ra=$result->result_array();
		$event_ids=[];
		foreach($ra as $a){ 
			$event_id=$a['event_id'];
			$event=$this->get_event($event_id);
			$schedule=$this->event_schedule($event);
			$cutoff_datetime=$schedule['cutoff_datetime'];
			$grace_duration=new DateInterval("PT12H"); // 12 hour grace time
			$cutoff_datetime->add($grace_duration);
			$now=new DateTime('now');
			if($now < $cutoff_datetime) $event_ids[]=$event_id;
		}
		return $event_ids;
	}


    public function get_ebd($event){
        $ebd=false;
        $earlybird_discounts=$event['earlybird_discounts'];
    	$schedule=$this->event_schedule($event);
    	$start_datetime=$schedule['start_datetime'];
    	$rc=preg_match_all('!(\d+)\s*days*\s*(\d+)!',$earlybird_discounts,$m,PREG_SET_ORDER);
   	    if($rc!==false && $rc>0){
   	    	$ebd=[];
        	uasort($m, 
        		function ($a, $b) {
   					if ($a[1] == $b[1]) return 0;
					return ($a[1] > $b[1]) ? -1 : 1;
				}
			);
			$now=new DateTime('now');
			$first=true;
			foreach($m as $x){
				$days=$x[1];
				$discount=$x[2];
				$date=clone $start_datetime;
				$date->sub(new DateInterval("P{$days}D"));
				if(($now<$date) && $first){
                    $available_now=true;
                    $first=false;
                }else $available_now=false;
				$ebd[]=compact('days','discount','date','available_now');
    		}
    	}
    	return $ebd;
    }
    
    public function member_price_now($event){
    
        $discount=0;
        $ebd=$this->get_ebd($event);
        if(!empty($ebd)) foreach($ebd as $d) if($d['available_now']) $discount=$d['discount'];
        $mp=$event['member_price'];
        $price_now=$mp-$discount;
        return max(0,$price_now);
    }

	
    public $formal_tzname=[
        'Eastern'=>'America/New_York',
        'Central'=>'America/Chicago',
        'Mountain'=>'America/Denver',
        'Mountain no DST'=>'America/Phoenix',
        'Pacific'=>'America/Los_Angeles',
        'Alaska'=>'America/Anchorage',
        'Hawaii'=>'America/Adak',
        'Hawaii no DST'=>'Pacific/Honolulu'
    ];

	public function get_club($club_id){
        $this->db->where('id',$club_id);
        $q=$this->db->get('club');
		$club=$q->row_array();
		
 		$club['rba']=$this->get_member($club['rba_id']);
 		$club['state']=$this->get_state_code($club['state_id']);
 		
 		$club['informal_tzname']=$club['tzname'];
 		if(!array_key_exists($club['informal_tzname'],$this->formal_tzname)) $this->die_error(__METHOD__, "Bad or missing event timezone name");
 		$club['tzname']=$this->formal_tzname[$club['informal_tzname']];
		
		return $club;
	}

	public function get_club_by_name($club_name){
        $this->db->where('name',$club_name);
        $q=$this->db->get('club');
		$club=$q->row_array();
 		$club['rba']=$this->get_member($club['rba_id']);
 		$club['informal_tzname']=$club['tzname'];
 		if(!array_key_exists($club['informal_tzname'],$this->formal_tzname)) $this->die_error(__METHOD__, "Bad or missing event timezone name");
 		$club['tzname']=$this->formal_tzname[$club['informal_tzname']];
		return $club;
	}

	
	public function event_status_q($event,$attribute){
		if(is_array($attribute)){
			$attribs=implode('|',$attribute);
			return (preg_match('/' . $attribs . '/', $event['status']) === 1);
		}else{
			return (strpos($event['status'], $attribute)!== false);
		}
  }

	public function get_event_id_by_date_dist($event_date,$event_dist){
		$sql="SELECT id FROM event where date='{$event_date}' and distance='{$event_dist}' LIMIT 1";
		$q=$this->db->query($sql);
		$row = $q->row_array();
		return $row['id'];
	}
	
	public function make_event_tagname($e){
	
        if(array_key_exists('is_route_event',$e)){ // This is a route_event object, not just an event. 
            $event=$this->get_event($e['event_id']);
        }else{
            $event=$e;
        }
	
		$route_id=(isset($event['rusa_route']))?$event['rusa_route']:((isset($event['rusa_route_id']))?$event['rusa_route_id']:"");
		$club_acronym=$event['club']['acronym'];
		$name = ($event['sanction']=='permanent')?"$club_acronym-PERM$route_id":"$club_acronym-".$event['sanction'];
		$distance = $this->make_dist($event);
		if($event['type']=='fleche'){
			$name_distance=$name . '-Fleche';
		}else{
			$name_distance=$name . '-' . $distance; 
		}
		$date=(!empty($event['date']))?('-'.$event['date']):"";
		return strtoupper($name_distance) . $date;
	}
	
    const info_code_hex_digits=4;

    public function info_code($route_event, $control_number){
        $et=$this->make_event_tagname($route_event);
        $secret=$route_event['club']['secret'];
        $plaintext="$et:$control_number:$secret";
        $info_code=strtoupper(substr(hash('md5',$plaintext),0,self::info_code_hex_digits));
        return $info_code;
	}


	
	public function set_event_cuesheet_version($event_id,$v){
		$this->db->where('id',$event_id);
		$rc=$this->db->update('event',['cue_version'=>$v]);
		if(FALSE==$rc){return "Failed to update cue version for event_id=$event_id to $v";}
	}
	
	public function get_member($member_id){
		return (isset($this->members_by_id[$member_id]))?$this->members_by_id[$member_id]:null;
	}

	public function get_member_db($member_id){
		$sql="SELECT * FROM member where member.id='{$member_id}' LIMIT 1";
		$result=$this->db->query($sql);
		return $result->row_array();
	}

	public function get_member_firstlast($first_name, $last_name){
        $fn=trim($first_name); $ln=trim($last_name);
		$sql="SELECT * FROM member where first_name='{$fn}' AND last_name='{$ln}'";
		$result=$this->db->query($sql);
		return $result->row_array();
	}

	public function get_member_by_rusa_id($rusa_id){
				$this->db->where('rusa_id',$rusa_id);
				$q=$this->db->get('member');
				return $q->row_array();
	}

	public function get_member_by_last_name($last_name){
				$this->db->where('last_name',$last_name);
				$q=$this->db->get('member');
				return $q->result_array();
	}

	public function get_member_by_numname($rusa_id, $first_name, $last_name){
		$efirst_name=$this->db->escape($first_name);
		$elast_name=$this->db->escape($last_name);

		$sql="SELECT * FROM member where rusa_id='{$rusa_id}'";
		$q=$this->db->query($sql);
		if($q->num_rows()==1){
			return $q->row_array();
		}else{
			$sql="SELECT * FROM member where first_name={$efirst_name} AND last_name={$elast_name}";
			$q=$this->db->query($sql);
			if($q->num_rows()==1){
				return $q->row_array();
			}else{
				return "not_found";
			}		
		}
	}
	
	
	public function get_member_contact_text($m){
		extract($this->get_member($m));
		
		$rider_info=<<<EOT
<TABLE WIDTH=100%>
<TR><TD>Name</TD><TD>$first_name $last_name</TD></TR>
<TR><TD>Mailing Address</TD><TD>$m_street, $m_city, $m_state $m_zip</TD></TR>
<TR><TD>Email</TD><TD>$m_email</TD></TR>
<TR><TD>Cell Phone</TD><TD>$m_phone</TD></TR>
<TR><TD>Alt Phone</TD><TD>$m_phone_alt</TD></TR>
<TR><TD>Emergency Contact</TD><TD>$emergency_name</TD></TR>
<TR><TD>Emergency Phone</TD><TD>$emergency_phone</TD></TR>
<TR><TD>Emergency Alt</TD><TD>$emergency_phone_alt</TD></TR>
<TR><TD>Tracker URL</TD><TD>$tracker</TD></TR>
</TABLE>
EOT;

		return $rider_info;

	}
	
	
	
	// REFACTOR
	// Why is this here? It's called by Register and Store controllers. Anywhere else? Seems like a fragment of something useful. 
	// perhaps this should be part of get_member? 
	
	public function compute_pms($mem){
		if($mem['expires']!="0000-00-00"){
			$delta=(time() - strtotime($mem['expires']));
			if($delta <= 0){
				$membership="current";
				$pms='Yes. Good till ' . $mem['expires'];  
			}else{
				$membership="terminated";
				$pms='No. Terminated ' . $mem['expires'] . ' -- Consider re-joining.';
			}
		}else{
			$membership="guest";
			$pms='No. Welcome guest! Consider joining.';
		}
		return compact('membership','pms');
	}
	
	// and this function seems like just a name remapping bunch of silliness that 
	// should be eliminated

	public function compute_memdata($mem){

		$rusa_id=$mem['rusa_id'];
		if(!empty($rusa_id)){
			$rms="Yes (". $rusa_id . ")";
		}else{
			$rms="No";
		}

		$pmsa=$this->compute_pms($mem);
		$pms=$pmsa['pms'];
		$membership=$pmsa['membership'];

		$memdata=array(
			'membership'	=> $membership,
			'rms'		=> $rms,
			'pms'		=> $pms,
			'rusa_id'		=> $mem['rusa_id'],
			'first_name'	=> $mem['first_name'],
			'last_name'		=> $mem['last_name'],
			'member_id'		=> $mem['id'],
			'administrator'	=> $mem['administrator'],
			'expires'		=> $mem['expires'],
			'contact_street'	=> $mem['m_street'],
			'contact_city'	=> $mem['m_city'],
			'contact_state'	=> $mem['m_state'],
			'contact_zip'	=> $mem['m_zip'],
			'contact_country'	=> $mem['m_country'],
			'contact_tracker'	=> $mem['tracker'],
			'contact_phone'	=> $mem['m_phone'],
			'contact_phone_alt'	=> $mem['m_phone_alt'],
			'contact_email'	=> $mem['m_email'],
			'contact_emergency_name'	=> $mem['emergency_name'],
			'contact_emergency_phone'	=> $mem['emergency_phone'],
			'contact_emergency_phone_alt'	=> $mem['emergency_phone_alt']
		);

		return $memdata;

	}


	public function get_club_trackers(){
		$sql="SELECT * FROM tracker";
		$q=$this->db->query($sql);
		$url=array();
		$tag=array();
		foreach ($q->result_array() as $row){
			$url[$row['id']]=$row['url'];      
			$tag[$row['id']]=$row['tag'];      
		}
		return compact('url','tag');
	}
	
    // Checkin model functions
    
    public function get_checkin($event_id,$member_id,$control_number){
        $this->db->where(compact('event_id','control_number','member_id'));
        $q=$this->db->get('checkin');
		$result=$q->row_array();
		if(empty($result)) return null;
		extract($result);
		$tz=new DateTimeZone('UTC'); // Checkins are stored as UTC
		$checkin_time=new DateTime($time,$tz);
		return compact('checkin_time', 'comment', 'preride');
    }

    public function get_checkin_datetime($event_id,$member_id,$control_number){
        $this->db->where(compact('event_id','control_number','member_id'));
        $q=$this->db->get('checkin');
		$result=$q->row_array();
		if(empty($result)) return null;
		$tz=new DateTimeZone('UTC'); // Checkins are stored as UTC
		$checkin_time=new DateTime($result['time'],$tz);
		return $checkin_time;
    }

    public function get_last_checkin($event_id,$member_id){
        $sql="SELECT * from checkin where event_id=$event_id AND member_id=$member_id order by control_number desc limit 1";
		$q=$this->db->query($sql);
		$result=$q->row_array();
		if(empty($result)) return null;
		$tz=new DateTimeZone('UTC'); // Checkins are stored as UTC
		$result['checkin_datetime']=new DateTime($result['time'],$tz);
		return $result;
    }
    
    public function delete_checkin($event_id,$member_id,$control_number){
        $this->db->where(compact('event_id','control_number','member_id'));
        $q=$this->db->delete('checkin');
		return $q;
    }
    
    public function put_checkin_datetime($event_id,$member_id,$control_number,$checkin_datetime='now'){
        $this->db->where(compact('event_id','control_number','member_id'));
        $q=$this->db->get('checkin');
		$result=$q->row_array();
		if(!empty($result)) $this->die_error(__METHOD__,"Can't check in twice! MEMBER ID $member_id already checked in to event $event_id at control $control_number at " . $result['time'] . ' UTC');
		$tz=new DateTimeZone('UTC'); // Checkins are stored as UTC
		if($checkin_datetime=='now') $checkin_datetime = new DateTime('now',$tz);
		$time=$checkin_datetime->format('Y-m-d H:i:s');
		$data = compact('rusa_id','event_id','control_number','time');
        return $this->db->insert('checkin', $data);
    }
    
    public function event_checkins_q($event_id){
        $this->db->where(compact('event_id'));
        $q=$this->db->get('checkin');
		return (0 < $q->num_rows());
    }
    
    
	// ROSTER models
	
	

	public function get_roster($event_id){
		$sql="SELECT roster.*, member.*, roster.id as roster_id, 
			CASE WHEN member.expires='0000-00-00' THEN 'guest' 
				WHEN member.administrator=1 THEN 'administrator' WHEN member.waive_fees=1 THEN 'volunteer' 
				WHEN member.expires<NOW() THEN 'terminated' ELSE 'member' END as membership
				 FROM roster,member where roster.member_id=member.id and event_id='{$event_id}' ORDER BY last_name,first_name";
		$q=$this->db->query($sql);
		return $q->result();
	}

	public function get_roster_member($roster_id){
		$sql="SELECT roster.*, member.*, roster.id as roster_id, member.id as member_id, 
			CASE WHEN member.expires='0000-00-00' THEN 'guest' 
				WHEN member.administrator=1 THEN 'administrator' WHEN member.waive_fees=1 THEN 'volunteer' 
				WHEN member.expires<NOW() THEN 'terminated' ELSE 'member' END as membership
				 FROM roster,member where roster.id='{$roster_id}' and roster.member_id=member.id";
		$q=$this->db->query($sql);
		return $q->row();
	}

  public function roster_count($event_id){
		$sql="SELECT COUNT(member.id) as num_riders FROM roster,member where roster.member_id=member.id and event_id='{$event_id}' ";
		$q=$this->db->query($sql);
		$r=$q->row();
		return $r->num_riders; 
	}


	public function get_vroster($event_id){
		$sql="SELECT * FROM volunteer_offer,member,paragraph 
			where 
			volunteer_offer.member_id=member.id and 
			volunteer_offer.event_id='{$event_id}' and
			volunteer_offer.job_id=paragraph.id ORDER BY last_name,first_name";
		$q=$this->db->query($sql);
		return $q->result();
	}

	public function get_com_roster($event_id){
		$sql="SELECT rusa_id,first_name,last_name,m_city,m_state FROM roster,member where roster.member_id=member.id and event_id='{$event_id}' AND COALESCE( NOT (result='VOL'),TRUE) ORDER BY last_name,first_name";
		$q=$this->db->query($sql);
		return $q;
	}

	public function get_rusa_results($event_id){
		$sql="SELECT IF(rusa_id>0,rusa_id,'') as '#RUSA#',first_name as 'FirstName',last_name as 'LastName',
					HOUR(elapsed_time) as 'Hours', MINUTE(elapsed_time) as 'Minutes', IF(result='FINISH',0,1) as 'DNF', 
					IF(m_country<>'US',1,0) as 'Foreign' FROM 
					roster,member where roster.member_id=member.id AND event_id='{$event_id}' AND ( NOT (result='DNS')) AND ( NOT (result='VOL')) ORDER BY last_name,first_name";
		$q=$this->db->query($sql);
		return $q;
	}

	public function get_full_results($event_id){
		$sql="SELECT member.id as 'pa_member_id', IF(rusa_id>0,rusa_id,'') as 'rusa_id',first_name, last_name, m_email, m_street, m_city, m_state, m_zip, m_country, result,
					HOUR(elapsed_time) as 'Hours', MINUTE(elapsed_time) as 'Minutes', comment FROM 
					roster,member where roster.member_id=member.id AND event_id='{$event_id}' ORDER BY last_name,first_name";
		$q=$this->db->query($sql);
		return $q;
	}
	
	public function set_null_finished($event_id){
		$sql="update roster set result='FINISH' WHERE event_id='{$event_id}' AND isnull(result)";
		$q=$this->db->query($sql);
		return $q;
	}


  public function Xevent_course_history($event){
		$rusa_route=$event['rusa_route'];
		$event_id=$event['id'];
		if(empty($rusa_route) or $rusa_route+0 < 1){
			return null;
		}else{
			$rr=$rusa_route;
			$sql="SELECT event.id,date,COUNT(result) as num_finishers FROM event,roster WHERE roster.result='FINISH' AND event.rusa_route='$rr' AND event.id=roster.event_id GROUP BY event.id ORDER BY date";
		  $result=$this->db->query($sql);
			$ra=$result->result_array();
			return $ra;
		}
	}

	public function event_course_history($event){
		$rusa_route=$event['rusa_route'];
		$event_id=$event['event_id'];
		if(empty($rusa_route) or $rusa_route+0 < 1){
			return null;
		}else{
			$rr=$rusa_route;
			$sql="SELECT event.id,date,distance,count(member_id) as num_finishers ,MIN(TIME_TO_SEC(elapsed_time)) as seconds FROM event,roster WHERE roster.result='FINISH' AND event.rusa_route='$rr' AND event.id=roster.event_id GROUP BY event.id ORDER BY date";
		  $result=$this->db->query($sql);
			$ra=$result->result_array();

			if(empty($ra)) return null;

			$events=$ra;

			$mysort=function ($a,$b){return ($a['seconds']<$b['seconds'])?-1:1;};
			usort($ra, $mysort);

			//$ffs=[];
		  // foreach($ra as $r){
			$r=array_shift($ra); // fastest ff
				$ei=$r['id'];
				$e=$this->get_event($ei);
//$this->die_error(__METHOD__, print_r($e,true));
				$date=$e['date'];
				$secs=$r['seconds'];
				$distance=$r['distance'];
				$speed=round( $distance / ($secs/3600), 1);
				$sql="SELECT first_name, last_name, elapsed_time FROM roster,member WHERE roster.event_id=$ei AND member.id=roster.member_id AND TIME_TO_SEC(roster.elapsed_time)=$secs";
		  	$result=$this->db->query($sql);
				$names=[];
				foreach($result->result_array() as $rh){
					$names[]=$rh['first_name'] . ' ' . $rh['last_name'];
					$elapsed_time=$rh['elapsed_time'];
				}
				list($hr,$min,$sec)=explode(':',$elapsed_time);
				$elapsed_time=sprintf('%02d:%02d',$hr,$min);
				$names=implode(', ',$names);
				$course_record=compact('date', 'names', 'elapsed_time','speed');
			//}
			return compact('events','course_record');
		}
	}	


	public function get_paragraph_array($location,$strip_tags=false){
		$sql="SELECT * FROM paragraph where location='{$location}' and hidden=0 order by description"; 
		$q=$this->db->query($sql);
		$a=$q->result_array();
		$info_text=[];
		foreach ($a as $f){
			if(!isset($info_text[$f['description']])){
				$info_text[$f['description']]=$f['text'];
			}else{
				$info_text[$f['description']].=$f['text'];
			}
		}
		
		if($strip_tags){
			foreach ($info_text as $desc=>$text){
				$info_text[$desc]=strip_tags($text);
			}
		}
		
		return $info_text;
	}

	public function get_paragraph($location,$strip_tags=false){
		$sql="SELECT * FROM paragraph where location='{$location}' and hidden=0 order by description"; 
		$q=$this->db->query($sql);
		$a=$q->result_array();
		$info_text="";
		foreach ($a as $f){
			$info_text.=$f['text'];
		}
		if($strip_tags){
			return strip_tags($info_text);
		}else{
			return $info_text;
		}
	}

	public function get_volunteer_jobs(){
		$sql="SELECT * FROM paragraph where location='volunteer' and hidden=0"; 
		$q=$this->db->query($sql);
		return $q->result_array();
	}

	public function dbResultsQ($event_id){
		$stmt = "SELECT result FROM roster where event_id='{$event_id}'"; 
		$q = $this->db->query($stmt);
		$has_results=false;
		foreach($q->result_array() as $r){
			if(empty($r['result'])){
				$has_results=false;
				break;
			}elseif($r['result']!='DNS'){
				$has_results=true;
			}
		}
		return $has_results;
	}

	public function he_decode($str){
		$non_iso=[
			'&ldquo;'=>'"',
			'&rdquo;'=>'"'
		];
		return html_entity_decode(strtr($str,$non_iso),ENT_QUOTES | ENT_XHTML, 'ISO-8859-1');
	}


	public function make_distance($event){
		if($event['type']=='fleche'){
		    $distance = ""; //"Fl&egrave;che";
		}elseif($event['type']=='brevet'){
		    $distance = $event['distance'] . "K Brevet" ;
		}elseif($event['type']=='populaire'){
		    $distance = $event['distance'] . "K Populaire" ;
		}else{
		    $distance = $event['distance'] . "K " . $event['type'] ;
		}
		return $distance;
	}

	public function make_dist($event){
		if($event['type']=='fleche'){
			return ""; //"Fl&egrave;che";
		}else{
			return $event['distance'] . "K" ;		  
		}
	}
	

	public function eventScheduledQ($event){
	  return !fieldsEmptyQ($event,array('sanction','type','distance','date'));
	}


	public function eventDescribedQ($event){
	  $s=$this->eventScheduledQ($event);
		$h=$this->event_status_q($event,'hidden');
		$e=fieldsEmptyQ($event,array('start_time','name','description','start_id'));
	  $d=!$h && !$e;
		$p=!is_null($event['member_price']) && !empty($event['payment_methods']);
	  return $d && $s && $p;
	}

	public function flecheHasTeamQ($event){
		$event_id=$event['id'];
		$sql="select * FROM fleche_team where event_id='{$event_id}' order by name";
		$q=$this->db->query($sql);
		return count($q->result_array())>0; 
	}


	public function eventRouteDescribedQ($event){
		if($event['type']=='fleche'){
			return $this->flecheHasTeamQ($event);
		}else{
			return (!empty($event['map']) || !empty($event['cuesheet']));
		}
	}

	public function old_makelink($url,$desc,$grayifempty=true,$class='grayed'){
		if(!empty($url)){		   
			return "<A HREF=\"$url\" TITLE=\"$desc\">$desc</A>";
		}else{
			return ($grayifempty)?"<span class=$class>$desc</span>":$desc;
		}
	} 

	public function makelink($url,$desc,$grayifempty=true,$class='grayed'){
		if(!empty($url)){		   
			$uri=(!preg_match('#http[s]?://#i',$url)) ? base_url($url) : $url;
			return "<A HREF=\"$uri\" TITLE=\"$desc\">$desc</A>";
		}else{
			return ($grayifempty)?"<span class=$class>$desc</span>":$desc;
		}
	} 

	public function makereglink($event,$desc='Register',$grayifempty=true){
	    $id=$event['id'];
	    $suspended=!empty($event['suspended']);
	    $desc=($suspended)?"Suspended":$desc;
		if($this->eventDescribedQ($event) && !$suspended){		   
			return '<A HREF="' . $this->event_register_url . "/$id" . '" TITLE="Online Registration">' . $desc. '</A>';
		}else{
		  return ($grayifempty)?"<span class=grayed>$desc</span>":$desc;
		}
	} 

	public function makeinfolink($event,$desc="Ride Details",$grayifempty=true){
	    $url=$event['info'];
	    $id=$event['id'];
			$name=$event['name'];
		if(!empty($url)){		   
			return anchor($url, $desc, 'TITLE="' . $name .'"');
		}elseif($this->eventDescribedQ($event)){		   
			return anchor($this->event_info_url . "/$id", $desc, 'TITLE="' . $name .'"');
		}else{
		  return ($grayifempty)?"<span class=grayed>$desc</span>":$desc;
		}
	} 

	public function makerosterlink($event,$desc='<i class="fas fa-users"></i>',$grayifempty=true,$show_anyway=false){
	    $id=$event['id'];
		if(($this->eventDescribedQ($event) || $show_anyway) && !$this->event_status_q($event,'canceled')){		  
			$roster_url=($event['type']=='fleche')?$this->fleche_roster_url:$this->event_roster_url; 
			return '<A HREF="' . $roster_url . "/$id" . '" TITLE="Registered Rider List">' . $desc. '</A>';
		}else{
		  return ($grayifempty)?"<span class=grayed>$desc</span>":$desc;
		}
	} 

	public function makecuelink($event,$grayifempty=true,$show_anyway=false){
	  $id=$event['id'];
		if($event['type']=='fleche'){
			$info_url=$this->fleche_roster_url;
			$icon='<i class="fas fa-users"></i>';
			$title='Teams';
		}else{
			$info_url=$this->route_info_url;
			$icon='<i class="fas fa-map"></i>';
			$title='Cues and Map';
		}

		if( $this->eventRouteDescribedQ($event) || $show_anyway) { //&& !$this->event_status_q($event,'canceled')){		  
			return "<A HREF='$info_url/$id' TITLE='$title'>$icon</A>";
		}else{
		  return ($grayifempty)?"<span class=grayed>$icon</span>":$icon;
		}
	} 

	public function makeResultsLink($row,$desc,$grayifempty=true){
		$url=$row['results'];
		$db_results=$row['has_db_results'];
		$event_id=$row['id'];
		if(filter_var($url, FILTER_VALIDATE_URL) !== false){		   
			return "<A HREF=\"$url\" TITLE=\"$desc\">$desc</A>";
		}elseif(!empty($url)){
			return "<A HREF='" . base_url($url) . "' TITLE=\"$desc\">$desc</A>";
		}elseif($db_results){
			return '<A HREF="' . $this->event_results_url . "/$event_id" . '" TITLE="Unofficial Results">' . $desc. '</A>';
		}else{
			return ($grayifempty)?"<span class=grayed>$desc</span>":$desc;
		}
	} 


	public function event_schedule($event){
		if($event['type']=='fleche'){
			return $this->fleche_event_schedule($event);
		}else{
			return $this->brevet_event_schedule($event);
		}
	}

	private function fleche_event_schedule($event){
			$tz = $this->get_local_time_zone();
			$current_datetime = new DateTime("now",$tz);
			extract($this->start_schedule($event)); // 'start_datetime','start_date_str','start_monthday_str','start_time_str','start_time_zone','start_datetime_str','start_year'

			$fleche_captain_registration_closes_date = $this->dateback_cutoff($start_datetime, $this->model_parando->fleche_captain_reg_cutoff);
			$fleche_captain_reg_cutoff_datetime = $this->midnight_cutoff($start_datetime, $this->model_parando->fleche_captain_reg_cutoff);
			$fleche_route_submission_date = $this->dateback_cutoff($start_datetime, $this->model_parando->fleche_route_submission_cutoff);
			// $fleche_brevet_cards_mailed_date = $this->dateback_cutoff($start_datetime, $this->model_parando->fleche_brevet_cards_mailed);			

// Provide way to override the standard reg cutoff date for brevets (and maybe fleche?)

			$reg_cutoff_days=(!empty($event['reg_cutoff_days']))?$event['reg_cutoff_days']:$this->model_parando->fleche_rider_reg_cutoff;
			$fleche_rider_registration_closes_date = $this->dateback_cutoff($start_datetime, $reg_cutoff_days);
			$reg_cutoff_datetime = $this->midnight_cutoff($start_datetime,$this->model_parando->fleche_rider_reg_cutoff);
			$reg_cutoff_datetime_str2=$reg_cutoff_datetime->format('G:i T, l j F');
			$fleche_earliest_start_date= $start_datetime->format('j F');
			$preferred_start_datetime = clone $start_datetime; $preferred_start_datetime->add(new DateInterval('P1DT20H'));
			$fleche_preferred_start_date = $preferred_start_datetime->format('j F');
			$latest_start_datetime = clone $start_datetime; $latest_start_datetime->add(new DateInterval('P1DT22H'));
			$fleche_latest_start_date = $latest_start_datetime->format('j F');
			$latest_finish_datetime = clone $start_datetime; $latest_finish_datetime->add(new DateInterval('P2DT22H'));
			$fleche_latest_finish_date = $latest_finish_datetime->format('j F');
			$fleche_brunch_banquet = $latest_finish_datetime->format('j F');
			$cutoff_datetime = $latest_finish_datetime;
			$cutoff_date_str = $cutoff_datetime->format('j F Y');
			$cutoff_time_str = $cutoff_datetime->format('H:i T');
			$event_completed = $current_datetime > $cutoff_datetime;
			$event_begun = $current_datetime > $start_datetime;
			$registration_closed = $current_datetime > $reg_cutoff_datetime || 
					$this->event_status_q($event,['suspended','canceled','hidden']);

			return compact(
				'start_datetime',
				'cutoff_datetime',
				'start_date_str',
				'start_year',
				'start_monthday_str',
				'start_time_str',
				'start_time_zone',
				'start_datetime_str',
				'start_daymonthyear_str',
				'reg_cutoff_datetime',
				'reg_cutoff_datetime_str2',
				'current_datetime',
				'cutoff_datetime',
				'cutoff_date_str',
				'cutoff_time_str',
				'fleche_captain_registration_closes_date',
				'fleche_captain_reg_cutoff_datetime',
				'fleche_route_submission_date',
				// 'fleche_brevet_cards_mailed_date',
				'fleche_rider_registration_closes_date',
				'fleche_earliest_start_date',
				'fleche_preferred_start_date',
				'latest_start_datetime',
				'fleche_latest_start_date',
				'fleche_latest_finish_date',
				'fleche_brunch_banquet',
				'event_completed',
				'event_begun',
				'registration_closed'
			);

	}
	
	private function midnight_cutoff($start,$days){
			$interval="P".$days."D";
			$cutoff_dateback = clone $start; 
			$cutoff_dateback->sub(new DateInterval($interval));
			$cutoff_datetime_str=$cutoff_dateback->format('Y-m-d 23:59 T');
			$cutoff_datetime = new DateTime($cutoff_datetime_str);
			return $cutoff_datetime;
	}

	private function dateback_cutoff($start,$days){
			$interval="P".$days."D";
			$cutoff_dateback = clone $start; 
			$cutoff_dateback->sub(new DateInterval($interval));
			$cutoff_datetime_str=$cutoff_dateback->format('M j');
			return $cutoff_datetime_str;
	}

	public function start_schedule($event){
			$tz = $this->get_local_time_zone();
			$start_datetime = new DateTime($event['start_time'].' '.$event['date'], $tz);
			$start_date_str = $start_datetime->format('l j F Y');
            $start_monthday_str=$start_datetime->format('M j');
            $start_daymonthyear_str=$start_datetime->format('j F Y');
			$start_time_str = $start_datetime->format('H:i T');
			$start_time_zone = $start_datetime->format('T');
			$start_datetime_str = $start_datetime->format('Y-m-d H:i:00');
			$start_year = $start_datetime->format('Y');
			return compact('start_datetime','start_date_str','start_monthday_str','start_daymonthyear_str','start_time_str','start_time_zone','start_datetime_str','start_year');
	}

	private function brevet_event_schedule($event){
			$tz = $this->get_local_time_zone();
			$current_datetime = new DateTime("now",$tz);
			extract($this->start_schedule($event));
			
// 			$reg_cutoff_dateback = clone $start_datetime; 
// 			$reg_cutoff_dateback->sub(new DateInterval('P2D'));
// 			$reg_cutoff_datetime_str=$reg_cutoff_dateback->format('Y-m-d 23:59 T');

// Provide way to override the standard reg cutoff date for brevets (and maybe fleche?)
			$reg_cutoff_days=(!empty($event['reg_cutoff_days']))?$event['reg_cutoff_days']:$this->model_parando->reg_cutoff;
			
			if($reg_cutoff_days==floor($reg_cutoff_days)){
				$reg_cutoff_datetime = $this->midnight_cutoff($start_datetime,$reg_cutoff_days);
			}else{
				$reg_cutoff_seconds=floor($reg_cutoff_days*24*60*60);
				$reg_cutoff_seconds_interval = new DateInterval('PT'.$reg_cutoff_seconds.'S');
				$reg_cutoff_datetime = clone $start_datetime;
				$reg_cutoff_datetime->sub($reg_cutoff_seconds_interval);				
			}
			
			
			$reg_cutoff_datetime_str2=$reg_cutoff_datetime->format('G:i T, l j F');

			$signin_datetime = clone $start_datetime; $signin_datetime->sub(new DateInterval('PT1H'));
			$meeting_datetime = clone $start_datetime; $meeting_datetime->sub(new DateInterval('PT10M'));
			$signin_time_str = $signin_datetime->format('H:i');
			$meeting_time_str = $meeting_datetime->format('H:i');

			$cutoff=array(
				200=>'PT13H30M',
				300=>'PT20H',
				400=>'PT27H',
				600=>'PT40H',
				1000=>'PT75H',
				1200=>'PT90H'
			);

			if(array_key_exists($event['distance'],$cutoff)){
				$cutoff_interval=new DateInterval($cutoff[$event['distance']]);
			}else{
				$tmax = $event['distance']/15.0;
				$tmax_hrs = floor($tmax);
				$tmax_mins = round(60.0 * ($tmax - $tmax_hrs));
				$cutoff_interval=new DateInterval(sprintf("PT%02dH%02dM",$tmax_hrs,$tmax_mins));
			}
			$cutoff_datetime = clone $start_datetime; $cutoff_datetime->add($cutoff_interval);
			$cutoff_date_str = $cutoff_datetime->format('j F Y');
			$cutoff_time_str = $cutoff_datetime->format('H:i T');

			$event_completed = $current_datetime > $cutoff_datetime;
			$event_begun = $current_datetime > $start_datetime;
//			$registration_closed = $current_datetime > $reg_cutoff_datetime || $event['hidden']==true;
			$registration_closed = $current_datetime > $reg_cutoff_datetime || 
					$this->event_status_q($event,['suspended','canceled','hidden']);

			return compact(
				'start_datetime',
				'start_date_str',
				'start_year',
				'start_monthday_str',
				'start_time_str',
				'start_time_zone',
				'start_datetime_str',
				'start_daymonthyear_str',
				'reg_cutoff_datetime',
				'reg_cutoff_datetime_str2',
				'signin_datetime',
				'meeting_datetime',
				'signin_time_str',
				'meeting_time_str',
				'current_datetime',
				'cutoff_interval',
				'cutoff_datetime',
				'cutoff_date_str',
				'cutoff_time_str',
				'event_completed',
				'event_begun',
				'registration_closed'
			);

	}

	

	public function check_credentials($rusa_id,$password){
	
		if(is_numeric($rusa_id) && $rusa_id>0 && $rusa_id<1000000){
			$sql="SELECT * FROM member WHERE rusa_id='{$rusa_id}'";
			$result=$this->db->query($sql);
		}elseif(!empty($rusa_id)){
			$sql="SELECT * FROM member WHERE last_name='{$rusa_id}'";
			$result=$this->db->query($sql);
		}
		
		
		$status = "";
		$data = null;
		
		if(isset($result) && $result->num_rows()===1){
			$data = $result->row();;
			if(!empty($data->password) && !empty($data->first_name) && !empty($data->last_name) && password_verify($password,$data->password)){
				if($data->administrator){ 
				  $status = 'login_admin';
				}else{
				  $status = 'login_user';
				}
			}else{
				$status='incorrect_password';
			}
		}else{
			$status='member_not_found';
		}
		
		return ['status'=>$status, 'data'=>$data];
	}



	public function die_error($heading,$message){
		$this->load->view('errors/html/error_general',array('title'=>$heading, 'heading'=>$heading,'message'=> $message));
		$this->output->_display();
		exit();
	}

	public function get_organizer($event){
		$organizer_id=$event['organizer'];
		if(!empty($organizer_id)){
			$organizer=$this->get_member($organizer_id);
		}else{
            $organizer=$this->get_rba($event['club_id']);
			$organizer_id=$organizer['id'];
		}
		$organizer_name=$organizer['first_name'] . ' ' . $organizer['last_name'];
		$organizer_phone=$organizer['m_phone'];
		$organizer_email=$organizer['m_email'];

		$organizer_address  = '';
		$organizer_address .= $organizer['m_street'] . '<br>';
		$organizer_address .= $organizer['m_city'] . ', ' . $organizer['m_state'] . ' ' . $organizer['m_zip'];

		$organizer_data=compact('organizer_id','organizer_name','organizer_phone','organizer_email','organizer_address');
		return $organizer_data;
	}


    // Depreciated
	public function check_event($event_id,$please='no'){
		$event=$this->get_event($event_id);
		if(isset($event)){

			$t=$this->event_schedule($event);
			$datetime_now = new DateTime();
			if($t['start_datetime']<$datetime_now || ($please!='please' && $t['reg_cutoff_datetime']<$datetime_now)){
//			if($t['reg_cutoff_datetime']<$datetime_now){
			   	return 'too_late_to_register';
			}


			$organizer_data=$this->get_organizer($event);			

			$event_data=array(
			    'event_id'		=> $event_id,
			    'event_contact_url'	=> site_url("info/contact/$event_id"),
			    'event_start_city'	=> $event['start_city'],
			    'event_start_state'	=> $event['start_state'],
			    'event_name'	=> $event['name'],
			    'event_distance'	=> $this->make_distance($event),
			    'event_date'	=> $t['start_date_str'],
			    'event_start_datetime' => $t['start_datetime_str'],
			    'event_reg_cutoff'	=> $t['reg_cutoff_datetime_str'],
			    'event_included'	=> $event['included'],
			    'event_member_price'	=> $event['member_price'],
			    'event_guest_price'	=> $event['guest_price'],
			    'event_lodging_1n_price'	=> $event['lodging_1n_price'],
			    'event_lodging_2n_price'	=> $event['lodging_2n_price']
			);

			$this->session->set_userdata(array_merge($organizer_data,$event_data));

			return 'ok_to_register';

		}else{
			return 'event_not_found';
		}
	  
	}


	// Find member in database 

	// Two options are offerend for identifying
	// -- RUSA Number
	// -- First/Last Name

	// Users might enter their names, number, or both. 
	// We try our best to figure out who this is 

	
	public function find_member($first_name,$last_name,$rusa_id){
	

		$names_given = !empty($first_name)&&!empty($last_name);
		$rusa_given = !empty($rusa_id);
		$both_given = $names_given && $rusa_given;

		$found=false;
		$result="unknown";

		if($both_given){  

			if(!$found){ // try for full_name/RUSAID, exact match 
				$sql="SELECT * FROM member WHERE first_name='{$first_name}' AND last_name='{$last_name}' AND rusa_id='{$rusa_id}'";
				$q=$this->db->query($sql);
				if($q->num_rows()>1){  // Multiple entries
					$found=true;
					$result="duplicate_entry";
				}elseif($q->num_rows()==1){
					$found=true;
					$result="full_match_rusa";
				}
			}

			if(!$found){ // try for last_name/RUSAID, match 
				$sql="SELECT * FROM member WHERE last_name='{$last_name}' AND rusa_id='{$rusa_id}'";
				$q=$this->db->query($sql);
				if($q->num_rows()>1){  // Multiple entries
					$found=true;
					$result="duplicate_entry";
				}elseif($q->num_rows()==1){
					$found=true;
					$result="last_and_rusa";
				}
			}

			if(!$found){ // try for last_name or RUSA ID match (legitimately might be multiple)
				$sql="SELECT * FROM member WHERE last_name='{$last_name}' OR rusa_id='{$rusa_id}'";
				$q=$this->db->query($sql);
				if($q->num_rows()>0){
					$found=true;
					$result="last";
				}
			}


		}elseif($names_given){ // no RUSA given

			if(!$found){// try for full_name, exact match 
				$sql="SELECT * FROM member WHERE first_name='{$first_name}' AND last_name='{$last_name}'";
				$q=$this->db->query($sql);
				if($q->num_rows()>1){  // Multiple entries
					$found=true;
					$result="duplicate_entry";
				}elseif($q->num_rows()==1){
					$found=true;
					$result="first_last";
				}
			}

			if(!$found){// try for last_name only match (legitimately might be multiple)
				$sql="SELECT * FROM member WHERE last_name='{$last_name}' ";
				$q=$this->db->query($sql);
				if($q->num_rows()>0){
					$found=true;
					$result="last";
				}
			}

		}else{
			$result="no_id_given";
		}

		return array('result'=>$result, 'query'=>$q);
	}

	public function check_unknown($first_name,$last_name,$rusa_id){

		$sql="SELECT * FROM member where first_name='{$first_name}' AND last_name='{$last_name}'";
		$q=$this->db->query($sql);
		if($q->num_rows() > 0){
			return "existing_first_last";
		}

		if(!empty($rusa_id)){
			$sql="SELECT * FROM member where rusa_id='{$rusa_id}'";
			$q=$this->db->query($sql);
			if($q->num_rows() > 0){
				return "existing_rusa";
			}
		}

		return "ok";

	}

	public function is_registered($event_id,$member_id){
		$sql="SELECT * from roster WHERE event_id='{$event_id}' and member_id='{$member_id}'";
		$q=$this->db->query($sql);
		$entry=$q->row();
		if(isset($entry)){
			if(!empty($entry->result)){
				return $entry->result;
			}else{
				return true;
			}
		}else{
			return false;
		}
	}


	public function make_form_group($tag,$label,$placeholder,$required_q=true){
		if(!empty(form_error($tag))){
		  echo "<div class=verror>" . form_error($tag) . "</div>";
		}
		$value=set_value($tag);
		$required=($required_q)?"required":"";
		$asterisk=($required_q)?"*":"";
		echo <<<EOT
		<div class=form-group>
		  <label for="{$tag}">$label$asterisk</label>    
		  <input type="text" placeholder="{$placeholder}" name="{$tag}" value="{$value}" $required>
		</div>
EOT;
	}
	
	public function make_member_code($m,$e=null){
		if(empty($e)){$e=time();}
		return $this->add_hash("$m-$e");
	}

	public function make_profile_edit_url($member_id){
		$member_code=$this->make_member_code($member_id);
		return site_url("login/member/$member_code");
	}
			

	public function check_member_code($token){
		$result = 'Invalid token';
		$a = explode("-", $token);
		if( count($a) == 3 ){
			list($m, $e, $hash)=$a;
			if($token == $this->make_member_code($m,$e)){
				$member=$this->get_member($m);
				$elapsed=time() - $e;
				if(empty($member)){
					$result="No member ($m)";
				}elseif($elapsed<=0){
					$result="Token from future ($elapsed s)";
				}elseif($elapsed>$this->token_expire){
					$result="Token expired ($elapsed s)";
				}else{
					$result=$a;
				}
			}
		}
		return $result;
	}


	public function add_hash($plaintext){
		$hash=$this->make_hash($plaintext);
		return "$plaintext-$hash";
	}
	
	public function make_hash($plaintext){
		if(empty($this->secret)) $this->die_error(__METHOD__,"No Secret!");
		$secret=$this->secret;
		$hash=strtoupper(substr(hash('sha256',"$plaintext-$secret"),0,$this->hash_hex_digits));
		return $hash;
	}
	
	public function make_start_code($event,$rusa_id){
		$event_id=$event['event_id'];
		$club=$event['club'];
		$club_acp_code=$club['acp_code'];
		$secret=$club['epp_secret'];  // $club['secret'];	

		$plaintext="$club_acp_code-$event_id-$rusa_id-$secret";
		
		
		return strtoupper(substr(hash('sha512',$plaintext),0,4));

	}


}
