<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

 
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

 
class Results_parando extends CI_Model {

	public $results_epoch;
	public $d_now;
	public $m_now;
	public $y_now;
	public $tz;


	public function __construct() {
		parent::__construct();
		$this->tz=$this->model_parando->get_local_time_zone();
		$this->d_now = new DateTime("now",$this->tz);
		$this->m_now=$this->d_now->format('n');
		$this->y_now=$this->d_now->format('Y');
		$this->results_epoch=$this->model_parando->results_epoch;
		$this->init_prior_results();
		$this->award_calc();
	}

	public $prior_results;

	private function init_prior_results(){
		$this->prior_results=[];
		$y_epoch=$this->results_epoch;
		$sql="SELECT * FROM awards where as_of<'{$y_epoch}-01-01'";
		$q=$this->db->query($sql);
		foreach($q->result_array() as $row){
			extract($row);
			$this->prior_results[$type][$member_id]=$number;			
		}
	}

	public function get_current_results(){
		$current_results=[];
		$y_epoch=$this->results_epoch;
		$sql="SELECT * FROM awards where as_of>='{$y_epoch}-01-01'";
		$q=$this->db->query($sql);
		foreach($q->result_array() as $row){
			extract($row);
			if(empty($current_results[$type][$member_id]) || $current_results[$type][$member_id]<$number){
				$current_results[$type][$member_id]=$number;		
			}	
		}
		return $current_results;
	}


	public function member_results($member_id){
		$sql="SELECT event_id, date, name, sanction, type, distance, result, elapsed_time, comment FROM roster,event WHERE 
						member_id='$member_id' AND roster.event_id=event.id order by date";
		$q=$this->db->query($sql);
		// $this->results_bym=[];
		// $this->results_byd=[];
		return $q->result_array();
	}
	

	public function all_results(){
		$sql="SELECT event_id, date, name, type, distance, count(result), avg(elapsed_time) FROM roster,event WHERE 
						roster.event_id=event.id group by event_id order by date";
		$q=$this->db->query($sql);
		// $this->results_bym=[];
		// $this->results_byd=[];
		return $q->result_array();
	}

	private	$r5000_keys=[200,300,360,400,600,1000,1240];
	private	$sr_keys=[200,300,400,600];
	public	$award_keys=['R5000','SR','R12'];
	
	private $covid=true;
	private $last_month_before_covid=2020*12 + (3-1);  // March 2020
	private $first_month_after_covid=2020*12 + (9-1);  // September 2020

	public function member_detail($member){

		$id=$member['id'];

		$results=$this->results_parando->member_results($id);

		$r5000_progress=array_fill_keys($this->r5000_keys,[]);

		$total_keys=['events','km','finish','seconds'];
		$total_total=array_fill_keys($total_keys,0);

		$award_count=array_fill_keys($this->award_keys,0);

		$this_y=0;
		$r12_streak=0;
		$r12_epoch=2000; // infinite past year
		$last_r12_m=$r12_epoch*12 - 2;

		// Loop through each result by rider

		$data['annual']=[];
		$data['lifetime']=[];

		foreach($results as $r){

			if($r['result']!='FINISH') continue;  // If someday we have accurate DNF info prior to 2018 we might track this
			list($y,$m,$d)=explode('-',$r['date']);
			
			$r12_m=$y*12+$m-1;
			$award_month=array_fill_keys($this->award_keys,false);

			// Starting new year
			if($y!=$this_y){ 
				if($this_y!=0){ // Save annual summary 
					$data['annual'][$this_y]['won_award']=($old_award_count!=$award_count);
					$award_map=[];
					foreach($this->award_keys as $a)
						if($old_award_count[$a]!=$award_count[$a]) $award_map[$a]=true;					
					$data['annual'][$this_y]['summary']=$this->calc_endyear($total_year,$award_count,$award_map);
					foreach($total_keys as $k) $total_total[$k]+=$total_year[$k];
				}
				$old_award_count=$award_count;
				$total_year=array_fill_keys($total_keys,0);
				$total_year['SR']=array_fill_keys($this->sr_keys,0);
				$this_y=$y;
				$data['annual'][$this_y]['results']=[];
			}

			// Starting new result row
			$total_year['events']++;

			if($r['type']=='fleche'){
				$distance=360;
				$dist_str='Fl&egrave;che';
			}else{
				$distance=$r['distance'];
				$dist_str= $distance . "K";
			}
			$r['dist_str']=$dist_str;

			if($r['result']=='FINISH'){
				$total_year['finish']++;  
				$total_year['km']+=$distance;
				if(isset($total_year['SR'][$distance]))$total_year['SR'][$distance]++; 
				if(isset($total_year['SR']) && array_product($total_year['SR'])>0){
					$award_month['SR']=true;
					$award_count['SR']++;
					$spend_sr=function($v){return ($v>0)?$v-1:0;};
					$total_year['SR']=array_map($spend_sr,$total_year['SR']);
				}
				if($distance>=200){
					if($r12_m==$last_r12_m+1 || // if the last 200+ was last month
					   ($this->covid && $r12_m==$this->first_month_after_covid && $last_r12_m==$this->last_month_before_covid)
					){	
						$r12_streak++;				// extend the streak
						$last_r12_m=$r12_m;		// and note this month had a 200+
						if($r12_streak%12==0){
							$award_month['R12']=true;
							$award_count['R12']++;
							if($r12_streak>12){
								$rn="R$r12_streak";
								$award_month[$rn]=true;
								$award_count[$rn]=(isset($award_count[$rn]))?$award_count[$rn]+1:1;
							}
						}
					}else if($r12_m>$last_r12_m+1){	// too long a gap  (not sure why the if clause is needed here)
						$r12_streak=1;						// reset the streak to 1
						$last_r12_m=$r12_m;				// and note this month had a 200+
					}
				}
				if(isset($r5000_progress[$distance])){
					$r5000_progress[$distance][]=new DateTime($r['date']);
					$er5=$this->earned_r5000($r5000_progress);
					if($er5===true){
						$award_month['R5000']=true;
						$award_count['R5000']++;
					}
				} 

			}

			if($r['result']=='FINISH'){
			
			if(isset($r['elapsed_time'])){		
				list($hr,$min,$sec)=explode(':',$r['elapsed_time']); 
				$total_year['seconds']+= ($r['type']=='fleche')?3600*24:3600*$hr+60*$min+$sec;
			}else{ 
				extract($member);
				$this->model_parando->die_error(__METHOD__,"Invalid results data for rider ID=$id ($first_name $last_name). Tell somebody to fix their data. There is a FINISH result with no elapsed time entered: " . print_r($r,true));
				}
			
			}

			$award_list=[];
			foreach($award_month as $a=>$v) 
				if($v) $award_list[]=($award_count[$a]>1)?$a." (".$award_count[$a].")":$a;
			$r['award_list']=$award_list;

			$r['r5000_progress']=$r5000_progress;

			$data['annual'][$this_y]['results'][]=$r;

		}

		// Final Summary

		if($this_y!=0){ // if there were results at all
			$data['annual'][$this_y]['won_award']=($old_award_count!=$award_count);
			$award_map=[];
			foreach($this->award_keys as $a)
				if($old_award_count[$a]!=$award_count[$a]) $award_map[$a]=true;					
			$data['annual'][$this_y]['summary']=$this->calc_endyear($total_year,$award_count,$award_map);
			foreach($total_keys as $k) $total_total[$k]+=$total_year[$k];
			$data['lifetime']['summary']=$this->calc_endyear($total_total,$award_count);
			$data['lifetime']['won_award']=false;
			foreach($this->award_keys as $a)
				if($award_count[$a]>0) $data['lifetime']['won_award']=true;					
			return $data;
		}else 
			return [];


	}
	
	private function calc_endyear($total_year, $award_count, $award_map=null){

			$award_list=[];
			foreach($award_count as $k=>$v) {
				if($v>0 && ($award_map===null || isset($award_map[$k]))) $award_list[]=($v>1)?"$k ($v)":$k;
			}

//			if($total_year['events']==0 || $total_year['seconds']==0)
//				$endyear = [];
//			else 
				$endyear = ['finishes'=>$total_year['finish'],  'distance'=>$total_year['km'], 'avg_speed'=>3600*$total_year['km']/ $total_year['seconds'], 'award_list'=> $award_list];

			return $endyear;
	}


	// Algorithm to determine if rider has earned an R5000 award at the moment
	// Depends on $progress array which is a list of queues, one for each required r5000 distance
  // The queues contain the DateTimes of each event of that type the rider has completed
  // It's assumed that this is called each time a new event is added to a queue
  // Once all the queues have at least one event, the time delta between the oldest
  // and newest event is computed. Expired events are removed one by one till there
  // are no more to remove. If all queues still have at least one event, then the 
  // rider earns the r5000 and the oldest entries are removed from all the queues.
  // One of the events removed will also be the newest (typically the 1240)

	private $r5000_interval_years=4;

	private function earned_r5000(&$progress){ // pass by ref to clean $progress

		$limit = 365.25 * $this->r5000_interval_years;

		// Quit immediately if missing an event
		foreach($this->r5000_keys as $k)
			if(empty($progress[$k])) return false;

		// Determine newest entry
		$end=null;
		foreach($this->r5000_keys as $k){
			$t=end($progress[$k]); // most recent entry
			if($end==null || $end < $t){
				$end=$t; $end_key=$k;
			}
		}

		$done=false;

		while(!$done){

			// Determine oldest entry
			$start=null;
			foreach($this->r5000_keys as $k){
				$t=reset($progress[$k]); // oldest entry
				if($start==null || $start > $t){
					$start=$t; $start_key=$k;
				}
			}

			// Remove it if too old
			$delta = $start->diff($end)->days;
			if($delta > $limit){
				array_shift($progress[$start_key]); 
				if($progress[$start_key]==[]) return false; // now missing an event, quit
			}else{
				$done=true;
			}

		}

		foreach($this->r5000_keys as $k) array_shift($progress[$k]); // remove oldest entries
		return true;

	}

	
	public $member_has;
	// public $award_keys=['R5000','SR','R12'];

	private function award_calc(){

		$this->member_has=[];
	
		$this->calc_results_bym_byd();
		$this->calc_member_has_r5000();
		$this->calc_member_has_sr();
		$this->calc_member_has_r12();

//		$this->model_parando->die_error(__METHOD__,print_r($this->member_has['R12_months'][234],true));


	}
	
	public $results_bymd;

//	public $results_byd;

	// Index of ALL finishes by member/year/month and by member/year/distance // REMOVED: event.distance >= 200 AND

	private function calc_results_bym_byd(){
		$sql="SELECT member_id, YEAR(date) as y, MONTH(date) as m, event.distance as d, elapsed_time FROM roster,event WHERE 
						roster.event_id=event.id AND
						roster.result = 'FINISH'";
		$q=$this->db->query($sql);
		$this->results_bymd=[];
		// $this->results_byd=[];
		foreach($q->result_array() as $e){
			extract($e);
			if(!empty($elapsed_time)){
				list($hr,$min,$sec)=explode(':',$elapsed_time); 
				$et_minutes=60*$hr+$min;
			

				if(!isset($this->results_bymd[$member_id][$y][$m][$d])){
					$this->results_bymd[$member_id][$y][$m][$d]=[$et_minutes];
				}else $this->results_bymd[$member_id][$y][$m][$d][]=$et_minutes;
			}
			// if(!isset($this->results_byd[$member_id][$y][$d])){
			// 	$this->results_byd[$member_id][$y][$d]=1;
			// }else ++$this->results_byd[$member_id][$y][$d];
		}
	}


	private function init_member_has_from_prior_results($award_key){
		$this->member_has[$award_key]=[];
		if(isset($this->prior_results[$award_key])){
			foreach($this->prior_results[$award_key] as $member_id=>$n){
				$this->member_has[$award_key][$member_id][$this->results_epoch - 1]=$n;
			}
		}
	}
  
	private function calc_member_has_r5000(){
		
		// $this->init_member_has_from_prior_results('R5000'); // Cant really do this correctly without detailed prior finish results
		
    // people who have completed a PA 1240
		$candidates=[];
		$sql="SELECT member_id FROM roster, event WHERE event.id=roster.event_id and event.distance=1240 and roster.result='FINISH'";
		$q=$this->db->query($sql);
		foreach($q->result_array() as $r)
			$candidates[]=$r['member_id'];

		foreach($candidates as $member_id){

			$n_r5000=0;
			$r5000_progress=array_fill_keys($this->r5000_keys,[]);

			$sql="SELECT date,distance,type FROM roster,event WHERE member_id='$member_id' and roster.result='FINISH' and roster.event_id=event.id order by date";
			$q=$this->db->query($sql);
			foreach($q->result_array() as $r){
				$date=$r['date']; $distance=($r['type']=='fleche')?360:$r['distance'];
				list($y,$m,$d)=explode('-',$date);
				if(isset($r5000_progress[$distance])){
					$r5000_progress[$distance][]=new DateTime($date);
					$er5=$this->earned_r5000($r5000_progress);
					if($er5===true){
						$n_r5000++;
						$this->member_has['R5000'][$member_id][$y] = $n_r5000;
					}
				} 
			}
		}
	}

	// SR Awards versus member,year
	private function calc_member_has_sr(){
		$this->init_member_has_from_prior_results('SR');
		foreach($this->results_bymd as $member_id=>$bool){
			$n_sr=(isset($this->prior_results['SR'][$member_id]))?$this->prior_results['SR'][$member_id]:0;
			for($y=$this->results_epoch; $y <=  $this->y_now; $y++){
				$n=0;
				foreach($this->sr_keys as $d){
					for($m=1; $m <= 12 && ($y<$this->y_now || $m<=$this->m_now); $m++){
						if(!empty($this->results_bymd[$member_id][$y][$m][$d])){
							$n++;
							break;
						}
					}
				}
				if($n == 4){
					$n_sr++;
					$this->member_has['SR'][$member_id][$y] = $n_sr;
				}
			}
		}
	}

 	
	// Compute streaks and R12 awards from epoch to now 		
	private function calc_member_has_r12(){
		

		$this->init_member_has_from_prior_results('R12');
		$this->init_member_has_from_prior_results('R12_months');

		foreach(array_keys($this->results_bymd) as $member_id){
			
			$n_r12=(isset($this->prior_results['R12'][$member_id]))?$this->prior_results['R12'][$member_id]:0;
			$streak=(isset($this->prior_results['R12_months'][$member_id]))?$this->prior_results['R12_months'][$member_id]:0;
			for($y=$this->results_epoch; $y <= $this->y_now; $y++){
				for($m=1; $m <= 12 && ($y<$this->y_now || $m<=$this->m_now); $m++){
					
					$r12_m=$y*12+$m-1;
					if($this->covid && $r12_m > $this->last_month_before_covid  &&  $r12_m < $this->first_month_after_covid){
						continue;
					}
								
					if( isset($this->results_bymd[$member_id][$y][$m]) && 200<=max(array_keys($this->results_bymd[$member_id][$y][$m])) ){
						$streak++;
						if(($streak % 12) == 0){
							$n_r12++;
							$this->member_has['R12'][$member_id][$y]=$n_r12; // has R12 
						}
					}else{
						if($y<$this->y_now || $m<$this->m_now) $streak=0;
					}
				
				}
				$this->member_has['R12_months'][$member_id][$y]=$streak;
			}
			
		}
		
		
	}




	public function latest_award_year($member_has){
			$year=null;
			for($y=$this->y_now; $y>=$this->results_epoch; $y--){
				foreach($member_has as $member_id => $by_year){
					if(isset($by_year[$y])){
						$year=$y;
						$y=0;
						break;
					}
				}
			}
			return $year;
	}


	public function annual_summary($year=null,$output_format='web'){

		if(empty($year)){$year=$this->y_now;}

		$this->event_calc($year);
		$this->overall_calc($year,$output_format);
	}

	public $event_data;
	public $event_ids;
	public $n_registered;
	public $n_started;
	public $n_finished;
	public $n_km;

	public function events_for_year($year){
		$sql="SELECT * FROM event WHERE event.date BETWEEN '{$year}-01-01' AND '{$year}-12-31' ORDER BY date";
		$q=$this->db->query($sql);
		$events=$q->result_array();
		return $events;
	}

	public function event_calc($year){
		$events=$this->events_for_year($year);
		$this->event_data=[];
		$this->event_ids=[];
		$this->n_registered=[];
		$this->n_started=[];
		$this->n_finished=[];
		$this->n_km=[];
		foreach($events as $e){
			$event_id=$e['id'];
			$this->event_ids[]=$event_id;
			$this->event_data[$event_id]=$e;
			$this->n_registered[$event_id]=0;
			$this->n_started[$event_id]=0;
			$this->n_finished[$event_id]=0;
			$this->n_km[$event_id]=0;
		}
	}


	public $table;
	public $results;
	public $member_n_registered;
	public $member_n_started;
	public $member_n_finished;
	public $member_n_km;
	public $n_sr;
	public $n_r12;
	public $n_events;
	public $total_percent;
	public $total_registered;
	public $total_starters;
	public $total_finishers;
	public $total_km;
	
	public function overall_calc($year,$output_format){
		$this->results_calc($year);
		$this->summary_calc();
		$this->table_calc($year,$output_format);
	}
	
	public function results_calc($year){
		$this->total_registered=0;
		$this->total_starters=0;
		$this->total_finishers=0;
		$this->total_km=0;

		$this->member_n_registered=[];
		$this->member_n_started=[];
		$this->member_n_finished=[];
		$this->member_n_km=[];
		$member=[];

		// Compute 2D array member,event finish statistics
		$sql="SELECT roster.*,member.first_name,member.last_name,member.rusa_id,event.distance,event.type,event.date,event.name,event.sanction FROM roster,member,event WHERE 
						roster.member_id=member.id AND 
						roster.event_id=event.id AND 
						event.date BETWEEN '{$year}-01-01' AND '{$year}-12-31'
						ORDER BY last_name,first_name";
		$q=$this->db->query($sql);
		foreach($q->result_array() as $e){

			extract($e);

			// Initialize accumulators
			if(!isset($member[$member_id])){
				$member[$member_id]=true;
				$this->member_n_registered[$member_id]=0;
				$this->member_n_started[$member_id]=0;
				$this->member_n_finished[$member_id]=0;
				$this->member_n_km[$member_id]=0;
//				$member_n_finished_type[$member_id]=[];
			}

			if(isset($this->n_registered[$event_id])){
				$this->n_registered[$event_id]++;
			}else{
				$this->n_registered[$event_id]=1;
			}
			
			$this->total_registered++;
			$this->member_n_registered[$member_id]++;
			if(in_array($result,['FINISH','DNF','DNQ'])){
				$this->total_starters++;
				if(isset($this->n_started[$event_id])){
					$this->n_started[$event_id]++;
				}else{
					$this->n_started[$event_id]=1;
				}
				$this->member_n_started[$member_id]++;
			}
			if($result=='FINISH'){
				$this->total_finishers++;
				if(isset($this->n_finished[$event_id])){
					$this->n_finished[$event_id]++;
				}else{
					$this->n_finished[$event_id]=1;
				}
				$this->total_km+=$distance;
				if(isset($this->n_km[$event_id])){
					$this->n_km[$event_id]+=$distance;
				}else{
					$this->n_km[$event_id]=$distance;
				}
				$this->member_n_finished[$member_id]++;
				$this->member_n_km[$member_id] += $distance;
				
// 				if($this->event_data[$event_id]['type']=="fleche"){
// 					$type="Fleche";
// 				}
// 				else{
// 					$type=($this->event_data[$event_id]['distance'] . "K");
// 				}
				
//				if(!isset($member_n_finished_type[$member_id][$type])){$member_n_finished_type[$member_id][$type]=0;}				
//				$member_n_finished_type[$member_id][$type]++;
			}
			// Fill in 2D index of results
			if($result=='FINISH'){
			    $finish=true;
				if(!empty($elapsed_time)){
					$a=explode(':',"$elapsed_time");
					if(count($a)==3){ 
						list($hr,$min,$sec)=$a;
						$result="$hr:$min";
						//if(!empty($cert)) $result.=" ($cert)";
					}else{$result="";}
				}else{$result="";}
			}else{
				$finish=false;
			}
			$e['result']=$result;
			$e['finish']=$finish;
			$this->results[$member_id][$event_id] = $e;
		}
		
	}

	public function summary_calc(){	// Summary computations
		$this->n_events=0;
		foreach($this->event_ids as $event_id){
			if(false!==strpos(strtolower($this->event_data[$event_id]['status']),'canceled')) continue;
			$d_event = new DateTime($this->event_data[$event_id]['date']);
			$this->n_events+=($this->d_now>$d_event)?1:0;
		}

		$this->total_percent = (empty($this->total_starters))?"":round(100.0 * $this->total_finishers / $this->total_starters, 1);
	}
	
	public function table_calc($year,$output_format){

		// Form the matrix table
		$this->table=[];
		$this->n_sr=0;
		$this->n_r12=0;
		$n_member=0;

		foreach($this->results as $member_id=>$e_list){
		
			extract($this->model_parando->members_by_id[$member_id]);
			
			$n_member++;
			
//			$n=0;
//			foreach(["200K","300K","400K","600K"] as $type){
//				$n += (!empty($member_n_finished_type[$member_id][$type]))?1:0;
//			}
//			$has_sr = $n == 4;

			$r12_run=(isset($this->member_has['R12_months'][$member_id][$year]))?$this->member_has['R12_months'][$member_id][$year]:0;
			$has_r12=(isset($this->member_has['R12'][$member_id][$year]))?$this->member_has['R12'][$member_id][$year]:0;
			$has_sr=(isset($this->member_has['SR'][$member_id][$year]))?$this->member_has['SR'][$member_id][$year]:0;
			
			$rusa_str=(!empty($rusa_id))?$rusa_id:"";

			switch($output_format){
				case 'csv_with_address':
				case 'with_address':
					$row=[$first_name, $last_name, $m_email, $m_street, $m_city, $m_state, $m_zip, $m_country, $rusa_str, $this->member_n_finished[$member_id], $this->member_n_km[$member_id], $r12_run]; 
					break;
				default:
					$row=[$first_name, $last_name, $rusa_str, $this->member_n_finished[$member_id], $this->member_n_km[$member_id], $r12_run]; 
					break;
			}


			$row[] = ($has_sr>0)?(($has_sr>1)?"SR ($has_sr)":"SR"):"";
			$this->n_sr += ($has_sr>0)?1:0;

			$row[] = ($has_r12>0)?(($has_r12>1)?"R-12 ($has_r12)":"R-12"):"";
			$this->n_r12 += ($has_r12>0)?1:0;
			
			$km_rank_col=count($row);
			
			$row[] = '**KM_RANK**'; // This column be replaced by KM Rank

			$all_events=[];
			$finishes=[];
			foreach($this->event_ids as $event_id){
				if(!empty($e_list[$event_id])){
					$all_events[]=$e_list[$event_id];
					$finishes[]=$e_list[$event_id];
				}else{
					$all_events[]="";
				}
			}
			switch($output_format){
				case 'csv_with_address':
				case 'with_address':
					$row=array_merge($row,[$finishes]);
					break;
				default:
					$row=array_merge($row,$all_events);
					break;
			}

			$this->table[]=['member_id'=>$member_id, 'row'=>$row];
		}

		$km_ranks=$this->rank(array_values($this->member_n_km));

		//$km_rank_col=count($this->table[0]['row']) - 1; // KM Rank assumed to be last column
		
		for($i=0; $i<$n_member; $i++){
			$n_km=$this->member_n_km[$this->table[$i]['member_id']];
			$this->table[$i]['row'][$km_rank_col]=($n_km>0)?$km_ranks[$n_km]:"-";
		}
		
		
	
	}
	

	private function rank($marks){
    $rank = 1; $ranks = [];
    rsort($marks,SORT_NUMERIC);
    foreach($marks as $mark) {
      if(!isset($ranks[$mark])) {
        $ranks[$mark] = $rank++;
      }
		}
    return $ranks;
	}

	public function get_award_list($member_has_list,$year,$group='lifetime'){

		$award_list=[];
		switch($group){
			case 'prior': // Lifetime totals of honorees prior to epoch
				foreach($member_has_list as $member_id => $number){
					$m = $this->model_parando->members_by_id[$member_id];
					$award_list[] = ['first_name'=>$m['first_name'], 'last_name'=>$m['last_name'], 'number'=>$number, 'member_id'=>$member_id];
				}
				break;
			case 'current': // Lifetime totals of honorees with awards in the current year


				foreach($member_has_list as $member_id => $by_year){
					if(isset($by_year[$year])){
						$m = $this->model_parando->members_by_id[$member_id];
						$number=$by_year[$year];
						$award_list[] = ['first_name'=>$m['first_name'], 'last_name'=>$m['last_name'], 'number'=>$number, 'member_id'=>$member_id];
					}
				}
				break;
			case 'lifetime': // Lifetime totals of all honorees with awards up to the current year
				foreach($member_has_list as $member_id => $by_year){
					$m = $this->model_parando->members_by_id[$member_id];
					$number=max($by_year);
					$award_list[] = ['first_name'=>$m['first_name'], 'last_name'=>$m['last_name'], 'number'=>$number, 'member_id'=>$member_id];
				}
				break;
			default:
				$this->model_parando->die_error(__METHOD__,"Unknown honoree group");
				break;
		}
		usort($award_list, function ($a, $b) { return ($a['last_name'] > $b['last_name']) || 
													($a['last_name'] == $b['last_name']) && ($a['first_name'] > $b['first_name']); });
		return $award_list;
	}	

	
	public function format_honor_roll($award_list, $prefix=" "){
		$honor_roll=[];
		foreach($award_list as $r){
			$num_txt = ($r['number']>1)?('('.$r['number'].')'):'';
			$first_last=$r['first_name'] . ' ' . $r['last_name'];
			$honor_roll[]=anchor("results/member/" . $r['member_id'], "$first_last $prefix $num_txt", "title='Detailed results for $first_last'");
		}		
		return $honor_roll;
	}

	public function honorees($member_has_list,$year,$group='lifetime',$prefix=" "){
		$al=$this->get_award_list($member_has_list,$year,$group);
		$hr=$this->format_honor_roll($al, $prefix);
		return $hr;
	}


}
