<?php

//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

?>
<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1">
<title>Controle Sign In Sheet</title>
<style>

table {
    border-collapse: collapse;
    table-layout: fixed;
}

table, th, td {
    border: 2px solid black;
    padding: 5px;
    height: 2em;
    text-align: center;
}

#fullname {
    text-align: left;
    font-size: 140%;
}

#dns {
    font-family: Arial, Helvetica, sans-serif;
    font-weight: 600;
    font-size: 140%;
    color: #D0D0D0;
}


th {
    font-family: Arial, Helvetica, sans-serif;
    font-weight: 600;
}

h1, h2, h3 {
    font-family: Arial, Helvetica, sans-serif;
}

@media print {
	table { 
		page-break-inside:auto 
	}
	td, th { 
		page-break-before: avoid; 
		page-break-after: avoid; 
		page-break-inside: avoid;
	}
	tr { 
		/* display: block; */
		page-break-after: auto; 
		page-break-inside: avoid;
	}
}

</style>
</head>
<body>


<h1>Controle Sign In Sheet</h1>
    <div class=event>
      <?php 
	echo '<h3>' . $event['name'] . ' ' . $event['distance_str'] . '</h3>';
	echo '<p>Start Date: ' . $event['start_date_str']  ;
	echo '<p>Start Time: ' . $event['start_time_str']  ;
      ?>
<p>Controle: _____________________________________</p>
    </div>

    <div class=roster>

      <TABLE BORDER WIDTH=100%>
<TR>
<TH WIDTH=3%>#</TH>
<TH WIDTH=4%>TRK</TH>
<TH WIDTH=25%>Name</TH>
<TH>Initials</TH>
<TH WIDTH=10%>Time In</TH>
<TH WIDTH=10%>Phone</TH>
<TH WIDTH=20%>Emergency</TH>
</TR>
      <?php 
	$i=1;
	$club_tracker=$this->model_parando->get_club_trackers();
	$team_name=null;
	foreach ($roster as $row)
	{
		$tracker_url=$row->tracker;
		$club_tracker_id=$row->tracker_id;
		if(!empty($club_tracker_id)){
			$tag=$club_tracker['tag'][$club_tracker_id];		   
			$tracker_link=$tag;
		}elseif(!empty($tracker_url)){		   
			$tracker_link="per";
		}else{
			$tracker_link="";
		}

		$phone=(empty($row->m_phone_alt)) ? $row->m_phone : ($row->m_phone . '<br>'. $row->m_phone_alt);
		$ephone=(empty($row->emergency_phone_alt)) ? $row->emergency_phone : ($row->emergency_phone . '<br>'. $row->emergency_phone_alt);
		$dns=($row->result == "DNS")?"DNS":"";


		if($team_name!=$row->name){
			$team_name=$row->name;
			$start_date=$row->start_date;
			$start_time=$row->start_time;
			echo "<TR><TD COLSPAN=7><EM>$team_name ($start_date, $start_time)</EM></TD></TR>";
		}

		echo '<TR>';
		echo '<TD>' . $i . '</TD>';
		echo '<TD>' . $tracker_link . '</TD>';
		echo '<TD ID="fullname">' . $row->first_name . ' ' . $row->last_name . '</TD>';
		echo "<TD></TD>";
		echo '<TD ID="dns">' . $dns . '</TD>';
		echo '<TD><small>' . $phone . '</small></TD>';
		echo '<TD><small>' . $row->emergency_name . ' ' . $ephone . '</small></TD>';
		echo '</TR>';
		$i++;
	}
      ?>
      </TABLE>
    </div>


</body>
</head>
