<?php

//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

?>
<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" type="text/css" href='<?php echo base_url("assets/fa/css/all.css")?>'>
<link rel="stylesheet" type="text/css" href='<?php echo base_url("assets/parando/css/global.css")?>'>
<link rel="stylesheet" type="text/css" href='<?php echo base_url("assets/parando/css/roster.css")?>'>
<title>Registered Riders for <?php echo $event['name'] . ' ' . $event['distance_str'];?></title>
<style>
.hidden a {
    color: white;
    background-color: white;
}
.hidden a:hover {
    color: #355681;
    background-color: white;
}

</style>
</head>
<body>

<div class=roster-container>

    <h2>Event</h2>
    <div class=event>
      <?php 
	$event_id=$event['event_id'];
	echo '<h3>' . $event['name'] . ' ' . $event['distance_str'] . '</h3>';
	echo '<p>Start Date: ' . $event['start_date_str']  ;
	echo '<p>Start Time: ' . $event['start_time_str']  ;
      ?>
    </div>

    <?php 
      $s=(count($roster)==1)?'':'s';
      echo "<h3>" . count($roster) . " Registered Rider$s</h3>";
    ?>
    <div class=roster>

      <TABLE WIDTH=100%>
      <TR><TH ID=firstcol></TH><TH>Name</TH><TH>Address</TH><TH>RUSA</TH></TR>
      <?php 
	$i=1;
	$marker_personal='<i class="fas fa-map-marker-alt" style="color: #355681;"></i>';
	$marker_club='<i class="fas fa-map-marker-alt" style="color: #ff824c;"></i>';
	$org=$this->model_parando->organization;
	$club_tracker=$this->model_parando->get_club_trackers();
	$country_fullname=$this->model_parando->get_countries();

	$max_rusa_digits=$this->model_parando->max_rusa_digits;

	foreach ($roster as $row)
	{
		$tracker_url=$row->tracker;
		$club_tracker_id=$row->tracker_id;
		if(!empty($club_tracker_id)){
			$url=$club_tracker['url'][$club_tracker_id];		   
			$tag=$club_tracker['tag'][$club_tracker_id];		   
			$tracker_link='<A HREF="' . $url . '" TITLE="Club Satellite Tracker ' . $tag . '">' . $marker_club . "</A>";
		}elseif(!empty($tracker_url)){		   
			$tracker_link="<A HREF=\"$tracker_url\" TITLE='Personal Satellite Tracker'>$marker_personal</A>";
		}else{
			$tracker_link="";
		}
		$grayed = ($row->result == "DNS")?"STYLE='color:#d0d0d0'":"";
		$rusa_id=$row->rusa_id;
    $first_last_name=$row->first_name . ' ' . $row->last_name;
		//$rusa_result_link=($row->rusa_id > 0) ? "<SPAN $grayed><A title='Detailed RUSA results for $first_last_name' HREF=https://rusa.org/cgi-bin/resultsearch_PF.pl?mid=$rusa_id><i $grayed class='fa fa-book'></i></a></SPAN>":'';
		//$rusa_member_link=($row->rusa_id > 0) ? "<A $grayed title='RUSA Membership Info for $first_last_name' HREF=https://rusa.org/cgi-bin/membersearch_PF.pl?mid=$rusa_id>$rusa_id</a>":'N/A';

		$rusa_id_pad=str_repeat('&nbsp;',$max_rusa_digits-strlen("$rusa_id"));
		$rusa_result_link=($row->rusa_id > 0) ? 
			"<A $grayed title='Detailed RUSA results for $first_last_name' HREF=https://rusa.org/cgi-bin/resultsearch_PF.pl?mid=$rusa_id><i $grayed class='fa fa-book'></i></a></SPAN>":'';
		$rusa_member_link=($row->rusa_id > 0) ? "$rusa_id_pad<A $grayed title='RUSA Membership Info for $first_last_name' HREF=https://rusa.org/cgi-bin/membersearch_PF.pl?mid=$rusa_id>$rusa_id</a>":'&nbsp;&nbsp;N/A';

		$club_results_link = anchor("results/member/" . $row->member_id, $first_last_name, "title='Detailed $org results for $first_last_name' $grayed");
		$state=($row->m_country != "US")?$country_fullname[$row->m_country]:$row->m_state;
		

		echo "<TR $grayed>";
		echo '<TD ID=firstcol>' . $tracker_link . '</TD>';
		echo '<TD>' . $club_results_link . '</TD>';
		echo '<TD>' . $row->m_city . ', ' . $state . '</TD>';
		echo "<TD ID=tt>" . $rusa_member_link . ' ' . $rusa_result_link . '</TD>';
		echo '</TR>';
		$i++;
	}
      ?>
      </TABLE>
    </div>

</div>

</body>
</head>
