<?php

//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

?>

<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" type="text/css" href='<?php echo base_url("assets/fa/css/all.css")?>'>
<link rel="stylesheet" type="text/css" href='<?php echo base_url("assets/parando/css/global.css")?>'>
<link rel="stylesheet" type="text/css" href='<?php echo base_url("assets/parando/css/roster.css")?>'>
<?php
	$org=$this->model_parando->organization;
  $preliminary=($this->model_parando->event_status_q($event,'locked'))?"Final":"Preliminary";
  $titletext=$preliminary . " Results for " . $event['name'] . ' ' . $event['distance_str'];
?>
<title><?php echo $titletext;?></title>
<style>
</style>
</head>
<body>

<div class=roster-container>

    <h2><?php echo $titletext;?></h2>
    <div class=event>
      <?php 
	$event_id=$event['event_id'];
	echo '<h3>' . $event['name'] . ' ' . $event['distance_str'] . '</h3>';
	echo '<p>Start Date: ' . $event['start_date_str']  ;
	echo '<p>Start Time: ' . $event['start_time_str']  ;
      ?>
    </div>

    <?php 
      $i_registered=count($roster);
      $s=($i_registered==1)?'':'s';
      echo "<h3>$i_registered Registered Rider$s</h3>";
    ?>
    <div class=roster>

      <TABLE WIDTH=100%>
      <TR><TH>Name</TH><TH>Address</TH><TH>RUSA</TH><TH>Result</TH><TH>Elapsed Time</TH><TH>Notes</TH></TR>
      <?php 
	$tandem_img="<IMG TITLE='Tandem' SRC='" . base_url('images/tandem.png') . "'>";
	$tandem_ivs="<IMG TITLE='Tandem' STYLE='visibility: hidden;' SRC='" . base_url('images/tandem.png') . "'>";
	$i_started=0; $i_finished=0;
	$country_fullname=$this->model_parando->get_countries();
	$min_seconds=null;
	$first_finisher_time=null;
	foreach ($roster as $row)
	{
		if(!empty($row->elapsed_time)){
			list($h,$m,$s)=explode(':',$row->elapsed_time);
			$seconds=3600*$h+60*$m+$s;
			// $seconds = strtotime("1970-01-01 $time UTC");
			if($row->result == 'FINISH'){
				if($min_seconds===null || $seconds<=$min_seconds){
					$min_seconds=$seconds;
					$first_finisher_time=$row->elapsed_time;
				}
			}
		}
	}


	$max_rusa_digits=$this->model_parando->max_rusa_digits;

	foreach ($roster as $row)
	{
		$rusa_id=$row->rusa_id;

		$grayed = ($row->result == "DNS")?"STYLE='color:#d0d0d0'":"";

    $first_last_name=$row->first_name . ' ' . $row->last_name;
		$rusa_id_pad=str_repeat('&nbsp;',$max_rusa_digits-strlen("$rusa_id"));
		$rusa_result_link=($row->rusa_id > 0) ? "<A $grayed title='Detailed RUSA results for $first_last_name' HREF=https://rusa.org/cgi-bin/resultsearch_PF.pl?mid=$rusa_id><i $grayed class='fa fa-book'></i></a></SPAN>":'';
		$rusa_member_link=($row->rusa_id > 0) ? "$rusa_id_pad<A $grayed title='RUSA Membership Info for $first_last_name' HREF=https://rusa.org/cgi-bin/membersearch_PF.pl?mid=$rusa_id>$rusa_id</a>":'&nbsp;&nbsp;N/A';
		$club_results_link = anchor("results/member/" . $row->member_id, $first_last_name, "title='Detailed $org results for $first_last_name' $grayed");

		// $rusa_link=($row->rusa_id > 0) ? "<A HREF=https://rusa.org/cgi-bin/resultsearch_PF.pl?mid=$rusa_id>$rusa_id</a>":'N/A';
		$state=($row->m_country != "US")?$country_fullname[$row->m_country]:$row->m_state;
		$tandem=(!empty($row->tandem))?("$tandem_img with " . $row->tandem):""; 
		if(in_array($row->result,['FINISH','DNF','DNQ'])){$i_started++;}
		if($row->result == "FINISH"){$i_finished++;}

		echo "<TR $grayed>";
		echo '<TD>' . $club_results_link . '</TD>';
		echo "<TD>" . $row->m_city . ', ' . $state . '</TD>';
		echo '<TD><SPAN ID=tt>' . $rusa_member_link . ' ' . $rusa_result_link . '</SPAN></TD>';
		echo '<TD>' . $row->result . '</TD>';
		echo '<TD>' . $row->elapsed_time . '</TD>';
		echo '<TD>' . (($first_finisher_time == $row->elapsed_time 
											&& (strpos(strtolower($row->comment), 'first finish') === false))?
												"First Finisher. ":'') . $row->comment . ' ' . $tandem . '</TD>';
		echo '</TR>';
	}
      ?>
      </TABLE>
    </div>
    <p><?php 
      $s=(count($roster)==1)?'':'s';
      echo "$i_started started; $i_finished finished";
      if($i_started>0){
	echo " (" . round(100*$i_finished/$i_started) . "%)";
      }
    ?></p>
    
<!--
    <p>
      <A HREF="<?php echo site_url("roster/rusacsv/$event_id");?>" TITLE="CSV Dowload for RUSA"><i class="fas fa-download"></i></a> 
    </p>
-->

</div>

</body>
</head>
