<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
  
//    PA Randonneurs Website Software
//    Copyright (C) 2019 Chris Nadovich https://parando.org/info/contact/webmaster
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    https://parando.org/assets/parando/src/LICENSE.txt
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

?>

<div class=roster-container>

    <h2><?php echo $title;?></h2>

    <?php 
			$event_id=$event['event_id'];
			$i_started=0; $i_finished=0;
			$tz = $this->model_parando->get_local_time_zone();
			foreach ($roster as $row){
				$start_datetime=new DateTime($row->start_time .' '. $row->start_date, $tz);
				$earliest=(isset($earliest))?min($earliest, $start_datetime):$start_datetime;
				$latest=(isset($latest))?max($latest, $start_datetime):$start_datetime;
				if(in_array($row->result,['FINISH','DNF','DNQ'])){$i_started++;}
				if($row->result == "FINISH"){$i_finished++;}
			}
      $i_registered=count($roster);
      $s=($i_registered==1)?'':'s';
      $s=(count($roster)==1)?'':'s';
			$earliest_str=$earliest->format('Y-m-d l H:i');
			$latest_str=$latest->format('l H:i');
	echo '<div class=event><h3>' . $event['name'] . ' ' . $event['distance_str'] . '</h3>';
	echo "Earliest Start: $earliest_str; " ;
	echo "Latest: $latest_str<br>" ;
      echo "<p><div class='italic bigger'>$i_registered Registered Rider$s</div>";
      echo "$i_started started; $i_finished finished";
      if($i_started>0){
				echo " (" . round(100*$i_finished/$i_started) . "%)";
      }
			echo "</p></div>";
    ?>
    <div class=roster>

      <TABLE WIDTH=100%>
      <?php 
	$country_fullname=$this->model_parando->get_countries();

		$tandem_img="<IMG TITLE='Tandem' SRC='" . base_url('images/tandem.png') . "'>";

	$team_name=null;
	foreach ($roster as $row)
	{
		$rusa_id=$row->rusa_id;
		$rusa_link=($row->rusa_id > 0) ? "<A HREF=https://rusa.org/cgi-bin/resultsearch_PF.pl?mid=$rusa_id>$rusa_id</a>":'N/A';
		$state=($row->m_country != "US")?$country_fullname[$row->m_country]:$row->m_state;

		if($team_name != $row->name){
			$team_name=$row->name;
			$start_datetime=new DateTime($row->start_time .' '. $row->start_date, $tz);
			$start_datetime_str=$start_datetime->format('l H:i');
			$start_location=$row->start_city .', '. $row->start_state;
			$team_description=$row->description;
			if(!empty($row->photo_url)){
				$photo_url=$row->photo_url;
				$photo_text="<div class=narrower><IMG TITLE='$team_name' SRC='$photo_url' WIDTH=100%></DIV>";
			}else{
				$photo_text="";
			}
			echo "<TR><TD COLSPAN=7><div class=team-name>$team_name</div></TD></TR>";
			echo "<TR><TD COLSPAN=7><div class 'bigger italic'>Starting from $start_location on $start_datetime_str</div></TD></TR>";
			echo "<TR><TD COLSPAN=7><div class=team-description>$team_description</div></TD></TR>";
			echo "<TR><TD COLSPAN=7>$photo_text</TD></TR>";
      	echo "<TR><TH>Name</TH><TH>Address</TH><TH>RUSA</TH><TH>Result</TH><TH>Elapsed Time</TH><TH>Notes</TH></TR>";
		}

		$tandem=(!empty($row->tandem))?("$tandem_img with " . $row->tandem):""; 
//				$on_tandem=(!empty($row->tandem))?$tandem_img:"$tandem_ivs";

// (($row->elapsed_time == $min_time && (strpos(strtolower($row->comment), 'first finish') === false))?'First Finisher. ':'') .

		echo '<TR>';
		echo '<TD>' . $row->first_name . ' ' . $row->last_name . '</TD>';
		echo '<TD>' . $row->m_city . ', ' . $state . '</TD>';
		echo '<TD>' . $rusa_link . '</TD>';
		echo '<TD>' . $row->result . '</TD>';
		echo '<TD>' . $row->elapsed_time . '</TD>';
		echo '<TD>' . $row->comment . ' ' . $tandem . '</TD>';
		echo '</TR>';
	}
      ?>
      </TABLE>
    </div>
    
<!--
    <p>
      <A HREF="<?php echo site_url("roster/rusacsv/$event_id");?>" TITLE="CSV Dowload for RUSA"><i class="fas fa-download"></i></a> 
    </p>
-->

</div>
